/*
 * File: TsmInterfaces.h
 * Date: 19 aug 2011
 * Time: 19:20:47
 * Generated by TismTool version 0.7
 */

#ifndef TSM_INTERFACES_H
#define TSM_INTERFACES_H

#include "TsmBase.h"
#include "TsmTrigger.h"
#include "TsmInterfacePort.h"
#include "TsmDefs.h"
using namespace std;
using namespace TsmRTE;

namespace MediaPlayer
{

  class IProxyReaderServer
  {
  public:
    virtual eRV Px_Open( int FileHandle ) = 0;
    virtual void Px_Close() = 0;
    virtual void Px_Stop() = 0;
    virtual void Px_Clear() = 0;
    virtual eRV Px_Read( tChunk* Chunk ) = 0;
    virtual void Px_IsFilled() = 0;
  };

  class TsmTrigger_IProxyReaderServer___Px_Open : public TsmTrigger
  {
  public:
    int FileHandle;
    eRV _RetVal;

    TsmTrigger_IProxyReaderServer___Px_Open( int FileHandle )
      : TsmTrigger( 8 )
      , FileHandle( FileHandle )
    {
    }
  };

  class TsmTrigger_IProxyReaderServer___Px_Close : public TsmTrigger
  {
  public:
    TsmTrigger_IProxyReaderServer___Px_Close()
      : TsmTrigger( 9 )
    {
    }
  };

  class TsmTrigger_IProxyReaderServer___Px_Stop : public TsmTrigger
  {
  public:
    TsmTrigger_IProxyReaderServer___Px_Stop()
      : TsmTrigger( 10 )
    {
    }
  };

  class TsmTrigger_IProxyReaderServer___Px_Clear : public TsmTrigger
  {
  public:
    TsmTrigger_IProxyReaderServer___Px_Clear()
      : TsmTrigger( 11 )
    {
    }
  };

  class TsmTrigger_IProxyReaderServer___Px_Read : public TsmTrigger
  {
  public:
    tChunk* Chunk;
    eRV _RetVal;

    TsmTrigger_IProxyReaderServer___Px_Read( tChunk* Chunk )
      : TsmTrigger( 12 )
      , Chunk( Chunk )
    {
    }
  };

  class TsmTrigger_IProxyReaderServer___Px_IsFilled : public TsmTrigger
  {
  public:
    TsmTrigger_IProxyReaderServer___Px_IsFilled()
      : TsmTrigger( 13 )
    {
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > IProxyReaderServer )
  class TsmIPort_IProxyReaderServer : public TsmInterfacePort, public IProxyReaderServer
  {
  public:
    TsmIPort_IProxyReaderServer( TsmBase* oParent )
    {
      TsmName = "IProxyReaderServer";
      TsmParent = oParent;
    }

    eRV Px_Open( int FileHandle )
    {
      bool bDBC;
      eRV _RetVal;
      TsmTrigger_IProxyReaderServer___Px_Open* tt = new TsmTrigger_IProxyReaderServer___Px_Open( FileHandle );
      TsmRecorder::AddCall( "Px_Open", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      _RetVal = tt->_RetVal;
      if ( bDBC )
      {
        delete tt;
      }
      return _RetVal;
    }

    void Px_Close()
    {
      bool bDBC;
      TsmTrigger_IProxyReaderServer___Px_Close* tt = new TsmTrigger_IProxyReaderServer___Px_Close;
      TsmRecorder::AddCall( "Px_Close", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Px_Stop()
    {
      bool bDBC;
      TsmTrigger_IProxyReaderServer___Px_Stop* tt = new TsmTrigger_IProxyReaderServer___Px_Stop;
      TsmRecorder::AddCall( "Px_Stop", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Px_Clear()
    {
      bool bDBC;
      TsmTrigger_IProxyReaderServer___Px_Clear* tt = new TsmTrigger_IProxyReaderServer___Px_Clear;
      TsmRecorder::AddCall( "Px_Clear", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    eRV Px_Read( tChunk* Chunk )
    {
      bool bDBC;
      eRV _RetVal;
      TsmTrigger_IProxyReaderServer___Px_Read* tt = new TsmTrigger_IProxyReaderServer___Px_Read( Chunk );
      TsmRecorder::AddCall( "Px_Read", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      _RetVal = tt->_RetVal;
      if ( bDBC )
      {
        delete tt;
      }
      return _RetVal;
    }

    void Px_IsFilled()
    {
      bool bDBC;
      TsmTrigger_IProxyReaderServer___Px_IsFilled* tt = new TsmTrigger_IProxyReaderServer___Px_IsFilled;
      TsmRecorder::AddCall( "Px_IsFilled", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }
  };

  class IProxyReaderClient
  {
  public:
    virtual void Px_CbOpened() = 0;
    virtual void Px_CbStopped() = 0;
    virtual void Px_CbDone() = 0;
    virtual void Px_CbError( int BadSector ) = 0;
    virtual void Px_CbClosed() = 0;
    virtual void Px_CbReading() = 0;
    virtual void Px_CbFilled() = 0;
  };

  class TsmTrigger_IProxyReaderClient___Px_CbOpened : public TsmTrigger
  {
  public:
    TsmTrigger_IProxyReaderClient___Px_CbOpened()
      : TsmTrigger( 30 )
    {
    }
  };

  class TsmTrigger_IProxyReaderClient___Px_CbStopped : public TsmTrigger
  {
  public:
    TsmTrigger_IProxyReaderClient___Px_CbStopped()
      : TsmTrigger( 31 )
    {
    }
  };

  class TsmTrigger_IProxyReaderClient___Px_CbDone : public TsmTrigger
  {
  public:
    TsmTrigger_IProxyReaderClient___Px_CbDone()
      : TsmTrigger( 32 )
    {
    }
  };

  class TsmTrigger_IProxyReaderClient___Px_CbError : public TsmTrigger
  {
  public:
    int BadSector;

    TsmTrigger_IProxyReaderClient___Px_CbError( int BadSector )
      : TsmTrigger( 33 )
      , BadSector( BadSector )
    {
    }
  };

  class TsmTrigger_IProxyReaderClient___Px_CbClosed : public TsmTrigger
  {
  public:
    TsmTrigger_IProxyReaderClient___Px_CbClosed()
      : TsmTrigger( 34 )
    {
    }
  };

  class TsmTrigger_IProxyReaderClient___Px_CbReading : public TsmTrigger
  {
  public:
    TsmTrigger_IProxyReaderClient___Px_CbReading()
      : TsmTrigger( 35 )
    {
    }
  };

  class TsmTrigger_IProxyReaderClient___Px_CbFilled : public TsmTrigger
  {
  public:
    TsmTrigger_IProxyReaderClient___Px_CbFilled()
      : TsmTrigger( 36 )
    {
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > IProxyReaderClient )
  class TsmIPort_IProxyReaderClient : public TsmInterfacePort, public IProxyReaderClient
  {
  public:
    TsmIPort_IProxyReaderClient( TsmBase* oParent )
    {
      TsmName = "IProxyReaderClient";
      TsmParent = oParent;
    }

    void Px_CbOpened()
    {
      bool bDBC;
      TsmTrigger_IProxyReaderClient___Px_CbOpened* tt = new TsmTrigger_IProxyReaderClient___Px_CbOpened;
      TsmRecorder::AddCall( "Px_CbOpened", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Px_CbStopped()
    {
      bool bDBC;
      TsmTrigger_IProxyReaderClient___Px_CbStopped* tt = new TsmTrigger_IProxyReaderClient___Px_CbStopped;
      TsmRecorder::AddCall( "Px_CbStopped", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Px_CbDone()
    {
      bool bDBC;
      TsmTrigger_IProxyReaderClient___Px_CbDone* tt = new TsmTrigger_IProxyReaderClient___Px_CbDone;
      TsmRecorder::AddCall( "Px_CbDone", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Px_CbError( int BadSector )
    {
      bool bDBC;
      TsmTrigger_IProxyReaderClient___Px_CbError* tt = new TsmTrigger_IProxyReaderClient___Px_CbError( BadSector );
      TsmRecorder::AddCall( "Px_CbError", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Px_CbClosed()
    {
      bool bDBC;
      TsmTrigger_IProxyReaderClient___Px_CbClosed* tt = new TsmTrigger_IProxyReaderClient___Px_CbClosed;
      TsmRecorder::AddCall( "Px_CbClosed", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Px_CbReading()
    {
      bool bDBC;
      TsmTrigger_IProxyReaderClient___Px_CbReading* tt = new TsmTrigger_IProxyReaderClient___Px_CbReading;
      TsmRecorder::AddCall( "Px_CbReading", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Px_CbFilled()
    {
      bool bDBC;
      TsmTrigger_IProxyReaderClient___Px_CbFilled* tt = new TsmTrigger_IProxyReaderClient___Px_CbFilled;
      TsmRecorder::AddCall( "Px_CbFilled", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }
  };

  class IProxyDisplayServer
  {
  public:
    virtual void Px_Continue() = 0;
    virtual eRV Px_Pause() = 0;
    virtual void Px_Prepare() = 0;
    virtual void Px_Start() = 0;
    virtual void Px_Stop() = 0;
  };

  class TsmTrigger_IProxyDisplayServer___Px_Continue : public TsmTrigger
  {
  public:
    TsmTrigger_IProxyDisplayServer___Px_Continue()
      : TsmTrigger( 14 )
    {
    }
  };

  class TsmTrigger_IProxyDisplayServer___Px_Pause : public TsmTrigger
  {
  public:
    eRV _RetVal;

    TsmTrigger_IProxyDisplayServer___Px_Pause()
      : TsmTrigger( 15 )
    {
    }
  };

  class TsmTrigger_IProxyDisplayServer___Px_Prepare : public TsmTrigger
  {
  public:
    TsmTrigger_IProxyDisplayServer___Px_Prepare()
      : TsmTrigger( 16 )
    {
    }
  };

  class TsmTrigger_IProxyDisplayServer___Px_Start : public TsmTrigger
  {
  public:
    TsmTrigger_IProxyDisplayServer___Px_Start()
      : TsmTrigger( 17 )
    {
    }
  };

  class TsmTrigger_IProxyDisplayServer___Px_Stop : public TsmTrigger
  {
  public:
    TsmTrigger_IProxyDisplayServer___Px_Stop()
      : TsmTrigger( 18 )
    {
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > IProxyDisplayServer )
  class TsmIPort_IProxyDisplayServer : public TsmInterfacePort, public IProxyDisplayServer
  {
  public:
    TsmIPort_IProxyDisplayServer( TsmBase* oParent )
    {
      TsmName = "IProxyDisplayServer";
      TsmParent = oParent;
    }

    void Px_Continue()
    {
      bool bDBC;
      TsmTrigger_IProxyDisplayServer___Px_Continue* tt = new TsmTrigger_IProxyDisplayServer___Px_Continue;
      TsmRecorder::AddCall( "Px_Continue", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    eRV Px_Pause()
    {
      bool bDBC;
      eRV _RetVal;
      TsmTrigger_IProxyDisplayServer___Px_Pause* tt = new TsmTrigger_IProxyDisplayServer___Px_Pause;
      TsmRecorder::AddCall( "Px_Pause", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      _RetVal = tt->_RetVal;
      if ( bDBC )
      {
        delete tt;
      }
      return _RetVal;
    }

    void Px_Prepare()
    {
      bool bDBC;
      TsmTrigger_IProxyDisplayServer___Px_Prepare* tt = new TsmTrigger_IProxyDisplayServer___Px_Prepare;
      TsmRecorder::AddCall( "Px_Prepare", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Px_Start()
    {
      bool bDBC;
      TsmTrigger_IProxyDisplayServer___Px_Start* tt = new TsmTrigger_IProxyDisplayServer___Px_Start;
      TsmRecorder::AddCall( "Px_Start", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Px_Stop()
    {
      bool bDBC;
      TsmTrigger_IProxyDisplayServer___Px_Stop* tt = new TsmTrigger_IProxyDisplayServer___Px_Stop;
      TsmRecorder::AddCall( "Px_Stop", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }
  };

  class IProxyDisplayClient
  {
  public:
    virtual void Px_CbContinued() = 0;
    virtual void Px_CbFinished() = 0;
    virtual void Px_CbPaused() = 0;
    virtual void Px_CbPrepared() = 0;
    virtual void Px_CbStarted() = 0;
    virtual void Px_CbStopped() = 0;
    virtual void Px_CbSynclost( tTime BadTime ) = 0;
  };

  class TsmTrigger_IProxyDisplayClient___Px_CbContinued : public TsmTrigger
  {
  public:
    TsmTrigger_IProxyDisplayClient___Px_CbContinued()
      : TsmTrigger( 37 )
    {
    }
  };

  class TsmTrigger_IProxyDisplayClient___Px_CbFinished : public TsmTrigger
  {
  public:
    TsmTrigger_IProxyDisplayClient___Px_CbFinished()
      : TsmTrigger( 38 )
    {
    }
  };

  class TsmTrigger_IProxyDisplayClient___Px_CbPaused : public TsmTrigger
  {
  public:
    TsmTrigger_IProxyDisplayClient___Px_CbPaused()
      : TsmTrigger( 39 )
    {
    }
  };

  class TsmTrigger_IProxyDisplayClient___Px_CbPrepared : public TsmTrigger
  {
  public:
    TsmTrigger_IProxyDisplayClient___Px_CbPrepared()
      : TsmTrigger( 40 )
    {
    }
  };

  class TsmTrigger_IProxyDisplayClient___Px_CbStarted : public TsmTrigger
  {
  public:
    TsmTrigger_IProxyDisplayClient___Px_CbStarted()
      : TsmTrigger( 41 )
    {
    }
  };

  class TsmTrigger_IProxyDisplayClient___Px_CbStopped : public TsmTrigger
  {
  public:
    TsmTrigger_IProxyDisplayClient___Px_CbStopped()
      : TsmTrigger( 42 )
    {
    }
  };

  class TsmTrigger_IProxyDisplayClient___Px_CbSynclost : public TsmTrigger
  {
  public:
    tTime BadTime;

    TsmTrigger_IProxyDisplayClient___Px_CbSynclost( tTime BadTime )
      : TsmTrigger( 43 )
      , BadTime( BadTime )
    {
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > IProxyDisplayClient )
  class TsmIPort_IProxyDisplayClient : public TsmInterfacePort, public IProxyDisplayClient
  {
  public:
    TsmIPort_IProxyDisplayClient( TsmBase* oParent )
    {
      TsmName = "IProxyDisplayClient";
      TsmParent = oParent;
    }

    void Px_CbContinued()
    {
      bool bDBC;
      TsmTrigger_IProxyDisplayClient___Px_CbContinued* tt = new TsmTrigger_IProxyDisplayClient___Px_CbContinued;
      TsmRecorder::AddCall( "Px_CbContinued", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Px_CbFinished()
    {
      bool bDBC;
      TsmTrigger_IProxyDisplayClient___Px_CbFinished* tt = new TsmTrigger_IProxyDisplayClient___Px_CbFinished;
      TsmRecorder::AddCall( "Px_CbFinished", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Px_CbPaused()
    {
      bool bDBC;
      TsmTrigger_IProxyDisplayClient___Px_CbPaused* tt = new TsmTrigger_IProxyDisplayClient___Px_CbPaused;
      TsmRecorder::AddCall( "Px_CbPaused", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Px_CbPrepared()
    {
      bool bDBC;
      TsmTrigger_IProxyDisplayClient___Px_CbPrepared* tt = new TsmTrigger_IProxyDisplayClient___Px_CbPrepared;
      TsmRecorder::AddCall( "Px_CbPrepared", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Px_CbStarted()
    {
      bool bDBC;
      TsmTrigger_IProxyDisplayClient___Px_CbStarted* tt = new TsmTrigger_IProxyDisplayClient___Px_CbStarted;
      TsmRecorder::AddCall( "Px_CbStarted", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Px_CbStopped()
    {
      bool bDBC;
      TsmTrigger_IProxyDisplayClient___Px_CbStopped* tt = new TsmTrigger_IProxyDisplayClient___Px_CbStopped;
      TsmRecorder::AddCall( "Px_CbStopped", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Px_CbSynclost( tTime BadTime )
    {
      bool bDBC;
      TsmTrigger_IProxyDisplayClient___Px_CbSynclost* tt = new TsmTrigger_IProxyDisplayClient___Px_CbSynclost( BadTime );
      TsmRecorder::AddCall( "Px_CbSynclost", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }
  };

  class IReaderClient
  {
  public:
    virtual void CbOpened() = 0;
    virtual void CbStopped() = 0;
    virtual void CbDone() = 0;
    virtual void CbError( int Sector ) = 0;
    virtual void CbClosed() = 0;
    virtual void CbReading() = 0;
    virtual void CbFilled() = 0;
  };

  class TsmTrigger_IReaderClient___CbOpened : public TsmTrigger
  {
  public:
    TsmTrigger_IReaderClient___CbOpened()
      : TsmTrigger( 1 )
    {
    }
  };

  class TsmTrigger_IReaderClient___CbStopped : public TsmTrigger
  {
  public:
    TsmTrigger_IReaderClient___CbStopped()
      : TsmTrigger( 2 )
    {
    }
  };

  class TsmTrigger_IReaderClient___CbDone : public TsmTrigger
  {
  public:
    TsmTrigger_IReaderClient___CbDone()
      : TsmTrigger( 3 )
    {
    }
  };

  class TsmTrigger_IReaderClient___CbError : public TsmTrigger
  {
  public:
    int Sector;

    TsmTrigger_IReaderClient___CbError( int Sector )
      : TsmTrigger( 4 )
      , Sector( Sector )
    {
    }
  };

  class TsmTrigger_IReaderClient___CbClosed : public TsmTrigger
  {
  public:
    TsmTrigger_IReaderClient___CbClosed()
      : TsmTrigger( 5 )
    {
    }
  };

  class TsmTrigger_IReaderClient___CbReading : public TsmTrigger
  {
  public:
    TsmTrigger_IReaderClient___CbReading()
      : TsmTrigger( 6 )
    {
    }
  };

  class TsmTrigger_IReaderClient___CbFilled : public TsmTrigger
  {
  public:
    TsmTrigger_IReaderClient___CbFilled()
      : TsmTrigger( 7 )
    {
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > IReaderClient )
  class TsmIPort_IReaderClient : public TsmInterfacePort, public IReaderClient
  {
  public:
    TsmIPort_IReaderClient( TsmBase* oParent )
    {
      TsmName = "IReaderClient";
      TsmParent = oParent;
    }

    void CbOpened()
    {
      bool bDBC;
      TsmTrigger_IReaderClient___CbOpened* tt = new TsmTrigger_IReaderClient___CbOpened;
      TsmRecorder::AddCall( "CbOpened", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void CbStopped()
    {
      bool bDBC;
      TsmTrigger_IReaderClient___CbStopped* tt = new TsmTrigger_IReaderClient___CbStopped;
      TsmRecorder::AddCall( "CbStopped", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void CbDone()
    {
      bool bDBC;
      TsmTrigger_IReaderClient___CbDone* tt = new TsmTrigger_IReaderClient___CbDone;
      TsmRecorder::AddCall( "CbDone", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void CbError( int Sector )
    {
      bool bDBC;
      TsmTrigger_IReaderClient___CbError* tt = new TsmTrigger_IReaderClient___CbError( Sector );
      TsmRecorder::AddCall( "CbError", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void CbClosed()
    {
      bool bDBC;
      TsmTrigger_IReaderClient___CbClosed* tt = new TsmTrigger_IReaderClient___CbClosed;
      TsmRecorder::AddCall( "CbClosed", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void CbReading()
    {
      bool bDBC;
      TsmTrigger_IReaderClient___CbReading* tt = new TsmTrigger_IReaderClient___CbReading;
      TsmRecorder::AddCall( "CbReading", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void CbFilled()
    {
      bool bDBC;
      TsmTrigger_IReaderClient___CbFilled* tt = new TsmTrigger_IReaderClient___CbFilled;
      TsmRecorder::AddCall( "CbFilled", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }
  };

  class IReaderServer
  {
  public:
    virtual void Close() = 0;
    virtual void Stop() = 0;
    virtual eRV Open( int FileHandle ) = 0;
    virtual eRV Read( tChunk* Chunk ) = 0;
    virtual void Clear() = 0;
  };

  class TsmTrigger_IReaderServer___Close : public TsmTrigger
  {
  public:
    TsmTrigger_IReaderServer___Close()
      : TsmTrigger( 44 )
    {
    }
  };

  class TsmTrigger_IReaderServer___Stop : public TsmTrigger
  {
  public:
    TsmTrigger_IReaderServer___Stop()
      : TsmTrigger( 45 )
    {
    }
  };

  class TsmTrigger_IReaderServer___Open : public TsmTrigger
  {
  public:
    int FileHandle;
    eRV _RetVal;

    TsmTrigger_IReaderServer___Open( int FileHandle )
      : TsmTrigger( 46 )
      , FileHandle( FileHandle )
    {
    }
  };

  class TsmTrigger_IReaderServer___Read : public TsmTrigger
  {
  public:
    eRV _RetVal;
    tChunk* Chunk;

    TsmTrigger_IReaderServer___Read( tChunk* Chunk )
      : TsmTrigger( 47 )
      , Chunk( Chunk )
    {
    }
  };

  class TsmTrigger_IReaderServer___Clear : public TsmTrigger
  {
  public:
    TsmTrigger_IReaderServer___Clear()
      : TsmTrigger( 48 )
    {
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > IReaderServer )
  class TsmIPort_IReaderServer : public TsmInterfacePort, public IReaderServer
  {
  public:
    TsmIPort_IReaderServer( TsmBase* oParent )
    {
      TsmName = "IReaderServer";
      TsmParent = oParent;
    }

    void Close()
    {
      bool bDBC;
      TsmTrigger_IReaderServer___Close* tt = new TsmTrigger_IReaderServer___Close;
      TsmRecorder::AddCall( "Close", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Stop()
    {
      bool bDBC;
      TsmTrigger_IReaderServer___Stop* tt = new TsmTrigger_IReaderServer___Stop;
      TsmRecorder::AddCall( "Stop", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    eRV Open( int FileHandle )
    {
      bool bDBC;
      eRV _RetVal;
      TsmTrigger_IReaderServer___Open* tt = new TsmTrigger_IReaderServer___Open( FileHandle );
      TsmRecorder::AddCall( "Open", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      _RetVal = tt->_RetVal;
      if ( bDBC )
      {
        delete tt;
      }
      return _RetVal;
    }

    eRV Read( tChunk* Chunk )
    {
      bool bDBC;
      eRV _RetVal;
      TsmTrigger_IReaderServer___Read* tt = new TsmTrigger_IReaderServer___Read( Chunk );
      TsmRecorder::AddCall( "Read", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      _RetVal = tt->_RetVal;
      if ( bDBC )
      {
        delete tt;
      }
      return _RetVal;
    }

    void Clear()
    {
      bool bDBC;
      TsmTrigger_IReaderServer___Clear* tt = new TsmTrigger_IReaderServer___Clear;
      TsmRecorder::AddCall( "Clear", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }
  };

  class IDisplayClient
  {
  public:
    virtual void CbPrepared() = 0;
    virtual void CbStarted() = 0;
    virtual void CbPaused() = 0;
    virtual void CbContinued() = 0;
    virtual void CbFinished() = 0;
    virtual void CbSynclost( tTime BadTime ) = 0;
    virtual void CbStopped() = 0;
  };

  class TsmTrigger_IDisplayClient___CbPrepared : public TsmTrigger
  {
  public:
    TsmTrigger_IDisplayClient___CbPrepared()
      : TsmTrigger( 19 )
    {
    }
  };

  class TsmTrigger_IDisplayClient___CbStarted : public TsmTrigger
  {
  public:
    TsmTrigger_IDisplayClient___CbStarted()
      : TsmTrigger( 20 )
    {
    }
  };

  class TsmTrigger_IDisplayClient___CbPaused : public TsmTrigger
  {
  public:
    TsmTrigger_IDisplayClient___CbPaused()
      : TsmTrigger( 21 )
    {
    }
  };

  class TsmTrigger_IDisplayClient___CbContinued : public TsmTrigger
  {
  public:
    TsmTrigger_IDisplayClient___CbContinued()
      : TsmTrigger( 22 )
    {
    }
  };

  class TsmTrigger_IDisplayClient___CbFinished : public TsmTrigger
  {
  public:
    TsmTrigger_IDisplayClient___CbFinished()
      : TsmTrigger( 23 )
    {
    }
  };

  class TsmTrigger_IDisplayClient___CbSynclost : public TsmTrigger
  {
  public:
    tTime BadTime;

    TsmTrigger_IDisplayClient___CbSynclost( tTime BadTime )
      : TsmTrigger( 24 )
      , BadTime( BadTime )
    {
    }
  };

  class TsmTrigger_IDisplayClient___CbStopped : public TsmTrigger
  {
  public:
    TsmTrigger_IDisplayClient___CbStopped()
      : TsmTrigger( 25 )
    {
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > IDisplayClient )
  class TsmIPort_IDisplayClient : public TsmInterfacePort, public IDisplayClient
  {
  public:
    TsmIPort_IDisplayClient( TsmBase* oParent )
    {
      TsmName = "IDisplayClient";
      TsmParent = oParent;
    }

    void CbPrepared()
    {
      bool bDBC;
      TsmTrigger_IDisplayClient___CbPrepared* tt = new TsmTrigger_IDisplayClient___CbPrepared;
      TsmRecorder::AddCall( "CbPrepared", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void CbStarted()
    {
      bool bDBC;
      TsmTrigger_IDisplayClient___CbStarted* tt = new TsmTrigger_IDisplayClient___CbStarted;
      TsmRecorder::AddCall( "CbStarted", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void CbPaused()
    {
      bool bDBC;
      TsmTrigger_IDisplayClient___CbPaused* tt = new TsmTrigger_IDisplayClient___CbPaused;
      TsmRecorder::AddCall( "CbPaused", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void CbContinued()
    {
      bool bDBC;
      TsmTrigger_IDisplayClient___CbContinued* tt = new TsmTrigger_IDisplayClient___CbContinued;
      TsmRecorder::AddCall( "CbContinued", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void CbFinished()
    {
      bool bDBC;
      TsmTrigger_IDisplayClient___CbFinished* tt = new TsmTrigger_IDisplayClient___CbFinished;
      TsmRecorder::AddCall( "CbFinished", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void CbSynclost( tTime BadTime )
    {
      bool bDBC;
      TsmTrigger_IDisplayClient___CbSynclost* tt = new TsmTrigger_IDisplayClient___CbSynclost( BadTime );
      TsmRecorder::AddCall( "CbSynclost", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void CbStopped()
    {
      bool bDBC;
      TsmTrigger_IDisplayClient___CbStopped* tt = new TsmTrigger_IDisplayClient___CbStopped;
      TsmRecorder::AddCall( "CbStopped", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }
  };

  class IDisplayServer
  {
  public:
    virtual void Prepare() = 0;
    virtual void Start() = 0;
    virtual eRV Pause() = 0;
    virtual void Continue() = 0;
    virtual void Stop() = 0;
  };

  class TsmTrigger_IDisplayServer___Prepare : public TsmTrigger
  {
  public:
    TsmTrigger_IDisplayServer___Prepare()
      : TsmTrigger( 49 )
    {
    }
  };

  class TsmTrigger_IDisplayServer___Start : public TsmTrigger
  {
  public:
    TsmTrigger_IDisplayServer___Start()
      : TsmTrigger( 50 )
    {
    }
  };

  class TsmTrigger_IDisplayServer___Pause : public TsmTrigger
  {
  public:
    eRV _RetVal;

    TsmTrigger_IDisplayServer___Pause()
      : TsmTrigger( 51 )
    {
    }
  };

  class TsmTrigger_IDisplayServer___Continue : public TsmTrigger
  {
  public:
    TsmTrigger_IDisplayServer___Continue()
      : TsmTrigger( 52 )
    {
    }
  };

  class TsmTrigger_IDisplayServer___Stop : public TsmTrigger
  {
  public:
    TsmTrigger_IDisplayServer___Stop()
      : TsmTrigger( 53 )
    {
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > IDisplayServer )
  class TsmIPort_IDisplayServer : public TsmInterfacePort, public IDisplayServer
  {
  public:
    TsmIPort_IDisplayServer( TsmBase* oParent )
    {
      TsmName = "IDisplayServer";
      TsmParent = oParent;
    }

    void Prepare()
    {
      bool bDBC;
      TsmTrigger_IDisplayServer___Prepare* tt = new TsmTrigger_IDisplayServer___Prepare;
      TsmRecorder::AddCall( "Prepare", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Start()
    {
      bool bDBC;
      TsmTrigger_IDisplayServer___Start* tt = new TsmTrigger_IDisplayServer___Start;
      TsmRecorder::AddCall( "Start", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    eRV Pause()
    {
      bool bDBC;
      eRV _RetVal;
      TsmTrigger_IDisplayServer___Pause* tt = new TsmTrigger_IDisplayServer___Pause;
      TsmRecorder::AddCall( "Pause", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      _RetVal = tt->_RetVal;
      if ( bDBC )
      {
        delete tt;
      }
      return _RetVal;
    }

    void Continue()
    {
      bool bDBC;
      TsmTrigger_IDisplayServer___Continue* tt = new TsmTrigger_IDisplayServer___Continue;
      TsmRecorder::AddCall( "Continue", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Stop()
    {
      bool bDBC;
      TsmTrigger_IDisplayServer___Stop* tt = new TsmTrigger_IDisplayServer___Stop;
      TsmRecorder::AddCall( "Stop", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }
  };

  class ITitlebaseServer
  {
  public:
    virtual int OpenTitle( string TitleId ) = 0;
    virtual void CloseTitle() = 0;
    virtual eRV SetTime( tTime& AtTime ) = 0;
    virtual eRV GetChunk( tChunk& NewChunk ) = 0;
    virtual void ReportReadError( int BadSector ) = 0;
    virtual void ReportSynclost( tTime& BadTime ) = 0;
    virtual eRV GetResult() = 0;
  };

  class TsmTrigger_ITitlebaseServer___OpenTitle : public TsmTrigger
  {
  public:
    string TitleId;
    int _RetVal;

    TsmTrigger_ITitlebaseServer___OpenTitle( string TitleId )
      : TsmTrigger( 54 )
      , TitleId( TitleId )
    {
    }
  };

  class TsmTrigger_ITitlebaseServer___CloseTitle : public TsmTrigger
  {
  public:
    TsmTrigger_ITitlebaseServer___CloseTitle()
      : TsmTrigger( 55 )
    {
    }
  };

  class TsmTrigger_ITitlebaseServer___SetTime : public TsmTrigger
  {
  public:
    tTime& AtTime;
    eRV _RetVal;

    TsmTrigger_ITitlebaseServer___SetTime( tTime& AtTime )
      : TsmTrigger( 56 )
      , AtTime( AtTime )
    {
    }
  };

  class TsmTrigger_ITitlebaseServer___GetChunk : public TsmTrigger
  {
  public:
    tChunk& NewChunk;
    eRV _RetVal;

    TsmTrigger_ITitlebaseServer___GetChunk( tChunk& NewChunk )
      : TsmTrigger( 57 )
      , NewChunk( NewChunk )
    {
    }
  };

  class TsmTrigger_ITitlebaseServer___ReportReadError : public TsmTrigger
  {
  public:
    int BadSector;

    TsmTrigger_ITitlebaseServer___ReportReadError( int BadSector )
      : TsmTrigger( 58 )
      , BadSector( BadSector )
    {
    }
  };

  class TsmTrigger_ITitlebaseServer___ReportSynclost : public TsmTrigger
  {
  public:
    tTime& BadTime;

    TsmTrigger_ITitlebaseServer___ReportSynclost( tTime& BadTime )
      : TsmTrigger( 59 )
      , BadTime( BadTime )
    {
    }
  };

  class TsmTrigger_ITitlebaseServer___GetResult : public TsmTrigger
  {
  public:
    eRV _RetVal;

    TsmTrigger_ITitlebaseServer___GetResult()
      : TsmTrigger( 60 )
    {
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > ITitlebaseServer )
  class TsmIPort_ITitlebaseServer : public TsmInterfacePort, public ITitlebaseServer
  {
  public:
    TsmIPort_ITitlebaseServer( TsmBase* oParent )
    {
      TsmName = "ITitlebaseServer";
      TsmParent = oParent;
    }

    int OpenTitle( string TitleId )
    {
      bool bDBC;
      int _RetVal;
      TsmTrigger_ITitlebaseServer___OpenTitle* tt = new TsmTrigger_ITitlebaseServer___OpenTitle( TitleId );
      TsmRecorder::AddCall( "OpenTitle", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      _RetVal = tt->_RetVal;
      if ( bDBC )
      {
        delete tt;
      }
      return _RetVal;
    }

    void CloseTitle()
    {
      bool bDBC;
      TsmTrigger_ITitlebaseServer___CloseTitle* tt = new TsmTrigger_ITitlebaseServer___CloseTitle;
      TsmRecorder::AddCall( "CloseTitle", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    eRV SetTime( tTime& AtTime )
    {
      bool bDBC;
      eRV _RetVal;
      TsmTrigger_ITitlebaseServer___SetTime* tt = new TsmTrigger_ITitlebaseServer___SetTime( AtTime );
      TsmRecorder::AddCall( "SetTime", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      _RetVal = tt->_RetVal;
      if ( bDBC )
      {
        delete tt;
      }
      return _RetVal;
    }

    eRV GetChunk( tChunk& NewChunk )
    {
      bool bDBC;
      eRV _RetVal;
      TsmTrigger_ITitlebaseServer___GetChunk* tt = new TsmTrigger_ITitlebaseServer___GetChunk( NewChunk );
      TsmRecorder::AddCall( "GetChunk", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      _RetVal = tt->_RetVal;
      if ( bDBC )
      {
        delete tt;
      }
      return _RetVal;
    }

    void ReportReadError( int BadSector )
    {
      bool bDBC;
      TsmTrigger_ITitlebaseServer___ReportReadError* tt = new TsmTrigger_ITitlebaseServer___ReportReadError( BadSector );
      TsmRecorder::AddCall( "ReportReadError", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void ReportSynclost( tTime& BadTime )
    {
      bool bDBC;
      TsmTrigger_ITitlebaseServer___ReportSynclost* tt = new TsmTrigger_ITitlebaseServer___ReportSynclost( BadTime );
      TsmRecorder::AddCall( "ReportSynclost", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    eRV GetResult()
    {
      bool bDBC;
      eRV _RetVal;
      TsmTrigger_ITitlebaseServer___GetResult* tt = new TsmTrigger_ITitlebaseServer___GetResult;
      TsmRecorder::AddCall( "GetResult", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      _RetVal = tt->_RetVal;
      if ( bDBC )
      {
        delete tt;
      }
      return _RetVal;
    }
  };

  class IPlayerClient
  {
  public:
    virtual void CbStarted() = 0;
    virtual void CbPaused() = 0;
    virtual void CbContinued() = 0;
    virtual void CbStopped() = 0;
    virtual void CbFinish() = 0;
    virtual void CbError() = 0;
  };

  class TsmTrigger_IPlayerClient___CbStarted : public TsmTrigger
  {
  public:
    TsmTrigger_IPlayerClient___CbStarted()
      : TsmTrigger( 61 )
    {
    }
  };

  class TsmTrigger_IPlayerClient___CbPaused : public TsmTrigger
  {
  public:
    TsmTrigger_IPlayerClient___CbPaused()
      : TsmTrigger( 62 )
    {
    }
  };

  class TsmTrigger_IPlayerClient___CbContinued : public TsmTrigger
  {
  public:
    TsmTrigger_IPlayerClient___CbContinued()
      : TsmTrigger( 63 )
    {
    }
  };

  class TsmTrigger_IPlayerClient___CbStopped : public TsmTrigger
  {
  public:
    TsmTrigger_IPlayerClient___CbStopped()
      : TsmTrigger( 64 )
    {
    }
  };

  class TsmTrigger_IPlayerClient___CbFinish : public TsmTrigger
  {
  public:
    TsmTrigger_IPlayerClient___CbFinish()
      : TsmTrigger( 65 )
    {
    }
  };

  class TsmTrigger_IPlayerClient___CbError : public TsmTrigger
  {
  public:
    TsmTrigger_IPlayerClient___CbError()
      : TsmTrigger( 66 )
    {
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > IPlayerClient )
  class TsmIPort_IPlayerClient : public TsmInterfacePort, public IPlayerClient
  {
  public:
    TsmIPort_IPlayerClient( TsmBase* oParent )
    {
      TsmName = "IPlayerClient";
      TsmParent = oParent;
    }

    void CbStarted()
    {
      bool bDBC;
      TsmTrigger_IPlayerClient___CbStarted* tt = new TsmTrigger_IPlayerClient___CbStarted;
      TsmRecorder::AddCall( "CbStarted", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void CbPaused()
    {
      bool bDBC;
      TsmTrigger_IPlayerClient___CbPaused* tt = new TsmTrigger_IPlayerClient___CbPaused;
      TsmRecorder::AddCall( "CbPaused", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void CbContinued()
    {
      bool bDBC;
      TsmTrigger_IPlayerClient___CbContinued* tt = new TsmTrigger_IPlayerClient___CbContinued;
      TsmRecorder::AddCall( "CbContinued", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void CbStopped()
    {
      bool bDBC;
      TsmTrigger_IPlayerClient___CbStopped* tt = new TsmTrigger_IPlayerClient___CbStopped;
      TsmRecorder::AddCall( "CbStopped", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void CbFinish()
    {
      bool bDBC;
      TsmTrigger_IPlayerClient___CbFinish* tt = new TsmTrigger_IPlayerClient___CbFinish;
      TsmRecorder::AddCall( "CbFinish", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void CbError()
    {
      bool bDBC;
      TsmTrigger_IPlayerClient___CbError* tt = new TsmTrigger_IPlayerClient___CbError;
      TsmRecorder::AddCall( "CbError", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }
  };

  class IPlayerServer
  {
  public:
    virtual eRV Start( string TitleId, tTime* AtTime ) = 0;
    virtual eRV Pause() = 0;
    virtual eRV Continue() = 0;
    virtual void Stop() = 0;
  };

  class TsmTrigger_IPlayerServer___Start : public TsmTrigger
  {
  public:
    string TitleId;
    tTime* AtTime;
    eRV _RetVal;

    TsmTrigger_IPlayerServer___Start( string TitleId, tTime* AtTime )
      : TsmTrigger( 26 )
      , TitleId( TitleId )
      , AtTime( AtTime )
    {
    }
  };

  class TsmTrigger_IPlayerServer___Pause : public TsmTrigger
  {
  public:
    eRV _RetVal;

    TsmTrigger_IPlayerServer___Pause()
      : TsmTrigger( 27 )
    {
    }
  };

  class TsmTrigger_IPlayerServer___Continue : public TsmTrigger
  {
  public:
    eRV _RetVal;

    TsmTrigger_IPlayerServer___Continue()
      : TsmTrigger( 28 )
    {
    }
  };

  class TsmTrigger_IPlayerServer___Stop : public TsmTrigger
  {
  public:
    TsmTrigger_IPlayerServer___Stop()
      : TsmTrigger( 29 )
    {
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > IPlayerServer )
  class TsmIPort_IPlayerServer : public TsmInterfacePort, public IPlayerServer
  {
  public:
    TsmIPort_IPlayerServer( TsmBase* oParent )
    {
      TsmName = "IPlayerServer";
      TsmParent = oParent;
    }

    eRV Start( string TitleId, tTime* AtTime )
    {
      bool bDBC;
      eRV _RetVal;
      TsmTrigger_IPlayerServer___Start* tt = new TsmTrigger_IPlayerServer___Start( TitleId, AtTime );
      TsmRecorder::AddCall( "Start", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      _RetVal = tt->_RetVal;
      if ( bDBC )
      {
        delete tt;
      }
      return _RetVal;
    }

    eRV Pause()
    {
      bool bDBC;
      eRV _RetVal;
      TsmTrigger_IPlayerServer___Pause* tt = new TsmTrigger_IPlayerServer___Pause;
      TsmRecorder::AddCall( "Pause", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      _RetVal = tt->_RetVal;
      if ( bDBC )
      {
        delete tt;
      }
      return _RetVal;
    }

    eRV Continue()
    {
      bool bDBC;
      eRV _RetVal;
      TsmTrigger_IPlayerServer___Continue* tt = new TsmTrigger_IPlayerServer___Continue;
      TsmRecorder::AddCall( "Continue", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      _RetVal = tt->_RetVal;
      if ( bDBC )
      {
        delete tt;
      }
      return _RetVal;
    }

    void Stop()
    {
      bool bDBC;
      TsmTrigger_IPlayerServer___Stop* tt = new TsmTrigger_IPlayerServer___Stop;
      TsmRecorder::AddCall( "Stop", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }
  };
}
#endif
