/*
 * TismTool © Tis Veugen, 2010-2011
 * Simulation, Verification
 *
 * TsmPCPort.h
 * version 3
 */
#ifndef TSM_PCPORT_H
#define TSM_PCPORT_H

#include "TsmPort.h"
#include "TsmIntQueue.h"
#include "TsmTrigger.h"
#include "TsmEnvelope.h"
using namespace std;

namespace TsmRTE
{
  /**
   * Passive Client Port
   */
  class TsmPCPort : public TsmPort
  {
  private:
    TsmIntQueue* mIntQueue;

  public:
    void setIntQueue( TsmIntQueue* oIntQueue )
    {
      mIntQueue = oIntQueue;
    }

    bool Handle( TsmTrigger* oTrigger )
    {
      TsmEnvelope lEnvelope( oTrigger, Target );
      oTrigger->SetDBU();
      mIntQueue->Put( lEnvelope );
      return false;
    }

    string ToSeq()
    {
      stringstream sb;
      sb << "I," << mIntQueue->getSeqId();
      return sb.str();
    }
  };
}
#endif
