/*
 * File: TsmSystem.h
 * Date: 19 aug 2011
 * Time: 19:20:44
 * Generated by TismTool version 0.7
 */

/*
 * Overview of identifications
 * ---------------------------
 * Ports:
 *     25 ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > rp_reader )
 *     26 ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ppp_reader )
 *     88 ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ppp_display )
 *     89 ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > rp_display )
 *    155 ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > pp_player )
 *    156 ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > rpp_reader )
 *    157 ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > rpp_display )
 *    532 ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > Port )
 *    588 ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > Port )
 *    666 ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > Port )
 *    722 ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > Port )
 *    808 ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > Port )
 *    850 ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > Port )
 *    890 ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > Port )
 *    939 ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > Port )
 *   1013 ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > Port )
 *   1045 ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > Port )
 *   1083 ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > Port )
 * Triggers:
 *      1 void IReaderClient___CbOpened()
 *      2 void IReaderClient___CbStopped()
 *      3 void IReaderClient___CbDone()
 *      4 void IReaderClient___CbError( int Sector )
 *      5 void IReaderClient___CbClosed()
 *      6 void IReaderClient___CbReading()
 *      7 void IReaderClient___CbFilled()
 *      8 eRV IProxyReaderServer___Px_Open( int FileHandle )
 *      9 void IProxyReaderServer___Px_Close()
 *     10 void IProxyReaderServer___Px_Stop()
 *     11 void IProxyReaderServer___Px_Clear()
 *     12 eRV IProxyReaderServer___Px_Read( tChunk* Chunk )
 *     13 void IProxyReaderServer___Px_IsFilled()
 *     14 void IProxyDisplayServer___Px_Continue()
 *     15 eRV IProxyDisplayServer___Px_Pause()
 *     16 void IProxyDisplayServer___Px_Prepare()
 *     17 void IProxyDisplayServer___Px_Start()
 *     18 void IProxyDisplayServer___Px_Stop()
 *     19 void IDisplayClient___CbPrepared()
 *     20 void IDisplayClient___CbStarted()
 *     21 void IDisplayClient___CbPaused()
 *     22 void IDisplayClient___CbContinued()
 *     23 void IDisplayClient___CbFinished()
 *     24 void IDisplayClient___CbSynclost( tTime BadTime )
 *     25 void IDisplayClient___CbStopped()
 *     26 eRV IPlayerServer___Start( String TitleId, tTime* AtTime )
 *     27 eRV IPlayerServer___Pause()
 *     28 eRV IPlayerServer___Continue()
 *     29 void IPlayerServer___Stop()
 *     30 void IProxyReaderClient___Px_CbOpened()
 *     31 void IProxyReaderClient___Px_CbStopped()
 *     32 void IProxyReaderClient___Px_CbDone()
 *     33 void IProxyReaderClient___Px_CbError( int BadSector )
 *     34 void IProxyReaderClient___Px_CbClosed()
 *     35 void IProxyReaderClient___Px_CbReading()
 *     36 void IProxyReaderClient___Px_CbFilled()
 *     37 void IProxyDisplayClient___Px_CbContinued()
 *     38 void IProxyDisplayClient___Px_CbFinished()
 *     39 void IProxyDisplayClient___Px_CbPaused()
 *     40 void IProxyDisplayClient___Px_CbPrepared()
 *     41 void IProxyDisplayClient___Px_CbStarted()
 *     42 void IProxyDisplayClient___Px_CbStopped()
 *     43 void IProxyDisplayClient___Px_CbSynclost( tTime BadTime )
 *     44 void IReaderServer___Close()
 *     45 void IReaderServer___Stop()
 *     46 eRV IReaderServer___Open( int FileHandle )
 *     47 eRV IReaderServer___Read( tChunk* Chunk )
 *     48 void IReaderServer___Clear()
 *     49 void IDisplayServer___Prepare()
 *     50 void IDisplayServer___Start()
 *     51 eRV IDisplayServer___Pause()
 *     52 void IDisplayServer___Continue()
 *     53 void IDisplayServer___Stop()
 *     54 int ITitlebaseServer___OpenTitle( String TitleId )
 *     55 void ITitlebaseServer___CloseTitle()
 *     56 eRV ITitlebaseServer___SetTime( tTime& AtTime )
 *     57 eRV ITitlebaseServer___GetChunk( tChunk& NewChunk )
 *     58 void ITitlebaseServer___ReportReadError( int BadSector )
 *     59 void ITitlebaseServer___ReportSynclost( tTime& BadTime )
 *     60 eRV ITitlebaseServer___GetResult()
 *     61 void IPlayerClient___CbStarted()
 *     62 void IPlayerClient___CbPaused()
 *     63 void IPlayerClient___CbContinued()
 *     64 void IPlayerClient___CbStopped()
 *     65 void IPlayerClient___CbFinish()
 *     66 void IPlayerClient___CbError()
 * Natives:
 *    556 ( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough ) ->
 *        ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough )
 *        Px_CbFilled();
 *    557 ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough ) ->
 *        ( ProxyReaderServerPsm >> CompoundState >> Open )
 *        Px_CbDone();
 *    565 ( ProxyReaderServerPsm >> CompoundState >> Reading ) ->
 *        ( ProxyReaderServerPsm >> CompoundState >> Error )
 *        Px_CbError( BadSector );
 *    576 ( ProxyReaderServerPsm >> Opening ) ->
 *        ( ProxyReaderServerPsm >> CompoundState >> Open )
 *        Px_CbOpened();
 *    579 ( ProxyReaderServerPsm >> Stopping ) ->
 *        ( ProxyReaderServerPsm >> CompoundState >> Open )
 *        Px_CbStopped();
 *    581 ( ProxyReaderServerPsm >> Seeking ) ->
 *        ( ProxyReaderServerPsm >> CompoundState >> Reading )
 *        Px_CbReading();
 *    585 ( ProxyReaderServerPsm >> Closing ) ->
 *        ( ProxyReaderServerPsm >> Idle )
 *        Px_CbClosed();
 *   -618 ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) ->
 *        ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
 *        RV=Px_Read( &Chunk );
 *   -620 ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough ) ->
 *        ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
 *        Px_IsFilled();
 *   -622 ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) ->
 *        ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
 *        Px_IsFilled();
 *   -627 ( ProxyReaderClientPsm >> CompoundState >> Open ) ->
 *        ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )
 *        RV=Px_Open( FileHandle );
 *   -628 ( ProxyReaderClientPsm >> CompoundState >> Open ) ->
 *        ( ProxyReaderClientPsm >> ChoiceState )
 *        Px_Close();
 *   -629 ( ProxyReaderClientPsm >> CompoundState >> Open ) ->
 *        ( ProxyReaderClientPsm >> CompoundState >> Open )
 *        Px_Clear();
 *   -630 ( ProxyReaderClientPsm >> CompoundState >> Open ) ->
 *        ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )
 *        RV=Px_Read( &Chunk );
 *   -642 ( ProxyReaderClientPsm >> Idle ) ->
 *        ( ProxyReaderClientPsm >> ChoiceState )
 *        Px_Close();
 *   -645 ( ProxyReaderClientPsm >> Closing ) ->
 *        ( ProxyReaderClientPsm >> ChoiceState )
 *        Px_Close();
 *   -646 ( ProxyReaderClientPsm >> Opening ) ->
 *        ( ProxyReaderClientPsm >> ChoiceState )
 *        RV=Px_Open( FileHandle );
 *   -648 ( ProxyReaderClientPsm >> CompoundState ) ->
 *        ( ProxyReaderClientPsm >> ChoiceState )
 *        Px_Stop();
 *   -650 ( ProxyReaderClientPsm >> Stopping ) ->
 *        ( ProxyReaderClientPsm >> ChoiceState )
 *        Px_Stop();
 *   -651 ( ProxyReaderClientPsm >> Opening ) ->
 *        ( ProxyReaderClientPsm >> ChoiceState )
 *        Px_Close();
 *   -655 ( ProxyReaderClientPsm >> Seeking ) ->
 *        ( ProxyReaderClientPsm >> ChoiceState )
 *        Px_Stop();
 *   -660 ( ProxyReaderClientPsm >> Seeking ) ->
 *        ( ProxyReaderClientPsm >> ChoiceState )
 *        RV=Px_Read( &Chunk );
 *   -662 ( ProxyReaderClientPsm >> Idle ) ->
 *        ( ProxyReaderClientPsm >> ChoiceState )
 *        RV=Px_Open( FileHandle );
 *    681 ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing ) ->
 *        ( ProxyDisplayServerPsm >> CompoundState >> Paused )
 *        Px_CbPaused();
 *    683 ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing ) ->
 *        ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
 *        Px_CbContinued();
 *    700 ( ProxyDisplayServerPsm >> CompoundState >> Preparing ) ->
 *        ( ProxyDisplayServerPsm >> CompoundState >> Ready )
 *        Px_CbPrepared();
 *    707 ( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) ->
 *        ( ProxyDisplayServerPsm >> CompoundState >> Paused )
 *        Px_CbPaused();
 *    709 ( ProxyDisplayServerPsm >> CompoundState >> Starting ) ->
 *        ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
 *        Px_CbStarted();
 *    711 ( ProxyDisplayServerPsm >> CompoundState >> CompoundState ) ->
 *        ( ProxyDisplayServerPsm >> CompoundState >> Finishing )
 *        Px_CbFinished();
 *    712 ( ProxyDisplayServerPsm >> CompoundState >> Starting ) ->
 *        ( ProxyDisplayServerPsm >> CompoundState >> JuncState )
 *        Px_CbSynclost( BadTime );
 *    713 ( ProxyDisplayServerPsm >> CompoundState >> CompoundState ) ->
 *        ( ProxyDisplayServerPsm >> CompoundState >> JuncState )
 *        Px_CbSynclost( BadTime );
 *    714 ( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) ->
 *        ( ProxyDisplayServerPsm >> CompoundState >> JuncState )
 *        Px_CbSynclost( BadTime );
 *    720 ( ProxyDisplayServerPsm >> Stopping ) ->
 *        ( ProxyDisplayServerPsm >> CompoundState )
 *        Px_CbStopped();
 *   -746 ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
 *        Px_Start();
 *   -748 ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
 *        RV=Px_Pause();
 *   -751 ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
 *        Px_Continue();
 *   -753 ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
 *        Px_Continue();
 *   -755 ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
 *        RV=Px_Pause();
 *   -774 ( ProxyDisplayClientPsm >> CompoundState >> Idle ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
 *        Px_Prepare();
 *   -776 ( ProxyDisplayClientPsm >> CompoundState >> Ready ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
 *        Px_Prepare();
 *   -778 ( ProxyDisplayClientPsm >> CompoundState >> Ready ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
 *        Px_Start();
 *   -780 ( ProxyDisplayClientPsm >> CompoundState >> Starting ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
 *        Px_Start();
 *   -781 ( ProxyDisplayClientPsm >> CompoundState >> Ready ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
 *        RV=Px_Pause();
 *   -783 ( ProxyDisplayClientPsm >> CompoundState >> StartPausing ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
 *        RV=Px_Pause();
 *   -787 ( ProxyDisplayClientPsm >> CompoundState >> Paused ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
 *        RV=Px_Pause();
 *   -788 ( ProxyDisplayClientPsm >> CompoundState >> Paused ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
 *        Px_Continue();
 *   -789 ( ProxyDisplayClientPsm >> CompoundState >> Preparing ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
 *        Px_Prepare();
 *   -793 ( ProxyDisplayClientPsm >> CompoundState ) ->
 *        ( ProxyDisplayClientPsm >> ChoiceState )
 *        Px_Stop();
 *   -795 ( ProxyDisplayClientPsm >> Stopping ) ->
 *        ( ProxyDisplayClientPsm >> ChoiceState )
 *        Px_Stop();
 *   -825 ( ReaderClientPsm >> CompoundState >> Open ) ->
 *        ( ReaderClientPsm >> CompoundState >> Open )
 *        Clear();
 *   -826 ( ReaderClientPsm >> CompoundState >> Open ) ->
 *        ( ReaderClientPsm >> Closing )
 *        Close();
 *   -829 ( ReaderClientPsm >> CompoundState >> Open ) ->
 *        ( ReaderClientPsm >> CompoundState >> ChoiceState )
 *        RV=Read( &Chunk );
 *   -839 ( ReaderClientPsm >> CompoundState ) ->
 *        ( ReaderClientPsm >> Stopping )
 *        Stop();
 *   -842 ( ReaderClientPsm >> Idle ) ->
 *        ( ReaderClientPsm >> ChoiceState )
 *        RV=Open( FileHandle );
 *    863 ( ReaderServerPsm >> CompoundState >> Reading >> NotEnough ) ->
 *        ( ReaderServerPsm >> CompoundState >> Reading >> Enough )
 *        CbFilled();
 *    868 ( ReaderServerPsm >> CompoundState >> Reading >> Enough ) ->
 *        ( ReaderServerPsm >> CompoundState >> Open )
 *        CbDone();
 *    869 ( ReaderServerPsm >> CompoundState >> Reading ) ->
 *        ( ReaderServerPsm >> CompoundState >> Error )
 *        CbError( Sector );
 *    879 ( ReaderServerPsm >> Opening ) ->
 *        ( ReaderServerPsm >> CompoundState >> Open )
 *        CbOpened();
 *    880 ( ReaderServerPsm >> Seeking ) ->
 *        ( ReaderServerPsm >> CompoundState >> Reading )
 *        CbReading();
 *    881 ( ReaderServerPsm >> Stopping ) ->
 *        ( ReaderServerPsm >> CompoundState >> Open )
 *        CbStopped();
 *    882 ( ReaderServerPsm >> Closing ) ->
 *        ( ReaderServerPsm >> Idle )
 *        CbClosed();
 *   -903 ( DisplayClientPsm >> CompoundState >> CompoundState >> Play ) ->
 *        ( DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
 *        RV=Pause();
 *   -917 ( DisplayClientPsm >> CompoundState >> Ready ) ->
 *        ( DisplayClientPsm >> CompoundState >> Starting )
 *        Start();
 *   -918 ( DisplayClientPsm >> CompoundState >> Ready ) ->
 *        ( DisplayClientPsm >> CompoundState >> StartPausing )
 *        RV=Pause();#TSM_ASSERT(RV==eRV.OK);
 *   -920 ( DisplayClientPsm >> CompoundState >> Idle ) ->
 *        ( DisplayClientPsm >> CompoundState >> Preparing )
 *        Prepare();
 *   -921 ( DisplayClientPsm >> CompoundState >> Paused ) ->
 *        ( DisplayClientPsm >> CompoundState >> CompoundState >> Continuing )
 *        Continue();
 *   -930 ( DisplayClientPsm >> CompoundState ) ->
 *        ( DisplayClientPsm >> Stopping )
 *        Stop();
 *    952 ( DisplayServerPsm >> Active >> Busy >> Pausing ) ->
 *        ( DisplayServerPsm >> Active >> Paused )
 *        CbPaused();
 *    953 ( DisplayServerPsm >> Active >> Busy >> Continuing ) ->
 *        ( DisplayServerPsm >> Active >> Busy >> Play )
 *        CbContinued();
 *    965 ( DisplayServerPsm >> Active >> Preparing ) ->
 *        ( DisplayServerPsm >> Active >> Ready )
 *        CbPrepared();
 *    967 ( DisplayServerPsm >> Active >> Starting ) ->
 *        ( DisplayServerPsm >> Active >> Busy >> Play )
 *        CbStarted();
 *    968 ( DisplayServerPsm >> Active >> Starting ) ->
 *        ( DisplayServerPsm >> Active >> Synclost )
 *        CbSynclost( BadTime );
 *    970 ( DisplayServerPsm >> Active >> StartPausing ) ->
 *        ( DisplayServerPsm >> Active >> Synclost )
 *        CbSynclost( BadTime );
 *    971 ( DisplayServerPsm >> Active >> StartPausing ) ->
 *        ( DisplayServerPsm >> Active >> Paused )
 *        CbPaused();
 *    974 ( DisplayServerPsm >> Active >> Busy ) ->
 *        ( DisplayServerPsm >> Active >> Synclost )
 *        CbSynclost( BadTime );
 *    975 ( DisplayServerPsm >> Active >> Busy ) ->
 *        ( DisplayServerPsm >> Active >> Finishing )
 *        CbFinished();
 *    978 ( DisplayServerPsm >> Stopping ) ->
 *        ( DisplayServerPsm >> Active )
 *        CbStopped();
 *   -996 ( TbClientPsm >> CompoundState >> Play ) ->
 *        ( TbClientPsm >> CompoundState >> Play )
 *        ReportReadError( BadSector );
 *   -997 ( TbClientPsm >> CompoundState >> Play ) ->
 *        ( TbClientPsm >> CompoundState >> ChoiceState )
 *        RV=GetChunk(Chunk);
 *   -998 ( TbClientPsm >> CompoundState ) ->
 *        ( TbClientPsm >> Idle )
 *        CloseTitle();
 *   -999 ( TbClientPsm >> CompoundState >> Play ) ->
 *        ( TbClientPsm >> CompoundState >> Play )
 *        ReportSynclost( BadTime );
 *  -1000 ( TbClientPsm >> CompoundState >> Ready ) ->
 *        ( TbClientPsm >> CompoundState >> ChoiceState )
 *        RV=SetTime( AtTime );
 *  -1003 ( TbClientPsm >> CompoundState >> End ) ->
 *        ( TbClientPsm >> CompoundState >> ChoiceState )
 *        RV=GetResult();
 *  -1009 ( TbClientPsm >> Idle ) ->
 *        ( TbClientPsm >> ChoiceState )
 *        FileHandle=OpenTitle(TitleId);
 *   1059 ( PlayerServerPsm >> Active >> Running >> Busy >> Pausing ) ->
 *        ( PlayerServerPsm >> Active >> Running >> Paused )
 *        CbPaused();
 *   1061 ( PlayerServerPsm >> Active >> Running >> Busy >> Continuing ) ->
 *        ( PlayerServerPsm >> Active >> Running >> Busy >> Play )
 *        CbContinued();
 *   1063 ( PlayerServerPsm >> Active >> Running >> Busy ) ->
 *        ( PlayerServerPsm >> Active >> Finishing )
 *        CbFinish();
 *   1070 ( PlayerServerPsm >> Active >> Starting ) ->
 *        ( PlayerServerPsm >> Active >> Running >> Busy >> Play )
 *        CbStarted();
 *   1071 ( PlayerServerPsm >> Active >> Running ) ->
 *        ( PlayerServerPsm >> Active >> Error )
 *        CbError();
 *   1072 ( PlayerServerPsm >> Active >> Starting ) ->
 *        ( PlayerServerPsm >> Active >> Error )
 *        CbError();
 *   1079 ( PlayerServerPsm >> Stopping ) ->
 *        ( PlayerServerPsm >> Idle )
 *        CbStopped();
 *  -1100 ( PlayerClientPsm >> Active >> Running >> Busy >> Play ) ->
 *        ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )
 *        RV=Pause();
 *  -1108 ( PlayerClientPsm >> Active >> Running >> Paused ) ->
 *        ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )
 *        RV=Continue();
 *  -1123 ( PlayerClientPsm >> Idle ) ->
 *        ( PlayerClientPsm >> ChoiceState )
 *        RV=Start(TitleId,&AtTime);
 *  -1124 ( PlayerClientPsm >> Active ) ->
 *        ( PlayerClientPsm >> Stopping )
 *        Stop();
 */

#ifndef TSM_SYSTEM_H
#define TSM_SYSTEM_H

#include "TsmIncludes.h"
#include "TsmInterfaces.h"
#include "TsmDefs.h"
using namespace std;
using namespace TsmRTE;

namespace MediaPlayer
{
  /********************************************************************
   * PACKAGE: ( Xmi > UML Standard Profile > MagicDraw Profile > datatypes )
   ********************************************************************/

   // ( Xmi > UML Standard Profile > MagicDraw Profile > datatypes )
  class Pac_0002_0003 : public TsmPackage
  {
  public:
    Pac_0002_0003( TsmBase* oParent )
    {
      TsmName = "datatypes";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > UML Standard Profile > MagicDraw Profile )
   ********************************************************************/

   // ( Xmi > UML Standard Profile > MagicDraw Profile )
  class Pac_0001_0002 : public TsmPackage
  {
  public:
    Pac_0001_0002( TsmBase* oParent )
    {
      TsmName = "MagicDraw Profile";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > UML Standard Profile > StandardProfileL2 )
   ********************************************************************/

   // ( Xmi > UML Standard Profile > StandardProfileL2 )
  class Pac_0001_0004 : public TsmPackage
  {
  public:
    Pac_0001_0004( TsmBase* oParent )
    {
      TsmName = "StandardProfileL2";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > UML Standard Profile > StandardProfileL3 )
   ********************************************************************/

   // ( Xmi > UML Standard Profile > StandardProfileL3 )
  class Pac_0001_0005 : public TsmPackage
  {
  public:
    Pac_0001_0005( TsmBase* oParent )
    {
      TsmName = "StandardProfileL3";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Repository > User > User )
  class Com_0008_0009 : public TsmPComponent
  {
  public:
    Com_0008_0009( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository > User )
   ********************************************************************/

   // ( Xmi > Data > Repository > User )
  class Pac_0007_0008 : public TsmPackage
  {
  public:
    Pac_0007_0008( TsmBase* oParent )
    {
      TsmName = "User";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Repository > Titlebase > Titlebase )
  class Com_0010_0011 : public TsmPComponent
  {
  public:
    Com_0010_0011( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository > Titlebase )
   ********************************************************************/

   // ( Xmi > Data > Repository > Titlebase )
  class Pac_0007_0010 : public TsmPackage
  {
  public:
    Pac_0007_0010( TsmBase* oParent )
    {
      TsmName = "Titlebase";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Repository > Reader > Reader )
  class Com_0012_0013 : public TsmPComponent
  {
  public:
    Com_0012_0013( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository > Reader )
   ********************************************************************/

   // ( Xmi > Data > Repository > Reader )
  class Pac_0007_0012 : public TsmPackage
  {
  public:
    Pac_0007_0012( TsmBase* oParent )
    {
      TsmName = "Reader";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Repository > Display > Display )
  class Com_0014_0015 : public TsmPComponent
  {
  public:
    Com_0014_0015( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository > Display )
   ********************************************************************/

   // ( Xmi > Data > Repository > Display )
  class Pac_0007_0014 : public TsmPackage
  {
  public:
    Pac_0007_0014( TsmBase* oParent )
    {
      TsmName = "Display";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> InitialState )
  class Ini_0159_0160 : public TsmPseudo
  {
  public:
    Ini_0159_0160( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 220, "( BackendFsm >> InitialState ) => ( BackendFsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 220: // UP: ( BackendFsm >> InitialState ) => ( BackendFsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> InitialState )
  class Ini_0426_0427 : public TsmPseudo
  {
  public:
    Ini_0426_0427( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 440, "( BackendFsm > Stopping >> InitialState ) => ( BackendFsm > Stopping >> Stop )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 440: // UP: ( BackendFsm > Stopping >> InitialState ) => ( BackendFsm > Stopping >> Stop )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> FinalState )
  class Fin_0426_0428 : public TsmFinal
  {
  public:
    Fin_0426_0428( TsmBase* oParent )
    {
      TsmName = "FinalState";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Tra_0426_0441( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 441:
        Tra_0426_0441( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> InitialState )
  class Ini_0444_0445 : public TsmPseudo
  {
  public:
    Ini_0444_0445( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 469, "( BackendFsm > Tac_Stop >> InitialState ) => ( BackendFsm > Tac_Stop >> CS_Display )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 469: // UP: ( BackendFsm > Tac_Stop >> InitialState ) => ( BackendFsm > Tac_Stop >> CS_Display )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> FinalState )
  class Fin_0444_0446 : public TsmFinal
  {
  public:
    Fin_0444_0446( TsmBase* oParent )
    {
      TsmName = "FinalState";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Tra_0459_0468( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 468:
        Tra_0459_0468( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Display >> InitialState )
  class Ini_0448_0449 : public TsmPseudo
  {
  public:
    Ini_0448_0449( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 457, "( BackendFsm > Tac_Stop >> CS_Display >> InitialState ) => ( BackendFsm > Tac_Stop >> CS_Display >> Base )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 457: // UP: ( BackendFsm > Tac_Stop >> CS_Display >> InitialState ) => ( BackendFsm > Tac_Stop >> CS_Display >> Base )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Display >> ChoiceState )
  class Cho_0448_0450 : public TsmPseudo
  {
  public:
    Cho_0448_0450( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 456, "( BackendFsm > Tac_Stop >> CS_Display >> ChoiceState ) => ( BackendFsm > Tac_Stop >> CS_Reader ) : 'IsProxyOk'" );
      mTransitions[ 1 ] = new TsmTransition( 454, "( BackendFsm > Tac_Stop >> CS_Display >> ChoiceState ) => ( BackendFsm > Tac_Stop >> CS_Display >> Wait ) : 'IsProxyNok'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0448_0453( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 456: // UP: ( BackendFsm > Tac_Stop >> CS_Display >> ChoiceState ) => ( BackendFsm > Tac_Stop >> CS_Reader )
        bHigher = true;
        break;
      case 454: // UP: ( BackendFsm > Tac_Stop >> CS_Display >> ChoiceState ) => ( BackendFsm > Tac_Stop >> CS_Display >> Wait )
        bHigher = true;
        break;
      case 453:
        Tra_0448_0453( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Display >> Base )
  class Lea_0448_0451 : public TsmLeaf
  {
  public:
    Lea_0448_0451( TsmBase* oParent )
    {
      TsmName = "Base";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 453, "( BackendFsm > Tac_Stop >> CS_Display >> Base ) => ( BackendFsm > Tac_Stop >> CS_Display >> ChoiceState )" );
    }

    void Tra_0448_0457( TsmHandler& oHandler );
    void Initial( TsmHandler& oHandler );
    void Tra_0448_0455( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 457:
        Tra_0448_0457( oHandler );
        break;
      case 453: // UP: ( BackendFsm > Tac_Stop >> CS_Display >> Base ) => ( BackendFsm > Tac_Stop >> CS_Display >> ChoiceState )
        bHigher = true;
        break;
      case 455:
        Tra_0448_0455( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Display >> Wait )
  class Lea_0448_0452 : public TsmLeaf
  {
  public:
    Lea_0448_0452( TsmBase* oParent )
    {
      TsmName = "Wait";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 455, "( BackendFsm > Tac_Stop >> CS_Display >> Wait ) => ( BackendFsm > Tac_Stop >> CS_Display >> Base )" );
    }

    void Tra_0448_0454( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 454:
        Tra_0448_0454( oHandler );
        break;
      case 455: // UP: ( BackendFsm > Tac_Stop >> CS_Display >> Wait ) => ( BackendFsm > Tac_Stop >> CS_Display >> Base )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Display >)
  class Reg_0447_0448 : public TsmRegion
  {
  private:
    Ini_0448_0449* oIni_0448_0449; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Display >> InitialState )
    Cho_0448_0450* oCho_0448_0450; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Display >> ChoiceState )
    Lea_0448_0451* oLea_0448_0451; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Display >> Base )
    Lea_0448_0452* oLea_0448_0452; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Display >> Wait )

  public:
    Reg_0447_0448( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0448_0449 = new Ini_0448_0449( this );
      oCho_0448_0450 = new Cho_0448_0450( this );
      oLea_0448_0451 = new Lea_0448_0451( this );
      oLea_0448_0452 = new Lea_0448_0452( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0448_0449;
      mStates[ 1 ] = oCho_0448_0450;
      mStates[ 2 ] = oLea_0448_0451;
      mStates[ 3 ] = oLea_0448_0452;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0448_0457( TsmHandler& oHandler );
    void Tra_0448_0454( TsmHandler& oHandler );
    void Tra_0448_0453( TsmHandler& oHandler );
    void Tra_0448_0455( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 457:
        Tra_0448_0457( oHandler );
        break;
      case 456: // Up: ( BackendFsm > Tac_Stop >> CS_Display >> ChoiceState ) => ( BackendFsm > Tac_Stop >> CS_Reader )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 454:
        Tra_0448_0454( oHandler );
        break;
      case 453:
        Tra_0448_0453( oHandler );
        break;
      case 455:
        Tra_0448_0455( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Display )
  class Com_0444_0447 : public TsmCompound
  {
  private:
    Reg_0447_0448* oReg_0447_0448; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Display >)

  public:
    Com_0444_0447( TsmBase* oParent )
    {
      TsmName = "CS_Display";
      TsmParent = oParent;
      oReg_0447_0448 = new Reg_0447_0448( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0447_0448;
      mNrTransitions = 0;
    }

    void Tra_0444_0469( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 469:
        Tra_0444_0469( oHandler );
        break;
      case 456: // UP: ( BackendFsm > Tac_Stop >> CS_Display >> ChoiceState ) => ( BackendFsm > Tac_Stop >> CS_Reader )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Reader >> InitialState )
  class Ini_0459_0460 : public TsmPseudo
  {
  public:
    Ini_0459_0460( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 467, "( BackendFsm > Tac_Stop >> CS_Reader >> InitialState ) => ( BackendFsm > Tac_Stop >> CS_Reader >> Base )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 467: // UP: ( BackendFsm > Tac_Stop >> CS_Reader >> InitialState ) => ( BackendFsm > Tac_Stop >> CS_Reader >> Base )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState )
  class Cho_0459_0461 : public TsmPseudo
  {
  public:
    Cho_0459_0461( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 468, "( BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState ) => ( BackendFsm > Tac_Stop >> FinalState ) : 'IsProxyOk'" );
      mTransitions[ 1 ] = new TsmTransition( 466, "( BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState ) => ( BackendFsm > Tac_Stop >> CS_Reader >> Wait ) : 'IsProxyNok'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0459_0464( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 468: // UP: ( BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState ) => ( BackendFsm > Tac_Stop >> FinalState )
        bHigher = true;
        break;
      case 466: // UP: ( BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState ) => ( BackendFsm > Tac_Stop >> CS_Reader >> Wait )
        bHigher = true;
        break;
      case 464:
        Tra_0459_0464( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Reader >> Base )
  class Lea_0459_0462 : public TsmLeaf
  {
  public:
    Lea_0459_0462( TsmBase* oParent )
    {
      TsmName = "Base";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 464, "( BackendFsm > Tac_Stop >> CS_Reader >> Base ) => ( BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState )" );
    }

    void Tra_0459_0467( TsmHandler& oHandler );
    void Initial( TsmHandler& oHandler );
    void Tra_0459_0465( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 467:
        Tra_0459_0467( oHandler );
        break;
      case 464: // UP: ( BackendFsm > Tac_Stop >> CS_Reader >> Base ) => ( BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState )
        bHigher = true;
        break;
      case 465:
        Tra_0459_0465( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Reader >> Wait )
  class Lea_0459_0463 : public TsmLeaf
  {
  public:
    Lea_0459_0463( TsmBase* oParent )
    {
      TsmName = "Wait";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 465, "( BackendFsm > Tac_Stop >> CS_Reader >> Wait ) => ( BackendFsm > Tac_Stop >> CS_Reader >> Base )" );
    }

    void Tra_0459_0466( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 466:
        Tra_0459_0466( oHandler );
        break;
      case 465: // UP: ( BackendFsm > Tac_Stop >> CS_Reader >> Wait ) => ( BackendFsm > Tac_Stop >> CS_Reader >> Base )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Reader >)
  class Reg_0458_0459 : public TsmRegion
  {
  private:
    Ini_0459_0460* oIni_0459_0460; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Reader >> InitialState )
    Cho_0459_0461* oCho_0459_0461; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState )
    Lea_0459_0462* oLea_0459_0462; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Reader >> Base )
    Lea_0459_0463* oLea_0459_0463; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Reader >> Wait )

  public:
    Reg_0458_0459( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0459_0460 = new Ini_0459_0460( this );
      oCho_0459_0461 = new Cho_0459_0461( this );
      oLea_0459_0462 = new Lea_0459_0462( this );
      oLea_0459_0463 = new Lea_0459_0463( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0459_0460;
      mStates[ 1 ] = oCho_0459_0461;
      mStates[ 2 ] = oLea_0459_0462;
      mStates[ 3 ] = oLea_0459_0463;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0459_0467( TsmHandler& oHandler );
    void Tra_0459_0466( TsmHandler& oHandler );
    void Tra_0459_0464( TsmHandler& oHandler );
    void Tra_0459_0465( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 467:
        Tra_0459_0467( oHandler );
        break;
      case 468: // Up: ( BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState ) => ( BackendFsm > Tac_Stop >> FinalState )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 466:
        Tra_0459_0466( oHandler );
        break;
      case 464:
        Tra_0459_0464( oHandler );
        break;
      case 465:
        Tra_0459_0465( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Reader )
  class Com_0444_0458 : public TsmCompound
  {
  private:
    Reg_0458_0459* oReg_0458_0459; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Reader >)

  public:
    Com_0444_0458( TsmBase* oParent )
    {
      TsmName = "CS_Reader";
      TsmParent = oParent;
      oReg_0458_0459 = new Reg_0458_0459( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0458_0459;
      mNrTransitions = 0;
    }

    void Tra_0448_0456( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 456:
        Tra_0448_0456( oHandler );
        break;
      case 468: // UP: ( BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState ) => ( BackendFsm > Tac_Stop >> FinalState )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >)
  class Reg_0443_0444 : public TsmRegion
  {
  private:
    Ini_0444_0445* oIni_0444_0445; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> InitialState )
    Fin_0444_0446* oFin_0444_0446; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> FinalState )
    Com_0444_0447* oCom_0444_0447; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Display )
    Com_0444_0458* oCom_0444_0458; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Reader )

  public:
    Reg_0443_0444( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0444_0445 = new Ini_0444_0445( this );
      oFin_0444_0446 = new Fin_0444_0446( this );
      oCom_0444_0447 = new Com_0444_0447( this );
      oCom_0444_0458 = new Com_0444_0458( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0444_0445;
      mStates[ 1 ] = oFin_0444_0446;
      mStates[ 2 ] = oCom_0444_0447;
      mStates[ 3 ] = oCom_0444_0458;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0444_0469( TsmHandler& oHandler );
    void Tra_0448_0456( TsmHandler& oHandler );
    void Tra_0459_0468( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 469:
        Tra_0444_0469( oHandler );
        break;
      case 456:
        Tra_0448_0456( oHandler );
        break;
      case 468:
        Tra_0459_0468( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop )
  class Fsm_0158_0443 : public TsmFsm
  {
  private:
    Reg_0443_0444* oReg_0443_0444; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >)

  public:
    Fsm_0158_0443( TsmBase* oParent )
    {
      TsmName = "Tac_Stop";
      TsmParent = oParent;
      oReg_0443_0444 = new Reg_0443_0444( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0443_0444;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> Stop )
  class Sub_0426_0429 : public TsmSubFsm
  {
  public:
    Sub_0426_0429( TsmBase* oParent )
    {
      TsmName = "Stop";
      TsmParent = oParent;
      oFsm = new Fsm_0158_0443( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop )
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 442, "( BackendFsm > Stopping >> Stop ) => ( BackendFsm > Stopping >> CS_Close )" );
    }

    void Tra_0426_0440( TsmHandler& oHandler );
    void ExecuteTriggerless( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 440:
        Tra_0426_0440( oHandler );
        break;
      case 442: // UP: ( BackendFsm > Stopping >> Stop ) => ( BackendFsm > Stopping >> CS_Close )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> CS_Close >> InitialState )
  class Ini_0431_0432 : public TsmPseudo
  {
  public:
    Ini_0431_0432( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 436, "( BackendFsm > Stopping >> CS_Close >> InitialState ) => ( BackendFsm > Stopping >> CS_Close >> Base )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 436: // UP: ( BackendFsm > Stopping >> CS_Close >> InitialState ) => ( BackendFsm > Stopping >> CS_Close >> Base )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> CS_Close >> ChoiceState )
  class Cho_0431_0433 : public TsmPseudo
  {
  public:
    Cho_0431_0433( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 441, "( BackendFsm > Stopping >> CS_Close >> ChoiceState ) => ( BackendFsm > Stopping >> FinalState ) : 'IsProxyOk'" );
      mTransitions[ 1 ] = new TsmTransition( 439, "( BackendFsm > Stopping >> CS_Close >> ChoiceState ) => ( BackendFsm > Stopping >> CS_Close >> Wait ) : 'IsProxyNok'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0431_0438( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 441: // UP: ( BackendFsm > Stopping >> CS_Close >> ChoiceState ) => ( BackendFsm > Stopping >> FinalState )
        bHigher = true;
        break;
      case 439: // UP: ( BackendFsm > Stopping >> CS_Close >> ChoiceState ) => ( BackendFsm > Stopping >> CS_Close >> Wait )
        bHigher = true;
        break;
      case 438:
        Tra_0431_0438( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> CS_Close >> Base )
  class Lea_0431_0434 : public TsmLeaf
  {
  public:
    Lea_0431_0434( TsmBase* oParent )
    {
      TsmName = "Base";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 438, "( BackendFsm > Stopping >> CS_Close >> Base ) => ( BackendFsm > Stopping >> CS_Close >> ChoiceState )" );
    }

    void Tra_0431_0436( TsmHandler& oHandler );
    void Initial( TsmHandler& oHandler );
    void Tra_0431_0437( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 436:
        Tra_0431_0436( oHandler );
        break;
      case 438: // UP: ( BackendFsm > Stopping >> CS_Close >> Base ) => ( BackendFsm > Stopping >> CS_Close >> ChoiceState )
        bHigher = true;
        break;
      case 437:
        Tra_0431_0437( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> CS_Close >> Wait )
  class Lea_0431_0435 : public TsmLeaf
  {
  public:
    Lea_0431_0435( TsmBase* oParent )
    {
      TsmName = "Wait";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 437, "( BackendFsm > Stopping >> CS_Close >> Wait ) => ( BackendFsm > Stopping >> CS_Close >> Base )" );
    }

    void Tra_0431_0439( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 439:
        Tra_0431_0439( oHandler );
        break;
      case 437: // UP: ( BackendFsm > Stopping >> CS_Close >> Wait ) => ( BackendFsm > Stopping >> CS_Close >> Base )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> CS_Close >)
  class Reg_0430_0431 : public TsmRegion
  {
  private:
    Ini_0431_0432* oIni_0431_0432; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> CS_Close >> InitialState )
    Cho_0431_0433* oCho_0431_0433; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> CS_Close >> ChoiceState )
    Lea_0431_0434* oLea_0431_0434; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> CS_Close >> Base )
    Lea_0431_0435* oLea_0431_0435; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> CS_Close >> Wait )

  public:
    Reg_0430_0431( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0431_0432 = new Ini_0431_0432( this );
      oCho_0431_0433 = new Cho_0431_0433( this );
      oLea_0431_0434 = new Lea_0431_0434( this );
      oLea_0431_0435 = new Lea_0431_0435( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0431_0432;
      mStates[ 1 ] = oCho_0431_0433;
      mStates[ 2 ] = oLea_0431_0434;
      mStates[ 3 ] = oLea_0431_0435;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0431_0436( TsmHandler& oHandler );
    void Tra_0431_0439( TsmHandler& oHandler );
    void Tra_0431_0438( TsmHandler& oHandler );
    void Tra_0431_0437( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 436:
        Tra_0431_0436( oHandler );
        break;
      case 441: // Up: ( BackendFsm > Stopping >> CS_Close >> ChoiceState ) => ( BackendFsm > Stopping >> FinalState )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 439:
        Tra_0431_0439( oHandler );
        break;
      case 438:
        Tra_0431_0438( oHandler );
        break;
      case 437:
        Tra_0431_0437( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> CS_Close )
  class Com_0426_0430 : public TsmCompound
  {
  private:
    Reg_0430_0431* oReg_0430_0431; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> CS_Close >)

  public:
    Com_0426_0430( TsmBase* oParent )
    {
      TsmName = "CS_Close";
      TsmParent = oParent;
      oReg_0430_0431 = new Reg_0430_0431( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0430_0431;
      mNrTransitions = 0;
    }

    void Tra_0426_0442( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 442:
        Tra_0426_0442( oHandler );
        break;
      case 441: // UP: ( BackendFsm > Stopping >> CS_Close >> ChoiceState ) => ( BackendFsm > Stopping >> FinalState )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >)
  class Reg_0425_0426 : public TsmRegion
  {
  private:
    Ini_0426_0427* oIni_0426_0427; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> InitialState )
    Fin_0426_0428* oFin_0426_0428; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> FinalState )
    Sub_0426_0429* oSub_0426_0429; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> Stop )
    Com_0426_0430* oCom_0426_0430; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> CS_Close )

  public:
    Reg_0425_0426( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0426_0427 = new Ini_0426_0427( this );
      oFin_0426_0428 = new Fin_0426_0428( this );
      oSub_0426_0429 = new Sub_0426_0429( this );
      oCom_0426_0430 = new Com_0426_0430( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0426_0427;
      mStates[ 1 ] = oFin_0426_0428;
      mStates[ 2 ] = oSub_0426_0429;
      mStates[ 3 ] = oCom_0426_0430;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0426_0440( TsmHandler& oHandler );
    void Tra_0426_0442( TsmHandler& oHandler );
    void Tra_0426_0441( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 440:
        Tra_0426_0440( oHandler );
        break;
      case 442:
        Tra_0426_0442( oHandler );
        break;
      case 441:
        Tra_0426_0441( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping )
  class Fsm_0158_0425 : public TsmFsm
  {
  private:
    Reg_0425_0426* oReg_0425_0426; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >)

  public:
    Fsm_0158_0425( TsmBase* oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      oReg_0425_0426 = new Reg_0425_0426( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0425_0426;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Stopping )
  class Sub_0159_0161 : public TsmSubFsm
  {
  public:
    Sub_0159_0161( TsmBase* oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      oFsm = new Fsm_0158_0425( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping )
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 223, "( BackendFsm >> Stopping ) => ( BackendFsm >> Idle )" );
    }

    void ExecuteTriggerless( TsmHandler& oHandler );
    void Tra_0159_0222( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 223: // UP: ( BackendFsm >> Stopping ) => ( BackendFsm >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 222:
        Tra_0159_0222( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Idle >> InitialState )
  class Ini_0163_0164 : public TsmPseudo
  {
  public:
    Ini_0163_0164( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 168, "( BackendFsm >> Idle >> InitialState ) => ( BackendFsm >> Idle >> Base )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 168: // UP: ( BackendFsm >> Idle >> InitialState ) => ( BackendFsm >> Idle >> Base )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Idle >> ChoiceState )
  class Cho_0163_0165 : public TsmPseudo
  {
  public:
    Cho_0163_0165( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 169, "( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Active >> Starting )" );
      mTransitions[ 1 ] = new TsmTransition( 171, "( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0163_0170( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 169: // UP: ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Active >> Starting )
        bHigher = true;
        break;
      case 171: // UP: ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle )
        bHigher = true;
        break;
      case 170:
        Tra_0163_0170( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Idle >> ChoiceState )
  class Cho_0163_0166 : public TsmPseudo
  {
  public:
    Cho_0163_0166( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 172, "( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle )" );
      mTransitions[ 1 ] = new TsmTransition( 170, "( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle >> ChoiceState )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0163_0173( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 172: // UP: ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle )
        bHigher = true;
        break;
      case 170: // UP: ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle >> ChoiceState )
        bHigher = true;
        break;
      case 173:
        Tra_0163_0173( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Idle >> Base )
  class Lea_0163_0167 : public TsmLeaf
  {
  public:
    Lea_0163_0167( TsmBase* oParent )
    {
      TsmName = "Base";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 173, "( BackendFsm >> Idle >> Base ) => ( BackendFsm >> Idle >> ChoiceState ) : pp_player->Start" );
    }

    void Tra_0163_0168( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void pp_player___Start( string TitleId, tTime* AtTime, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 168:
        Tra_0163_0168( oHandler );
        break;
      case 173: // UP: ( BackendFsm >> Idle >> Base ) => ( BackendFsm >> Idle >> ChoiceState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Idle >)
  class Reg_0162_0163 : public TsmRegion
  {
  private:
    Ini_0163_0164* oIni_0163_0164; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Idle >> InitialState )
    Cho_0163_0165* oCho_0163_0165; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Idle >> ChoiceState )
    Cho_0163_0166* oCho_0163_0166; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Idle >> ChoiceState )
    Lea_0163_0167* oLea_0163_0167; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Idle >> Base )

  public:
    Reg_0162_0163( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0163_0164 = new Ini_0163_0164( this );
      oCho_0163_0165 = new Cho_0163_0165( this );
      oCho_0163_0166 = new Cho_0163_0166( this );
      oLea_0163_0167 = new Lea_0163_0167( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0163_0164;
      mStates[ 1 ] = oCho_0163_0165;
      mStates[ 2 ] = oCho_0163_0166;
      mStates[ 3 ] = oLea_0163_0167;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0163_0168( TsmHandler& oHandler );
    void Tra_0163_0170( TsmHandler& oHandler );
    void Tra_0163_0173( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 168:
        Tra_0163_0168( oHandler );
        break;
      case 169: // Up: ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Active >> Starting )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 171: // Up: ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 172: // Up: ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 170:
        Tra_0163_0170( oHandler );
        break;
      case 173:
        Tra_0163_0173( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Idle )
  class Com_0159_0162 : public TsmCompound
  {
  private:
    Reg_0162_0163* oReg_0162_0163; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Idle >)

  public:
    Com_0159_0162( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      oReg_0162_0163 = new Reg_0162_0163( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0162_0163;
      mNrTransitions = 0;
    }

    void Tra_0159_0220( TsmHandler& oHandler );
    void Tra_0159_0223( TsmHandler& oHandler );
    void Tra_0163_0171( TsmHandler& oHandler );
    void Tra_0163_0172( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 220:
        Tra_0159_0220( oHandler );
        break;
      case 223:
        Tra_0159_0223( oHandler );
        break;
      case 169: // UP: ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Active >> Starting )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 171:
        Tra_0163_0171( oHandler );
        break;
      case 172:
        Tra_0163_0172( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> JuncState )
  class Jun_0175_0176 : public TsmPseudo
  {
  public:
    Jun_0175_0176( TsmBase* oParent )
    {
      TsmName = "JuncState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 215, "( BackendFsm >> Active >> JuncState ) => ( BackendFsm >> Active >> JuncState )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0175_0212( TsmHandler& oHandler );
    void Tra_0175_0208( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 215: // UP: ( BackendFsm >> Active >> JuncState ) => ( BackendFsm >> Active >> JuncState )
        bHigher = true;
        break;
      case 212:
        Tra_0175_0212( oHandler );
        break;
      case 208:
        Tra_0175_0208( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> JuncState )
  class Jun_0175_0177 : public TsmPseudo
  {
  public:
    Jun_0175_0177( TsmBase* oParent )
    {
      TsmName = "JuncState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 201, "( BackendFsm >> Active >> JuncState ) => ( BackendFsm >> Active >> Finishing )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0175_0207( TsmHandler& oHandler );
    void Tra_0175_0206( TsmHandler& oHandler );
    void Tra_0175_0213( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 201: // UP: ( BackendFsm >> Active >> JuncState ) => ( BackendFsm >> Active >> Finishing )
        bHigher = true;
        break;
      case 207:
        Tra_0175_0207( oHandler );
        break;
      case 206:
        Tra_0175_0206( oHandler );
        break;
      case 213:
        Tra_0175_0213( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> JuncState )
  class Jun_0175_0178 : public TsmPseudo
  {
  public:
    Jun_0175_0178( TsmBase* oParent )
    {
      TsmName = "JuncState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 221, "( BackendFsm >> Active >> JuncState ) => ( BackendFsm >> Active >> Error )" );
    }

    void Tra_0175_0215( TsmHandler& oHandler );
    void Initial( TsmHandler& oHandler );
    void Tra_0175_0211( TsmHandler& oHandler );
    void Tra_0175_0216( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 215:
        Tra_0175_0215( oHandler );
        break;
      case 221: // UP: ( BackendFsm >> Active >> JuncState ) => ( BackendFsm >> Active >> Error )
        bHigher = true;
        break;
      case 211:
        Tra_0175_0211( oHandler );
        break;
      case 216:
        Tra_0175_0216( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Starting > ConnExitRef )
  class Con_0179_0180 : public TsmState
  {
  public:
    Con_0179_0180( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 212, "( BackendFsm >> Active >> Starting > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 212: // UP: ( BackendFsm >> Active >> Starting > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> InitialState )
  class Ini_0390_0391 : public TsmPseudo
  {
  public:
    Ini_0390_0391( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 415, "( BackendFsm > Starting >> InitialState ) => ( BackendFsm > Starting >> CS_Open )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 415: // UP: ( BackendFsm > Starting >> InitialState ) => ( BackendFsm > Starting >> CS_Open )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> FinalState )
  class Fin_0390_0392 : public TsmFinal
  {
  public:
    Fin_0390_0392( TsmBase* oParent )
    {
      TsmName = "FinalState";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Tra_0390_0420( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 420:
        Tra_0390_0420( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> JuncState )
  class Jun_0390_0393 : public TsmPseudo
  {
  public:
    Jun_0390_0393( TsmBase* oParent )
    {
      TsmName = "JuncState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 418, "( BackendFsm > Starting >> JuncState ) => ( BackendFsm > Starting > ExitError )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0390_0417( TsmHandler& oHandler );
    void Tra_0390_0416( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 418: // UP: ( BackendFsm > Starting >> JuncState ) => ( BackendFsm > Starting > ExitError )
        bHigher = true;
        break;
      case 417:
        Tra_0390_0417( oHandler );
        break;
      case 416:
        Tra_0390_0416( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> StartRead > ConnExitRef )
  class Con_0394_0395 : public TsmState
  {
  public:
    Con_0394_0395( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 419, "( BackendFsm > Starting >> StartRead > ConnExitRef ) => ( BackendFsm > Starting >> Recover )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 419: // UP: ( BackendFsm > Starting >> StartRead > ConnExitRef ) => ( BackendFsm > Starting >> Recover )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> StartRead > ConnExitRef )
  class Con_0394_0396 : public TsmState
  {
  public:
    Con_0394_0396( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 417, "( BackendFsm > Starting >> StartRead > ConnExitRef ) => ( BackendFsm > Starting >> JuncState )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 417: // UP: ( BackendFsm > Starting >> StartRead > ConnExitRef ) => ( BackendFsm > Starting >> JuncState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> InitialState )
  class Ini_0311_0312 : public TsmPseudo
  {
  public:
    Ini_0311_0312( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 354, "( BackendFsm > Tac_StartRead >> InitialState ) => ( BackendFsm > Tac_StartRead >> LeafState )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 354: // UP: ( BackendFsm > Tac_StartRead >> InitialState ) => ( BackendFsm > Tac_StartRead >> LeafState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> FinalState )
  class Fin_0311_0313 : public TsmFinal
  {
  public:
    Fin_0311_0313( TsmBase* oParent )
    {
      TsmName = "FinalState";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Tra_0341_0350( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 350:
        Tra_0341_0350( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> ChoiceState )
  class Cho_0311_0314 : public TsmPseudo
  {
  public:
    Cho_0311_0314( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 352, "( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead > ExitNoData )" );
      mTransitions[ 1 ] = new TsmTransition( 353, "( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead > ExitReadFailure )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0311_0355( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 352: // UP: ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead > ExitNoData )
        bHigher = true;
        break;
      case 353: // UP: ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead > ExitReadFailure )
        bHigher = true;
        break;
      case 355:
        Tra_0311_0355( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> ChoiceState )
  class Cho_0311_0315 : public TsmPseudo
  {
  public:
    Cho_0311_0315( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 357, "( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Prepare )" );
      mTransitions[ 1 ] = new TsmTransition( 355, "( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> ChoiceState )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0311_0356( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 357: // UP: ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Prepare )
        bHigher = true;
        break;
      case 355: // UP: ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> ChoiceState )
        bHigher = true;
        break;
      case 356:
        Tra_0311_0356( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> ChoiceState )
  class Cho_0311_0316 : public TsmPseudo
  {
  public:
    Cho_0311_0316( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 359, "( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled )" );
      mTransitions[ 1 ] = new TsmTransition( 358, "( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead > ExitChunkError )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0329_0339( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 359: // UP: ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled )
        bHigher = true;
        break;
      case 358: // UP: ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead > ExitChunkError )
        bHigher = true;
        break;
      case 339:
        Tra_0329_0339( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Prepare >> InitialState )
  class Ini_0318_0319 : public TsmPseudo
  {
  public:
    Ini_0318_0319( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 327, "( BackendFsm > Tac_StartRead >> CS_Prepare >> InitialState ) => ( BackendFsm > Tac_StartRead >> CS_Prepare >> Base )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 327: // UP: ( BackendFsm > Tac_StartRead >> CS_Prepare >> InitialState ) => ( BackendFsm > Tac_StartRead >> CS_Prepare >> Base )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState )
  class Cho_0318_0320 : public TsmPseudo
  {
  public:
    Cho_0318_0320( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 325, "( BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Read ) : 'IsProxyOk'" );
      mTransitions[ 1 ] = new TsmTransition( 323, "( BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Prepare >> Wait ) : 'IsProxyNok'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0318_0326( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 325: // UP: ( BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Read )
        bHigher = true;
        break;
      case 323: // UP: ( BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Prepare >> Wait )
        bHigher = true;
        break;
      case 326:
        Tra_0318_0326( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Prepare >> Base )
  class Lea_0318_0321 : public TsmLeaf
  {
  public:
    Lea_0318_0321( TsmBase* oParent )
    {
      TsmName = "Base";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 326, "( BackendFsm > Tac_StartRead >> CS_Prepare >> Base ) => ( BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState )" );
    }

    void Tra_0318_0327( TsmHandler& oHandler );
    void Initial( TsmHandler& oHandler );
    void Tra_0318_0324( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 327:
        Tra_0318_0327( oHandler );
        break;
      case 326: // UP: ( BackendFsm > Tac_StartRead >> CS_Prepare >> Base ) => ( BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState )
        bHigher = true;
        break;
      case 324:
        Tra_0318_0324( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Prepare >> Wait )
  class Lea_0318_0322 : public TsmLeaf
  {
  public:
    Lea_0318_0322( TsmBase* oParent )
    {
      TsmName = "Wait";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 324, "( BackendFsm > Tac_StartRead >> CS_Prepare >> Wait ) => ( BackendFsm > Tac_StartRead >> CS_Prepare >> Base )" );
    }

    void Tra_0318_0323( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 323:
        Tra_0318_0323( oHandler );
        break;
      case 324: // UP: ( BackendFsm > Tac_StartRead >> CS_Prepare >> Wait ) => ( BackendFsm > Tac_StartRead >> CS_Prepare >> Base )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Prepare >)
  class Reg_0317_0318 : public TsmRegion
  {
  private:
    Ini_0318_0319* oIni_0318_0319; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Prepare >> InitialState )
    Cho_0318_0320* oCho_0318_0320; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState )
    Lea_0318_0321* oLea_0318_0321; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Prepare >> Base )
    Lea_0318_0322* oLea_0318_0322; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Prepare >> Wait )

  public:
    Reg_0317_0318( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0318_0319 = new Ini_0318_0319( this );
      oCho_0318_0320 = new Cho_0318_0320( this );
      oLea_0318_0321 = new Lea_0318_0321( this );
      oLea_0318_0322 = new Lea_0318_0322( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0318_0319;
      mStates[ 1 ] = oCho_0318_0320;
      mStates[ 2 ] = oLea_0318_0321;
      mStates[ 3 ] = oLea_0318_0322;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0318_0327( TsmHandler& oHandler );
    void Tra_0318_0323( TsmHandler& oHandler );
    void Tra_0318_0326( TsmHandler& oHandler );
    void Tra_0318_0324( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 327:
        Tra_0318_0327( oHandler );
        break;
      case 325: // Up: ( BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Read )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 323:
        Tra_0318_0323( oHandler );
        break;
      case 326:
        Tra_0318_0326( oHandler );
        break;
      case 324:
        Tra_0318_0324( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Prepare )
  class Com_0311_0317 : public TsmCompound
  {
  private:
    Reg_0317_0318* oReg_0317_0318; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Prepare >)

  public:
    Com_0311_0317( TsmBase* oParent )
    {
      TsmName = "CS_Prepare";
      TsmParent = oParent;
      oReg_0317_0318 = new Reg_0317_0318( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0317_0318;
      mNrTransitions = 0;
    }

    void Tra_0311_0357( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 357:
        Tra_0311_0357( oHandler );
        break;
      case 325: // UP: ( BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Read )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Read >> InitialState )
  class Ini_0329_0330 : public TsmPseudo
  {
  public:
    Ini_0329_0330( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 336, "( BackendFsm > Tac_StartRead >> CS_Read >> InitialState ) => ( BackendFsm > Tac_StartRead >> CS_Read >> Base )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 336: // UP: ( BackendFsm > Tac_StartRead >> CS_Read >> InitialState ) => ( BackendFsm > Tac_StartRead >> CS_Read >> Base )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState )
  class Cho_0329_0331 : public TsmPseudo
  {
  public:
    Cho_0329_0331( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 339, "( BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> ChoiceState ) : 'IsProxyOk'" );
      mTransitions[ 1 ] = new TsmTransition( 334, "( BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Read >> Wait ) : 'IsProxyNok'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0329_0338( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 339: // UP: ( BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> ChoiceState )
        bHigher = true;
        break;
      case 334: // UP: ( BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Read >> Wait )
        bHigher = true;
        break;
      case 338:
        Tra_0329_0338( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Read >> Base )
  class Lea_0329_0332 : public TsmLeaf
  {
  public:
    Lea_0329_0332( TsmBase* oParent )
    {
      TsmName = "Base";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 338, "( BackendFsm > Tac_StartRead >> CS_Read >> Base ) => ( BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState )" );
    }

    void Tra_0329_0336( TsmHandler& oHandler );
    void Initial( TsmHandler& oHandler );
    void Tra_0329_0335( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 336:
        Tra_0329_0336( oHandler );
        break;
      case 338: // UP: ( BackendFsm > Tac_StartRead >> CS_Read >> Base ) => ( BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState )
        bHigher = true;
        break;
      case 335:
        Tra_0329_0335( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Read >> Wait )
  class Lea_0329_0333 : public TsmLeaf
  {
  public:
    Lea_0329_0333( TsmBase* oParent )
    {
      TsmName = "Wait";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 335, "( BackendFsm > Tac_StartRead >> CS_Read >> Wait ) => ( BackendFsm > Tac_StartRead >> CS_Read >> Base )" );
    }

    void Tra_0329_0334( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 334:
        Tra_0329_0334( oHandler );
        break;
      case 335: // UP: ( BackendFsm > Tac_StartRead >> CS_Read >> Wait ) => ( BackendFsm > Tac_StartRead >> CS_Read >> Base )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Read >)
  class Reg_0328_0329 : public TsmRegion
  {
  private:
    Ini_0329_0330* oIni_0329_0330; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Read >> InitialState )
    Cho_0329_0331* oCho_0329_0331; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState )
    Lea_0329_0332* oLea_0329_0332; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Read >> Base )
    Lea_0329_0333* oLea_0329_0333; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Read >> Wait )

  public:
    Reg_0328_0329( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0329_0330 = new Ini_0329_0330( this );
      oCho_0329_0331 = new Cho_0329_0331( this );
      oLea_0329_0332 = new Lea_0329_0332( this );
      oLea_0329_0333 = new Lea_0329_0333( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0329_0330;
      mStates[ 1 ] = oCho_0329_0331;
      mStates[ 2 ] = oLea_0329_0332;
      mStates[ 3 ] = oLea_0329_0333;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0329_0336( TsmHandler& oHandler );
    void Tra_0329_0334( TsmHandler& oHandler );
    void Tra_0329_0338( TsmHandler& oHandler );
    void Tra_0329_0335( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 336:
        Tra_0329_0336( oHandler );
        break;
      case 339: // Up: ( BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> ChoiceState )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 334:
        Tra_0329_0334( oHandler );
        break;
      case 338:
        Tra_0329_0338( oHandler );
        break;
      case 335:
        Tra_0329_0335( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Read )
  class Com_0311_0328 : public TsmCompound
  {
  private:
    Reg_0328_0329* oReg_0328_0329; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Read >)

  public:
    Com_0311_0328( TsmBase* oParent )
    {
      TsmName = "CS_Read";
      TsmParent = oParent;
      oReg_0328_0329 = new Reg_0328_0329( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0328_0329;
      mNrTransitions = 0;
    }

    void Tra_0318_0325( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 325:
        Tra_0318_0325( oHandler );
        break;
      case 339: // UP: ( BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_IsFilled >> InitialState )
  class Ini_0341_0342 : public TsmPseudo
  {
  public:
    Ini_0341_0342( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 349, "( BackendFsm > Tac_StartRead >> CS_IsFilled >> InitialState ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Base )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 349: // UP: ( BackendFsm > Tac_StartRead >> CS_IsFilled >> InitialState ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Base )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState )
  class Cho_0341_0343 : public TsmPseudo
  {
  public:
    Cho_0341_0343( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 350, "( BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> FinalState ) : 'IsProxyOk'" );
      mTransitions[ 1 ] = new TsmTransition( 348, "( BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Wait ) : 'IsProxyNok'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0341_0346( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 350: // UP: ( BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> FinalState )
        bHigher = true;
        break;
      case 348: // UP: ( BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Wait )
        bHigher = true;
        break;
      case 346:
        Tra_0341_0346( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_IsFilled >> Base )
  class Lea_0341_0344 : public TsmLeaf
  {
  public:
    Lea_0341_0344( TsmBase* oParent )
    {
      TsmName = "Base";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 346, "( BackendFsm > Tac_StartRead >> CS_IsFilled >> Base ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState )" );
    }

    void Tra_0341_0349( TsmHandler& oHandler );
    void Initial( TsmHandler& oHandler );
    void Tra_0341_0347( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 349:
        Tra_0341_0349( oHandler );
        break;
      case 346: // UP: ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Base ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState )
        bHigher = true;
        break;
      case 347:
        Tra_0341_0347( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_IsFilled >> Wait )
  class Lea_0341_0345 : public TsmLeaf
  {
  public:
    Lea_0341_0345( TsmBase* oParent )
    {
      TsmName = "Wait";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 347, "( BackendFsm > Tac_StartRead >> CS_IsFilled >> Wait ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Base )" );
    }

    void Tra_0341_0348( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 348:
        Tra_0341_0348( oHandler );
        break;
      case 347: // UP: ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Wait ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Base )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_IsFilled >)
  class Reg_0340_0341 : public TsmRegion
  {
  private:
    Ini_0341_0342* oIni_0341_0342; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_IsFilled >> InitialState )
    Cho_0341_0343* oCho_0341_0343; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState )
    Lea_0341_0344* oLea_0341_0344; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_IsFilled >> Base )
    Lea_0341_0345* oLea_0341_0345; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_IsFilled >> Wait )

  public:
    Reg_0340_0341( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0341_0342 = new Ini_0341_0342( this );
      oCho_0341_0343 = new Cho_0341_0343( this );
      oLea_0341_0344 = new Lea_0341_0344( this );
      oLea_0341_0345 = new Lea_0341_0345( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0341_0342;
      mStates[ 1 ] = oCho_0341_0343;
      mStates[ 2 ] = oLea_0341_0344;
      mStates[ 3 ] = oLea_0341_0345;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0341_0349( TsmHandler& oHandler );
    void Tra_0341_0348( TsmHandler& oHandler );
    void Tra_0341_0346( TsmHandler& oHandler );
    void Tra_0341_0347( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 349:
        Tra_0341_0349( oHandler );
        break;
      case 350: // Up: ( BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> FinalState )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 348:
        Tra_0341_0348( oHandler );
        break;
      case 346:
        Tra_0341_0346( oHandler );
        break;
      case 347:
        Tra_0341_0347( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_IsFilled )
  class Com_0311_0340 : public TsmCompound
  {
  private:
    Reg_0340_0341* oReg_0340_0341; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_IsFilled >)

  public:
    Com_0311_0340( TsmBase* oParent )
    {
      TsmName = "CS_IsFilled";
      TsmParent = oParent;
      oReg_0340_0341 = new Reg_0340_0341( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0340_0341;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 337, "( BackendFsm > Tac_StartRead >> CS_IsFilled ) => ( BackendFsm > Tac_StartRead > ExitReadError ) : rpp_reader->Px_CbError" );
    }

    void Tra_0311_0359( TsmHandler& oHandler );
    void rpp_reader___Px_CbError( int BadSector, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 156:
        switch ( Command )
        {
        case 33:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 359:
        Tra_0311_0359( oHandler );
        break;
      case 350: // UP: ( BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> FinalState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 337: // UP: ( BackendFsm > Tac_StartRead >> CS_IsFilled ) => ( BackendFsm > Tac_StartRead > ExitReadError )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> LeafState )
  class Lea_0311_0351 : public TsmLeaf
  {
  public:
    Lea_0311_0351( TsmBase* oParent )
    {
      TsmName = "LeafState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 356, "( BackendFsm > Tac_StartRead >> LeafState ) => ( BackendFsm > Tac_StartRead >> ChoiceState )" );
    }

    void Tra_0311_0354( TsmHandler& oHandler );
    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 354:
        Tra_0311_0354( oHandler );
        break;
      case 356: // UP: ( BackendFsm > Tac_StartRead >> LeafState ) => ( BackendFsm > Tac_StartRead >> ChoiceState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >)
  class Reg_0310_0311 : public TsmRegion
  {
  private:
    Ini_0311_0312* oIni_0311_0312; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> InitialState )
    Fin_0311_0313* oFin_0311_0313; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> FinalState )
    Cho_0311_0314* oCho_0311_0314; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> ChoiceState )
    Cho_0311_0315* oCho_0311_0315; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> ChoiceState )
    Cho_0311_0316* oCho_0311_0316; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> ChoiceState )
    Com_0311_0317* oCom_0311_0317; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Prepare )
    Com_0311_0328* oCom_0311_0328; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Read )
    Com_0311_0340* oCom_0311_0340; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_IsFilled )
    Lea_0311_0351* oLea_0311_0351; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> LeafState )

  public:
    Reg_0310_0311( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0311_0312 = new Ini_0311_0312( this );
      oFin_0311_0313 = new Fin_0311_0313( this );
      oCho_0311_0314 = new Cho_0311_0314( this );
      oCho_0311_0315 = new Cho_0311_0315( this );
      oCho_0311_0316 = new Cho_0311_0316( this );
      oCom_0311_0317 = new Com_0311_0317( this );
      oCom_0311_0328 = new Com_0311_0328( this );
      oCom_0311_0340 = new Com_0311_0340( this );
      oLea_0311_0351 = new Lea_0311_0351( this );
      mNrStates = 9;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0311_0312;
      mStates[ 1 ] = oFin_0311_0313;
      mStates[ 2 ] = oCho_0311_0314;
      mStates[ 3 ] = oCho_0311_0315;
      mStates[ 4 ] = oCho_0311_0316;
      mStates[ 5 ] = oCom_0311_0317;
      mStates[ 6 ] = oCom_0311_0328;
      mStates[ 7 ] = oCom_0311_0340;
      mStates[ 8 ] = oLea_0311_0351;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0311_0354( TsmHandler& oHandler );
    void Tra_0311_0357( TsmHandler& oHandler );
    void Tra_0311_0355( TsmHandler& oHandler );
    void Tra_0311_0359( TsmHandler& oHandler );
    void Tra_0318_0325( TsmHandler& oHandler );
    void Tra_0329_0339( TsmHandler& oHandler );
    void Tra_0341_0350( TsmHandler& oHandler );
    void Tra_0311_0356( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::OK|TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 354:
        Tra_0311_0354( oHandler );
        break;
      case 352: // Up: ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead > ExitNoData )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 353: // Up: ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead > ExitReadFailure )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 357:
        Tra_0311_0357( oHandler );
        break;
      case 355:
        Tra_0311_0355( oHandler );
        break;
      case 359:
        Tra_0311_0359( oHandler );
        break;
      case 358: // Up: ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead > ExitChunkError )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 325:
        Tra_0318_0325( oHandler );
        break;
      case 339:
        Tra_0329_0339( oHandler );
        break;
      case 350:
        Tra_0341_0350( oHandler );
        break;
      case 356:
        Tra_0311_0356( oHandler );
        break;
      case 337: // Up: ( BackendFsm > Tac_StartRead >> CS_IsFilled ) => ( BackendFsm > Tac_StartRead > ExitReadError )
        mCurrentState = NULL;
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead )
  class Fsm_0158_0310 : public TsmFsm
  {
  private:
    Reg_0310_0311* oReg_0310_0311; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >)

  public:
    Fsm_0158_0310( TsmBase* oParent )
    {
      TsmName = "Tac_StartRead";
      TsmParent = oParent;
      oReg_0310_0311 = new Reg_0310_0311( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0310_0311;
      mNrTransitions = 0;
    }

    void Tra_0311_0352( TsmHandler& oHandler );
    void Tra_0311_0353( TsmHandler& oHandler );
    void Tra_0311_0358( TsmHandler& oHandler );
    void Tra_0329_0337( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 352:
        Tra_0311_0352( oHandler );
        break;
      case 353:
        Tra_0311_0353( oHandler );
        break;
      case 358:
        Tra_0311_0358( oHandler );
        break;
      case 337:
        Tra_0329_0337( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> StartRead )
  class Sub_0390_0394 : public TsmSubFsm
  {
  private:
    Con_0394_0395* oCon_0394_0395; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> StartRead > ConnExitRef )
    Con_0394_0396* oCon_0394_0396; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> StartRead > ConnExitRef )

  public:
    Sub_0390_0394( TsmBase* oParent )
    {
      TsmName = "StartRead";
      TsmParent = oParent;
      oFsm = new Fsm_0158_0310( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead )
      oCon_0394_0395 = new Con_0394_0395( this );
      oCon_0394_0396 = new Con_0394_0396( this );
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 423, "( BackendFsm > Starting >> StartRead ) => ( BackendFsm > Starting >> StartPlay )" );
    }

    void ExecuteTriggerless( TsmHandler& oHandler );
    void Tra_0402_0413( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    ~Sub_0390_0394()
    {
      delete oCon_0394_0395;
      delete oCon_0394_0396;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 423: // UP: ( BackendFsm > Starting >> StartRead ) => ( BackendFsm > Starting >> StartPlay )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 361: // UmlConnExit(Ref)
        oCon_0394_0395->Initial( oHandler );
        break;
      case 360: // UmlConnExit(Ref)
      case 362: // UmlConnExit(Ref)
      case 363: // UmlConnExit(Ref)
        oCon_0394_0396->Initial( oHandler );
        break;
      case 419: // UP: ( BackendFsm > Starting >> StartRead > ConnExitRef ) => ( BackendFsm > Starting >> Recover )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 417: // UP: ( BackendFsm > Starting >> StartRead > ConnExitRef ) => ( BackendFsm > Starting >> JuncState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 413:
        Tra_0402_0413( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> Recover > ConnExitRef )
  class Con_0397_0398 : public TsmState
  {
  public:
    Con_0397_0398( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 416, "( BackendFsm > Starting >> Recover > ConnExitRef ) => ( BackendFsm > Starting >> JuncState )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 416: // UP: ( BackendFsm > Starting >> Recover > ConnExitRef ) => ( BackendFsm > Starting >> JuncState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> InitialState )
  class Ini_0471_0472 : public TsmPseudo
  {
  public:
    Ini_0471_0472( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 484, "( BackendFsm > Tac_Recover >> InitialState ) => ( BackendFsm > Tac_Recover >> Stop )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 484: // UP: ( BackendFsm > Tac_Recover >> InitialState ) => ( BackendFsm > Tac_Recover >> Stop )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> FinalState )
  class Fin_0471_0473 : public TsmFinal
  {
  public:
    Fin_0471_0473( TsmBase* oParent )
    {
      TsmName = "FinalState";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Tra_0471_0481( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 481:
        Tra_0471_0481( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> Stop )
  class Sub_0471_0474 : public TsmSubFsm
  {
  public:
    Sub_0471_0474( TsmBase* oParent )
    {
      TsmName = "Stop";
      TsmParent = oParent;
      oFsm = new Fsm_0158_0443( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop )
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 479, "( BackendFsm > Tac_Recover >> Stop ) => ( BackendFsm > Tac_Recover >> StartRead )" );
    }

    void Tra_0471_0484( TsmHandler& oHandler );
    void ExecuteTriggerless( TsmHandler& oHandler );
    void Tra_0471_0483( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 484:
        Tra_0471_0484( oHandler );
        break;
      case 479: // UP: ( BackendFsm > Tac_Recover >> Stop ) => ( BackendFsm > Tac_Recover >> StartRead )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 483:
        Tra_0471_0483( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> StartRead > ConnExitRef )
  class Con_0475_0476 : public TsmState
  {
  public:
    Con_0475_0476( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 480, "( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover > ExitNoData )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 480: // UP: ( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover > ExitNoData )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> StartRead > ConnExitRef )
  class Con_0475_0477 : public TsmState
  {
  public:
    Con_0475_0477( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 483, "( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover >> Stop )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 483: // UP: ( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover >> Stop )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> StartRead > ConnExitRef )
  class Con_0475_0478 : public TsmState
  {
  public:
    Con_0475_0478( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 482, "( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover > ExitReadFailure )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 482: // UP: ( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover > ExitReadFailure )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> StartRead )
  class Sub_0471_0475 : public TsmSubFsm
  {
  private:
    Con_0475_0476* oCon_0475_0476; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> StartRead > ConnExitRef )
    Con_0475_0477* oCon_0475_0477; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> StartRead > ConnExitRef )
    Con_0475_0478* oCon_0475_0478; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> StartRead > ConnExitRef )

  public:
    Sub_0471_0475( TsmBase* oParent )
    {
      TsmName = "StartRead";
      TsmParent = oParent;
      oFsm = new Fsm_0158_0310( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead )
      oCon_0475_0476 = new Con_0475_0476( this );
      oCon_0475_0477 = new Con_0475_0477( this );
      oCon_0475_0478 = new Con_0475_0478( this );
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 481, "( BackendFsm > Tac_Recover >> StartRead ) => ( BackendFsm > Tac_Recover >> FinalState )" );
    }

    void Tra_0471_0479( TsmHandler& oHandler );
    void ExecuteTriggerless( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    ~Sub_0471_0475()
    {
      delete oCon_0475_0476;
      delete oCon_0475_0477;
      delete oCon_0475_0478;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 479:
        Tra_0471_0479( oHandler );
        break;
      case 481: // UP: ( BackendFsm > Tac_Recover >> StartRead ) => ( BackendFsm > Tac_Recover >> FinalState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 360: // UmlConnExit(Ref)
        oCon_0475_0476->Initial( oHandler );
        break;
      case 361: // UmlConnExit(Ref)
        oCon_0475_0477->Initial( oHandler );
        break;
      case 362: // UmlConnExit(Ref)
      case 363: // UmlConnExit(Ref)
        oCon_0475_0478->Initial( oHandler );
        break;
      case 480: // UP: ( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover > ExitNoData )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 483: // UP: ( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover >> Stop )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 482: // UP: ( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover > ExitReadFailure )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >)
  class Reg_0470_0471 : public TsmRegion
  {
  private:
    Ini_0471_0472* oIni_0471_0472; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> InitialState )
    Fin_0471_0473* oFin_0471_0473; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> FinalState )
    Sub_0471_0474* oSub_0471_0474; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> Stop )
    Sub_0471_0475* oSub_0471_0475; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> StartRead )

  public:
    Reg_0470_0471( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0471_0472 = new Ini_0471_0472( this );
      oFin_0471_0473 = new Fin_0471_0473( this );
      oSub_0471_0474 = new Sub_0471_0474( this );
      oSub_0471_0475 = new Sub_0471_0475( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0471_0472;
      mStates[ 1 ] = oFin_0471_0473;
      mStates[ 2 ] = oSub_0471_0474;
      mStates[ 3 ] = oSub_0471_0475;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0471_0484( TsmHandler& oHandler );
    void Tra_0471_0479( TsmHandler& oHandler );
    void Tra_0471_0481( TsmHandler& oHandler );
    void Tra_0471_0483( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::OK|TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 484:
        Tra_0471_0484( oHandler );
        break;
      case 479:
        Tra_0471_0479( oHandler );
        break;
      case 481:
        Tra_0471_0481( oHandler );
        break;
      case 480: // Up: ( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover > ExitNoData )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 483:
        Tra_0471_0483( oHandler );
        break;
      case 482: // Up: ( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover > ExitReadFailure )
        mCurrentState = NULL;
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover )
  class Fsm_0158_0470 : public TsmFsm
  {
  private:
    Reg_0470_0471* oReg_0470_0471; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >)

  public:
    Fsm_0158_0470( TsmBase* oParent )
    {
      TsmName = "Tac_Recover";
      TsmParent = oParent;
      oReg_0470_0471 = new Reg_0470_0471( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0470_0471;
      mNrTransitions = 0;
    }

    void Tra_0471_0480( TsmHandler& oHandler );
    void Tra_0471_0482( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 480:
        Tra_0471_0480( oHandler );
        break;
      case 482:
        Tra_0471_0482( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> Recover )
  class Sub_0390_0397 : public TsmSubFsm
  {
  private:
    Con_0397_0398* oCon_0397_0398; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> Recover > ConnExitRef )

  public:
    Sub_0390_0397( TsmBase* oParent )
    {
      TsmName = "Recover";
      TsmParent = oParent;
      oFsm = new Fsm_0158_0470( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover )
      oCon_0397_0398 = new Con_0397_0398( this );
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 422, "( BackendFsm > Starting >> Recover ) => ( BackendFsm > Starting >> StartPlay )" );
    }

    void Tra_0390_0419( TsmHandler& oHandler );
    void ExecuteTriggerless( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    ~Sub_0390_0397()
    {
      delete oCon_0397_0398;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 419:
        Tra_0390_0419( oHandler );
        break;
      case 422: // UP: ( BackendFsm > Starting >> Recover ) => ( BackendFsm > Starting >> StartPlay )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 485: // UmlConnExit(Ref)
      case 486: // UmlConnExit(Ref)
        oCon_0397_0398->Initial( oHandler );
        break;
      case 416: // UP: ( BackendFsm > Starting >> Recover > ConnExitRef ) => ( BackendFsm > Starting >> JuncState )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> StartPlay > ConnExitRef )
  class Con_0399_0400 : public TsmState
  {
  public:
    Con_0399_0400( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 421, "( BackendFsm > Starting >> StartPlay > ConnExitRef ) => ( BackendFsm > Starting > ExitError )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 421: // UP: ( BackendFsm > Starting >> StartPlay > ConnExitRef ) => ( BackendFsm > Starting > ExitError )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> InitialState )
  class Ini_0225_0226 : public TsmPseudo
  {
  public:
    Ini_0225_0226( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 240, "( BackendFsm > Tac_StartPlay >> InitialState ) => ( BackendFsm > Tac_StartPlay >> CS )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 240: // UP: ( BackendFsm > Tac_StartPlay >> InitialState ) => ( BackendFsm > Tac_StartPlay >> CS )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> FinalState )
  class Fin_0225_0227 : public TsmFinal
  {
  public:
    Fin_0225_0227( TsmBase* oParent )
    {
      TsmName = "FinalState";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Tra_0229_0237( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 237:
        Tra_0229_0237( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> CS >> InitialState )
  class Ini_0229_0230 : public TsmPseudo
  {
  public:
    Ini_0229_0230( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 238, "( BackendFsm > Tac_StartPlay >> CS >> InitialState ) => ( BackendFsm > Tac_StartPlay >> CS >> Base )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 238: // UP: ( BackendFsm > Tac_StartPlay >> CS >> InitialState ) => ( BackendFsm > Tac_StartPlay >> CS >> Base )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> CS >> ChoiceState )
  class Cho_0229_0231 : public TsmPseudo
  {
  public:
    Cho_0229_0231( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 237, "( BackendFsm > Tac_StartPlay >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPlay >> FinalState ) : 'IsProxyOk'" );
      mTransitions[ 1 ] = new TsmTransition( 236, "( BackendFsm > Tac_StartPlay >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPlay >> CS >> Wait ) : 'IsProxyNok'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0229_0234( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 237: // UP: ( BackendFsm > Tac_StartPlay >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPlay >> FinalState )
        bHigher = true;
        break;
      case 236: // UP: ( BackendFsm > Tac_StartPlay >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPlay >> CS >> Wait )
        bHigher = true;
        break;
      case 234:
        Tra_0229_0234( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> CS >> Base )
  class Lea_0229_0232 : public TsmLeaf
  {
  public:
    Lea_0229_0232( TsmBase* oParent )
    {
      TsmName = "Base";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 234, "( BackendFsm > Tac_StartPlay >> CS >> Base ) => ( BackendFsm > Tac_StartPlay >> CS >> ChoiceState )" );
    }

    void Tra_0229_0238( TsmHandler& oHandler );
    void Initial( TsmHandler& oHandler );
    void Tra_0229_0235( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 238:
        Tra_0229_0238( oHandler );
        break;
      case 234: // UP: ( BackendFsm > Tac_StartPlay >> CS >> Base ) => ( BackendFsm > Tac_StartPlay >> CS >> ChoiceState )
        bHigher = true;
        break;
      case 235:
        Tra_0229_0235( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> CS >> Wait )
  class Lea_0229_0233 : public TsmLeaf
  {
  public:
    Lea_0229_0233( TsmBase* oParent )
    {
      TsmName = "Wait";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 235, "( BackendFsm > Tac_StartPlay >> CS >> Wait ) => ( BackendFsm > Tac_StartPlay >> CS >> Base )" );
    }

    void Tra_0229_0236( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 236:
        Tra_0229_0236( oHandler );
        break;
      case 235: // UP: ( BackendFsm > Tac_StartPlay >> CS >> Wait ) => ( BackendFsm > Tac_StartPlay >> CS >> Base )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> CS >)
  class Reg_0228_0229 : public TsmRegion
  {
  private:
    Ini_0229_0230* oIni_0229_0230; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> CS >> InitialState )
    Cho_0229_0231* oCho_0229_0231; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> CS >> ChoiceState )
    Lea_0229_0232* oLea_0229_0232; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> CS >> Base )
    Lea_0229_0233* oLea_0229_0233; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> CS >> Wait )

  public:
    Reg_0228_0229( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0229_0230 = new Ini_0229_0230( this );
      oCho_0229_0231 = new Cho_0229_0231( this );
      oLea_0229_0232 = new Lea_0229_0232( this );
      oLea_0229_0233 = new Lea_0229_0233( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0229_0230;
      mStates[ 1 ] = oCho_0229_0231;
      mStates[ 2 ] = oLea_0229_0232;
      mStates[ 3 ] = oLea_0229_0233;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0229_0238( TsmHandler& oHandler );
    void Tra_0229_0236( TsmHandler& oHandler );
    void Tra_0229_0234( TsmHandler& oHandler );
    void Tra_0229_0235( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 238:
        Tra_0229_0238( oHandler );
        break;
      case 237: // Up: ( BackendFsm > Tac_StartPlay >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPlay >> FinalState )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 236:
        Tra_0229_0236( oHandler );
        break;
      case 234:
        Tra_0229_0234( oHandler );
        break;
      case 235:
        Tra_0229_0235( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> CS )
  class Com_0225_0228 : public TsmCompound
  {
  private:
    Reg_0228_0229* oReg_0228_0229; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> CS >)

  public:
    Com_0225_0228( TsmBase* oParent )
    {
      TsmName = "CS";
      TsmParent = oParent;
      oReg_0228_0229 = new Reg_0228_0229( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0228_0229;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 239, "( BackendFsm > Tac_StartPlay >> CS ) => ( BackendFsm > Tac_StartPlay > ExitReadError ) : rpp_reader->Px_CbError" );
      mTransitions[ 1 ] = new TsmTransition( 241, "( BackendFsm > Tac_StartPlay >> CS ) => ( BackendFsm > Tac_StartPlay > ExitSynclost ) : rpp_display->Px_CbSynclost" );
    }

    void Tra_0225_0240( TsmHandler& oHandler );
    void rpp_reader___Px_CbError( int BadSector, TsmHandler& oHandler );
    void rpp_display___Px_CbSynclost( tTime BadTime, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 156:
        switch ( Command )
        {
        case 33:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 43:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 240:
        Tra_0225_0240( oHandler );
        break;
      case 237: // UP: ( BackendFsm > Tac_StartPlay >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPlay >> FinalState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 239: // UP: ( BackendFsm > Tac_StartPlay >> CS ) => ( BackendFsm > Tac_StartPlay > ExitReadError )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 241: // UP: ( BackendFsm > Tac_StartPlay >> CS ) => ( BackendFsm > Tac_StartPlay > ExitSynclost )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >)
  class Reg_0224_0225 : public TsmRegion
  {
  private:
    Ini_0225_0226* oIni_0225_0226; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> InitialState )
    Fin_0225_0227* oFin_0225_0227; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> FinalState )
    Com_0225_0228* oCom_0225_0228; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> CS )

  public:
    Reg_0224_0225( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0225_0226 = new Ini_0225_0226( this );
      oFin_0225_0227 = new Fin_0225_0227( this );
      oCom_0225_0228 = new Com_0225_0228( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0225_0226;
      mStates[ 1 ] = oFin_0225_0227;
      mStates[ 2 ] = oCom_0225_0228;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0225_0240( TsmHandler& oHandler );
    void Tra_0229_0237( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::OK|TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::OK|TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 240:
        Tra_0225_0240( oHandler );
        break;
      case 237:
        Tra_0229_0237( oHandler );
        break;
      case 239: // Up: ( BackendFsm > Tac_StartPlay >> CS ) => ( BackendFsm > Tac_StartPlay > ExitReadError )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 241: // Up: ( BackendFsm > Tac_StartPlay >> CS ) => ( BackendFsm > Tac_StartPlay > ExitSynclost )
        mCurrentState = NULL;
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay )
  class Fsm_0158_0224 : public TsmFsm
  {
  private:
    Reg_0224_0225* oReg_0224_0225; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >)

  public:
    Fsm_0158_0224( TsmBase* oParent )
    {
      TsmName = "Tac_StartPlay";
      TsmParent = oParent;
      oReg_0224_0225 = new Reg_0224_0225( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0224_0225;
      mNrTransitions = 0;
    }

    void Tra_0225_0239( TsmHandler& oHandler );
    void Tra_0225_0241( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 239:
        Tra_0225_0239( oHandler );
        break;
      case 241:
        Tra_0225_0241( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> StartPlay )
  class Sub_0390_0399 : public TsmSubFsm
  {
  private:
    Con_0399_0400* oCon_0399_0400; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> StartPlay > ConnExitRef )

  public:
    Sub_0390_0399( TsmBase* oParent )
    {
      TsmName = "StartPlay";
      TsmParent = oParent;
      oFsm = new Fsm_0158_0224( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay )
      oCon_0399_0400 = new Con_0399_0400( this );
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 420, "( BackendFsm > Starting >> StartPlay ) => ( BackendFsm > Starting >> FinalState )" );
    }

    void Tra_0390_0423( TsmHandler& oHandler );
    void Tra_0390_0422( TsmHandler& oHandler );
    void ExecuteTriggerless( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    ~Sub_0390_0399()
    {
      delete oCon_0399_0400;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 423:
        Tra_0390_0423( oHandler );
        break;
      case 422:
        Tra_0390_0422( oHandler );
        break;
      case 420: // UP: ( BackendFsm > Starting >> StartPlay ) => ( BackendFsm > Starting >> FinalState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 242: // UmlConnExit(Ref)
      case 243: // UmlConnExit(Ref)
        oCon_0399_0400->Initial( oHandler );
        break;
      case 421: // UP: ( BackendFsm > Starting >> StartPlay > ConnExitRef ) => ( BackendFsm > Starting > ExitError )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open >> InitialState )
  class Ini_0402_0403 : public TsmPseudo
  {
  public:
    Ini_0402_0403( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 410, "( BackendFsm > Starting >> CS_Open >> InitialState ) => ( BackendFsm > Starting >> CS_Open >> Base )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 410: // UP: ( BackendFsm > Starting >> CS_Open >> InitialState ) => ( BackendFsm > Starting >> CS_Open >> Base )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open >> ChoiceState )
  class Cho_0402_0404 : public TsmPseudo
  {
  public:
    Cho_0402_0404( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 409, "( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting >> CS_Open >> ChoiceState ) : 'IsProxyOk'" );
      mTransitions[ 1 ] = new TsmTransition( 411, "( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting >> CS_Open >> Wait ) : 'IsProxyNok'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0402_0408( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 409: // UP: ( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting >> CS_Open >> ChoiceState )
        bHigher = true;
        break;
      case 411: // UP: ( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting >> CS_Open >> Wait )
        bHigher = true;
        break;
      case 408:
        Tra_0402_0408( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open >> ChoiceState )
  class Cho_0402_0405 : public TsmPseudo
  {
  public:
    Cho_0402_0405( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 413, "( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting >> StartRead )" );
      mTransitions[ 1 ] = new TsmTransition( 414, "( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting > ExitError )" );
    }

    void Tra_0402_0409( TsmHandler& oHandler );
    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 409:
        Tra_0402_0409( oHandler );
        break;
      case 413: // UP: ( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting >> StartRead )
        bHigher = true;
        break;
      case 414: // UP: ( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting > ExitError )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open >> Base )
  class Lea_0402_0406 : public TsmLeaf
  {
  public:
    Lea_0402_0406( TsmBase* oParent )
    {
      TsmName = "Base";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 408, "( BackendFsm > Starting >> CS_Open >> Base ) => ( BackendFsm > Starting >> CS_Open >> ChoiceState )" );
    }

    void Tra_0402_0410( TsmHandler& oHandler );
    void Initial( TsmHandler& oHandler );
    void Tra_0402_0412( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 410:
        Tra_0402_0410( oHandler );
        break;
      case 408: // UP: ( BackendFsm > Starting >> CS_Open >> Base ) => ( BackendFsm > Starting >> CS_Open >> ChoiceState )
        bHigher = true;
        break;
      case 412:
        Tra_0402_0412( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open >> Wait )
  class Lea_0402_0407 : public TsmLeaf
  {
  public:
    Lea_0402_0407( TsmBase* oParent )
    {
      TsmName = "Wait";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 412, "( BackendFsm > Starting >> CS_Open >> Wait ) => ( BackendFsm > Starting >> CS_Open >> Base )" );
    }

    void Tra_0402_0411( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 411:
        Tra_0402_0411( oHandler );
        break;
      case 412: // UP: ( BackendFsm > Starting >> CS_Open >> Wait ) => ( BackendFsm > Starting >> CS_Open >> Base )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open >)
  class Reg_0401_0402 : public TsmRegion
  {
  private:
    Ini_0402_0403* oIni_0402_0403; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open >> InitialState )
    Cho_0402_0404* oCho_0402_0404; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open >> ChoiceState )
    Cho_0402_0405* oCho_0402_0405; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open >> ChoiceState )
    Lea_0402_0406* oLea_0402_0406; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open >> Base )
    Lea_0402_0407* oLea_0402_0407; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open >> Wait )

  public:
    Reg_0401_0402( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0402_0403 = new Ini_0402_0403( this );
      oCho_0402_0404 = new Cho_0402_0404( this );
      oCho_0402_0405 = new Cho_0402_0405( this );
      oLea_0402_0406 = new Lea_0402_0406( this );
      oLea_0402_0407 = new Lea_0402_0407( this );
      mNrStates = 5;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0402_0403;
      mStates[ 1 ] = oCho_0402_0404;
      mStates[ 2 ] = oCho_0402_0405;
      mStates[ 3 ] = oLea_0402_0406;
      mStates[ 4 ] = oLea_0402_0407;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0402_0410( TsmHandler& oHandler );
    void Tra_0402_0409( TsmHandler& oHandler );
    void Tra_0402_0411( TsmHandler& oHandler );
    void Tra_0402_0408( TsmHandler& oHandler );
    void Tra_0402_0412( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 410:
        Tra_0402_0410( oHandler );
        break;
      case 409:
        Tra_0402_0409( oHandler );
        break;
      case 411:
        Tra_0402_0411( oHandler );
        break;
      case 413: // Up: ( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting >> StartRead )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 414: // Up: ( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting > ExitError )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 408:
        Tra_0402_0408( oHandler );
        break;
      case 412:
        Tra_0402_0412( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open )
  class Com_0390_0401 : public TsmCompound
  {
  private:
    Reg_0401_0402* oReg_0401_0402; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open >)

  public:
    Com_0390_0401( TsmBase* oParent )
    {
      TsmName = "CS_Open";
      TsmParent = oParent;
      oReg_0401_0402 = new Reg_0401_0402( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0401_0402;
      mNrTransitions = 0;
    }

    void Tra_0390_0415( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 415:
        Tra_0390_0415( oHandler );
        break;
      case 413: // UP: ( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting >> StartRead )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 414: // UP: ( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting > ExitError )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >)
  class Reg_0389_0390 : public TsmRegion
  {
  private:
    Ini_0390_0391* oIni_0390_0391; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> InitialState )
    Fin_0390_0392* oFin_0390_0392; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> FinalState )
    Jun_0390_0393* oJun_0390_0393; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> JuncState )
    Sub_0390_0394* oSub_0390_0394; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> StartRead )
    Sub_0390_0397* oSub_0390_0397; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> Recover )
    Sub_0390_0399* oSub_0390_0399; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> StartPlay )
    Com_0390_0401* oCom_0390_0401; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open )

  public:
    Reg_0389_0390( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0390_0391 = new Ini_0390_0391( this );
      oFin_0390_0392 = new Fin_0390_0392( this );
      oJun_0390_0393 = new Jun_0390_0393( this );
      oSub_0390_0394 = new Sub_0390_0394( this );
      oSub_0390_0397 = new Sub_0390_0397( this );
      oSub_0390_0399 = new Sub_0390_0399( this );
      oCom_0390_0401 = new Com_0390_0401( this );
      mNrStates = 7;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0390_0391;
      mStates[ 1 ] = oFin_0390_0392;
      mStates[ 2 ] = oJun_0390_0393;
      mStates[ 3 ] = oSub_0390_0394;
      mStates[ 4 ] = oSub_0390_0397;
      mStates[ 5 ] = oSub_0390_0399;
      mStates[ 6 ] = oCom_0390_0401;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0390_0415( TsmHandler& oHandler );
    void Tra_0390_0423( TsmHandler& oHandler );
    void Tra_0390_0419( TsmHandler& oHandler );
    void Tra_0390_0417( TsmHandler& oHandler );
    void Tra_0390_0422( TsmHandler& oHandler );
    void Tra_0390_0416( TsmHandler& oHandler );
    void Tra_0390_0420( TsmHandler& oHandler );
    void Tra_0402_0413( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::OK|TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::OK|TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 415:
        Tra_0390_0415( oHandler );
        break;
      case 418: // Up: ( BackendFsm > Starting >> JuncState ) => ( BackendFsm > Starting > ExitError )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 423:
        Tra_0390_0423( oHandler );
        break;
      case 419:
        Tra_0390_0419( oHandler );
        break;
      case 417:
        Tra_0390_0417( oHandler );
        break;
      case 422:
        Tra_0390_0422( oHandler );
        break;
      case 416:
        Tra_0390_0416( oHandler );
        break;
      case 420:
        Tra_0390_0420( oHandler );
        break;
      case 421: // Up: ( BackendFsm > Starting >> StartPlay > ConnExitRef ) => ( BackendFsm > Starting > ExitError )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 413:
        Tra_0402_0413( oHandler );
        break;
      case 414: // Up: ( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting > ExitError )
        mCurrentState = NULL;
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting )
  class Fsm_0158_0389 : public TsmFsm
  {
  private:
    Reg_0389_0390* oReg_0389_0390; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >)

  public:
    Fsm_0158_0389( TsmBase* oParent )
    {
      TsmName = "Starting";
      TsmParent = oParent;
      oReg_0389_0390 = new Reg_0389_0390( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0389_0390;
      mNrTransitions = 0;
    }

    void Tra_0390_0418( TsmHandler& oHandler );
    void Tra_0390_0421( TsmHandler& oHandler );
    void Tra_0402_0414( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 418:
        Tra_0390_0418( oHandler );
        break;
      case 421:
        Tra_0390_0421( oHandler );
        break;
      case 414:
        Tra_0402_0414( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Starting )
  class Sub_0175_0179 : public TsmSubFsm
  {
  private:
    Con_0179_0180* oCon_0179_0180; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Starting > ConnExitRef )

  public:
    Sub_0175_0179( TsmBase* oParent )
    {
      TsmName = "Starting";
      TsmParent = oParent;
      oFsm = new Fsm_0158_0389( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting )
      oCon_0179_0180 = new Con_0179_0180( this );
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 199, "( BackendFsm >> Active >> Starting ) => ( BackendFsm >> Active >> Play )" );
    }

    void Tra_0163_0169( TsmHandler& oHandler );
    void ExecuteTriggerless( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    ~Sub_0175_0179()
    {
      delete oCon_0179_0180;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 169:
        Tra_0163_0169( oHandler );
        break;
      case 199: // UP: ( BackendFsm >> Active >> Starting ) => ( BackendFsm >> Active >> Play )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 424: // UmlConnExit(Ref)
        oCon_0179_0180->Initial( oHandler );
        break;
      case 212: // UP: ( BackendFsm >> Active >> Starting > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Play > ConnExitRef )
  class Con_0181_0182 : public TsmState
  {
  public:
    Con_0181_0182( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 208, "( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 208: // UP: ( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Play > ConnExitRef )
  class Con_0181_0183 : public TsmState
  {
  public:
    Con_0181_0183( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 207, "( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 207: // UP: ( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Play > ConnExitRef )
  class Con_0181_0184 : public TsmState
  {
  public:
    Con_0181_0184( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 204, "( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> Pausing > ConnEntryRef )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 204: // UP: ( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> Pausing > ConnEntryRef )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Play > ConnExitRef )
  class Con_0181_0185 : public TsmState
  {
  public:
    Con_0181_0185( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 205, "( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> Pausing > ConnEntryRef )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 205: // UP: ( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> Pausing > ConnEntryRef )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> InitialState )
  class Ini_0268_0269 : public TsmPseudo
  {
  public:
    Ini_0268_0269( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 283, "( BackendFsm > Play >> InitialState ) => ( BackendFsm > Play >> Base )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 283: // UP: ( BackendFsm > Play >> InitialState ) => ( BackendFsm > Play >> Base )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> JuncState )
  class Jun_0268_0270 : public TsmPseudo
  {
  public:
    Jun_0268_0270( TsmBase* oParent )
    {
      TsmName = "JuncState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 292, "( BackendFsm > Play >> JuncState ) => ( BackendFsm > Play >> Recover )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0268_0288( TsmHandler& oHandler );
    void Tra_0268_0284( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 292: // UP: ( BackendFsm > Play >> JuncState ) => ( BackendFsm > Play >> Recover )
        bHigher = true;
        break;
      case 288:
        Tra_0268_0288( oHandler );
        break;
      case 284:
        Tra_0268_0284( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> JuncState )
  class Jun_0268_0271 : public TsmPseudo
  {
  public:
    Jun_0268_0271( TsmBase* oParent )
    {
      TsmName = "JuncState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 293, "( BackendFsm > Play >> JuncState ) => ( BackendFsm > Play >> Recover )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0268_0287( TsmHandler& oHandler );
    void Tra_0268_0285( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 293: // UP: ( BackendFsm > Play >> JuncState ) => ( BackendFsm > Play >> Recover )
        bHigher = true;
        break;
      case 287:
        Tra_0268_0287( oHandler );
        break;
      case 285:
        Tra_0268_0285( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> Recover > ConnExitRef )
  class Con_0272_0273 : public TsmState
  {
  public:
    Con_0272_0273( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 281, "( BackendFsm > Play >> Recover > ConnExitRef ) => ( BackendFsm > Play > ExitFinished )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 281: // UP: ( BackendFsm > Play >> Recover > ConnExitRef ) => ( BackendFsm > Play > ExitFinished )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> Recover > ConnExitRef )
  class Con_0272_0274 : public TsmState
  {
  public:
    Con_0272_0274( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 286, "( BackendFsm > Play >> Recover > ConnExitRef ) => ( BackendFsm > Play > ExitError )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 286: // UP: ( BackendFsm > Play >> Recover > ConnExitRef ) => ( BackendFsm > Play > ExitError )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> Recover )
  class Sub_0268_0272 : public TsmSubFsm
  {
  private:
    Con_0272_0273* oCon_0272_0273; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> Recover > ConnExitRef )
    Con_0272_0274* oCon_0272_0274; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> Recover > ConnExitRef )

  public:
    Sub_0268_0272( TsmBase* oParent )
    {
      TsmName = "Recover";
      TsmParent = oParent;
      oFsm = new Fsm_0158_0470( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover )
      oCon_0272_0273 = new Con_0272_0273( this );
      oCon_0272_0274 = new Con_0272_0274( this );
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 279, "( BackendFsm > Play >> Recover ) => ( BackendFsm > Play >> StartPlay )" );
      mTransitions[ 1 ] = new TsmTransition( 290, "( BackendFsm > Play >> Recover ) => ( BackendFsm > Play > ExitPauseRecover ) : pp_player->Pause" );
    }

    void Tra_0268_0292( TsmHandler& oHandler );
    void Tra_0268_0293( TsmHandler& oHandler );
    void ExecuteTriggerless( TsmHandler& oHandler );
    void pp_player___Pause( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerSubFsm( TsmHandler& oHandler );

    ~Sub_0268_0272()
    {
      delete oCon_0272_0273;
      delete oCon_0272_0274;
    }

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 27:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 292:
        Tra_0268_0292( oHandler );
        break;
      case 293:
        Tra_0268_0293( oHandler );
        break;
      case 279: // UP: ( BackendFsm > Play >> Recover ) => ( BackendFsm > Play >> StartPlay )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 485: // UmlConnExit(Ref)
        oCon_0272_0273->Initial( oHandler );
        break;
      case 486: // UmlConnExit(Ref)
        oCon_0272_0274->Initial( oHandler );
        break;
      case 281: // UP: ( BackendFsm > Play >> Recover > ConnExitRef ) => ( BackendFsm > Play > ExitFinished )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 286: // UP: ( BackendFsm > Play >> Recover > ConnExitRef ) => ( BackendFsm > Play > ExitError )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 290: // UP: ( BackendFsm > Play >> Recover ) => ( BackendFsm > Play > ExitPauseRecover )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> StartPlay > ConnExitRef )
  class Con_0275_0276 : public TsmState
  {
  public:
    Con_0275_0276( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 287, "( BackendFsm > Play >> StartPlay > ConnExitRef ) => ( BackendFsm > Play >> JuncState )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 287: // UP: ( BackendFsm > Play >> StartPlay > ConnExitRef ) => ( BackendFsm > Play >> JuncState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> StartPlay > ConnExitRef )
  class Con_0275_0277 : public TsmState
  {
  public:
    Con_0275_0277( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 288, "( BackendFsm > Play >> StartPlay > ConnExitRef ) => ( BackendFsm > Play >> JuncState )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 288: // UP: ( BackendFsm > Play >> StartPlay > ConnExitRef ) => ( BackendFsm > Play >> JuncState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> StartPlay )
  class Sub_0268_0275 : public TsmSubFsm
  {
  private:
    Con_0275_0276* oCon_0275_0276; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> StartPlay > ConnExitRef )
    Con_0275_0277* oCon_0275_0277; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> StartPlay > ConnExitRef )

  public:
    Sub_0268_0275( TsmBase* oParent )
    {
      TsmName = "StartPlay";
      TsmParent = oParent;
      oFsm = new Fsm_0158_0224( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay )
      oCon_0275_0276 = new Con_0275_0276( this );
      oCon_0275_0277 = new Con_0275_0277( this );
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 282, "( BackendFsm > Play >> StartPlay ) => ( BackendFsm > Play >> Base )" );
      mTransitions[ 1 ] = new TsmTransition( 291, "( BackendFsm > Play >> StartPlay ) => ( BackendFsm > Play > ExitPauseStart ) : pp_player->Pause" );
    }

    void Tra_0268_0279( TsmHandler& oHandler );
    void ExecuteTriggerless( TsmHandler& oHandler );
    void pp_player___Pause( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerSubFsm( TsmHandler& oHandler );

    ~Sub_0268_0275()
    {
      delete oCon_0275_0276;
      delete oCon_0275_0277;
    }

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 27:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 279:
        Tra_0268_0279( oHandler );
        break;
      case 282: // UP: ( BackendFsm > Play >> StartPlay ) => ( BackendFsm > Play >> Base )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 243: // UmlConnExit(Ref)
        oCon_0275_0276->Initial( oHandler );
        break;
      case 242: // UmlConnExit(Ref)
        oCon_0275_0277->Initial( oHandler );
        break;
      case 287: // UP: ( BackendFsm > Play >> StartPlay > ConnExitRef ) => ( BackendFsm > Play >> JuncState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 288: // UP: ( BackendFsm > Play >> StartPlay > ConnExitRef ) => ( BackendFsm > Play >> JuncState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 291: // UP: ( BackendFsm > Play >> StartPlay ) => ( BackendFsm > Play > ExitPauseStart )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> Base )
  class Lea_0268_0278 : public TsmLeaf
  {
  public:
    Lea_0268_0278( TsmBase* oParent )
    {
      TsmName = "Base";
      TsmParent = oParent;
      mNrTransitions = 4;
      mTransitions = new TsmTransition*[ 4 ];
      mTransitions[ 0 ] = new TsmTransition( 289, "( BackendFsm > Play >> Base ) => ( BackendFsm > Play > ExitPause ) : pp_player->Pause" );
      mTransitions[ 1 ] = new TsmTransition( 284, "( BackendFsm > Play >> Base ) => ( BackendFsm > Play >> JuncState ) : rpp_reader->Px_CbError" );
      mTransitions[ 2 ] = new TsmTransition( 280, "( BackendFsm > Play >> Base ) => ( BackendFsm > Play > ExitFinished ) : rpp_display->Px_CbFinished" );
      mTransitions[ 3 ] = new TsmTransition( 285, "( BackendFsm > Play >> Base ) => ( BackendFsm > Play >> JuncState ) : rpp_display->Px_CbSynclost" );
    }

    void Tra_0268_0283( TsmHandler& oHandler );
    void Tra_0268_0282( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void pp_player___Pause( TsmHandler& oHandler );
    void rpp_reader___Px_CbError( int BadSector, TsmHandler& oHandler );
    void rpp_display___Px_CbFinished( TsmHandler& oHandler );
    void rpp_display___Px_CbSynclost( tTime BadTime, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 27:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 33:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 38:
          return TsmProspect::OK;
        case 43:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 283:
        Tra_0268_0283( oHandler );
        break;
      case 282:
        Tra_0268_0282( oHandler );
        break;
      case 289: // UP: ( BackendFsm > Play >> Base ) => ( BackendFsm > Play > ExitPause )
        bHigher = true;
        break;
      case 284: // UP: ( BackendFsm > Play >> Base ) => ( BackendFsm > Play >> JuncState )
        bHigher = true;
        break;
      case 280: // UP: ( BackendFsm > Play >> Base ) => ( BackendFsm > Play > ExitFinished )
        bHigher = true;
        break;
      case 285: // UP: ( BackendFsm > Play >> Base ) => ( BackendFsm > Play >> JuncState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >)
  class Reg_0267_0268 : public TsmRegion
  {
  private:
    Ini_0268_0269* oIni_0268_0269; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> InitialState )
    Jun_0268_0270* oJun_0268_0270; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> JuncState )
    Jun_0268_0271* oJun_0268_0271; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> JuncState )
    Sub_0268_0272* oSub_0268_0272; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> Recover )
    Sub_0268_0275* oSub_0268_0275; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> StartPlay )
    Lea_0268_0278* oLea_0268_0278; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> Base )

  public:
    Reg_0267_0268( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0268_0269 = new Ini_0268_0269( this );
      oJun_0268_0270 = new Jun_0268_0270( this );
      oJun_0268_0271 = new Jun_0268_0271( this );
      oSub_0268_0272 = new Sub_0268_0272( this );
      oSub_0268_0275 = new Sub_0268_0275( this );
      oLea_0268_0278 = new Lea_0268_0278( this );
      mNrStates = 6;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0268_0269;
      mStates[ 1 ] = oJun_0268_0270;
      mStates[ 2 ] = oJun_0268_0271;
      mStates[ 3 ] = oSub_0268_0272;
      mStates[ 4 ] = oSub_0268_0275;
      mStates[ 5 ] = oLea_0268_0278;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0268_0283( TsmHandler& oHandler );
    void Tra_0268_0292( TsmHandler& oHandler );
    void Tra_0268_0293( TsmHandler& oHandler );
    void Tra_0268_0279( TsmHandler& oHandler );
    void Tra_0268_0282( TsmHandler& oHandler );
    void Tra_0268_0287( TsmHandler& oHandler );
    void Tra_0268_0288( TsmHandler& oHandler );
    void Tra_0268_0284( TsmHandler& oHandler );
    void Tra_0268_0285( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::OK|TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::OK|TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::OK|TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::OK|TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 283:
        Tra_0268_0283( oHandler );
        break;
      case 292:
        Tra_0268_0292( oHandler );
        break;
      case 293:
        Tra_0268_0293( oHandler );
        break;
      case 279:
        Tra_0268_0279( oHandler );
        break;
      case 281: // Up: ( BackendFsm > Play >> Recover > ConnExitRef ) => ( BackendFsm > Play > ExitFinished )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 286: // Up: ( BackendFsm > Play >> Recover > ConnExitRef ) => ( BackendFsm > Play > ExitError )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 282:
        Tra_0268_0282( oHandler );
        break;
      case 287:
        Tra_0268_0287( oHandler );
        break;
      case 288:
        Tra_0268_0288( oHandler );
        break;
      case 290: // Up: ( BackendFsm > Play >> Recover ) => ( BackendFsm > Play > ExitPauseRecover )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 291: // Up: ( BackendFsm > Play >> StartPlay ) => ( BackendFsm > Play > ExitPauseStart )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 289: // Up: ( BackendFsm > Play >> Base ) => ( BackendFsm > Play > ExitPause )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 284:
        Tra_0268_0284( oHandler );
        break;
      case 280: // Up: ( BackendFsm > Play >> Base ) => ( BackendFsm > Play > ExitFinished )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 285:
        Tra_0268_0285( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play )
  class Fsm_0158_0267 : public TsmFsm
  {
  private:
    Reg_0267_0268* oReg_0267_0268; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >)

  public:
    Fsm_0158_0267( TsmBase* oParent )
    {
      TsmName = "Play";
      TsmParent = oParent;
      oReg_0267_0268 = new Reg_0267_0268( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0267_0268;
      mNrTransitions = 0;
    }

    void Tra_0268_0281( TsmHandler& oHandler );
    void Tra_0268_0286( TsmHandler& oHandler );
    void Tra_0268_0290( TsmHandler& oHandler );
    void Tra_0268_0291( TsmHandler& oHandler );
    void Tra_0268_0289( TsmHandler& oHandler );
    void Tra_0268_0280( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 281:
        Tra_0268_0281( oHandler );
        break;
      case 286:
        Tra_0268_0286( oHandler );
        break;
      case 290:
        Tra_0268_0290( oHandler );
        break;
      case 291:
        Tra_0268_0291( oHandler );
        break;
      case 289:
        Tra_0268_0289( oHandler );
        break;
      case 280:
        Tra_0268_0280( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Play )
  class Sub_0175_0181 : public TsmSubFsm
  {
  private:
    Con_0181_0182* oCon_0181_0182; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Play > ConnExitRef )
    Con_0181_0183* oCon_0181_0183; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Play > ConnExitRef )
    Con_0181_0184* oCon_0181_0184; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Play > ConnExitRef )
    Con_0181_0185* oCon_0181_0185; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Play > ConnExitRef )

  public:
    Sub_0175_0181( TsmBase* oParent )
    {
      TsmName = "Play";
      TsmParent = oParent;
      oFsm = new Fsm_0158_0267( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play )
      oCon_0181_0182 = new Con_0181_0182( this );
      oCon_0181_0183 = new Con_0181_0183( this );
      oCon_0181_0184 = new Con_0181_0184( this );
      oCon_0181_0185 = new Con_0181_0185( this );
      mNrTransitions = 0;
    }

    void Tra_0175_0199( TsmHandler& oHandler );
    void Tra_0175_0210( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    ~Sub_0175_0181()
    {
      delete oCon_0181_0182;
      delete oCon_0181_0183;
      delete oCon_0181_0184;
      delete oCon_0181_0185;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 199:
        Tra_0175_0199( oHandler );
        break;
      case 295: // UmlConnExit(Ref)
        oCon_0181_0182->Initial( oHandler );
        break;
      case 294: // UmlConnExit(Ref)
        oCon_0181_0183->Initial( oHandler );
        break;
      case 296: // UmlConnExit(Ref)
      case 298: // UmlConnExit(Ref)
        oCon_0181_0184->Initial( oHandler );
        break;
      case 297: // UmlConnExit(Ref)
        oCon_0181_0185->Initial( oHandler );
        break;
      case 208: // UP: ( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 207: // UP: ( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 204: // UP: ( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> Pausing > ConnEntryRef )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 205: // UP: ( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> Pausing > ConnEntryRef )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 210:
        Tra_0175_0210( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Pausing > ConnEntryRef )
  class Con_0186_0187 : public TsmState
  {
  public:
    Con_0186_0187( TsmBase* oParent )
    {
      TsmName = "ConnEntryRef";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Pausing > ConnEntryRef )
  class Con_0186_0188 : public TsmState
  {
  public:
    Con_0186_0188( TsmBase* oParent )
    {
      TsmName = "ConnEntryRef";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Pausing > ConnExitRef )
  class Con_0186_0189 : public TsmState
  {
  public:
    Con_0186_0189( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 206, "( BackendFsm >> Active >> Pausing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 206: // UP: ( BackendFsm >> Active >> Pausing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Pausing > ConnExitRef )
  class Con_0186_0190 : public TsmState
  {
  public:
    Con_0186_0190( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 211, "( BackendFsm >> Active >> Pausing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 211: // UP: ( BackendFsm >> Active >> Pausing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> FinalState )
  class Fin_0245_0246 : public TsmFinal
  {
  public:
    Fin_0245_0246( TsmBase* oParent )
    {
      TsmName = "FinalState";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Tra_0245_0255( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 255:
        Tra_0245_0255( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> StartPause > ConnExitRef )
  class Con_0247_0248 : public TsmState
  {
  public:
    Con_0247_0248( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 258, "( BackendFsm > Pausing >> StartPause > ConnExitRef ) => ( BackendFsm > Pausing >> Recover )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 258: // UP: ( BackendFsm > Pausing >> StartPause > ConnExitRef ) => ( BackendFsm > Pausing >> Recover )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> StartPause > ConnExitRef )
  class Con_0247_0249 : public TsmState
  {
  public:
    Con_0247_0249( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 259, "( BackendFsm > Pausing >> StartPause > ConnExitRef ) => ( BackendFsm > Pausing >> Recover )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 259: // UP: ( BackendFsm > Pausing >> StartPause > ConnExitRef ) => ( BackendFsm > Pausing >> Recover )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> StartPause > ConnExitRef )
  class Con_0247_0250 : public TsmState
  {
  public:
    Con_0247_0250( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 261, "( BackendFsm > Pausing >> StartPause > ConnExitRef ) => ( BackendFsm > Pausing > ExitFinished )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 261: // UP: ( BackendFsm > Pausing >> StartPause > ConnExitRef ) => ( BackendFsm > Pausing > ExitFinished )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> InitialState )
  class Ini_0365_0366 : public TsmPseudo
  {
  public:
    Ini_0365_0366( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 383, "( BackendFsm > Tac_StartPause >> InitialState ) => ( BackendFsm > Tac_StartPause >> CS )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 383: // UP: ( BackendFsm > Tac_StartPause >> InitialState ) => ( BackendFsm > Tac_StartPause >> CS )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> FinalState )
  class Fin_0365_0367 : public TsmFinal
  {
  public:
    Fin_0365_0367( TsmBase* oParent )
    {
      TsmName = "FinalState";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Tra_0369_0380( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 380:
        Tra_0369_0380( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS >> InitialState )
  class Ini_0369_0370 : public TsmPseudo
  {
  public:
    Ini_0369_0370( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 378, "( BackendFsm > Tac_StartPause >> CS >> InitialState ) => ( BackendFsm > Tac_StartPause >> CS >> Base )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 378: // UP: ( BackendFsm > Tac_StartPause >> CS >> InitialState ) => ( BackendFsm > Tac_StartPause >> CS >> Base )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS >> ChoiceState )
  class Cho_0369_0371 : public TsmPseudo
  {
  public:
    Cho_0369_0371( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 379, "( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) : 'IsProxyOk'" );
      mTransitions[ 1 ] = new TsmTransition( 377, "( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> CS >> Wait ) : 'IsProxyNok'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0369_0375( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 379: // UP: ( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> CS >> ChoiceState )
        bHigher = true;
        break;
      case 377: // UP: ( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> CS >> Wait )
        bHigher = true;
        break;
      case 375:
        Tra_0369_0375( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS >> ChoiceState )
  class Cho_0369_0372 : public TsmPseudo
  {
  public:
    Cho_0369_0372( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 380, "( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> FinalState )" );
      mTransitions[ 1 ] = new TsmTransition( 381, "( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> CS >> Wait )" );
    }

    void Tra_0369_0379( TsmHandler& oHandler );
    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 379:
        Tra_0369_0379( oHandler );
        break;
      case 380: // UP: ( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> FinalState )
        bHigher = true;
        break;
      case 381: // UP: ( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> CS >> Wait )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS >> Base )
  class Lea_0369_0373 : public TsmLeaf
  {
  public:
    Lea_0369_0373( TsmBase* oParent )
    {
      TsmName = "Base";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 375, "( BackendFsm > Tac_StartPause >> CS >> Base ) => ( BackendFsm > Tac_StartPause >> CS >> ChoiceState )" );
    }

    void Tra_0369_0378( TsmHandler& oHandler );
    void Initial( TsmHandler& oHandler );
    void Tra_0369_0376( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 378:
        Tra_0369_0378( oHandler );
        break;
      case 375: // UP: ( BackendFsm > Tac_StartPause >> CS >> Base ) => ( BackendFsm > Tac_StartPause >> CS >> ChoiceState )
        bHigher = true;
        break;
      case 376:
        Tra_0369_0376( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS >> Wait )
  class Lea_0369_0374 : public TsmLeaf
  {
  public:
    Lea_0369_0374( TsmBase* oParent )
    {
      TsmName = "Wait";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 376, "( BackendFsm > Tac_StartPause >> CS >> Wait ) => ( BackendFsm > Tac_StartPause >> CS >> Base )" );
    }

    void Tra_0369_0377( TsmHandler& oHandler );
    void Tra_0369_0381( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 377:
        Tra_0369_0377( oHandler );
        break;
      case 381:
        Tra_0369_0381( oHandler );
        break;
      case 376: // UP: ( BackendFsm > Tac_StartPause >> CS >> Wait ) => ( BackendFsm > Tac_StartPause >> CS >> Base )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS >)
  class Reg_0368_0369 : public TsmRegion
  {
  private:
    Ini_0369_0370* oIni_0369_0370; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS >> InitialState )
    Cho_0369_0371* oCho_0369_0371; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS >> ChoiceState )
    Cho_0369_0372* oCho_0369_0372; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS >> ChoiceState )
    Lea_0369_0373* oLea_0369_0373; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS >> Base )
    Lea_0369_0374* oLea_0369_0374; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS >> Wait )

  public:
    Reg_0368_0369( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0369_0370 = new Ini_0369_0370( this );
      oCho_0369_0371 = new Cho_0369_0371( this );
      oCho_0369_0372 = new Cho_0369_0372( this );
      oLea_0369_0373 = new Lea_0369_0373( this );
      oLea_0369_0374 = new Lea_0369_0374( this );
      mNrStates = 5;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0369_0370;
      mStates[ 1 ] = oCho_0369_0371;
      mStates[ 2 ] = oCho_0369_0372;
      mStates[ 3 ] = oLea_0369_0373;
      mStates[ 4 ] = oLea_0369_0374;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0369_0378( TsmHandler& oHandler );
    void Tra_0369_0379( TsmHandler& oHandler );
    void Tra_0369_0377( TsmHandler& oHandler );
    void Tra_0369_0381( TsmHandler& oHandler );
    void Tra_0369_0375( TsmHandler& oHandler );
    void Tra_0369_0376( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 378:
        Tra_0369_0378( oHandler );
        break;
      case 379:
        Tra_0369_0379( oHandler );
        break;
      case 377:
        Tra_0369_0377( oHandler );
        break;
      case 380: // Up: ( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> FinalState )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 381:
        Tra_0369_0381( oHandler );
        break;
      case 375:
        Tra_0369_0375( oHandler );
        break;
      case 376:
        Tra_0369_0376( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS )
  class Com_0365_0368 : public TsmCompound
  {
  private:
    Reg_0368_0369* oReg_0368_0369; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS >)

  public:
    Com_0365_0368( TsmBase* oParent )
    {
      TsmName = "CS";
      TsmParent = oParent;
      oReg_0368_0369 = new Reg_0368_0369( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0368_0369;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 382, "( BackendFsm > Tac_StartPause >> CS ) => ( BackendFsm > Tac_StartPause > ExitReadError ) : rpp_reader->Px_CbError" );
      mTransitions[ 1 ] = new TsmTransition( 385, "( BackendFsm > Tac_StartPause >> CS ) => ( BackendFsm > Tac_StartPause > ExitFinished ) : rpp_display->Px_CbFinished" );
      mTransitions[ 2 ] = new TsmTransition( 384, "( BackendFsm > Tac_StartPause >> CS ) => ( BackendFsm > Tac_StartPause > ExitSynclost ) : rpp_display->Px_CbSynclost" );
    }

    void Tra_0365_0383( TsmHandler& oHandler );
    void rpp_reader___Px_CbError( int BadSector, TsmHandler& oHandler );
    void rpp_display___Px_CbFinished( TsmHandler& oHandler );
    void rpp_display___Px_CbSynclost( tTime BadTime, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 156:
        switch ( Command )
        {
        case 33:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 38:
          return TsmProspect::OK;
        case 43:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 383:
        Tra_0365_0383( oHandler );
        break;
      case 380: // UP: ( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> FinalState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 382: // UP: ( BackendFsm > Tac_StartPause >> CS ) => ( BackendFsm > Tac_StartPause > ExitReadError )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 385: // UP: ( BackendFsm > Tac_StartPause >> CS ) => ( BackendFsm > Tac_StartPause > ExitFinished )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 384: // UP: ( BackendFsm > Tac_StartPause >> CS ) => ( BackendFsm > Tac_StartPause > ExitSynclost )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >)
  class Reg_0364_0365 : public TsmRegion
  {
  private:
    Ini_0365_0366* oIni_0365_0366; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> InitialState )
    Fin_0365_0367* oFin_0365_0367; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> FinalState )
    Com_0365_0368* oCom_0365_0368; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS )

  public:
    Reg_0364_0365( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0365_0366 = new Ini_0365_0366( this );
      oFin_0365_0367 = new Fin_0365_0367( this );
      oCom_0365_0368 = new Com_0365_0368( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0365_0366;
      mStates[ 1 ] = oFin_0365_0367;
      mStates[ 2 ] = oCom_0365_0368;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0365_0383( TsmHandler& oHandler );
    void Tra_0369_0380( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::OK|TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::OK|TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::OK|TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 383:
        Tra_0365_0383( oHandler );
        break;
      case 380:
        Tra_0369_0380( oHandler );
        break;
      case 382: // Up: ( BackendFsm > Tac_StartPause >> CS ) => ( BackendFsm > Tac_StartPause > ExitReadError )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 385: // Up: ( BackendFsm > Tac_StartPause >> CS ) => ( BackendFsm > Tac_StartPause > ExitFinished )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 384: // Up: ( BackendFsm > Tac_StartPause >> CS ) => ( BackendFsm > Tac_StartPause > ExitSynclost )
        mCurrentState = NULL;
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause )
  class Fsm_0158_0364 : public TsmFsm
  {
  private:
    Reg_0364_0365* oReg_0364_0365; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >)

  public:
    Fsm_0158_0364( TsmBase* oParent )
    {
      TsmName = "Tac_StartPause";
      TsmParent = oParent;
      oReg_0364_0365 = new Reg_0364_0365( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0364_0365;
      mNrTransitions = 0;
    }

    void Tra_0365_0382( TsmHandler& oHandler );
    void Tra_0365_0385( TsmHandler& oHandler );
    void Tra_0365_0384( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 382:
        Tra_0365_0382( oHandler );
        break;
      case 385:
        Tra_0365_0385( oHandler );
        break;
      case 384:
        Tra_0365_0384( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> StartPause )
  class Sub_0245_0247 : public TsmSubFsm
  {
  private:
    Con_0247_0248* oCon_0247_0248; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> StartPause > ConnExitRef )
    Con_0247_0249* oCon_0247_0249; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> StartPause > ConnExitRef )
    Con_0247_0250* oCon_0247_0250; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> StartPause > ConnExitRef )

  public:
    Sub_0245_0247( TsmBase* oParent )
    {
      TsmName = "StartPause";
      TsmParent = oParent;
      oFsm = new Fsm_0158_0364( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause )
      oCon_0247_0248 = new Con_0247_0248( this );
      oCon_0247_0249 = new Con_0247_0249( this );
      oCon_0247_0250 = new Con_0247_0250( this );
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 255, "( BackendFsm > Pausing >> StartPause ) => ( BackendFsm > Pausing >> FinalState )" );
    }

    void ExecuteTriggerless( TsmHandler& oHandler );
    void Tra_0245_0262( TsmHandler& oHandler );
    void Tra_0245_0254( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    ~Sub_0245_0247()
    {
      delete oCon_0247_0248;
      delete oCon_0247_0249;
      delete oCon_0247_0250;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 255: // UP: ( BackendFsm > Pausing >> StartPause ) => ( BackendFsm > Pausing >> FinalState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 386: // UmlConnExit(Ref)
        oCon_0247_0248->Initial( oHandler );
        break;
      case 387: // UmlConnExit(Ref)
        oCon_0247_0249->Initial( oHandler );
        break;
      case 388: // UmlConnExit(Ref)
        oCon_0247_0250->Initial( oHandler );
        break;
      case 258: // UP: ( BackendFsm > Pausing >> StartPause > ConnExitRef ) => ( BackendFsm > Pausing >> Recover )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 259: // UP: ( BackendFsm > Pausing >> StartPause > ConnExitRef ) => ( BackendFsm > Pausing >> Recover )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 261: // UP: ( BackendFsm > Pausing >> StartPause > ConnExitRef ) => ( BackendFsm > Pausing > ExitFinished )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 262:
        Tra_0245_0262( oHandler );
        break;
      case 254:
        Tra_0245_0254( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> Recover > ConnExitRef )
  class Con_0251_0252 : public TsmState
  {
  public:
    Con_0251_0252( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 256, "( BackendFsm > Pausing >> Recover > ConnExitRef ) => ( BackendFsm > Pausing > ExitFinished )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 256: // UP: ( BackendFsm > Pausing >> Recover > ConnExitRef ) => ( BackendFsm > Pausing > ExitFinished )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> Recover > ConnExitRef )
  class Con_0251_0253 : public TsmState
  {
  public:
    Con_0251_0253( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 257, "( BackendFsm > Pausing >> Recover > ConnExitRef ) => ( BackendFsm > Pausing > ExitError )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 257: // UP: ( BackendFsm > Pausing >> Recover > ConnExitRef ) => ( BackendFsm > Pausing > ExitError )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> Recover )
  class Sub_0245_0251 : public TsmSubFsm
  {
  private:
    Con_0251_0252* oCon_0251_0252; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> Recover > ConnExitRef )
    Con_0251_0253* oCon_0251_0253; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> Recover > ConnExitRef )

  public:
    Sub_0245_0251( TsmBase* oParent )
    {
      TsmName = "Recover";
      TsmParent = oParent;
      oFsm = new Fsm_0158_0470( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover )
      oCon_0251_0252 = new Con_0251_0252( this );
      oCon_0251_0253 = new Con_0251_0253( this );
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 262, "( BackendFsm > Pausing >> Recover ) => ( BackendFsm > Pausing >> StartPause )" );
    }

    void Tra_0245_0258( TsmHandler& oHandler );
    void Tra_0245_0259( TsmHandler& oHandler );
    void ExecuteTriggerless( TsmHandler& oHandler );
    void Tra_0245_0260( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    ~Sub_0245_0251()
    {
      delete oCon_0251_0252;
      delete oCon_0251_0253;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 258:
        Tra_0245_0258( oHandler );
        break;
      case 259:
        Tra_0245_0259( oHandler );
        break;
      case 262: // UP: ( BackendFsm > Pausing >> Recover ) => ( BackendFsm > Pausing >> StartPause )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 485: // UmlConnExit(Ref)
        oCon_0251_0252->Initial( oHandler );
        break;
      case 486: // UmlConnExit(Ref)
        oCon_0251_0253->Initial( oHandler );
        break;
      case 256: // UP: ( BackendFsm > Pausing >> Recover > ConnExitRef ) => ( BackendFsm > Pausing > ExitFinished )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 257: // UP: ( BackendFsm > Pausing >> Recover > ConnExitRef ) => ( BackendFsm > Pausing > ExitError )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 260:
        Tra_0245_0260( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >)
  class Reg_0244_0245 : public TsmRegion
  {
  private:
    Fin_0245_0246* oFin_0245_0246; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> FinalState )
    Sub_0245_0247* oSub_0245_0247; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> StartPause )
    Sub_0245_0251* oSub_0245_0251; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> Recover )

  public:
    Reg_0244_0245( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oFin_0245_0246 = new Fin_0245_0246( this );
      oSub_0245_0247 = new Sub_0245_0247( this );
      oSub_0245_0251 = new Sub_0245_0251( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oFin_0245_0246;
      mStates[ 1 ] = oSub_0245_0247;
      mStates[ 2 ] = oSub_0245_0251;
    }

    void Tra_0245_0255( TsmHandler& oHandler );
    void Tra_0245_0258( TsmHandler& oHandler );
    void Tra_0245_0259( TsmHandler& oHandler );
    void Tra_0245_0262( TsmHandler& oHandler );
    void Tra_0245_0254( TsmHandler& oHandler );
    void Tra_0245_0260( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::OK|TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::OK|TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::OK|TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 255:
        Tra_0245_0255( oHandler );
        break;
      case 258:
        Tra_0245_0258( oHandler );
        break;
      case 259:
        Tra_0245_0259( oHandler );
        break;
      case 261: // Up: ( BackendFsm > Pausing >> StartPause > ConnExitRef ) => ( BackendFsm > Pausing > ExitFinished )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 262:
        Tra_0245_0262( oHandler );
        break;
      case 256: // Up: ( BackendFsm > Pausing >> Recover > ConnExitRef ) => ( BackendFsm > Pausing > ExitFinished )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 257: // Up: ( BackendFsm > Pausing >> Recover > ConnExitRef ) => ( BackendFsm > Pausing > ExitError )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 254:
        Tra_0245_0254( oHandler );
        break;
      case 260:
        Tra_0245_0260( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing > EntryPauseStart )
  class Con_0244_0263 : public TsmState
  {
  public:
    Con_0244_0263( TsmBase* oParent )
    {
      TsmName = "EntryPauseStart";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 254, "( BackendFsm > Pausing > EntryPauseStart ) => ( BackendFsm > Pausing >> StartPause )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 254: // UP: ( BackendFsm > Pausing > EntryPauseStart ) => ( BackendFsm > Pausing >> StartPause )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing > EntryPauseRecover )
  class Con_0244_0264 : public TsmState
  {
  public:
    Con_0244_0264( TsmBase* oParent )
    {
      TsmName = "EntryPauseRecover";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 260, "( BackendFsm > Pausing > EntryPauseRecover ) => ( BackendFsm > Pausing >> Recover )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 260: // UP: ( BackendFsm > Pausing > EntryPauseRecover ) => ( BackendFsm > Pausing >> Recover )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing )
  class Fsm_0158_0244 : public TsmFsm
  {
  private:
    Reg_0244_0245* oReg_0244_0245; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >)
    Con_0244_0263* oCon_0244_0263; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing > EntryPauseStart )
    Con_0244_0264* oCon_0244_0264; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing > EntryPauseRecover )

  public:
    Fsm_0158_0244( TsmBase* oParent )
    {
      TsmName = "Pausing";
      TsmParent = oParent;
      oReg_0244_0245 = new Reg_0244_0245( this );
      oCon_0244_0263 = new Con_0244_0263( this );
      oCon_0244_0264 = new Con_0244_0264( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0244_0245;
      mNrTransitions = 0;
    }

    void Entrypoint( TsmHandler& oHandler )
    {
      oReg_0244_0245->Reset();
      switch ( oHandler.Index )
      {
      case 263:
        oCon_0244_0263->Initial( oHandler );
        break;
      case 264:
        oCon_0244_0264->Initial( oHandler );
        break;
      }
      ExecuteHandler( oHandler );
    }
    void Tra_0245_0261( TsmHandler& oHandler );
    void Tra_0245_0256( TsmHandler& oHandler );
    void Tra_0245_0257( TsmHandler& oHandler );
    void Tra_0245_0254( TsmHandler& oHandler );
    void Tra_0245_0260( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    ~Fsm_0158_0244()
    {
      delete oCon_0244_0263;
      delete oCon_0244_0264;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 261:
        Tra_0245_0261( oHandler );
        break;
      case 256:
        Tra_0245_0256( oHandler );
        break;
      case 257:
        Tra_0245_0257( oHandler );
        break;
      case 254:
        Tra_0245_0254( oHandler );
        break;
      case 260:
        Tra_0245_0260( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Pausing )
  class Sub_0175_0186 : public TsmSubFsm
  {
  private:
    Con_0186_0189* oCon_0186_0189; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Pausing > ConnExitRef )
    Con_0186_0190* oCon_0186_0190; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Pausing > ConnExitRef )

  public:
    Sub_0175_0186( TsmBase* oParent )
    {
      TsmName = "Pausing";
      TsmParent = oParent;
      oFsm = new Fsm_0158_0244( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing )
      oCon_0186_0189 = new Con_0186_0189( this );
      oCon_0186_0190 = new Con_0186_0190( this );
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 203, "( BackendFsm >> Active >> Pausing ) => ( BackendFsm >> Active >> Paused )" );
    }

    void Tra_0175_0204( TsmHandler& oHandler );
    void Tra_0175_0205( TsmHandler& oHandler );
    void ExecuteTriggerless( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    ~Sub_0175_0186()
    {
      delete oCon_0186_0189;
      delete oCon_0186_0190;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 204:
        Tra_0175_0204( oHandler );
        break;
      case 205:
        Tra_0175_0205( oHandler );
        break;
      case 203: // UP: ( BackendFsm >> Active >> Pausing ) => ( BackendFsm >> Active >> Paused )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 266: // UmlConnExit(Ref)
        oCon_0186_0189->Initial( oHandler );
        break;
      case 265: // UmlConnExit(Ref)
        oCon_0186_0190->Initial( oHandler );
        break;
      case 206: // UP: ( BackendFsm >> Active >> Pausing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 211: // UP: ( BackendFsm >> Active >> Pausing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Paused > ConnExitRef )
  class Con_0191_0192 : public TsmState
  {
  public:
    Con_0191_0192( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 214, "( BackendFsm >> Active >> Paused > ConnExitRef ) => ( BackendFsm >> Active >> Continuing > ConnEntryRef )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 214: // UP: ( BackendFsm >> Active >> Paused > ConnExitRef ) => ( BackendFsm >> Active >> Continuing > ConnEntryRef )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Paused >> InitialState )
  class Ini_0300_0301 : public TsmPseudo
  {
  public:
    Ini_0300_0301( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 305, "( BackendFsm > Paused >> InitialState ) => ( BackendFsm > Paused >> Base )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 305: // UP: ( BackendFsm > Paused >> InitialState ) => ( BackendFsm > Paused >> Base )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Paused >> FinalState )
  class Fin_0300_0302 : public TsmFinal
  {
  public:
    Fin_0300_0302( TsmBase* oParent )
    {
      TsmName = "FinalState";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Tra_0300_0308( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 308:
        Tra_0300_0308( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Paused >> Base )
  class Lea_0300_0303 : public TsmLeaf
  {
  public:
    Lea_0300_0303( TsmBase* oParent )
    {
      TsmName = "Base";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 308, "( BackendFsm > Paused >> Base ) => ( BackendFsm > Paused >> FinalState ) : pp_player->Continue" );
      mTransitions[ 1 ] = new TsmTransition( 306, "( BackendFsm > Paused >> Base ) => ( BackendFsm > Paused >> ReadError ) : rpp_reader->Px_CbError" );
    }

    void Tra_0300_0305( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void pp_player___Continue( TsmHandler& oHandler );
    void rpp_reader___Px_CbError( int BadSector, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 28:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 33:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 305:
        Tra_0300_0305( oHandler );
        break;
      case 308: // UP: ( BackendFsm > Paused >> Base ) => ( BackendFsm > Paused >> FinalState )
        bHigher = true;
        break;
      case 306: // UP: ( BackendFsm > Paused >> Base ) => ( BackendFsm > Paused >> ReadError )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Paused >> ReadError )
  class Lea_0300_0304 : public TsmLeaf
  {
  public:
    Lea_0300_0304( TsmBase* oParent )
    {
      TsmName = "ReadError";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 307, "( BackendFsm > Paused >> ReadError ) => ( BackendFsm > Paused > ExitReadError ) : pp_player->Continue" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void pp_player___Continue( TsmHandler& oHandler );
    void Tra_0300_0306( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 28:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 307: // UP: ( BackendFsm > Paused >> ReadError ) => ( BackendFsm > Paused > ExitReadError )
        bHigher = true;
        break;
      case 306:
        Tra_0300_0306( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Paused >)
  class Reg_0299_0300 : public TsmRegion
  {
  private:
    Ini_0300_0301* oIni_0300_0301; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Paused >> InitialState )
    Fin_0300_0302* oFin_0300_0302; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Paused >> FinalState )
    Lea_0300_0303* oLea_0300_0303; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Paused >> Base )
    Lea_0300_0304* oLea_0300_0304; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Paused >> ReadError )

  public:
    Reg_0299_0300( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0300_0301 = new Ini_0300_0301( this );
      oFin_0300_0302 = new Fin_0300_0302( this );
      oLea_0300_0303 = new Lea_0300_0303( this );
      oLea_0300_0304 = new Lea_0300_0304( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0300_0301;
      mStates[ 1 ] = oFin_0300_0302;
      mStates[ 2 ] = oLea_0300_0303;
      mStates[ 3 ] = oLea_0300_0304;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0300_0305( TsmHandler& oHandler );
    void Tra_0300_0308( TsmHandler& oHandler );
    void Tra_0300_0306( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 28:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 33:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 305:
        Tra_0300_0305( oHandler );
        break;
      case 308:
        Tra_0300_0308( oHandler );
        break;
      case 307: // Up: ( BackendFsm > Paused >> ReadError ) => ( BackendFsm > Paused > ExitReadError )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 306:
        Tra_0300_0306( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Paused )
  class Fsm_0158_0299 : public TsmFsm
  {
  private:
    Reg_0299_0300* oReg_0299_0300; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Paused >)

  public:
    Fsm_0158_0299( TsmBase* oParent )
    {
      TsmName = "Paused";
      TsmParent = oParent;
      oReg_0299_0300 = new Reg_0299_0300( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0299_0300;
      mNrTransitions = 0;
    }

    void Tra_0300_0307( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 307:
        Tra_0300_0307( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Paused )
  class Sub_0175_0191 : public TsmSubFsm
  {
  private:
    Con_0191_0192* oCon_0191_0192; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Paused > ConnExitRef )

  public:
    Sub_0175_0191( TsmBase* oParent )
    {
      TsmName = "Paused";
      TsmParent = oParent;
      oFsm = new Fsm_0158_0299( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Paused )
      oCon_0191_0192 = new Con_0191_0192( this );
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 209, "( BackendFsm >> Active >> Paused ) => ( BackendFsm >> Active >> Continuing )" );
    }

    void Tra_0175_0203( TsmHandler& oHandler );
    void ExecuteTriggerless( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    ~Sub_0175_0191()
    {
      delete oCon_0191_0192;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 203:
        Tra_0175_0203( oHandler );
        break;
      case 209: // UP: ( BackendFsm >> Active >> Paused ) => ( BackendFsm >> Active >> Continuing )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 309: // UmlConnExit(Ref)
        oCon_0191_0192->Initial( oHandler );
        break;
      case 214: // UP: ( BackendFsm >> Active >> Paused > ConnExitRef ) => ( BackendFsm >> Active >> Continuing > ConnEntryRef )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Continuing > ConnEntryRef )
  class Con_0193_0194 : public TsmState
  {
  public:
    Con_0193_0194( TsmBase* oParent )
    {
      TsmName = "ConnEntryRef";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Continuing > ConnExitRef )
  class Con_0193_0195 : public TsmState
  {
  public:
    Con_0193_0195( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 216, "( BackendFsm >> Active >> Continuing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 216: // UP: ( BackendFsm >> Active >> Continuing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Continuing > ConnExitRef )
  class Con_0193_0196 : public TsmState
  {
  public:
    Con_0193_0196( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 213, "( BackendFsm >> Active >> Continuing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 213: // UP: ( BackendFsm >> Active >> Continuing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> InitialState )
  class Ini_0488_0489 : public TsmPseudo
  {
  public:
    Ini_0488_0489( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 512, "( BackendFsm > Continuing >> InitialState ) => ( BackendFsm > Continuing >> CS )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 512: // UP: ( BackendFsm > Continuing >> InitialState ) => ( BackendFsm > Continuing >> CS )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> FinalState )
  class Fin_0488_0490 : public TsmFinal
  {
  public:
    Fin_0488_0490( TsmBase* oParent )
    {
      TsmName = "FinalState";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Tra_0502_0508( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 508:
        Tra_0502_0508( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> FinalState )
  class Fin_0488_0491 : public TsmFinal
  {
  public:
    Fin_0488_0491( TsmBase* oParent )
    {
      TsmName = "FinalState";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Tra_0488_0520( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 520:
        Tra_0488_0520( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> JuncState )
  class Jun_0488_0492 : public TsmPseudo
  {
  public:
    Jun_0488_0492( TsmBase* oParent )
    {
      TsmName = "JuncState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 525, "( BackendFsm > Continuing >> JuncState ) => ( BackendFsm > Continuing >> Recover )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0488_0517( TsmHandler& oHandler );
    void Tra_0488_0515( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 525: // UP: ( BackendFsm > Continuing >> JuncState ) => ( BackendFsm > Continuing >> Recover )
        bHigher = true;
        break;
      case 517:
        Tra_0488_0517( oHandler );
        break;
      case 515:
        Tra_0488_0515( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> JuncState )
  class Jun_0488_0493 : public TsmPseudo
  {
  public:
    Jun_0488_0493( TsmBase* oParent )
    {
      TsmName = "JuncState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 523, "( BackendFsm > Continuing >> JuncState ) => ( BackendFsm > Continuing >> JuncState )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0488_0518( TsmHandler& oHandler );
    void Tra_0488_0516( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 523: // UP: ( BackendFsm > Continuing >> JuncState ) => ( BackendFsm > Continuing >> JuncState )
        bHigher = true;
        break;
      case 518:
        Tra_0488_0518( oHandler );
        break;
      case 516:
        Tra_0488_0516( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> JuncState )
  class Jun_0488_0494 : public TsmPseudo
  {
  public:
    Jun_0488_0494( TsmBase* oParent )
    {
      TsmName = "JuncState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 524, "( BackendFsm > Continuing >> JuncState ) => ( BackendFsm > Continuing >> Recover )" );
    }

    void Tra_0488_0523( TsmHandler& oHandler );
    void Initial( TsmHandler& oHandler );
    void Tra_0488_0522( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 523:
        Tra_0488_0523( oHandler );
        break;
      case 524: // UP: ( BackendFsm > Continuing >> JuncState ) => ( BackendFsm > Continuing >> Recover )
        bHigher = true;
        break;
      case 522:
        Tra_0488_0522( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> Recover > ConnExitRef )
  class Con_0495_0496 : public TsmState
  {
  public:
    Con_0495_0496( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 513, "( BackendFsm > Continuing >> Recover > ConnExitRef ) => ( BackendFsm > Continuing > ExitFinished )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 513: // UP: ( BackendFsm > Continuing >> Recover > ConnExitRef ) => ( BackendFsm > Continuing > ExitFinished )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> Recover > ConnExitRef )
  class Con_0495_0497 : public TsmState
  {
  public:
    Con_0495_0497( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 519, "( BackendFsm > Continuing >> Recover > ConnExitRef ) => ( BackendFsm > Continuing > ExitError )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 519: // UP: ( BackendFsm > Continuing >> Recover > ConnExitRef ) => ( BackendFsm > Continuing > ExitError )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> Recover )
  class Sub_0488_0495 : public TsmSubFsm
  {
  private:
    Con_0495_0496* oCon_0495_0496; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> Recover > ConnExitRef )
    Con_0495_0497* oCon_0495_0497; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> Recover > ConnExitRef )

  public:
    Sub_0488_0495( TsmBase* oParent )
    {
      TsmName = "Recover";
      TsmParent = oParent;
      oFsm = new Fsm_0158_0470( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover )
      oCon_0495_0496 = new Con_0495_0496( this );
      oCon_0495_0497 = new Con_0495_0497( this );
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 514, "( BackendFsm > Continuing >> Recover ) => ( BackendFsm > Continuing >> StartPlay )" );
    }

    void Tra_0488_0525( TsmHandler& oHandler );
    void Tra_0488_0524( TsmHandler& oHandler );
    void ExecuteTriggerless( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    ~Sub_0488_0495()
    {
      delete oCon_0495_0496;
      delete oCon_0495_0497;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 525:
        Tra_0488_0525( oHandler );
        break;
      case 524:
        Tra_0488_0524( oHandler );
        break;
      case 514: // UP: ( BackendFsm > Continuing >> Recover ) => ( BackendFsm > Continuing >> StartPlay )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 485: // UmlConnExit(Ref)
        oCon_0495_0496->Initial( oHandler );
        break;
      case 486: // UmlConnExit(Ref)
        oCon_0495_0497->Initial( oHandler );
        break;
      case 513: // UP: ( BackendFsm > Continuing >> Recover > ConnExitRef ) => ( BackendFsm > Continuing > ExitFinished )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 519: // UP: ( BackendFsm > Continuing >> Recover > ConnExitRef ) => ( BackendFsm > Continuing > ExitError )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> StartPlay > ConnExitRef )
  class Con_0498_0499 : public TsmState
  {
  public:
    Con_0498_0499( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 518, "( BackendFsm > Continuing >> StartPlay > ConnExitRef ) => ( BackendFsm > Continuing >> JuncState )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 518: // UP: ( BackendFsm > Continuing >> StartPlay > ConnExitRef ) => ( BackendFsm > Continuing >> JuncState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> StartPlay > ConnExitRef )
  class Con_0498_0500 : public TsmState
  {
  public:
    Con_0498_0500( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 517, "( BackendFsm > Continuing >> StartPlay > ConnExitRef ) => ( BackendFsm > Continuing >> JuncState )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 517: // UP: ( BackendFsm > Continuing >> StartPlay > ConnExitRef ) => ( BackendFsm > Continuing >> JuncState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> StartPlay )
  class Sub_0488_0498 : public TsmSubFsm
  {
  private:
    Con_0498_0499* oCon_0498_0499; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> StartPlay > ConnExitRef )
    Con_0498_0500* oCon_0498_0500; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> StartPlay > ConnExitRef )

  public:
    Sub_0488_0498( TsmBase* oParent )
    {
      TsmName = "StartPlay";
      TsmParent = oParent;
      oFsm = new Fsm_0158_0224( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay )
      oCon_0498_0499 = new Con_0498_0499( this );
      oCon_0498_0500 = new Con_0498_0500( this );
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 520, "( BackendFsm > Continuing >> StartPlay ) => ( BackendFsm > Continuing >> FinalState )" );
    }

    void Tra_0488_0514( TsmHandler& oHandler );
    void ExecuteTriggerless( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    ~Sub_0488_0498()
    {
      delete oCon_0498_0499;
      delete oCon_0498_0500;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 514:
        Tra_0488_0514( oHandler );
        break;
      case 520: // UP: ( BackendFsm > Continuing >> StartPlay ) => ( BackendFsm > Continuing >> FinalState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 242: // UmlConnExit(Ref)
        oCon_0498_0499->Initial( oHandler );
        break;
      case 243: // UmlConnExit(Ref)
        oCon_0498_0500->Initial( oHandler );
        break;
      case 518: // UP: ( BackendFsm > Continuing >> StartPlay > ConnExitRef ) => ( BackendFsm > Continuing >> JuncState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 517: // UP: ( BackendFsm > Continuing >> StartPlay > ConnExitRef ) => ( BackendFsm > Continuing >> JuncState )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> CS >> InitialState )
  class Ini_0502_0503 : public TsmPseudo
  {
  public:
    Ini_0502_0503( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 509, "( BackendFsm > Continuing >> CS >> InitialState ) => ( BackendFsm > Continuing >> CS >> Base )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 509: // UP: ( BackendFsm > Continuing >> CS >> InitialState ) => ( BackendFsm > Continuing >> CS >> Base )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> CS >> ChoiceState )
  class Cho_0502_0504 : public TsmPseudo
  {
  public:
    Cho_0502_0504( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 508, "( BackendFsm > Continuing >> CS >> ChoiceState ) => ( BackendFsm > Continuing >> FinalState ) : 'IsProxyOk'" );
      mTransitions[ 1 ] = new TsmTransition( 507, "( BackendFsm > Continuing >> CS >> ChoiceState ) => ( BackendFsm > Continuing >> CS >> Wait ) : 'IsProxyNok'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0502_0511( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 508: // UP: ( BackendFsm > Continuing >> CS >> ChoiceState ) => ( BackendFsm > Continuing >> FinalState )
        bHigher = true;
        break;
      case 507: // UP: ( BackendFsm > Continuing >> CS >> ChoiceState ) => ( BackendFsm > Continuing >> CS >> Wait )
        bHigher = true;
        break;
      case 511:
        Tra_0502_0511( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> CS >> Base )
  class Lea_0502_0505 : public TsmLeaf
  {
  public:
    Lea_0502_0505( TsmBase* oParent )
    {
      TsmName = "Base";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 511, "( BackendFsm > Continuing >> CS >> Base ) => ( BackendFsm > Continuing >> CS >> ChoiceState )" );
    }

    void Tra_0502_0509( TsmHandler& oHandler );
    void Initial( TsmHandler& oHandler );
    void Tra_0502_0510( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 509:
        Tra_0502_0509( oHandler );
        break;
      case 511: // UP: ( BackendFsm > Continuing >> CS >> Base ) => ( BackendFsm > Continuing >> CS >> ChoiceState )
        bHigher = true;
        break;
      case 510:
        Tra_0502_0510( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> CS >> Wait )
  class Lea_0502_0506 : public TsmLeaf
  {
  public:
    Lea_0502_0506( TsmBase* oParent )
    {
      TsmName = "Wait";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 510, "( BackendFsm > Continuing >> CS >> Wait ) => ( BackendFsm > Continuing >> CS >> Base )" );
    }

    void Tra_0502_0507( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 507:
        Tra_0502_0507( oHandler );
        break;
      case 510: // UP: ( BackendFsm > Continuing >> CS >> Wait ) => ( BackendFsm > Continuing >> CS >> Base )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> CS >)
  class Reg_0501_0502 : public TsmRegion
  {
  private:
    Ini_0502_0503* oIni_0502_0503; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> CS >> InitialState )
    Cho_0502_0504* oCho_0502_0504; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> CS >> ChoiceState )
    Lea_0502_0505* oLea_0502_0505; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> CS >> Base )
    Lea_0502_0506* oLea_0502_0506; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> CS >> Wait )

  public:
    Reg_0501_0502( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0502_0503 = new Ini_0502_0503( this );
      oCho_0502_0504 = new Cho_0502_0504( this );
      oLea_0502_0505 = new Lea_0502_0505( this );
      oLea_0502_0506 = new Lea_0502_0506( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0502_0503;
      mStates[ 1 ] = oCho_0502_0504;
      mStates[ 2 ] = oLea_0502_0505;
      mStates[ 3 ] = oLea_0502_0506;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0502_0509( TsmHandler& oHandler );
    void Tra_0502_0507( TsmHandler& oHandler );
    void Tra_0502_0511( TsmHandler& oHandler );
    void Tra_0502_0510( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 509:
        Tra_0502_0509( oHandler );
        break;
      case 508: // Up: ( BackendFsm > Continuing >> CS >> ChoiceState ) => ( BackendFsm > Continuing >> FinalState )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 507:
        Tra_0502_0507( oHandler );
        break;
      case 511:
        Tra_0502_0511( oHandler );
        break;
      case 510:
        Tra_0502_0510( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> CS )
  class Com_0488_0501 : public TsmCompound
  {
  private:
    Reg_0501_0502* oReg_0501_0502; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> CS >)

  public:
    Com_0488_0501( TsmBase* oParent )
    {
      TsmName = "CS";
      TsmParent = oParent;
      oReg_0501_0502 = new Reg_0501_0502( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0501_0502;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 516, "( BackendFsm > Continuing >> CS ) => ( BackendFsm > Continuing >> JuncState ) : rpp_reader->Px_CbError" );
      mTransitions[ 1 ] = new TsmTransition( 521, "( BackendFsm > Continuing >> CS ) => ( BackendFsm > Continuing > ExitFinished ) : rpp_display->Px_CbFinished" );
      mTransitions[ 2 ] = new TsmTransition( 515, "( BackendFsm > Continuing >> CS ) => ( BackendFsm > Continuing >> JuncState ) : rpp_display->Px_CbSynclost" );
    }

    void Tra_0488_0512( TsmHandler& oHandler );
    void rpp_reader___Px_CbError( int BadSector, TsmHandler& oHandler );
    void rpp_display___Px_CbFinished( TsmHandler& oHandler );
    void rpp_display___Px_CbSynclost( tTime BadTime, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 156:
        switch ( Command )
        {
        case 33:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 38:
          return TsmProspect::OK;
        case 43:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 512:
        Tra_0488_0512( oHandler );
        break;
      case 508: // UP: ( BackendFsm > Continuing >> CS >> ChoiceState ) => ( BackendFsm > Continuing >> FinalState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 516: // UP: ( BackendFsm > Continuing >> CS ) => ( BackendFsm > Continuing >> JuncState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 521: // UP: ( BackendFsm > Continuing >> CS ) => ( BackendFsm > Continuing > ExitFinished )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 515: // UP: ( BackendFsm > Continuing >> CS ) => ( BackendFsm > Continuing >> JuncState )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >)
  class Reg_0487_0488 : public TsmRegion
  {
  private:
    Ini_0488_0489* oIni_0488_0489; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> InitialState )
    Fin_0488_0490* oFin_0488_0490; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> FinalState )
    Fin_0488_0491* oFin_0488_0491; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> FinalState )
    Jun_0488_0492* oJun_0488_0492; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> JuncState )
    Jun_0488_0493* oJun_0488_0493; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> JuncState )
    Jun_0488_0494* oJun_0488_0494; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> JuncState )
    Sub_0488_0495* oSub_0488_0495; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> Recover )
    Sub_0488_0498* oSub_0488_0498; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> StartPlay )
    Com_0488_0501* oCom_0488_0501; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> CS )

  public:
    Reg_0487_0488( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0488_0489 = new Ini_0488_0489( this );
      oFin_0488_0490 = new Fin_0488_0490( this );
      oFin_0488_0491 = new Fin_0488_0491( this );
      oJun_0488_0492 = new Jun_0488_0492( this );
      oJun_0488_0493 = new Jun_0488_0493( this );
      oJun_0488_0494 = new Jun_0488_0494( this );
      oSub_0488_0495 = new Sub_0488_0495( this );
      oSub_0488_0498 = new Sub_0488_0498( this );
      oCom_0488_0501 = new Com_0488_0501( this );
      mNrStates = 9;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0488_0489;
      mStates[ 1 ] = oFin_0488_0490;
      mStates[ 2 ] = oFin_0488_0491;
      mStates[ 3 ] = oJun_0488_0492;
      mStates[ 4 ] = oJun_0488_0493;
      mStates[ 5 ] = oJun_0488_0494;
      mStates[ 6 ] = oSub_0488_0495;
      mStates[ 7 ] = oSub_0488_0498;
      mStates[ 8 ] = oCom_0488_0501;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0488_0512( TsmHandler& oHandler );
    void Tra_0488_0525( TsmHandler& oHandler );
    void Tra_0488_0523( TsmHandler& oHandler );
    void Tra_0488_0524( TsmHandler& oHandler );
    void Tra_0488_0514( TsmHandler& oHandler );
    void Tra_0488_0520( TsmHandler& oHandler );
    void Tra_0488_0518( TsmHandler& oHandler );
    void Tra_0488_0517( TsmHandler& oHandler );
    void Tra_0502_0508( TsmHandler& oHandler );
    void Tra_0488_0522( TsmHandler& oHandler );
    void Tra_0488_0516( TsmHandler& oHandler );
    void Tra_0488_0515( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::OK|TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::OK|TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::OK|TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 512:
        Tra_0488_0512( oHandler );
        break;
      case 525:
        Tra_0488_0525( oHandler );
        break;
      case 523:
        Tra_0488_0523( oHandler );
        break;
      case 524:
        Tra_0488_0524( oHandler );
        break;
      case 514:
        Tra_0488_0514( oHandler );
        break;
      case 513: // Up: ( BackendFsm > Continuing >> Recover > ConnExitRef ) => ( BackendFsm > Continuing > ExitFinished )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 519: // Up: ( BackendFsm > Continuing >> Recover > ConnExitRef ) => ( BackendFsm > Continuing > ExitError )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 520:
        Tra_0488_0520( oHandler );
        break;
      case 518:
        Tra_0488_0518( oHandler );
        break;
      case 517:
        Tra_0488_0517( oHandler );
        break;
      case 508:
        Tra_0502_0508( oHandler );
        break;
      case 522:
        Tra_0488_0522( oHandler );
        break;
      case 516:
        Tra_0488_0516( oHandler );
        break;
      case 521: // Up: ( BackendFsm > Continuing >> CS ) => ( BackendFsm > Continuing > ExitFinished )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 515:
        Tra_0488_0515( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing > EntryReadError )
  class Con_0487_0526 : public TsmState
  {
  public:
    Con_0487_0526( TsmBase* oParent )
    {
      TsmName = "EntryReadError";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 522, "( BackendFsm > Continuing > EntryReadError ) => ( BackendFsm > Continuing >> JuncState )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 522: // UP: ( BackendFsm > Continuing > EntryReadError ) => ( BackendFsm > Continuing >> JuncState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing )
  class Fsm_0158_0487 : public TsmFsm
  {
  private:
    Reg_0487_0488* oReg_0487_0488; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >)
    Con_0487_0526* oCon_0487_0526; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing > EntryReadError )

  public:
    Fsm_0158_0487( TsmBase* oParent )
    {
      TsmName = "Continuing";
      TsmParent = oParent;
      oReg_0487_0488 = new Reg_0487_0488( this );
      oCon_0487_0526 = new Con_0487_0526( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0487_0488;
      mNrTransitions = 0;
    }

    void Entrypoint( TsmHandler& oHandler )
    {
      oReg_0487_0488->Reset();
      switch ( oHandler.Index )
      {
      case 526:
        oCon_0487_0526->Initial( oHandler );
        break;
      }
      ExecuteHandler( oHandler );
    }
    void Tra_0488_0513( TsmHandler& oHandler );
    void Tra_0488_0519( TsmHandler& oHandler );
    void Tra_0488_0522( TsmHandler& oHandler );
    void Tra_0488_0521( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    ~Fsm_0158_0487()
    {
      delete oCon_0487_0526;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 513:
        Tra_0488_0513( oHandler );
        break;
      case 519:
        Tra_0488_0519( oHandler );
        break;
      case 522:
        Tra_0488_0522( oHandler );
        break;
      case 521:
        Tra_0488_0521( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Continuing )
  class Sub_0175_0193 : public TsmSubFsm
  {
  private:
    Con_0193_0195* oCon_0193_0195; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Continuing > ConnExitRef )
    Con_0193_0196* oCon_0193_0196; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Continuing > ConnExitRef )

  public:
    Sub_0175_0193( TsmBase* oParent )
    {
      TsmName = "Continuing";
      TsmParent = oParent;
      oFsm = new Fsm_0158_0487( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing )
      oCon_0193_0195 = new Con_0193_0195( this );
      oCon_0193_0196 = new Con_0193_0196( this );
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 210, "( BackendFsm >> Active >> Continuing ) => ( BackendFsm >> Active >> Play )" );
    }

    void Tra_0175_0209( TsmHandler& oHandler );
    void Tra_0175_0214( TsmHandler& oHandler );
    void ExecuteTriggerless( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    ~Sub_0175_0193()
    {
      delete oCon_0193_0195;
      delete oCon_0193_0196;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 209:
        Tra_0175_0209( oHandler );
        break;
      case 214:
        Tra_0175_0214( oHandler );
        break;
      case 210: // UP: ( BackendFsm >> Active >> Continuing ) => ( BackendFsm >> Active >> Play )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 528: // UmlConnExit(Ref)
        oCon_0193_0195->Initial( oHandler );
        break;
      case 527: // UmlConnExit(Ref)
        oCon_0193_0196->Initial( oHandler );
        break;
      case 216: // UP: ( BackendFsm >> Active >> Continuing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 213: // UP: ( BackendFsm >> Active >> Continuing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Finishing )
  class Lea_0175_0197 : public TsmLeaf
  {
  public:
    Lea_0175_0197( TsmBase* oParent )
    {
      TsmName = "Finishing";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 202, "( BackendFsm >> Active >> Finishing ) => ( BackendFsm >> Active >> Finishing ) : pp_player->Pause" );
      mTransitions[ 1 ] = new TsmTransition( 219, "( BackendFsm >> Active >> Finishing ) => ( BackendFsm >> Active >> Finishing ) : rpp_reader->Px_CbError" );
    }

    void Tra_0175_0201( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0175_0202( TsmHandler& oHandler );
    void pp_player___Pause( TsmHandler& oHandler );
    void Tra_0175_0219( TsmHandler& oHandler );
    void rpp_reader___Px_CbError( int BadSector, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 27:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 33:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 201:
        Tra_0175_0201( oHandler );
        break;
      case 202:
        Tra_0175_0202( oHandler );
        break;
      case 219:
        Tra_0175_0219( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Error )
  class Lea_0175_0198 : public TsmLeaf
  {
  public:
    Lea_0175_0198( TsmBase* oParent )
    {
      TsmName = "Error";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 217, "( BackendFsm >> Active >> Error ) => ( BackendFsm >> Active >> Error )" );
      mTransitions[ 1 ] = new TsmTransition( 200, "( BackendFsm >> Active >> Error ) => ( BackendFsm >> Active >> Error ) : pp_player->Pause" );
    }

    void Tra_0159_0221( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0175_0217( TsmHandler& oHandler );
    void Tra_0175_0200( TsmHandler& oHandler );
    void pp_player___Pause( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::OK|TsmProspect::ANY;
        case 28:
          return TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 221:
        Tra_0159_0221( oHandler );
        break;
      case 217:
        Tra_0175_0217( oHandler );
        break;
      case 200:
        Tra_0175_0200( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >)
  class Reg_0174_0175 : public TsmRegion
  {
  private:
    Jun_0175_0176* oJun_0175_0176; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> JuncState )
    Jun_0175_0177* oJun_0175_0177; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> JuncState )
    Jun_0175_0178* oJun_0175_0178; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> JuncState )
    Sub_0175_0179* oSub_0175_0179; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Starting )
    Sub_0175_0181* oSub_0175_0181; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Play )
    Sub_0175_0186* oSub_0175_0186; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Pausing )
    Sub_0175_0191* oSub_0175_0191; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Paused )
    Sub_0175_0193* oSub_0175_0193; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Continuing )
    Lea_0175_0197* oLea_0175_0197; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Finishing )
    Lea_0175_0198* oLea_0175_0198; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Error )

  public:
    Reg_0174_0175( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oJun_0175_0176 = new Jun_0175_0176( this );
      oJun_0175_0177 = new Jun_0175_0177( this );
      oJun_0175_0178 = new Jun_0175_0178( this );
      oSub_0175_0179 = new Sub_0175_0179( this );
      oSub_0175_0181 = new Sub_0175_0181( this );
      oSub_0175_0186 = new Sub_0175_0186( this );
      oSub_0175_0191 = new Sub_0175_0191( this );
      oSub_0175_0193 = new Sub_0175_0193( this );
      oLea_0175_0197 = new Lea_0175_0197( this );
      oLea_0175_0198 = new Lea_0175_0198( this );
      mNrStates = 10;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oJun_0175_0176;
      mStates[ 1 ] = oJun_0175_0177;
      mStates[ 2 ] = oJun_0175_0178;
      mStates[ 3 ] = oSub_0175_0179;
      mStates[ 4 ] = oSub_0175_0181;
      mStates[ 5 ] = oSub_0175_0186;
      mStates[ 6 ] = oSub_0175_0191;
      mStates[ 7 ] = oSub_0175_0193;
      mStates[ 8 ] = oLea_0175_0197;
      mStates[ 9 ] = oLea_0175_0198;
    }

    void Tra_0163_0169( TsmHandler& oHandler );
    void Tra_0175_0215( TsmHandler& oHandler );
    void Tra_0175_0201( TsmHandler& oHandler );
    void Tra_0159_0221( TsmHandler& oHandler );
    void Tra_0175_0199( TsmHandler& oHandler );
    void Tra_0175_0212( TsmHandler& oHandler );
    void Tra_0175_0208( TsmHandler& oHandler );
    void Tra_0175_0207( TsmHandler& oHandler );
    void Tra_0175_0204( TsmHandler& oHandler );
    void Tra_0175_0205( TsmHandler& oHandler );
    void Tra_0175_0203( TsmHandler& oHandler );
    void Tra_0175_0206( TsmHandler& oHandler );
    void Tra_0175_0211( TsmHandler& oHandler );
    void Tra_0175_0209( TsmHandler& oHandler );
    void Tra_0175_0214( TsmHandler& oHandler );
    void Tra_0175_0210( TsmHandler& oHandler );
    void Tra_0175_0216( TsmHandler& oHandler );
    void Tra_0175_0213( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::ANY;
        case 27:
          return TsmProspect::OK|TsmProspect::ANY;
        case 28:
          return TsmProspect::OK|TsmProspect::ANY;
        case 29:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::ANY;
        case 33:
          return TsmProspect::OK|TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::OK|TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::OK|TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 169:
        Tra_0163_0169( oHandler );
        break;
      case 215:
        Tra_0175_0215( oHandler );
        break;
      case 201:
        Tra_0175_0201( oHandler );
        break;
      case 221:
        Tra_0159_0221( oHandler );
        break;
      case 199:
        Tra_0175_0199( oHandler );
        break;
      case 212:
        Tra_0175_0212( oHandler );
        break;
      case 208:
        Tra_0175_0208( oHandler );
        break;
      case 207:
        Tra_0175_0207( oHandler );
        break;
      case 204:
        Tra_0175_0204( oHandler );
        break;
      case 205:
        Tra_0175_0205( oHandler );
        break;
      case 203:
        Tra_0175_0203( oHandler );
        break;
      case 206:
        Tra_0175_0206( oHandler );
        break;
      case 211:
        Tra_0175_0211( oHandler );
        break;
      case 209:
        Tra_0175_0209( oHandler );
        break;
      case 214:
        Tra_0175_0214( oHandler );
        break;
      case 210:
        Tra_0175_0210( oHandler );
        break;
      case 216:
        Tra_0175_0216( oHandler );
        break;
      case 213:
        Tra_0175_0213( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active )
  class Com_0159_0174 : public TsmCompound
  {
  private:
    Reg_0174_0175* oReg_0174_0175; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >)

  public:
    Com_0159_0174( TsmBase* oParent )
    {
      TsmName = "Active";
      TsmParent = oParent;
      oReg_0174_0175 = new Reg_0174_0175( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0174_0175;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 222, "( BackendFsm >> Active ) => ( BackendFsm >> Stopping ) : pp_player->Stop" );
      mTransitions[ 1 ] = new TsmTransition( 218, "( BackendFsm >> Active ) => ( BackendFsm >> Active ) : rpp_reader->Px_CbDone" );
    }

    void Tra_0163_0169( TsmHandler& oHandler );
    void pp_player___Stop( TsmHandler& oHandler );
    void Tra_0175_0218( TsmHandler& oHandler );
    void rpp_reader___Px_CbDone( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 29:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 32:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 169:
        Tra_0163_0169( oHandler );
        break;
      case 222: // UP: ( BackendFsm >> Active ) => ( BackendFsm >> Stopping )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 218:
        Tra_0175_0218( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >)
  class Reg_0158_0159 : public TsmRegion
  {
  private:
    Ini_0159_0160* oIni_0159_0160; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> InitialState )
    Sub_0159_0161* oSub_0159_0161; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Stopping )
    Com_0159_0162* oCom_0159_0162; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Idle )
    Com_0159_0174* oCom_0159_0174; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active )

  public:
    Reg_0158_0159( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0159_0160 = new Ini_0159_0160( this );
      oSub_0159_0161 = new Sub_0159_0161( this );
      oCom_0159_0162 = new Com_0159_0162( this );
      oCom_0159_0174 = new Com_0159_0174( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0159_0160;
      mStates[ 1 ] = oSub_0159_0161;
      mStates[ 2 ] = oCom_0159_0162;
      mStates[ 3 ] = oCom_0159_0174;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0159_0220( TsmHandler& oHandler );
    void Tra_0159_0223( TsmHandler& oHandler );
    void Tra_0163_0169( TsmHandler& oHandler );
    void Tra_0159_0222( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 155:
        switch ( Command )
        {
        case 26:
          return TsmProspect::OK|TsmProspect::ANY;
        case 27:
          return TsmProspect::OK|TsmProspect::ANY;
        case 28:
          return TsmProspect::OK|TsmProspect::ANY;
        case 29:
          return TsmProspect::OK|TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 155
      case 156:
        switch ( Command )
        {
        case 30:
          return TsmProspect::ANY;
        case 31:
          return TsmProspect::ANY;
        case 32:
          return TsmProspect::OK|TsmProspect::ANY;
        case 33:
          return TsmProspect::OK|TsmProspect::ANY;
        case 34:
          return TsmProspect::ANY;
        case 35:
          return TsmProspect::ANY;
        case 36:
          return TsmProspect::ANY;
        default:
          break;
        }
        break; // end of Port 156
      case 157:
        switch ( Command )
        {
        case 37:
          return TsmProspect::ANY;
        case 38:
          return TsmProspect::OK|TsmProspect::ANY;
        case 39:
          return TsmProspect::ANY;
        case 40:
          return TsmProspect::ANY;
        case 41:
          return TsmProspect::ANY;
        case 42:
          return TsmProspect::ANY;
        case 43:
          return TsmProspect::OK|TsmProspect::ANY;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 220:
        Tra_0159_0220( oHandler );
        break;
      case 223:
        Tra_0159_0223( oHandler );
        break;
      case 169:
        Tra_0163_0169( oHandler );
        break;
      case 222:
        Tra_0159_0222( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm )
  class Fsm_0153_0158 : public TsmFsm
  {
  private:
    Reg_0158_0159* oReg_0158_0159; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >)

  public:
    Fsm_0153_0158( TsmBase* oParent )
    {
      TsmName = "BackendFsm";
      TsmParent = oParent;
      oReg_0158_0159 = new Reg_0158_0159( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0158_0159;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass )
  class Cla_0151_0153 : public TsmProxyUser
  {
  private:
    Fsm_0153_0158* oFsm_0153_0158; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm )
    TsmIPort_ITitlebaseServer* rp_titlebase; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > rp_titlebase )
    TsmIPort_IPlayerServer* TsmPI__pp_player; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > pp_player )
    TsmIPort_IPlayerClient* pp_player; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > pp_player )
    TsmIPort_IProxyReaderServer* rpp_reader; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > rpp_reader )
    TsmIPort_IProxyReaderClient* TsmPI__rpp_reader; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > rpp_reader )
    TsmIPort_IProxyDisplayServer* rpp_display; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > rpp_display )
    TsmIPort_IProxyDisplayClient* TsmPI__rpp_display; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > rpp_display )
    TsmPSPort* mPSMessager;
    TsmPCPort* mPCMessager;
    eRV frv;
    int MyFHandle;
    tChunk MyChunk;

  public:
    Cla_0151_0153( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0153_0158 = new Fsm_0153_0158( this );
      TsmPI__pp_player = new TsmIPort_IPlayerServer( this );
      TsmPI__rpp_reader = new TsmIPort_IProxyReaderClient( this );
      TsmPI__rpp_display = new TsmIPort_IProxyDisplayClient( this );
      mPSMessager = new TsmPSPort();
      mPCMessager = new TsmPCPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0153_0158;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "pp_player" )
      {
        return TsmPI__pp_player;
      }
      if ( sPortName == "rpp_reader" )
      {
        return TsmPI__rpp_reader;
      }
      if ( sPortName == "rpp_display" )
      {
        return TsmPI__rpp_display;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "rp_titlebase" )
      {
        rp_titlebase = static_cast<TsmIPort_ITitlebaseServer*>(oProvidedInterface);
        rp_titlebase->Source = this;
        return;
      }
      if ( sPortName == "pp_player" )
      {
        pp_player = static_cast<TsmIPort_IPlayerClient*>(oProvidedInterface);
        pp_player->Source = this;
        return;
      }
      if ( sPortName == "rpp_reader" )
      {
        rpp_reader = static_cast<TsmIPort_IProxyReaderServer*>(oProvidedInterface);
        rpp_reader->Source = this;
        return;
      }
      if ( sPortName == "rpp_display" )
      {
        rpp_display = static_cast<TsmIPort_IProxyDisplayServer*>(oProvidedInterface);
        rpp_display->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0153_0158->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    void Function_1017( TsmHandler& oHandler );
    bool Guard_1018( string TitleId, tTime* AtTime );
    eRV Function_1019( string TitleId, tTime* AtTime );
    void Function_1020( TsmHandler& oHandler );
    eRV Function_1021( string TitleId, tTime* AtTime );
    void Function_1022( TsmHandler& oHandler );
    bool Guard_1023( string TitleId, tTime* AtTime );
    eRV Function_1024( string TitleId, tTime* AtTime );
    void Function_1025( TsmHandler& oHandler );
    void Function_1026( TsmHandler& oHandler );
    void Function_1027( TsmHandler& oHandler );
    void Function_1028( TsmHandler& oHandler );
    void Function_1029( TsmHandler& oHandler );
    void Function_1030( TsmHandler& oHandler );
    void Function_1031( TsmHandler& oHandler );
    void Function_1032( TsmHandler& oHandler );
    void Function_1033( TsmHandler& oHandler );
    bool Guard_1034();
    bool Guard_1035();
    void Function_1036( TsmHandler& oHandler );
    bool Guard_1037();
    void Function_1038( TsmHandler& oHandler );
    void Function_1039( TsmHandler& oHandler );
    void Function_1040( TsmHandler& oHandler );
    void Function_1041( TsmHandler& oHandler );
    bool Guard_1042();
    void Function_1043( TsmHandler& oHandler );
    bool Guard_1044();
    void Function_1045( TsmHandler& oHandler );
    void Function_1046( TsmHandler& oHandler );
    void Function_1047( TsmHandler& oHandler );
    void Function_1048( TsmHandler& oHandler );
    void Function_1049( TsmHandler& oHandler );
    void Function_1050( TsmHandler& oHandler );
    void Function_1254( TsmHandler& oHandler );
    eRV Function_1255();
    void Function_1256( TsmHandler& oHandler );
    eRV Function_1257();
    void Function_1258( TsmHandler& oHandler );
    eRV Function_1259();
    void Function_1260( TsmHandler& oHandler );
    eRV Function_1261();
    void Function_1262( TsmHandler& oHandler );
    eRV Function_1263();
    void Function_1264( TsmHandler& oHandler );
    eRV Function_1265();
    void Function_1266( TsmHandler& oHandler );
    eRV Function_1267();
    void Function_1268( TsmHandler& oHandler );
    void Function_1269( TsmHandler& oHandler );
    void Function_1270( TsmHandler& oHandler );
    void Function_1271( TsmHandler& oHandler );
    void Function_1272( TsmHandler& oHandler );
    void Function_1273( TsmHandler& oHandler );
    void Function_1274( TsmHandler& oHandler );
    void Function_1275( TsmHandler& oHandler );
    void Function_1276( TsmHandler& oHandler );
    void Function_1277( TsmHandler& oHandler );
    void Function_1278( TsmHandler& oHandler );
    void Function_1279( TsmHandler& oHandler );
    void Function_1280( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0151_0153()
    {
      delete TsmPI__pp_player;
      delete TsmPI__rpp_reader;
      delete TsmPI__rpp_display;
      delete mPSMessager;
      delete mPCMessager;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > Backend )
  class Com_0021_0151 : public TsmPComponent
  {
  private:
    Cla_0151_0153* BE_Class; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BE_Class )

  public:
    Com_0021_0151( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      BE_Class = new Cla_0151_0153( this, "BE_Class" );
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = BE_Class;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "d_pp_player" )
      {
        return BE_Class->GetProvidedInterface( "pp_player" );
      }
      if ( sPortName == "d_rpp_reader" )
      {
        return BE_Class->GetProvidedInterface( "rpp_reader" );
      }
      if ( sPortName == "d_rpp_display" )
      {
        return BE_Class->GetProvidedInterface( "rpp_display" );
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Decomposition > Backend )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "d_rp_titlebase" )
      {
        BE_Class->SetRequiredInterface( "rp_titlebase", oProvidedInterface );
        return;
      }
      if ( sPortName == "d_pp_player" )
      {
        BE_Class->SetRequiredInterface( "pp_player", oProvidedInterface );
        return;
      }
      if ( sPortName == "d_rpp_reader" )
      {
        BE_Class->SetRequiredInterface( "rpp_reader", oProvidedInterface );
        return;
      }
      if ( sPortName == "d_rpp_display" )
      {
        BE_Class->SetRequiredInterface( "rpp_display", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Decomposition > Backend )";
      throw TsmException( s );
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> InitialState )
  class Ini_0091_0092 : public TsmPseudo
  {
  public:
    Ini_0091_0092( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 141, "( ProxyDisplayFsm >> InitialState ) => ( ProxyDisplayFsm >> Active )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 141: // UP: ( ProxyDisplayFsm >> InitialState ) => ( ProxyDisplayFsm >> Active )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> InitialState )
  class Ini_0094_0095 : public TsmPseudo
  {
  public:
    Ini_0094_0095( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 120, "( ProxyDisplayFsm >> Active >> InitialState ) => ( ProxyDisplayFsm >> Active >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 120: // UP: ( ProxyDisplayFsm >> Active >> InitialState ) => ( ProxyDisplayFsm >> Active >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> JuncState )
  class Jun_0094_0096 : public TsmPseudo
  {
  public:
    Jun_0094_0096( TsmBase* oParent )
    {
      TsmName = "JuncState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 138, "( ProxyDisplayFsm >> Active >> JuncState ) => ( ProxyDisplayFsm >> Active >> Synclost )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0094_0136( TsmHandler& oHandler );
    void Tra_0094_0135( TsmHandler& oHandler );
    void Tra_0094_0137( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 138: // UP: ( ProxyDisplayFsm >> Active >> JuncState ) => ( ProxyDisplayFsm >> Active >> Synclost )
        bHigher = true;
        break;
      case 136:
        Tra_0094_0136( oHandler );
        break;
      case 135:
        Tra_0094_0135( oHandler );
        break;
      case 137:
        Tra_0094_0137( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Busy >> ChoiceState )
  class Cho_0098_0099 : public TsmPseudo
  {
  public:
    Cho_0098_0099( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 111, "( ProxyDisplayFsm >> Active >> Busy >> ChoiceState ) => ( ProxyDisplayFsm >> Active >> Busy >> Pausing ) : 'ProxyNok'" );
      mTransitions[ 1 ] = new TsmTransition( 110, "( ProxyDisplayFsm >> Active >> Busy >> ChoiceState ) => ( ProxyDisplayFsm >> Active >> Busy >> Play ) : 'ProxyOk'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0098_0109( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 111: // UP: ( ProxyDisplayFsm >> Active >> Busy >> ChoiceState ) => ( ProxyDisplayFsm >> Active >> Busy >> Pausing )
        bHigher = true;
        break;
      case 110: // UP: ( ProxyDisplayFsm >> Active >> Busy >> ChoiceState ) => ( ProxyDisplayFsm >> Active >> Busy >> Play )
        bHigher = true;
        break;
      case 109:
        Tra_0098_0109( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Busy >> Play )
  class Lea_0098_0100 : public TsmLeaf
  {
  public:
    Lea_0098_0100( TsmBase* oParent )
    {
      TsmName = "Play";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 107, "( ProxyDisplayFsm >> Active >> Busy >> Play ) => ( ProxyDisplayFsm >> Active >> Busy >> Play ) : 'ProxyOk' ppp_display->Px_Continue" );
      mTransitions[ 1 ] = new TsmTransition( 109, "( ProxyDisplayFsm >> Active >> Busy >> Play ) => ( ProxyDisplayFsm >> Active >> Busy >> ChoiceState ) : ppp_display->Px_Pause" );
      mTransitions[ 2 ] = new TsmTransition( 103, "( ProxyDisplayFsm >> Active >> Busy >> Play ) => ( ProxyDisplayFsm >> Active >> Busy >> Play ) : 'ProxyOk' ppp_display->Px_Start" );
    }

    void Tra_0098_0110( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0098_0107( TsmHandler& oHandler );
    void ppp_display___Px_Continue( TsmHandler& oHandler );
    void ppp_display___Px_Pause( TsmHandler& oHandler );
    void Tra_0098_0103( TsmHandler& oHandler );
    void ppp_display___Px_Start( TsmHandler& oHandler );
    void Tra_0094_0132( TsmHandler& oHandler );
    void Tra_0098_0106( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 88:
        switch ( Command )
        {
        case 14:
          return TsmProspect::OK;
        case 15:
          return TsmProspect::OK;
        case 17:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 110:
        Tra_0098_0110( oHandler );
        break;
      case 107:
        Tra_0098_0107( oHandler );
        break;
      case 109: // UP: ( ProxyDisplayFsm >> Active >> Busy >> Play ) => ( ProxyDisplayFsm >> Active >> Busy >> ChoiceState )
        bHigher = true;
        break;
      case 103:
        Tra_0098_0103( oHandler );
        break;
      case 132:
        Tra_0094_0132( oHandler );
        break;
      case 106:
        Tra_0098_0106( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Busy >> Pausing )
  class Lea_0098_0101 : public TsmLeaf
  {
  public:
    Lea_0098_0101( TsmBase* oParent )
    {
      TsmName = "Pausing";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 105, "( ProxyDisplayFsm >> Active >> Busy >> Pausing ) => ( ProxyDisplayFsm >> Active >> Busy >> Pausing ) : 'ProxyNok' ppp_display->Px_Pause" );
      mTransitions[ 1 ] = new TsmTransition( 104, "( ProxyDisplayFsm >> Active >> Busy >> Pausing ) => ( ProxyDisplayFsm >> Active >> Paused ) : rp_display->CbPaused" );
    }

    void Tra_0098_0111( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0098_0105( TsmHandler& oHandler );
    void ppp_display___Px_Pause( TsmHandler& oHandler );
    void rp_display___CbPaused( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 88:
        switch ( Command )
        {
        case 15:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 88
      case 89:
        switch ( Command )
        {
        case 21:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 111:
        Tra_0098_0111( oHandler );
        break;
      case 105:
        Tra_0098_0105( oHandler );
        break;
      case 104: // UP: ( ProxyDisplayFsm >> Active >> Busy >> Pausing ) => ( ProxyDisplayFsm >> Active >> Paused )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Busy >> Continuing )
  class Lea_0098_0102 : public TsmLeaf
  {
  public:
    Lea_0098_0102( TsmBase* oParent )
    {
      TsmName = "Continuing";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 108, "( ProxyDisplayFsm >> Active >> Busy >> Continuing ) => ( ProxyDisplayFsm >> Active >> Busy >> Continuing ) : 'ProxyNok' ppp_display->Px_Continue" );
      mTransitions[ 1 ] = new TsmTransition( 106, "( ProxyDisplayFsm >> Active >> Busy >> Continuing ) => ( ProxyDisplayFsm >> Active >> Busy >> Play ) : rp_display->CbContinued" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0098_0108( TsmHandler& oHandler );
    void ppp_display___Px_Continue( TsmHandler& oHandler );
    void Tra_0094_0133( TsmHandler& oHandler );
    void rp_display___CbContinued( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 88:
        switch ( Command )
        {
        case 14:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 88
      case 89:
        switch ( Command )
        {
        case 22:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 108:
        Tra_0098_0108( oHandler );
        break;
      case 133:
        Tra_0094_0133( oHandler );
        break;
      case 106: // UP: ( ProxyDisplayFsm >> Active >> Busy >> Continuing ) => ( ProxyDisplayFsm >> Active >> Busy >> Play )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Busy >)
  class Reg_0097_0098 : public TsmRegion
  {
  private:
    Cho_0098_0099* oCho_0098_0099; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Busy >> ChoiceState )
    Lea_0098_0100* oLea_0098_0100; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Busy >> Play )
    Lea_0098_0101* oLea_0098_0101; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Busy >> Pausing )
    Lea_0098_0102* oLea_0098_0102; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Busy >> Continuing )

  public:
    Reg_0097_0098( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oCho_0098_0099 = new Cho_0098_0099( this );
      oLea_0098_0100 = new Lea_0098_0100( this );
      oLea_0098_0101 = new Lea_0098_0101( this );
      oLea_0098_0102 = new Lea_0098_0102( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oCho_0098_0099;
      mStates[ 1 ] = oLea_0098_0100;
      mStates[ 2 ] = oLea_0098_0101;
      mStates[ 3 ] = oLea_0098_0102;
    }

    void Tra_0098_0111( TsmHandler& oHandler );
    void Tra_0098_0110( TsmHandler& oHandler );
    void Tra_0094_0133( TsmHandler& oHandler );
    void Tra_0098_0109( TsmHandler& oHandler );
    void Tra_0094_0132( TsmHandler& oHandler );
    void Tra_0098_0106( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 88:
        switch ( Command )
        {
        case 14:
          return TsmProspect::OK;
        case 15:
          return TsmProspect::OK;
        case 17:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 88
      case 89:
        switch ( Command )
        {
        case 21:
          return TsmProspect::OK;
        case 22:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 111:
        Tra_0098_0111( oHandler );
        break;
      case 110:
        Tra_0098_0110( oHandler );
        break;
      case 133:
        Tra_0094_0133( oHandler );
        break;
      case 109:
        Tra_0098_0109( oHandler );
        break;
      case 132:
        Tra_0094_0132( oHandler );
        break;
      case 104: // Up: ( ProxyDisplayFsm >> Active >> Busy >> Pausing ) => ( ProxyDisplayFsm >> Active >> Paused )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 106:
        Tra_0098_0106( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Busy )
  class Com_0094_0097 : public TsmCompound
  {
  private:
    Reg_0097_0098* oReg_0097_0098; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Busy >)

  public:
    Com_0094_0097( TsmBase* oParent )
    {
      TsmName = "Busy";
      TsmParent = oParent;
      oReg_0097_0098 = new Reg_0097_0098( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0097_0098;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 134, "( ProxyDisplayFsm >> Active >> Busy ) => ( ProxyDisplayFsm >> Active >> Finishing ) : rp_display->CbFinished" );
      mTransitions[ 1 ] = new TsmTransition( 136, "( ProxyDisplayFsm >> Active >> Busy ) => ( ProxyDisplayFsm >> Active >> JuncState ) : rp_display->CbSynclost" );
    }

    void Tra_0094_0133( TsmHandler& oHandler );
    void Tra_0094_0132( TsmHandler& oHandler );
    void rp_display___CbFinished( TsmHandler& oHandler );
    void rp_display___CbSynclost( tTime BadTime, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 89:
        switch ( Command )
        {
        case 23:
          return TsmProspect::OK;
        case 24:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 133:
        Tra_0094_0133( oHandler );
        break;
      case 132:
        Tra_0094_0132( oHandler );
        break;
      case 104: // UP: ( ProxyDisplayFsm >> Active >> Busy >> Pausing ) => ( ProxyDisplayFsm >> Active >> Paused )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 134: // UP: ( ProxyDisplayFsm >> Active >> Busy ) => ( ProxyDisplayFsm >> Active >> Finishing )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 136: // UP: ( ProxyDisplayFsm >> Active >> Busy ) => ( ProxyDisplayFsm >> Active >> JuncState )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Ready )
  class Lea_0094_0112 : public TsmLeaf
  {
  public:
    Lea_0094_0112( TsmBase* oParent )
    {
      TsmName = "Ready";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 126, "( ProxyDisplayFsm >> Active >> Ready ) => ( ProxyDisplayFsm >> Active >> StartPausing ) : 'ProxyNok' ppp_display->Px_Pause" );
      mTransitions[ 1 ] = new TsmTransition( 127, "( ProxyDisplayFsm >> Active >> Ready ) => ( ProxyDisplayFsm >> Active >> Ready ) : 'ProxyOk' ppp_display->Px_Prepare" );
      mTransitions[ 2 ] = new TsmTransition( 125, "( ProxyDisplayFsm >> Active >> Ready ) => ( ProxyDisplayFsm >> Active >> Starting ) : 'ProxyNok' ppp_display->Px_Start" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void ppp_display___Px_Pause( TsmHandler& oHandler );
    void Tra_0094_0127( TsmHandler& oHandler );
    void ppp_display___Px_Prepare( TsmHandler& oHandler );
    void ppp_display___Px_Start( TsmHandler& oHandler );
    void Tra_0094_0123( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 88:
        switch ( Command )
        {
        case 15:
          return TsmProspect::OK;
        case 16:
          return TsmProspect::OK;
        case 17:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 126: // UP: ( ProxyDisplayFsm >> Active >> Ready ) => ( ProxyDisplayFsm >> Active >> StartPausing )
        bHigher = true;
        break;
      case 127:
        Tra_0094_0127( oHandler );
        break;
      case 125: // UP: ( ProxyDisplayFsm >> Active >> Ready ) => ( ProxyDisplayFsm >> Active >> Starting )
        bHigher = true;
        break;
      case 123:
        Tra_0094_0123( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Preparing )
  class Lea_0094_0113 : public TsmLeaf
  {
  public:
    Lea_0094_0113( TsmBase* oParent )
    {
      TsmName = "Preparing";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 124, "( ProxyDisplayFsm >> Active >> Preparing ) => ( ProxyDisplayFsm >> Active >> Preparing ) : 'ProxyNok' ppp_display->Px_Prepare" );
      mTransitions[ 1 ] = new TsmTransition( 123, "( ProxyDisplayFsm >> Active >> Preparing ) => ( ProxyDisplayFsm >> Active >> Ready ) : rp_display->CbPrepared" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0094_0124( TsmHandler& oHandler );
    void ppp_display___Px_Prepare( TsmHandler& oHandler );
    void Tra_0094_0122( TsmHandler& oHandler );
    void rp_display___CbPrepared( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 88:
        switch ( Command )
        {
        case 16:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 88
      case 89:
        switch ( Command )
        {
        case 19:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 124:
        Tra_0094_0124( oHandler );
        break;
      case 122:
        Tra_0094_0122( oHandler );
        break;
      case 123: // UP: ( ProxyDisplayFsm >> Active >> Preparing ) => ( ProxyDisplayFsm >> Active >> Ready )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Idle )
  class Lea_0094_0114 : public TsmLeaf
  {
  public:
    Lea_0094_0114( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 122, "( ProxyDisplayFsm >> Active >> Idle ) => ( ProxyDisplayFsm >> Active >> Preparing ) : 'ProxyNok' ppp_display->Px_Prepare" );
      mTransitions[ 1 ] = new TsmTransition( 121, "( ProxyDisplayFsm >> Active >> Idle ) => ( ProxyDisplayFsm >> Active >> Idle ) : 'ProxyOk' ppp_display->Px_Stop" );
    }

    void Tra_0094_0120( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void ppp_display___Px_Prepare( TsmHandler& oHandler );
    void Tra_0094_0121( TsmHandler& oHandler );
    void ppp_display___Px_Stop( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 88:
        switch ( Command )
        {
        case 16:
          return TsmProspect::OK;
        case 18:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 120:
        Tra_0094_0120( oHandler );
        break;
      case 122: // UP: ( ProxyDisplayFsm >> Active >> Idle ) => ( ProxyDisplayFsm >> Active >> Preparing )
        bHigher = true;
        break;
      case 121:
        Tra_0094_0121( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Starting )
  class Lea_0094_0115 : public TsmLeaf
  {
  public:
    Lea_0094_0115( TsmBase* oParent )
    {
      TsmName = "Starting";
      TsmParent = oParent;
      mNrTransitions = 4;
      mTransitions = new TsmTransition*[ 4 ];
      mTransitions[ 0 ] = new TsmTransition( 139, "( ProxyDisplayFsm >> Active >> Starting ) => ( ProxyDisplayFsm >> Active >> Starting ) : 'ProxyNok' ppp_display->Px_Pause" );
      mTransitions[ 1 ] = new TsmTransition( 128, "( ProxyDisplayFsm >> Active >> Starting ) => ( ProxyDisplayFsm >> Active >> Starting ) : 'ProxyNok' ppp_display->Px_Start" );
      mTransitions[ 2 ] = new TsmTransition( 132, "( ProxyDisplayFsm >> Active >> Starting ) => ( ProxyDisplayFsm >> Active >> Busy >> Play ) : rp_display->CbStarted" );
      mTransitions[ 3 ] = new TsmTransition( 135, "( ProxyDisplayFsm >> Active >> Starting ) => ( ProxyDisplayFsm >> Active >> JuncState ) : rp_display->CbSynclost" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0094_0139( TsmHandler& oHandler );
    void ppp_display___Px_Pause( TsmHandler& oHandler );
    void Tra_0094_0125( TsmHandler& oHandler );
    void Tra_0094_0128( TsmHandler& oHandler );
    void ppp_display___Px_Start( TsmHandler& oHandler );
    void rp_display___CbStarted( TsmHandler& oHandler );
    void rp_display___CbSynclost( tTime BadTime, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 88:
        switch ( Command )
        {
        case 15:
          return TsmProspect::OK;
        case 17:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 88
      case 89:
        switch ( Command )
        {
        case 20:
          return TsmProspect::OK;
        case 24:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 139:
        Tra_0094_0139( oHandler );
        break;
      case 125:
        Tra_0094_0125( oHandler );
        break;
      case 128:
        Tra_0094_0128( oHandler );
        break;
      case 132: // UP: ( ProxyDisplayFsm >> Active >> Starting ) => ( ProxyDisplayFsm >> Active >> Busy >> Play )
        bHigher = true;
        break;
      case 135: // UP: ( ProxyDisplayFsm >> Active >> Starting ) => ( ProxyDisplayFsm >> Active >> JuncState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Synclost )
  class Lea_0094_0116 : public TsmLeaf
  {
  public:
    Lea_0094_0116( TsmBase* oParent )
    {
      TsmName = "Synclost";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Tra_0094_0138( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 138:
        Tra_0094_0138( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> StartPausing )
  class Lea_0094_0117 : public TsmLeaf
  {
  public:
    Lea_0094_0117( TsmBase* oParent )
    {
      TsmName = "StartPausing";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 129, "( ProxyDisplayFsm >> Active >> StartPausing ) => ( ProxyDisplayFsm >> Active >> StartPausing ) : 'ProxyNok' ppp_display->Px_Pause" );
      mTransitions[ 1 ] = new TsmTransition( 130, "( ProxyDisplayFsm >> Active >> StartPausing ) => ( ProxyDisplayFsm >> Active >> Paused ) : rp_display->CbPaused" );
      mTransitions[ 2 ] = new TsmTransition( 137, "( ProxyDisplayFsm >> Active >> StartPausing ) => ( ProxyDisplayFsm >> Active >> JuncState ) : rp_display->CbSynclost" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0094_0126( TsmHandler& oHandler );
    void Tra_0094_0129( TsmHandler& oHandler );
    void ppp_display___Px_Pause( TsmHandler& oHandler );
    void rp_display___CbPaused( TsmHandler& oHandler );
    void rp_display___CbSynclost( tTime BadTime, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 88:
        switch ( Command )
        {
        case 15:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 88
      case 89:
        switch ( Command )
        {
        case 21:
          return TsmProspect::OK;
        case 24:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 126:
        Tra_0094_0126( oHandler );
        break;
      case 129:
        Tra_0094_0129( oHandler );
        break;
      case 130: // UP: ( ProxyDisplayFsm >> Active >> StartPausing ) => ( ProxyDisplayFsm >> Active >> Paused )
        bHigher = true;
        break;
      case 137: // UP: ( ProxyDisplayFsm >> Active >> StartPausing ) => ( ProxyDisplayFsm >> Active >> JuncState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Paused )
  class Lea_0094_0118 : public TsmLeaf
  {
  public:
    Lea_0094_0118( TsmBase* oParent )
    {
      TsmName = "Paused";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 133, "( ProxyDisplayFsm >> Active >> Paused ) => ( ProxyDisplayFsm >> Active >> Busy >> Continuing ) : 'ProxyNok' ppp_display->Px_Continue" );
      mTransitions[ 1 ] = new TsmTransition( 131, "( ProxyDisplayFsm >> Active >> Paused ) => ( ProxyDisplayFsm >> Active >> Paused ) : 'ProxyOk' ppp_display->Px_Pause" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void ppp_display___Px_Continue( TsmHandler& oHandler );
    void Tra_0094_0131( TsmHandler& oHandler );
    void ppp_display___Px_Pause( TsmHandler& oHandler );
    void Tra_0098_0104( TsmHandler& oHandler );
    void Tra_0094_0130( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 88:
        switch ( Command )
        {
        case 14:
          return TsmProspect::OK;
        case 15:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 133: // UP: ( ProxyDisplayFsm >> Active >> Paused ) => ( ProxyDisplayFsm >> Active >> Busy >> Continuing )
        bHigher = true;
        break;
      case 131:
        Tra_0094_0131( oHandler );
        break;
      case 104:
        Tra_0098_0104( oHandler );
        break;
      case 130:
        Tra_0094_0130( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Finishing )
  class Lea_0094_0119 : public TsmLeaf
  {
  public:
    Lea_0094_0119( TsmBase* oParent )
    {
      TsmName = "Finishing";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0094_0134( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 134:
        Tra_0094_0134( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >)
  class Reg_0093_0094 : public TsmRegion
  {
  private:
    Ini_0094_0095* oIni_0094_0095; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> InitialState )
    Jun_0094_0096* oJun_0094_0096; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> JuncState )
    Com_0094_0097* oCom_0094_0097; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Busy )
    Lea_0094_0112* oLea_0094_0112; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Ready )
    Lea_0094_0113* oLea_0094_0113; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Preparing )
    Lea_0094_0114* oLea_0094_0114; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Idle )
    Lea_0094_0115* oLea_0094_0115; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Starting )
    Lea_0094_0116* oLea_0094_0116; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Synclost )
    Lea_0094_0117* oLea_0094_0117; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> StartPausing )
    Lea_0094_0118* oLea_0094_0118; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Paused )
    Lea_0094_0119* oLea_0094_0119; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Finishing )

  public:
    Reg_0093_0094( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0094_0095 = new Ini_0094_0095( this );
      oJun_0094_0096 = new Jun_0094_0096( this );
      oCom_0094_0097 = new Com_0094_0097( this );
      oLea_0094_0112 = new Lea_0094_0112( this );
      oLea_0094_0113 = new Lea_0094_0113( this );
      oLea_0094_0114 = new Lea_0094_0114( this );
      oLea_0094_0115 = new Lea_0094_0115( this );
      oLea_0094_0116 = new Lea_0094_0116( this );
      oLea_0094_0117 = new Lea_0094_0117( this );
      oLea_0094_0118 = new Lea_0094_0118( this );
      oLea_0094_0119 = new Lea_0094_0119( this );
      mNrStates = 11;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0094_0095;
      mStates[ 1 ] = oJun_0094_0096;
      mStates[ 2 ] = oCom_0094_0097;
      mStates[ 3 ] = oLea_0094_0112;
      mStates[ 4 ] = oLea_0094_0113;
      mStates[ 5 ] = oLea_0094_0114;
      mStates[ 6 ] = oLea_0094_0115;
      mStates[ 7 ] = oLea_0094_0116;
      mStates[ 8 ] = oLea_0094_0117;
      mStates[ 9 ] = oLea_0094_0118;
      mStates[ 10 ] = oLea_0094_0119;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0094_0120( TsmHandler& oHandler );
    void Tra_0094_0138( TsmHandler& oHandler );
    void Tra_0094_0133( TsmHandler& oHandler );
    void Tra_0094_0126( TsmHandler& oHandler );
    void Tra_0094_0122( TsmHandler& oHandler );
    void Tra_0094_0125( TsmHandler& oHandler );
    void Tra_0094_0123( TsmHandler& oHandler );
    void Tra_0094_0132( TsmHandler& oHandler );
    void Tra_0098_0104( TsmHandler& oHandler );
    void Tra_0094_0130( TsmHandler& oHandler );
    void Tra_0094_0134( TsmHandler& oHandler );
    void Tra_0094_0136( TsmHandler& oHandler );
    void Tra_0094_0135( TsmHandler& oHandler );
    void Tra_0094_0137( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 88:
        switch ( Command )
        {
        case 14:
          return TsmProspect::OK;
        case 15:
          return TsmProspect::OK;
        case 16:
          return TsmProspect::OK;
        case 17:
          return TsmProspect::OK;
        case 18:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 88
      case 89:
        switch ( Command )
        {
        case 19:
          return TsmProspect::OK;
        case 20:
          return TsmProspect::OK;
        case 21:
          return TsmProspect::OK;
        case 22:
          return TsmProspect::OK;
        case 23:
          return TsmProspect::OK;
        case 24:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 120:
        Tra_0094_0120( oHandler );
        break;
      case 138:
        Tra_0094_0138( oHandler );
        break;
      case 133:
        Tra_0094_0133( oHandler );
        break;
      case 126:
        Tra_0094_0126( oHandler );
        break;
      case 122:
        Tra_0094_0122( oHandler );
        break;
      case 125:
        Tra_0094_0125( oHandler );
        break;
      case 123:
        Tra_0094_0123( oHandler );
        break;
      case 132:
        Tra_0094_0132( oHandler );
        break;
      case 104:
        Tra_0098_0104( oHandler );
        break;
      case 130:
        Tra_0094_0130( oHandler );
        break;
      case 134:
        Tra_0094_0134( oHandler );
        break;
      case 136:
        Tra_0094_0136( oHandler );
        break;
      case 135:
        Tra_0094_0135( oHandler );
        break;
      case 137:
        Tra_0094_0137( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active )
  class Com_0091_0093 : public TsmCompound
  {
  private:
    Reg_0093_0094* oReg_0093_0094; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >)

  public:
    Com_0091_0093( TsmBase* oParent )
    {
      TsmName = "Active";
      TsmParent = oParent;
      oReg_0093_0094 = new Reg_0093_0094( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0093_0094;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 142, "( ProxyDisplayFsm >> Active ) => ( ProxyDisplayFsm >> Stopping ) : 'ProxyNok' ppp_display->Px_Stop" );
    }

    void Tra_0091_0141( TsmHandler& oHandler );
    void ppp_display___Px_Stop( TsmHandler& oHandler );
    void Tra_0091_0143( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 88:
        switch ( Command )
        {
        case 18:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 141:
        Tra_0091_0141( oHandler );
        break;
      case 142: // UP: ( ProxyDisplayFsm >> Active ) => ( ProxyDisplayFsm >> Stopping )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 143:
        Tra_0091_0143( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Stopping )
  class Lea_0091_0140 : public TsmLeaf
  {
  public:
    Lea_0091_0140( TsmBase* oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      mNrTransitions = 8;
      mTransitions = new TsmTransition*[ 8 ];
      mTransitions[ 0 ] = new TsmTransition( 144, "( ProxyDisplayFsm >> Stopping ) => ( ProxyDisplayFsm >> Stopping ) : 'ProxyNok' ppp_display->Px_Stop" );
      mTransitions[ 1 ] = new TsmTransition( 145, "( ProxyDisplayFsm >> Stopping ) => ( ProxyDisplayFsm >> Stopping ) : rp_display->CbPrepared" );
      mTransitions[ 2 ] = new TsmTransition( 146, "( ProxyDisplayFsm >> Stopping ) => ( ProxyDisplayFsm >> Stopping ) : rp_display->CbStarted" );
      mTransitions[ 3 ] = new TsmTransition( 148, "( ProxyDisplayFsm >> Stopping ) => ( ProxyDisplayFsm >> Stopping ) : rp_display->CbPaused" );
      mTransitions[ 4 ] = new TsmTransition( 149, "( ProxyDisplayFsm >> Stopping ) => ( ProxyDisplayFsm >> Stopping ) : rp_display->CbContinued" );
      mTransitions[ 5 ] = new TsmTransition( 147, "( ProxyDisplayFsm >> Stopping ) => ( ProxyDisplayFsm >> Stopping ) : rp_display->CbFinished" );
      mTransitions[ 6 ] = new TsmTransition( 150, "( ProxyDisplayFsm >> Stopping ) => ( ProxyDisplayFsm >> Stopping ) : rp_display->CbSynclost" );
      mTransitions[ 7 ] = new TsmTransition( 143, "( ProxyDisplayFsm >> Stopping ) => ( ProxyDisplayFsm >> Active ) : rp_display->CbStopped" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0091_0142( TsmHandler& oHandler );
    void Tra_0091_0144( TsmHandler& oHandler );
    void ppp_display___Px_Stop( TsmHandler& oHandler );
    void Tra_0091_0145( TsmHandler& oHandler );
    void rp_display___CbPrepared( TsmHandler& oHandler );
    void Tra_0091_0146( TsmHandler& oHandler );
    void rp_display___CbStarted( TsmHandler& oHandler );
    void Tra_0091_0148( TsmHandler& oHandler );
    void rp_display___CbPaused( TsmHandler& oHandler );
    void Tra_0091_0149( TsmHandler& oHandler );
    void rp_display___CbContinued( TsmHandler& oHandler );
    void Tra_0091_0147( TsmHandler& oHandler );
    void rp_display___CbFinished( TsmHandler& oHandler );
    void Tra_0091_0150( TsmHandler& oHandler );
    void rp_display___CbSynclost( tTime BadTime, TsmHandler& oHandler );
    void rp_display___CbStopped( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 88:
        switch ( Command )
        {
        case 18:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 88
      case 89:
        switch ( Command )
        {
        case 19:
          return TsmProspect::OK;
        case 20:
          return TsmProspect::OK;
        case 21:
          return TsmProspect::OK;
        case 22:
          return TsmProspect::OK;
        case 23:
          return TsmProspect::OK;
        case 24:
          return TsmProspect::OK;
        case 25:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 142:
        Tra_0091_0142( oHandler );
        break;
      case 144:
        Tra_0091_0144( oHandler );
        break;
      case 145:
        Tra_0091_0145( oHandler );
        break;
      case 146:
        Tra_0091_0146( oHandler );
        break;
      case 148:
        Tra_0091_0148( oHandler );
        break;
      case 149:
        Tra_0091_0149( oHandler );
        break;
      case 147:
        Tra_0091_0147( oHandler );
        break;
      case 150:
        Tra_0091_0150( oHandler );
        break;
      case 143: // UP: ( ProxyDisplayFsm >> Stopping ) => ( ProxyDisplayFsm >> Active )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >)
  class Reg_0090_0091 : public TsmRegion
  {
  private:
    Ini_0091_0092* oIni_0091_0092; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> InitialState )
    Com_0091_0093* oCom_0091_0093; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active )
    Lea_0091_0140* oLea_0091_0140; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Stopping )

  public:
    Reg_0090_0091( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0091_0092 = new Ini_0091_0092( this );
      oCom_0091_0093 = new Com_0091_0093( this );
      oLea_0091_0140 = new Lea_0091_0140( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0091_0092;
      mStates[ 1 ] = oCom_0091_0093;
      mStates[ 2 ] = oLea_0091_0140;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0091_0141( TsmHandler& oHandler );
    void Tra_0091_0142( TsmHandler& oHandler );
    void Tra_0091_0143( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 88:
        switch ( Command )
        {
        case 14:
          return TsmProspect::OK;
        case 15:
          return TsmProspect::OK;
        case 16:
          return TsmProspect::OK;
        case 17:
          return TsmProspect::OK;
        case 18:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 88
      case 89:
        switch ( Command )
        {
        case 19:
          return TsmProspect::OK;
        case 20:
          return TsmProspect::OK;
        case 21:
          return TsmProspect::OK;
        case 22:
          return TsmProspect::OK;
        case 23:
          return TsmProspect::OK;
        case 24:
          return TsmProspect::OK;
        case 25:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 141:
        Tra_0091_0141( oHandler );
        break;
      case 142:
        Tra_0091_0142( oHandler );
        break;
      case 143:
        Tra_0091_0143( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm )
  class Fsm_0087_0090 : public TsmFsm
  {
  private:
    Reg_0090_0091* oReg_0090_0091; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >)

  public:
    Fsm_0087_0090( TsmBase* oParent )
    {
      TsmName = "ProxyDisplayFsm";
      TsmParent = oParent;
      oReg_0090_0091 = new Reg_0090_0091( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0090_0091;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay )
  class Cla_0085_0087 : public TsmProxy
  {
  private:
    Fsm_0087_0090* oFsm_0087_0090; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm )
    TsmIPort_IProxyDisplayServer* TsmPI__ppp_display; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ppp_display )
    TsmIPort_IProxyDisplayClient* ppp_display; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ppp_display )
    TsmIPort_IDisplayServer* rp_display; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > rp_display )
    TsmIPort_IDisplayClient* TsmPI__rp_display; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > rp_display )
    TsmPSPort* mPSMessager;
    TsmPCPort* mPCMessager;
    eRV frv;

  public:
    Cla_0085_0087( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0087_0090 = new Fsm_0087_0090( this );
      TsmPI__ppp_display = new TsmIPort_IProxyDisplayServer( this );
      TsmPI__rp_display = new TsmIPort_IDisplayClient( this );
      mPSMessager = new TsmPSPort();
      mPCMessager = new TsmPCPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0087_0090;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "ppp_display" )
      {
        return TsmPI__ppp_display;
      }
      if ( sPortName == "rp_display" )
      {
        return TsmPI__rp_display;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "ppp_display" )
      {
        ppp_display = static_cast<TsmIPort_IProxyDisplayClient*>(oProvidedInterface);
        ppp_display->Source = this;
        return;
      }
      if ( sPortName == "rp_display" )
      {
        rp_display = static_cast<TsmIPort_IDisplayServer*>(oProvidedInterface);
        rp_display->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0087_0090->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    void Function_1011( TsmHandler& oHandler );
    bool Guard_1012();
    eRV Function_1013();
    void Function_1014( TsmHandler& oHandler );
    eRV Function_1015();
    void Function_1016( TsmHandler& oHandler );
    void Function_1228( TsmHandler& oHandler );
    void Function_1229( TsmHandler& oHandler );
    void Function_1230( TsmHandler& oHandler );
    void Function_1231( TsmHandler& oHandler );
    void Function_1232( TsmHandler& oHandler );
    void Function_1233( TsmHandler& oHandler );
    void Function_1234( TsmHandler& oHandler );
    void Function_1235( TsmHandler& oHandler );
    eRV Function_1236();
    void Function_1237( TsmHandler& oHandler );
    void Function_1238( TsmHandler& oHandler );
    void Function_1239( TsmHandler& oHandler );
    void Function_1240( TsmHandler& oHandler );
    void Function_1241( TsmHandler& oHandler );
    void Function_1242( TsmHandler& oHandler );
    void Function_1243( TsmHandler& oHandler );
    void Function_1244( TsmHandler& oHandler );
    void Function_1245( TsmHandler& oHandler );
    void Function_1246( TsmHandler& oHandler );
    void Function_1247( TsmHandler& oHandler );
    void Function_1248( TsmHandler& oHandler );
    void Function_1249( TsmHandler& oHandler );
    void Function_1250( TsmHandler& oHandler );
    void Function_1251( TsmHandler& oHandler );
    void Function_1252( TsmHandler& oHandler );
    void Function_1253( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0085_0087()
    {
      delete TsmPI__ppp_display;
      delete TsmPI__rp_display;
      delete mPSMessager;
      delete mPCMessager;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay )
  class Com_0021_0085 : public TsmPComponent
  {
  private:
    Cla_0085_0087* PxDisplay; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > PxDisplay )

  public:
    Com_0021_0085( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      PxDisplay = new Cla_0085_0087( this, "PxDisplay" );
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = PxDisplay;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "d_ppp_display" )
      {
        return PxDisplay->GetProvidedInterface( "ppp_display" );
      }
      if ( sPortName == "d_rp_display" )
      {
        return PxDisplay->GetProvidedInterface( "rp_display" );
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "d_ppp_display" )
      {
        PxDisplay->SetRequiredInterface( "ppp_display", oProvidedInterface );
        return;
      }
      if ( sPortName == "d_rp_display" )
      {
        PxDisplay->SetRequiredInterface( "rp_display", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay )";
      throw TsmException( s );
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> InitialState )
  class Ini_0028_0029 : public TsmPseudo
  {
  public:
    Ini_0028_0029( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 68, "( ProxyReaderFsm >> InitialState ) => ( ProxyReaderFsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 68: // UP: ( ProxyReaderFsm >> InitialState ) => ( ProxyReaderFsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Idle >> InitialState )
  class Ini_0031_0032 : public TsmPseudo
  {
  public:
    Ini_0031_0032( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 35, "( ProxyReaderFsm >> Idle >> InitialState ) => ( ProxyReaderFsm >> Idle >> Base )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 35: // UP: ( ProxyReaderFsm >> Idle >> InitialState ) => ( ProxyReaderFsm >> Idle >> Base )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Idle >> ChoiceState )
  class Cho_0031_0033 : public TsmPseudo
  {
  public:
    Cho_0031_0033( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 37, "( ProxyReaderFsm >> Idle >> ChoiceState ) => ( ProxyReaderFsm >> Opening ) : 'ProxyNok'" );
      mTransitions[ 1 ] = new TsmTransition( 39, "( ProxyReaderFsm >> Idle >> ChoiceState ) => ( ProxyReaderFsm >> Idle >> Base ) : 'ProxyOk'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0031_0038( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 37: // UP: ( ProxyReaderFsm >> Idle >> ChoiceState ) => ( ProxyReaderFsm >> Opening )
        bHigher = true;
        break;
      case 39: // UP: ( ProxyReaderFsm >> Idle >> ChoiceState ) => ( ProxyReaderFsm >> Idle >> Base )
        bHigher = true;
        break;
      case 38:
        Tra_0031_0038( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Idle >> Base )
  class Lea_0031_0034 : public TsmLeaf
  {
  public:
    Lea_0031_0034( TsmBase* oParent )
    {
      TsmName = "Base";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 38, "( ProxyReaderFsm >> Idle >> Base ) => ( ProxyReaderFsm >> Idle >> ChoiceState ) : ppp_reader->Px_Open" );
      mTransitions[ 1 ] = new TsmTransition( 36, "( ProxyReaderFsm >> Idle >> Base ) => ( ProxyReaderFsm >> Idle >> Base ) : 'ProxyOk' ppp_reader->Px_Close" );
      mTransitions[ 2 ] = new TsmTransition( 40, "( ProxyReaderFsm >> Idle >> Base ) => ( ProxyReaderFsm >> Idle >> Base ) : 'ProxyOk' ppp_reader->Px_Stop" );
    }

    void Tra_0031_0035( TsmHandler& oHandler );
    void Tra_0031_0039( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void ppp_reader___Px_Open( int FileHandle, TsmHandler& oHandler );
    void Tra_0031_0036( TsmHandler& oHandler );
    void ppp_reader___Px_Close( TsmHandler& oHandler );
    void Tra_0031_0040( TsmHandler& oHandler );
    void ppp_reader___Px_Stop( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 26:
        switch ( Command )
        {
        case 8:
          return TsmProspect::OK;
        case 9:
          return TsmProspect::OK;
        case 10:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 35:
        Tra_0031_0035( oHandler );
        break;
      case 39:
        Tra_0031_0039( oHandler );
        break;
      case 38: // UP: ( ProxyReaderFsm >> Idle >> Base ) => ( ProxyReaderFsm >> Idle >> ChoiceState )
        bHigher = true;
        break;
      case 36:
        Tra_0031_0036( oHandler );
        break;
      case 40:
        Tra_0031_0040( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Idle >)
  class Reg_0030_0031 : public TsmRegion
  {
  private:
    Ini_0031_0032* oIni_0031_0032; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Idle >> InitialState )
    Cho_0031_0033* oCho_0031_0033; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Idle >> ChoiceState )
    Lea_0031_0034* oLea_0031_0034; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Idle >> Base )

  public:
    Reg_0030_0031( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0031_0032 = new Ini_0031_0032( this );
      oCho_0031_0033 = new Cho_0031_0033( this );
      oLea_0031_0034 = new Lea_0031_0034( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0031_0032;
      mStates[ 1 ] = oCho_0031_0033;
      mStates[ 2 ] = oLea_0031_0034;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0031_0035( TsmHandler& oHandler );
    void Tra_0031_0039( TsmHandler& oHandler );
    void Tra_0031_0038( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 26:
        switch ( Command )
        {
        case 8:
          return TsmProspect::OK;
        case 9:
          return TsmProspect::OK;
        case 10:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 35:
        Tra_0031_0035( oHandler );
        break;
      case 37: // Up: ( ProxyReaderFsm >> Idle >> ChoiceState ) => ( ProxyReaderFsm >> Opening )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 39:
        Tra_0031_0039( oHandler );
        break;
      case 38:
        Tra_0031_0038( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Idle )
  class Com_0028_0030 : public TsmCompound
  {
  private:
    Reg_0030_0031* oReg_0030_0031; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Idle >)

  public:
    Com_0028_0030( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      oReg_0030_0031 = new Reg_0030_0031( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0030_0031;
      mNrTransitions = 0;
    }

    void Tra_0028_0068( TsmHandler& oHandler );
    void Tra_0028_0080( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 68:
        Tra_0028_0068( oHandler );
        break;
      case 37: // UP: ( ProxyReaderFsm >> Idle >> ChoiceState ) => ( ProxyReaderFsm >> Opening )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 80:
        Tra_0028_0080( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> ChoiceState )
  class Cho_0042_0043 : public TsmPseudo
  {
  public:
    Cho_0042_0043( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 62, "( ProxyReaderFsm >> CompoundState >> ChoiceState ) => ( ProxyReaderFsm >> Seeking ) : 'ProxyNok'" );
      mTransitions[ 1 ] = new TsmTransition( 63, "( ProxyReaderFsm >> CompoundState >> ChoiceState ) => ( ProxyReaderFsm >> CompoundState >> Error ) : 'ProxyOk'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0042_0061( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 62: // UP: ( ProxyReaderFsm >> CompoundState >> ChoiceState ) => ( ProxyReaderFsm >> Seeking )
        bHigher = true;
        break;
      case 63: // UP: ( ProxyReaderFsm >> CompoundState >> ChoiceState ) => ( ProxyReaderFsm >> CompoundState >> Error )
        bHigher = true;
        break;
      case 61:
        Tra_0042_0061( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Reading >> InitialState )
  class Ini_0045_0046 : public TsmPseudo
  {
  public:
    Ini_0045_0046( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 49, "( ProxyReaderFsm >> CompoundState >> Reading >> InitialState ) => ( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 49: // UP: ( ProxyReaderFsm >> CompoundState >> Reading >> InitialState ) => ( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Reading >> NotEnough )
  class Lea_0045_0047 : public TsmLeaf
  {
  public:
    Lea_0045_0047( TsmBase* oParent )
    {
      TsmName = "NotEnough";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 51, "( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderFsm >> CompoundState >> Reading >> Enough ) : rp_reader->CbFilled" );
      mTransitions[ 1 ] = new TsmTransition( 50, "( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough ) : 'ProxyOk' ppp_reader->Px_Read" );
      mTransitions[ 2 ] = new TsmTransition( 54, "( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough ) : 'ProxyNok' ppp_reader->Px_IsFilled" );
    }

    void Tra_0045_0049( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void rp_reader___CbFilled( TsmHandler& oHandler );
    void Tra_0045_0050( TsmHandler& oHandler );
    void ppp_reader___Px_Read( tChunk* Chunk, TsmHandler& oHandler );
    void Tra_0045_0054( TsmHandler& oHandler );
    void ppp_reader___Px_IsFilled( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 25:
        switch ( Command )
        {
        case 7:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 25
      case 26:
        switch ( Command )
        {
        case 12:
          return TsmProspect::OK;
        case 13:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 49:
        Tra_0045_0049( oHandler );
        break;
      case 51: // UP: ( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderFsm >> CompoundState >> Reading >> Enough )
        bHigher = true;
        break;
      case 50:
        Tra_0045_0050( oHandler );
        break;
      case 54:
        Tra_0045_0054( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Reading >> Enough )
  class Lea_0045_0048 : public TsmLeaf
  {
  public:
    Lea_0045_0048( TsmBase* oParent )
    {
      TsmName = "Enough";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 52, "( ProxyReaderFsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderFsm >> CompoundState >> Open ) : rp_reader->CbDone" );
      mTransitions[ 1 ] = new TsmTransition( 53, "( ProxyReaderFsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderFsm >> CompoundState >> Reading >> Enough ) : 'ProxyOk' ppp_reader->Px_IsFilled" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void rp_reader___CbDone( TsmHandler& oHandler );
    void Tra_0045_0051( TsmHandler& oHandler );
    void Tra_0045_0053( TsmHandler& oHandler );
    void ppp_reader___Px_IsFilled( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 25:
        switch ( Command )
        {
        case 3:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 25
      case 26:
        switch ( Command )
        {
        case 13:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 52: // UP: ( ProxyReaderFsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderFsm >> CompoundState >> Open )
        bHigher = true;
        break;
      case 51:
        Tra_0045_0051( oHandler );
        break;
      case 53:
        Tra_0045_0053( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Reading >)
  class Reg_0044_0045 : public TsmRegion
  {
  private:
    Ini_0045_0046* oIni_0045_0046; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Reading >> InitialState )
    Lea_0045_0047* oLea_0045_0047; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Reading >> NotEnough )
    Lea_0045_0048* oLea_0045_0048; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Reading >> Enough )

  public:
    Reg_0044_0045( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0045_0046 = new Ini_0045_0046( this );
      oLea_0045_0047 = new Lea_0045_0047( this );
      oLea_0045_0048 = new Lea_0045_0048( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0045_0046;
      mStates[ 1 ] = oLea_0045_0047;
      mStates[ 2 ] = oLea_0045_0048;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0045_0049( TsmHandler& oHandler );
    void Tra_0045_0051( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 25:
        switch ( Command )
        {
        case 3:
          return TsmProspect::OK;
        case 7:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 25
      case 26:
        switch ( Command )
        {
        case 12:
          return TsmProspect::OK;
        case 13:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 49:
        Tra_0045_0049( oHandler );
        break;
      case 52: // Up: ( ProxyReaderFsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderFsm >> CompoundState >> Open )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 51:
        Tra_0045_0051( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Reading )
  class Com_0042_0044 : public TsmCompound
  {
  private:
    Reg_0044_0045* oReg_0044_0045; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Reading >)

  public:
    Com_0042_0044( TsmBase* oParent )
    {
      TsmName = "Reading";
      TsmParent = oParent;
      oReg_0044_0045 = new Reg_0044_0045( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0044_0045;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 60, "( ProxyReaderFsm >> CompoundState >> Reading ) => ( ProxyReaderFsm >> CompoundState >> Error ) : rp_reader->CbError" );
    }

    void rp_reader___CbError( int Sector, TsmHandler& oHandler );
    void Tra_0028_0076( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 25:
        switch ( Command )
        {
        case 4:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 52: // UP: ( ProxyReaderFsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderFsm >> CompoundState >> Open )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 60: // UP: ( ProxyReaderFsm >> CompoundState >> Reading ) => ( ProxyReaderFsm >> CompoundState >> Error )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 76:
        Tra_0028_0076( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Open )
  class Lea_0042_0055 : public TsmLeaf
  {
  public:
    Lea_0042_0055( TsmBase* oParent )
    {
      TsmName = "Open";
      TsmParent = oParent;
      mNrTransitions = 5;
      mTransitions = new TsmTransition*[ 5 ];
      mTransitions[ 0 ] = new TsmTransition( 57, "( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> CompoundState >> Open ) : 'ProxyOk' ppp_reader->Px_Open" );
      mTransitions[ 1 ] = new TsmTransition( 78, "( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> Closing ) : 'ProxyNok' ppp_reader->Px_Close" );
      mTransitions[ 2 ] = new TsmTransition( 58, "( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> CompoundState >> Open ) : 'ProxyOk' ppp_reader->Px_Stop" );
      mTransitions[ 3 ] = new TsmTransition( 59, "( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> CompoundState >> Open ) : ppp_reader->Px_Clear" );
      mTransitions[ 4 ] = new TsmTransition( 61, "( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> CompoundState >> ChoiceState ) : ppp_reader->Px_Read" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0028_0071( TsmHandler& oHandler );
    void Tra_0028_0074( TsmHandler& oHandler );
    void Tra_0045_0052( TsmHandler& oHandler );
    void Tra_0042_0057( TsmHandler& oHandler );
    void ppp_reader___Px_Open( int FileHandle, TsmHandler& oHandler );
    void ppp_reader___Px_Close( TsmHandler& oHandler );
    void Tra_0042_0058( TsmHandler& oHandler );
    void ppp_reader___Px_Stop( TsmHandler& oHandler );
    void Tra_0042_0059( TsmHandler& oHandler );
    void ppp_reader___Px_Clear( TsmHandler& oHandler );
    void ppp_reader___Px_Read( tChunk* Chunk, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 26:
        switch ( Command )
        {
        case 8:
          return TsmProspect::OK;
        case 9:
          return TsmProspect::OK;
        case 10:
          return TsmProspect::OK;
        case 11:
          return TsmProspect::OK;
        case 12:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 71:
        Tra_0028_0071( oHandler );
        break;
      case 74:
        Tra_0028_0074( oHandler );
        break;
      case 52:
        Tra_0045_0052( oHandler );
        break;
      case 57:
        Tra_0042_0057( oHandler );
        break;
      case 78: // UP: ( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> Closing )
        bHigher = true;
        break;
      case 58:
        Tra_0042_0058( oHandler );
        break;
      case 59:
        Tra_0042_0059( oHandler );
        break;
      case 61: // UP: ( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> CompoundState >> ChoiceState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Error )
  class Lea_0042_0056 : public TsmLeaf
  {
  public:
    Lea_0042_0056( TsmBase* oParent )
    {
      TsmName = "Error";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Tra_0042_0063( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0042_0060( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 63:
        Tra_0042_0063( oHandler );
        break;
      case 60:
        Tra_0042_0060( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >)
  class Reg_0041_0042 : public TsmRegion
  {
  private:
    Cho_0042_0043* oCho_0042_0043; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> ChoiceState )
    Com_0042_0044* oCom_0042_0044; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Reading )
    Lea_0042_0055* oLea_0042_0055; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Open )
    Lea_0042_0056* oLea_0042_0056; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Error )

  public:
    Reg_0041_0042( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oCho_0042_0043 = new Cho_0042_0043( this );
      oCom_0042_0044 = new Com_0042_0044( this );
      oLea_0042_0055 = new Lea_0042_0055( this );
      oLea_0042_0056 = new Lea_0042_0056( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oCho_0042_0043;
      mStates[ 1 ] = oCom_0042_0044;
      mStates[ 2 ] = oLea_0042_0055;
      mStates[ 3 ] = oLea_0042_0056;
    }

    void Tra_0042_0063( TsmHandler& oHandler );
    void Tra_0028_0071( TsmHandler& oHandler );
    void Tra_0028_0074( TsmHandler& oHandler );
    void Tra_0045_0052( TsmHandler& oHandler );
    void Tra_0042_0060( TsmHandler& oHandler );
    void Tra_0028_0076( TsmHandler& oHandler );
    void Tra_0042_0061( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 25:
        switch ( Command )
        {
        case 3:
          return TsmProspect::OK;
        case 4:
          return TsmProspect::OK;
        case 7:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 25
      case 26:
        switch ( Command )
        {
        case 8:
          return TsmProspect::OK;
        case 9:
          return TsmProspect::OK;
        case 10:
          return TsmProspect::OK;
        case 11:
          return TsmProspect::OK;
        case 12:
          return TsmProspect::OK;
        case 13:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 62: // Up: ( ProxyReaderFsm >> CompoundState >> ChoiceState ) => ( ProxyReaderFsm >> Seeking )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 63:
        Tra_0042_0063( oHandler );
        break;
      case 71:
        Tra_0028_0071( oHandler );
        break;
      case 74:
        Tra_0028_0074( oHandler );
        break;
      case 52:
        Tra_0045_0052( oHandler );
        break;
      case 60:
        Tra_0042_0060( oHandler );
        break;
      case 76:
        Tra_0028_0076( oHandler );
        break;
      case 78: // Up: ( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> Closing )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 61:
        Tra_0042_0061( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState )
  class Com_0028_0041 : public TsmCompound
  {
  private:
    Reg_0041_0042* oReg_0041_0042; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >)

  public:
    Com_0028_0041( TsmBase* oParent )
    {
      TsmName = "CS_41";
      TsmParent = oParent;
      oReg_0041_0042 = new Reg_0041_0042( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0041_0042;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 72, "( ProxyReaderFsm >> CompoundState ) => ( ProxyReaderFsm >> Stopping ) : 'ProxyNok' ppp_reader->Px_Stop" );
    }

    void Tra_0028_0071( TsmHandler& oHandler );
    void Tra_0028_0074( TsmHandler& oHandler );
    void Tra_0028_0076( TsmHandler& oHandler );
    void ppp_reader___Px_Stop( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 26:
        switch ( Command )
        {
        case 10:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 62: // UP: ( ProxyReaderFsm >> CompoundState >> ChoiceState ) => ( ProxyReaderFsm >> Seeking )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 71:
        Tra_0028_0071( oHandler );
        break;
      case 74:
        Tra_0028_0074( oHandler );
        break;
      case 76:
        Tra_0028_0076( oHandler );
        break;
      case 78: // UP: ( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> Closing )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 72: // UP: ( ProxyReaderFsm >> CompoundState ) => ( ProxyReaderFsm >> Stopping )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Opening )
  class Lea_0028_0064 : public TsmLeaf
  {
  public:
    Lea_0028_0064( TsmBase* oParent )
    {
      TsmName = "Opening";
      TsmParent = oParent;
      mNrTransitions = 4;
      mTransitions = new TsmTransition*[ 4 ];
      mTransitions[ 0 ] = new TsmTransition( 71, "( ProxyReaderFsm >> Opening ) => ( ProxyReaderFsm >> CompoundState >> Open ) : rp_reader->CbOpened" );
      mTransitions[ 1 ] = new TsmTransition( 69, "( ProxyReaderFsm >> Opening ) => ( ProxyReaderFsm >> Opening ) : 'ProxyNok' ppp_reader->Px_Open" );
      mTransitions[ 2 ] = new TsmTransition( 70, "( ProxyReaderFsm >> Opening ) => ( ProxyReaderFsm >> Opening ) : 'ProxyNok' ppp_reader->Px_Close" );
      mTransitions[ 3 ] = new TsmTransition( 84, "( ProxyReaderFsm >> Opening ) => ( ProxyReaderFsm >> Opening ) : 'ProxyNok' ppp_reader->Px_Stop" );
    }

    void Tra_0031_0037( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void rp_reader___CbOpened( TsmHandler& oHandler );
    void Tra_0028_0069( TsmHandler& oHandler );
    void ppp_reader___Px_Open( int FileHandle, TsmHandler& oHandler );
    void Tra_0028_0070( TsmHandler& oHandler );
    void ppp_reader___Px_Close( TsmHandler& oHandler );
    void Tra_0028_0084( TsmHandler& oHandler );
    void ppp_reader___Px_Stop( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 25:
        switch ( Command )
        {
        case 1:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 25
      case 26:
        switch ( Command )
        {
        case 8:
          return TsmProspect::OK;
        case 9:
          return TsmProspect::OK;
        case 10:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 37:
        Tra_0031_0037( oHandler );
        break;
      case 71: // UP: ( ProxyReaderFsm >> Opening ) => ( ProxyReaderFsm >> CompoundState >> Open )
        bHigher = true;
        break;
      case 69:
        Tra_0028_0069( oHandler );
        break;
      case 70:
        Tra_0028_0070( oHandler );
        break;
      case 84:
        Tra_0028_0084( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Stopping )
  class Lea_0028_0065 : public TsmLeaf
  {
  public:
    Lea_0028_0065( TsmBase* oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      mNrTransitions = 5;
      mTransitions = new TsmTransition*[ 5 ];
      mTransitions[ 0 ] = new TsmTransition( 74, "( ProxyReaderFsm >> Stopping ) => ( ProxyReaderFsm >> CompoundState >> Open ) : rp_reader->CbStopped" );
      mTransitions[ 1 ] = new TsmTransition( 83, "( ProxyReaderFsm >> Stopping ) => ( ProxyReaderFsm >> Stopping ) : rp_reader->CbDone" );
      mTransitions[ 2 ] = new TsmTransition( 81, "( ProxyReaderFsm >> Stopping ) => ( ProxyReaderFsm >> Stopping ) : rp_reader->CbError" );
      mTransitions[ 3 ] = new TsmTransition( 82, "( ProxyReaderFsm >> Stopping ) => ( ProxyReaderFsm >> Stopping ) : rp_reader->CbFilled" );
      mTransitions[ 4 ] = new TsmTransition( 73, "( ProxyReaderFsm >> Stopping ) => ( ProxyReaderFsm >> Stopping ) : 'ProxyNok' ppp_reader->Px_Stop" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void rp_reader___CbStopped( TsmHandler& oHandler );
    void Tra_0028_0083( TsmHandler& oHandler );
    void rp_reader___CbDone( TsmHandler& oHandler );
    void Tra_0028_0081( TsmHandler& oHandler );
    void rp_reader___CbError( int Sector, TsmHandler& oHandler );
    void Tra_0028_0082( TsmHandler& oHandler );
    void rp_reader___CbFilled( TsmHandler& oHandler );
    void Tra_0028_0072( TsmHandler& oHandler );
    void Tra_0028_0073( TsmHandler& oHandler );
    void ppp_reader___Px_Stop( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 25:
        switch ( Command )
        {
        case 2:
          return TsmProspect::OK;
        case 3:
          return TsmProspect::OK;
        case 4:
          return TsmProspect::OK;
        case 7:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 25
      case 26:
        switch ( Command )
        {
        case 10:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 74: // UP: ( ProxyReaderFsm >> Stopping ) => ( ProxyReaderFsm >> CompoundState >> Open )
        bHigher = true;
        break;
      case 83:
        Tra_0028_0083( oHandler );
        break;
      case 81:
        Tra_0028_0081( oHandler );
        break;
      case 82:
        Tra_0028_0082( oHandler );
        break;
      case 72:
        Tra_0028_0072( oHandler );
        break;
      case 73:
        Tra_0028_0073( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Closing )
  class Lea_0028_0066 : public TsmLeaf
  {
  public:
    Lea_0028_0066( TsmBase* oParent )
    {
      TsmName = "Closing";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 80, "( ProxyReaderFsm >> Closing ) => ( ProxyReaderFsm >> Idle ) : rp_reader->CbClosed" );
      mTransitions[ 1 ] = new TsmTransition( 79, "( ProxyReaderFsm >> Closing ) => ( ProxyReaderFsm >> Closing ) : 'ProxyNok' ppp_reader->Px_Close" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void rp_reader___CbClosed( TsmHandler& oHandler );
    void Tra_0028_0078( TsmHandler& oHandler );
    void Tra_0028_0079( TsmHandler& oHandler );
    void ppp_reader___Px_Close( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 25:
        switch ( Command )
        {
        case 5:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 25
      case 26:
        switch ( Command )
        {
        case 9:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 80: // UP: ( ProxyReaderFsm >> Closing ) => ( ProxyReaderFsm >> Idle )
        bHigher = true;
        break;
      case 78:
        Tra_0028_0078( oHandler );
        break;
      case 79:
        Tra_0028_0079( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Seeking )
  class Lea_0028_0067 : public TsmLeaf
  {
  public:
    Lea_0028_0067( TsmBase* oParent )
    {
      TsmName = "Seeking";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 76, "( ProxyReaderFsm >> Seeking ) => ( ProxyReaderFsm >> CompoundState >> Reading ) : rp_reader->CbReading" );
      mTransitions[ 1 ] = new TsmTransition( 75, "( ProxyReaderFsm >> Seeking ) => ( ProxyReaderFsm >> Seeking ) : 'ProxyNok' ppp_reader->Px_Stop" );
      mTransitions[ 2 ] = new TsmTransition( 77, "( ProxyReaderFsm >> Seeking ) => ( ProxyReaderFsm >> Seeking ) : 'ProxyNok' ppp_reader->Px_Read" );
    }

    void Tra_0042_0062( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void rp_reader___CbReading( TsmHandler& oHandler );
    void Tra_0028_0075( TsmHandler& oHandler );
    void ppp_reader___Px_Stop( TsmHandler& oHandler );
    void Tra_0028_0077( TsmHandler& oHandler );
    void ppp_reader___Px_Read( tChunk* Chunk, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 25:
        switch ( Command )
        {
        case 6:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 25
      case 26:
        switch ( Command )
        {
        case 10:
          return TsmProspect::OK;
        case 12:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 62:
        Tra_0042_0062( oHandler );
        break;
      case 76: // UP: ( ProxyReaderFsm >> Seeking ) => ( ProxyReaderFsm >> CompoundState >> Reading )
        bHigher = true;
        break;
      case 75:
        Tra_0028_0075( oHandler );
        break;
      case 77:
        Tra_0028_0077( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >)
  class Reg_0027_0028 : public TsmRegion
  {
  private:
    Ini_0028_0029* oIni_0028_0029; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> InitialState )
    Com_0028_0030* oCom_0028_0030; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Idle )
    Com_0028_0041* oCom_0028_0041; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState )
    Lea_0028_0064* oLea_0028_0064; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Opening )
    Lea_0028_0065* oLea_0028_0065; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Stopping )
    Lea_0028_0066* oLea_0028_0066; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Closing )
    Lea_0028_0067* oLea_0028_0067; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Seeking )

  public:
    Reg_0027_0028( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0028_0029 = new Ini_0028_0029( this );
      oCom_0028_0030 = new Com_0028_0030( this );
      oCom_0028_0041 = new Com_0028_0041( this );
      oLea_0028_0064 = new Lea_0028_0064( this );
      oLea_0028_0065 = new Lea_0028_0065( this );
      oLea_0028_0066 = new Lea_0028_0066( this );
      oLea_0028_0067 = new Lea_0028_0067( this );
      mNrStates = 7;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0028_0029;
      mStates[ 1 ] = oCom_0028_0030;
      mStates[ 2 ] = oCom_0028_0041;
      mStates[ 3 ] = oLea_0028_0064;
      mStates[ 4 ] = oLea_0028_0065;
      mStates[ 5 ] = oLea_0028_0066;
      mStates[ 6 ] = oLea_0028_0067;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0028_0068( TsmHandler& oHandler );
    void Tra_0031_0037( TsmHandler& oHandler );
    void Tra_0042_0062( TsmHandler& oHandler );
    void Tra_0028_0071( TsmHandler& oHandler );
    void Tra_0028_0074( TsmHandler& oHandler );
    void Tra_0028_0080( TsmHandler& oHandler );
    void Tra_0028_0076( TsmHandler& oHandler );
    void Tra_0028_0078( TsmHandler& oHandler );
    void Tra_0028_0072( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 25:
        switch ( Command )
        {
        case 1:
          return TsmProspect::OK;
        case 2:
          return TsmProspect::OK;
        case 3:
          return TsmProspect::OK;
        case 4:
          return TsmProspect::OK;
        case 5:
          return TsmProspect::OK;
        case 6:
          return TsmProspect::OK;
        case 7:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 25
      case 26:
        switch ( Command )
        {
        case 8:
          return TsmProspect::OK;
        case 9:
          return TsmProspect::OK;
        case 10:
          return TsmProspect::OK;
        case 11:
          return TsmProspect::OK;
        case 12:
          return TsmProspect::OK;
        case 13:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 68:
        Tra_0028_0068( oHandler );
        break;
      case 37:
        Tra_0031_0037( oHandler );
        break;
      case 62:
        Tra_0042_0062( oHandler );
        break;
      case 71:
        Tra_0028_0071( oHandler );
        break;
      case 74:
        Tra_0028_0074( oHandler );
        break;
      case 80:
        Tra_0028_0080( oHandler );
        break;
      case 76:
        Tra_0028_0076( oHandler );
        break;
      case 78:
        Tra_0028_0078( oHandler );
        break;
      case 72:
        Tra_0028_0072( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm )
  class Fsm_0024_0027 : public TsmFsm
  {
  private:
    Reg_0027_0028* oReg_0027_0028; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >)

  public:
    Fsm_0024_0027( TsmBase* oParent )
    {
      TsmName = "ProxyReaderFsm";
      TsmParent = oParent;
      oReg_0027_0028 = new Reg_0027_0028( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0027_0028;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader )
  class Cla_0022_0024 : public TsmProxy
  {
  private:
    Fsm_0024_0027* oFsm_0024_0027; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm )
    TsmIPort_IReaderServer* rp_reader; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > rp_reader )
    TsmIPort_IReaderClient* TsmPI__rp_reader; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > rp_reader )
    TsmIPort_IProxyReaderServer* TsmPI__ppp_reader; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ppp_reader )
    TsmIPort_IProxyReaderClient* ppp_reader; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ppp_reader )
    TsmPSPort* mPSMessager;
    TsmPCPort* mPCMessager;
    eRV frv;

  public:
    Cla_0022_0024( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0024_0027 = new Fsm_0024_0027( this );
      TsmPI__rp_reader = new TsmIPort_IReaderClient( this );
      TsmPI__ppp_reader = new TsmIPort_IProxyReaderServer( this );
      mPSMessager = new TsmPSPort();
      mPCMessager = new TsmPCPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0024_0027;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "rp_reader" )
      {
        return TsmPI__rp_reader;
      }
      if ( sPortName == "ppp_reader" )
      {
        return TsmPI__ppp_reader;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "rp_reader" )
      {
        rp_reader = static_cast<TsmIPort_IReaderServer*>(oProvidedInterface);
        rp_reader->Source = this;
        return;
      }
      if ( sPortName == "ppp_reader" )
      {
        ppp_reader = static_cast<TsmIPort_IProxyReaderClient*>(oProvidedInterface);
        ppp_reader->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0024_0027->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    bool Guard_1001( int FileHandle );
    eRV Function_1002( int FileHandle );
    void Function_1003( TsmHandler& oHandler );
    eRV Function_1004( int FileHandle );
    void Function_1005( TsmHandler& oHandler );
    bool Guard_1006( tChunk* Chunk );
    eRV Function_1007( tChunk* Chunk );
    void Function_1008( TsmHandler& oHandler );
    eRV Function_1009( tChunk* Chunk );
    void Function_1010( TsmHandler& oHandler );
    void Function_1199( TsmHandler& oHandler );
    void Function_1200( TsmHandler& oHandler );
    void Function_1201( TsmHandler& oHandler );
    void Function_1202( TsmHandler& oHandler );
    void Function_1203( TsmHandler& oHandler );
    void Function_1204( TsmHandler& oHandler );
    void Function_1205( TsmHandler& oHandler );
    void Function_1206( TsmHandler& oHandler );
    eRV Function_1207( int FileHandle );
    void Function_1208( TsmHandler& oHandler );
    eRV Function_1209( int FileHandle );
    void Function_1210( TsmHandler& oHandler );
    void Function_1211( TsmHandler& oHandler );
    void Function_1212( TsmHandler& oHandler );
    void Function_1213( TsmHandler& oHandler );
    void Function_1214( TsmHandler& oHandler );
    void Function_1215( TsmHandler& oHandler );
    void Function_1216( TsmHandler& oHandler );
    void Function_1217( TsmHandler& oHandler );
    void Function_1218( TsmHandler& oHandler );
    void Function_1219( TsmHandler& oHandler );
    void Function_1220( TsmHandler& oHandler );
    void Function_1221( TsmHandler& oHandler );
    eRV Function_1222( tChunk* Chunk );
    void Function_1223( TsmHandler& oHandler );
    void Function_1224( TsmHandler& oHandler );
    void Function_1225( TsmHandler& oHandler );
    void Function_1226( TsmHandler& oHandler );
    void Function_1227( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0022_0024()
    {
      delete TsmPI__rp_reader;
      delete TsmPI__ppp_reader;
      delete mPSMessager;
      delete mPCMessager;
    }
  };

   // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader )
  class Com_0021_0022 : public TsmPComponent
  {
  private:
    Cla_0022_0024* PxReader; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > PxReader )

  public:
    Com_0021_0022( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      PxReader = new Cla_0022_0024( this, "PxReader" );
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = PxReader;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "d_rp_reader" )
      {
        return PxReader->GetProvidedInterface( "rp_reader" );
      }
      if ( sPortName == "d_ppp_reader" )
      {
        return PxReader->GetProvidedInterface( "ppp_reader" );
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Decomposition > ProxyReader )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "d_rp_reader" )
      {
        PxReader->SetRequiredInterface( "rp_reader", oProvidedInterface );
        return;
      }
      if ( sPortName == "d_ppp_reader" )
      {
        PxReader->SetRequiredInterface( "ppp_reader", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Decomposition > ProxyReader )";
      throw TsmException( s );
    }
  };

   // ( Xmi > Data > Repository > Player > Player )
  class Com_0016_0017 : public TsmAComponent
  {
  private:
    Com_0021_0151* PlayerBackend; // ( Xmi > Data > Repository > Player > Player > PlayerBackend )
    Com_0021_0085* PlayerProxyDisplay; // ( Xmi > Data > Repository > Player > Player > PlayerProxyDisplay )
    Com_0021_0022* PlayerProxyReader; // ( Xmi > Data > Repository > Player > Player > PlayerProxyReader )
    TsmIPort_IReaderClient* TsmPI__dd_rp_reader; // ( Xmi > Data > Repository > Player > Player > dd_rp_reader )
    TsmACPort* TsmMr__dd_rp_reader;
    TsmIPort_IPlayerServer* TsmPI__dd_pp_player; // ( Xmi > Data > Repository > Player > Player > dd_pp_player )
    TsmASPort* TsmMr__dd_pp_player;
    TsmIPort_IDisplayClient* TsmPI__dd_rp_display; // ( Xmi > Data > Repository > Player > Player > dd_rp_display )
    TsmACPort* TsmMr__dd_rp_display;

  public:
    Com_0016_0017( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      PlayerBackend = new Com_0021_0151( this, "PlayerBackend" );
      PlayerProxyDisplay = new Com_0021_0085( this, "PlayerProxyDisplay" );
      PlayerProxyReader = new Com_0021_0022( this, "PlayerProxyReader" );
      mNrComponents = 3;
      mComponents = new TsmComponent*[ 3 ];
      mComponents[ 0 ] = PlayerBackend;
      mComponents[ 1 ] = PlayerProxyDisplay;
      mComponents[ 2 ] = PlayerProxyReader;
      TsmPI__dd_rp_reader = new TsmIPort_IReaderClient( this );
      TsmMr__dd_rp_reader = new TsmACPort();
      TsmPI__dd_pp_player = new TsmIPort_IPlayerServer( this );
      TsmMr__dd_pp_player = new TsmASPort();
      TsmPI__dd_rp_display = new TsmIPort_IDisplayClient( this );
      TsmMr__dd_rp_display = new TsmACPort();
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "dd_rp_reader" )
      {
        return TsmPI__dd_rp_reader;
      }
      if ( sPortName == "dd_pp_player" )
      {
        return TsmPI__dd_pp_player;
      }
      if ( sPortName == "dd_rp_display" )
      {
        return TsmPI__dd_rp_display;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Player )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "dd_rp_reader" )
      {
        PlayerProxyReader->SetRequiredInterface( "d_rp_reader", oProvidedInterface );
        return;
      }
      if ( sPortName == "dd_pp_player" )
      {
        PlayerBackend->SetRequiredInterface( "d_pp_player", oProvidedInterface );
        return;
      }
      if ( sPortName == "dd_rp_titlebase" )
      {
        PlayerBackend->SetRequiredInterface( "d_rp_titlebase", oProvidedInterface );
        return;
      }
      if ( sPortName == "dd_rp_display" )
      {
        PlayerProxyDisplay->SetRequiredInterface( "d_rp_display", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Player )";
      throw TsmException( s );
    }
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );

    ~Com_0016_0017()
    {
      delete TsmPI__dd_rp_reader;
      delete TsmMr__dd_rp_reader;
      delete TsmPI__dd_pp_player;
      delete TsmMr__dd_pp_player;
      delete TsmPI__dd_rp_display;
      delete TsmMr__dd_rp_display;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository > Player > Decomposition )
   ********************************************************************/

   // ( Xmi > Data > Repository > Player > Decomposition )
  class Pac_0016_0021 : public TsmPackage
  {
  public:
    Pac_0016_0021( TsmBase* oParent )
    {
      TsmName = "Decomposition";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> InitialState )
  class Ini_0534_0535 : public TsmPseudo
  {
  public:
    Ini_0534_0535( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 573, "( ProxyReaderServerPsm >> InitialState ) => ( ProxyReaderServerPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 573: // UP: ( ProxyReaderServerPsm >> InitialState ) => ( ProxyReaderServerPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Idle >> InitialState )
  class Ini_0537_0538 : public TsmPseudo
  {
  public:
    Ini_0537_0538( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 541, "( ProxyReaderServerPsm >> Idle >> InitialState ) => ( ProxyReaderServerPsm >> Idle >> Base )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 541: // UP: ( ProxyReaderServerPsm >> Idle >> InitialState ) => ( ProxyReaderServerPsm >> Idle >> Base )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Idle >> ChoiceState )
  class Cho_0537_0539 : public TsmPseudo
  {
  private:
    int MaxNrChoices;

  public:
    Cho_0537_0539( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      MaxNrChoices = 2;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 543, "( ProxyReaderServerPsm >> Idle >> ChoiceState ) => ( ProxyReaderServerPsm >> Opening ) : 'ProxyNok'" );
      mTransitions[ 1 ] = new TsmTransition( 545, "( ProxyReaderServerPsm >> Idle >> ChoiceState ) => ( ProxyReaderServerPsm >> Idle >> Base ) : 'ProxyOk'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0537_0544( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 543: // UP: ( ProxyReaderServerPsm >> Idle >> ChoiceState ) => ( ProxyReaderServerPsm >> Opening )
        bHigher = true;
        break;
      case 545: // UP: ( ProxyReaderServerPsm >> Idle >> ChoiceState ) => ( ProxyReaderServerPsm >> Idle >> Base )
        bHigher = true;
        break;
      case 544:
        Tra_0537_0544( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Idle >> Base )
  class Lea_0537_0540 : public TsmLeaf
  {
  public:
    Lea_0537_0540( TsmBase* oParent )
    {
      TsmName = "Base";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 544, "( ProxyReaderServerPsm >> Idle >> Base ) => ( ProxyReaderServerPsm >> Idle >> ChoiceState ) : Px_Open" );
      mTransitions[ 1 ] = new TsmTransition( 542, "( ProxyReaderServerPsm >> Idle >> Base ) => ( ProxyReaderServerPsm >> Idle >> Base ) : 'ProxyOk' Px_Close" );
    }

    void Tra_0537_0541( TsmHandler& oHandler );
    void Tra_0537_0545( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___Px_Open( int FileHandle, TsmHandler& oHandler );
    void Tra_0537_0542( TsmHandler& oHandler );
    void Port___Px_Close( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 532:
        switch ( Command )
        {
        case 8:
          return TsmProspect::OK;
        case 9:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 541:
        Tra_0537_0541( oHandler );
        break;
      case 545:
        Tra_0537_0545( oHandler );
        break;
      case 544: // UP: ( ProxyReaderServerPsm >> Idle >> Base ) => ( ProxyReaderServerPsm >> Idle >> ChoiceState )
        bHigher = true;
        break;
      case 542:
        Tra_0537_0542( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Idle >)
  class Reg_0536_0537 : public TsmRegion
  {
  private:
    Ini_0537_0538* oIni_0537_0538; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Idle >> InitialState )
    Cho_0537_0539* oCho_0537_0539; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Idle >> ChoiceState )
    Lea_0537_0540* oLea_0537_0540; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Idle >> Base )

  public:
    Reg_0536_0537( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0537_0538 = new Ini_0537_0538( this );
      oCho_0537_0539 = new Cho_0537_0539( this );
      oLea_0537_0540 = new Lea_0537_0540( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0537_0538;
      mStates[ 1 ] = oCho_0537_0539;
      mStates[ 2 ] = oLea_0537_0540;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0537_0541( TsmHandler& oHandler );
    void Tra_0537_0545( TsmHandler& oHandler );
    void Tra_0537_0544( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 532:
        switch ( Command )
        {
        case 8:
          return TsmProspect::OK;
        case 9:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 541:
        Tra_0537_0541( oHandler );
        break;
      case 543: // Up: ( ProxyReaderServerPsm >> Idle >> ChoiceState ) => ( ProxyReaderServerPsm >> Opening )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 545:
        Tra_0537_0545( oHandler );
        break;
      case 544:
        Tra_0537_0544( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Idle )
  class Com_0534_0536 : public TsmCompound
  {
  private:
    Reg_0536_0537* oReg_0536_0537; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Idle >)

  public:
    Com_0534_0536( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      oReg_0536_0537 = new Reg_0536_0537( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0536_0537;
      mNrTransitions = 0;
    }

    void Tra_0534_0573( TsmHandler& oHandler );
    void Tra_0534_0585( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 573:
        Tra_0534_0573( oHandler );
        break;
      case 543: // UP: ( ProxyReaderServerPsm >> Idle >> ChoiceState ) => ( ProxyReaderServerPsm >> Opening )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 585:
        Tra_0534_0585( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> ChoiceState )
  class Cho_0547_0548 : public TsmPseudo
  {
  private:
    int MaxNrChoices;

  public:
    Cho_0547_0548( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      MaxNrChoices = 2;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 567, "( ProxyReaderServerPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderServerPsm >> Seeking ) : 'ProxyNok'" );
      mTransitions[ 1 ] = new TsmTransition( 568, "( ProxyReaderServerPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderServerPsm >> CompoundState >> Error ) : 'ProxyOk'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0547_0566( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 567: // UP: ( ProxyReaderServerPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderServerPsm >> Seeking )
        bHigher = true;
        break;
      case 568: // UP: ( ProxyReaderServerPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderServerPsm >> CompoundState >> Error )
        bHigher = true;
        break;
      case 566:
        Tra_0547_0566( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Reading >> InitialState )
  class Ini_0550_0551 : public TsmPseudo
  {
  public:
    Ini_0550_0551( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 554, "( ProxyReaderServerPsm >> CompoundState >> Reading >> InitialState ) => ( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 554: // UP: ( ProxyReaderServerPsm >> CompoundState >> Reading >> InitialState ) => ( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough )
  class Lea_0550_0552 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0550_0552( TsmBase* oParent )
    {
      TsmName = "NotEnough";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 556, "( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough )" );
      mTransitions[ 1 ] = new TsmTransition( 555, "( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough ) : 'ProxyOk' Px_Read" );
      mTransitions[ 2 ] = new TsmTransition( 559, "( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough ) : 'ProxyNok' Px_IsFilled" );
    }

    void Tra_0550_0554( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0550_0555( TsmHandler& oHandler );
    void Port___Px_Read( tChunk* Chunk, TsmHandler& oHandler );
    void Tra_0550_0559( TsmHandler& oHandler );
    void Port___Px_IsFilled( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 556:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 532:
        switch ( Command )
        {
        case 12:
          return TsmProspect::OK;
        case 13:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 554:
        Tra_0550_0554( oHandler );
        break;
      case 556: // UP: ( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 555:
        Tra_0550_0555( oHandler );
        break;
      case 559:
        Tra_0550_0559( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Reading >> Enough )
  class Lea_0550_0553 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0550_0553( TsmBase* oParent )
    {
      TsmName = "Enough";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 557, "( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderServerPsm >> CompoundState >> Open )" );
      mTransitions[ 1 ] = new TsmTransition( 558, "( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough ) : 'ProxyOk' Px_IsFilled" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0550_0556( TsmHandler& oHandler );
    void Tra_0550_0558( TsmHandler& oHandler );
    void Port___Px_IsFilled( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 557:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 532:
        switch ( Command )
        {
        case 13:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 556:
        Tra_0550_0556( oHandler );
        break;
      case 557: // UP: ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderServerPsm >> CompoundState >> Open )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 558:
        Tra_0550_0558( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Reading >)
  class Reg_0549_0550 : public TsmRegion
  {
  private:
    Ini_0550_0551* oIni_0550_0551; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Reading >> InitialState )
    Lea_0550_0552* oLea_0550_0552; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough )
    Lea_0550_0553* oLea_0550_0553; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Reading >> Enough )

  public:
    Reg_0549_0550( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0550_0551 = new Ini_0550_0551( this );
      oLea_0550_0552 = new Lea_0550_0552( this );
      oLea_0550_0553 = new Lea_0550_0553( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0550_0551;
      mStates[ 1 ] = oLea_0550_0552;
      mStates[ 2 ] = oLea_0550_0553;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0550_0554( TsmHandler& oHandler );
    void Tra_0550_0556( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 556:
          return TsmProspect::OK;
        case 557:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 532:
        switch ( Command )
        {
        case 12:
          return TsmProspect::OK;
        case 13:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 554:
        Tra_0550_0554( oHandler );
        break;
      case 556:
        Tra_0550_0556( oHandler );
        break;
      case 557: // Up: ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderServerPsm >> CompoundState >> Open )
        mCurrentState = NULL;
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Reading )
  class Com_0547_0549 : public TsmCompound
  {
  private:
    static const int aNatives[1];
    Reg_0549_0550* oReg_0549_0550; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Reading >)

  public:
    Com_0547_0549( TsmBase* oParent )
    {
      TsmName = "Reading";
      TsmParent = oParent;
      oReg_0549_0550 = new Reg_0549_0550( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0549_0550;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 565, "( ProxyReaderServerPsm >> CompoundState >> Reading ) => ( ProxyReaderServerPsm >> CompoundState >> Error )" );
    }

    void Tra_0534_0581( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtMyExit( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 565:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 565: // UP: ( ProxyReaderServerPsm >> CompoundState >> Reading ) => ( ProxyReaderServerPsm >> CompoundState >> Error )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 557: // UP: ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderServerPsm >> CompoundState >> Open )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 581:
        Tra_0534_0581( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Open )
  class Lea_0547_0560 : public TsmLeaf
  {
  public:
    Lea_0547_0560( TsmBase* oParent )
    {
      TsmName = "Open";
      TsmParent = oParent;
      mNrTransitions = 5;
      mTransitions = new TsmTransition*[ 5 ];
      mTransitions[ 0 ] = new TsmTransition( 562, "( ProxyReaderServerPsm >> CompoundState >> Open ) => ( ProxyReaderServerPsm >> CompoundState >> Open ) : 'ProxyOk' Px_Open" );
      mTransitions[ 1 ] = new TsmTransition( 583, "( ProxyReaderServerPsm >> CompoundState >> Open ) => ( ProxyReaderServerPsm >> Closing ) : 'ProxyNok' Px_Close" );
      mTransitions[ 2 ] = new TsmTransition( 563, "( ProxyReaderServerPsm >> CompoundState >> Open ) => ( ProxyReaderServerPsm >> CompoundState >> Open ) : 'ProxyOk' Px_Stop" );
      mTransitions[ 3 ] = new TsmTransition( 564, "( ProxyReaderServerPsm >> CompoundState >> Open ) => ( ProxyReaderServerPsm >> CompoundState >> Open ) : Px_Clear" );
      mTransitions[ 4 ] = new TsmTransition( 566, "( ProxyReaderServerPsm >> CompoundState >> Open ) => ( ProxyReaderServerPsm >> CompoundState >> ChoiceState ) : Px_Read" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0550_0557( TsmHandler& oHandler );
    void Tra_0534_0576( TsmHandler& oHandler );
    void Tra_0534_0579( TsmHandler& oHandler );
    void Tra_0547_0562( TsmHandler& oHandler );
    void Port___Px_Open( int FileHandle, TsmHandler& oHandler );
    void Port___Px_Close( TsmHandler& oHandler );
    void Tra_0547_0563( TsmHandler& oHandler );
    void Port___Px_Stop( TsmHandler& oHandler );
    void Tra_0547_0564( TsmHandler& oHandler );
    void Port___Px_Clear( TsmHandler& oHandler );
    void Port___Px_Read( tChunk* Chunk, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 532:
        switch ( Command )
        {
        case 8:
          return TsmProspect::OK;
        case 9:
          return TsmProspect::OK;
        case 10:
          return TsmProspect::OK;
        case 11:
          return TsmProspect::OK;
        case 12:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 557:
        Tra_0550_0557( oHandler );
        break;
      case 576:
        Tra_0534_0576( oHandler );
        break;
      case 579:
        Tra_0534_0579( oHandler );
        break;
      case 562:
        Tra_0547_0562( oHandler );
        break;
      case 583: // UP: ( ProxyReaderServerPsm >> CompoundState >> Open ) => ( ProxyReaderServerPsm >> Closing )
        bHigher = true;
        break;
      case 563:
        Tra_0547_0563( oHandler );
        break;
      case 564:
        Tra_0547_0564( oHandler );
        break;
      case 566: // UP: ( ProxyReaderServerPsm >> CompoundState >> Open ) => ( ProxyReaderServerPsm >> CompoundState >> ChoiceState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Error )
  class Lea_0547_0561 : public TsmLeaf
  {
  public:
    Lea_0547_0561( TsmBase* oParent )
    {
      TsmName = "Error";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Tra_0547_0568( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0547_0565( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 568:
        Tra_0547_0568( oHandler );
        break;
      case 565:
        Tra_0547_0565( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >)
  class Reg_0546_0547 : public TsmRegion
  {
  private:
    Cho_0547_0548* oCho_0547_0548; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> ChoiceState )
    Com_0547_0549* oCom_0547_0549; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Reading )
    Lea_0547_0560* oLea_0547_0560; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Open )
    Lea_0547_0561* oLea_0547_0561; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Error )

  public:
    Reg_0546_0547( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oCho_0547_0548 = new Cho_0547_0548( this );
      oCom_0547_0549 = new Com_0547_0549( this );
      oLea_0547_0560 = new Lea_0547_0560( this );
      oLea_0547_0561 = new Lea_0547_0561( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oCho_0547_0548;
      mStates[ 1 ] = oCom_0547_0549;
      mStates[ 2 ] = oLea_0547_0560;
      mStates[ 3 ] = oLea_0547_0561;
    }

    void Tra_0547_0568( TsmHandler& oHandler );
    void Tra_0547_0565( TsmHandler& oHandler );
    void Tra_0550_0557( TsmHandler& oHandler );
    void Tra_0534_0576( TsmHandler& oHandler );
    void Tra_0534_0579( TsmHandler& oHandler );
    void Tra_0534_0581( TsmHandler& oHandler );
    void Tra_0547_0566( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 565:
          return TsmProspect::OK;
        case 556:
          return TsmProspect::OK;
        case 557:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 532:
        switch ( Command )
        {
        case 8:
          return TsmProspect::OK;
        case 9:
          return TsmProspect::OK;
        case 10:
          return TsmProspect::OK;
        case 11:
          return TsmProspect::OK;
        case 12:
          return TsmProspect::OK;
        case 13:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 567: // Up: ( ProxyReaderServerPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderServerPsm >> Seeking )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 568:
        Tra_0547_0568( oHandler );
        break;
      case 565:
        Tra_0547_0565( oHandler );
        break;
      case 557:
        Tra_0550_0557( oHandler );
        break;
      case 576:
        Tra_0534_0576( oHandler );
        break;
      case 579:
        Tra_0534_0579( oHandler );
        break;
      case 581:
        Tra_0534_0581( oHandler );
        break;
      case 583: // Up: ( ProxyReaderServerPsm >> CompoundState >> Open ) => ( ProxyReaderServerPsm >> Closing )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 566:
        Tra_0547_0566( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState )
  class Com_0534_0546 : public TsmCompound
  {
  private:
    Reg_0546_0547* oReg_0546_0547; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >)

  public:
    Com_0534_0546( TsmBase* oParent )
    {
      TsmName = "CS_546";
      TsmParent = oParent;
      oReg_0546_0547 = new Reg_0546_0547( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0546_0547;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 577, "( ProxyReaderServerPsm >> CompoundState ) => ( ProxyReaderServerPsm >> Stopping ) : 'ProxyNok' Px_Stop" );
    }

    void Tra_0534_0576( TsmHandler& oHandler );
    void Tra_0534_0579( TsmHandler& oHandler );
    void Tra_0534_0581( TsmHandler& oHandler );
    void Port___Px_Stop( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 532:
        switch ( Command )
        {
        case 10:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 567: // UP: ( ProxyReaderServerPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderServerPsm >> Seeking )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 576:
        Tra_0534_0576( oHandler );
        break;
      case 579:
        Tra_0534_0579( oHandler );
        break;
      case 581:
        Tra_0534_0581( oHandler );
        break;
      case 583: // UP: ( ProxyReaderServerPsm >> CompoundState >> Open ) => ( ProxyReaderServerPsm >> Closing )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 577: // UP: ( ProxyReaderServerPsm >> CompoundState ) => ( ProxyReaderServerPsm >> Stopping )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Opening )
  class Lea_0534_0569 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0534_0569( TsmBase* oParent )
    {
      TsmName = "Opening";
      TsmParent = oParent;
      mNrTransitions = 4;
      mTransitions = new TsmTransition*[ 4 ];
      mTransitions[ 0 ] = new TsmTransition( 576, "( ProxyReaderServerPsm >> Opening ) => ( ProxyReaderServerPsm >> CompoundState >> Open )" );
      mTransitions[ 1 ] = new TsmTransition( 574, "( ProxyReaderServerPsm >> Opening ) => ( ProxyReaderServerPsm >> Opening ) : 'ProxyNok' Px_Open" );
      mTransitions[ 2 ] = new TsmTransition( 575, "( ProxyReaderServerPsm >> Opening ) => ( ProxyReaderServerPsm >> Opening ) : 'ProxyNok' Px_Close" );
      mTransitions[ 3 ] = new TsmTransition( 586, "( ProxyReaderServerPsm >> Opening ) => ( ProxyReaderServerPsm >> Opening ) : 'ProxyNok' Px_Stop" );
    }

    void Tra_0537_0543( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0534_0574( TsmHandler& oHandler );
    void Port___Px_Open( int FileHandle, TsmHandler& oHandler );
    void Tra_0534_0575( TsmHandler& oHandler );
    void Port___Px_Close( TsmHandler& oHandler );
    void Tra_0534_0586( TsmHandler& oHandler );
    void Port___Px_Stop( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 576:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 532:
        switch ( Command )
        {
        case 8:
          return TsmProspect::OK;
        case 9:
          return TsmProspect::OK;
        case 10:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 543:
        Tra_0537_0543( oHandler );
        break;
      case 576: // UP: ( ProxyReaderServerPsm >> Opening ) => ( ProxyReaderServerPsm >> CompoundState >> Open )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 574:
        Tra_0534_0574( oHandler );
        break;
      case 575:
        Tra_0534_0575( oHandler );
        break;
      case 586:
        Tra_0534_0586( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Stopping )
  class Lea_0534_0570 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0534_0570( TsmBase* oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 579, "( ProxyReaderServerPsm >> Stopping ) => ( ProxyReaderServerPsm >> CompoundState >> Open )" );
      mTransitions[ 1 ] = new TsmTransition( 578, "( ProxyReaderServerPsm >> Stopping ) => ( ProxyReaderServerPsm >> Stopping ) : 'ProxyNok' Px_Stop" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0534_0577( TsmHandler& oHandler );
    void Tra_0534_0578( TsmHandler& oHandler );
    void Port___Px_Stop( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 579:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 532:
        switch ( Command )
        {
        case 10:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 579: // UP: ( ProxyReaderServerPsm >> Stopping ) => ( ProxyReaderServerPsm >> CompoundState >> Open )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 577:
        Tra_0534_0577( oHandler );
        break;
      case 578:
        Tra_0534_0578( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Closing )
  class Lea_0534_0571 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0534_0571( TsmBase* oParent )
    {
      TsmName = "Closing";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 585, "( ProxyReaderServerPsm >> Closing ) => ( ProxyReaderServerPsm >> Idle )" );
      mTransitions[ 1 ] = new TsmTransition( 584, "( ProxyReaderServerPsm >> Closing ) => ( ProxyReaderServerPsm >> Closing ) : 'ProxyNok' Px_Close" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0534_0583( TsmHandler& oHandler );
    void Tra_0534_0584( TsmHandler& oHandler );
    void Port___Px_Close( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 585:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 532:
        switch ( Command )
        {
        case 9:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 585: // UP: ( ProxyReaderServerPsm >> Closing ) => ( ProxyReaderServerPsm >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 583:
        Tra_0534_0583( oHandler );
        break;
      case 584:
        Tra_0534_0584( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Seeking )
  class Lea_0534_0572 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0534_0572( TsmBase* oParent )
    {
      TsmName = "Seeking";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 581, "( ProxyReaderServerPsm >> Seeking ) => ( ProxyReaderServerPsm >> CompoundState >> Reading )" );
      mTransitions[ 1 ] = new TsmTransition( 580, "( ProxyReaderServerPsm >> Seeking ) => ( ProxyReaderServerPsm >> Seeking ) : 'ProxyNok' Px_Stop" );
      mTransitions[ 2 ] = new TsmTransition( 582, "( ProxyReaderServerPsm >> Seeking ) => ( ProxyReaderServerPsm >> Seeking ) : 'ProxyNok' Px_Read" );
    }

    void Tra_0547_0567( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0534_0580( TsmHandler& oHandler );
    void Port___Px_Stop( TsmHandler& oHandler );
    void Tra_0534_0582( TsmHandler& oHandler );
    void Port___Px_Read( tChunk* Chunk, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 581:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 532:
        switch ( Command )
        {
        case 10:
          return TsmProspect::OK;
        case 12:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 567:
        Tra_0547_0567( oHandler );
        break;
      case 581: // UP: ( ProxyReaderServerPsm >> Seeking ) => ( ProxyReaderServerPsm >> CompoundState >> Reading )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 580:
        Tra_0534_0580( oHandler );
        break;
      case 582:
        Tra_0534_0582( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >)
  class Reg_0533_0534 : public TsmRegion
  {
  private:
    Ini_0534_0535* oIni_0534_0535; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> InitialState )
    Com_0534_0536* oCom_0534_0536; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Idle )
    Com_0534_0546* oCom_0534_0546; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState )
    Lea_0534_0569* oLea_0534_0569; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Opening )
    Lea_0534_0570* oLea_0534_0570; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Stopping )
    Lea_0534_0571* oLea_0534_0571; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Closing )
    Lea_0534_0572* oLea_0534_0572; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Seeking )

  public:
    Reg_0533_0534( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0534_0535 = new Ini_0534_0535( this );
      oCom_0534_0536 = new Com_0534_0536( this );
      oCom_0534_0546 = new Com_0534_0546( this );
      oLea_0534_0569 = new Lea_0534_0569( this );
      oLea_0534_0570 = new Lea_0534_0570( this );
      oLea_0534_0571 = new Lea_0534_0571( this );
      oLea_0534_0572 = new Lea_0534_0572( this );
      mNrStates = 7;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0534_0535;
      mStates[ 1 ] = oCom_0534_0536;
      mStates[ 2 ] = oCom_0534_0546;
      mStates[ 3 ] = oLea_0534_0569;
      mStates[ 4 ] = oLea_0534_0570;
      mStates[ 5 ] = oLea_0534_0571;
      mStates[ 6 ] = oLea_0534_0572;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0534_0573( TsmHandler& oHandler );
    void Tra_0537_0543( TsmHandler& oHandler );
    void Tra_0547_0567( TsmHandler& oHandler );
    void Tra_0534_0576( TsmHandler& oHandler );
    void Tra_0534_0579( TsmHandler& oHandler );
    void Tra_0534_0585( TsmHandler& oHandler );
    void Tra_0534_0581( TsmHandler& oHandler );
    void Tra_0534_0583( TsmHandler& oHandler );
    void Tra_0534_0577( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 565:
          return TsmProspect::OK;
        case 556:
          return TsmProspect::OK;
        case 557:
          return TsmProspect::OK;
        case 576:
          return TsmProspect::OK;
        case 579:
          return TsmProspect::OK;
        case 585:
          return TsmProspect::OK;
        case 581:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 532:
        switch ( Command )
        {
        case 8:
          return TsmProspect::OK;
        case 9:
          return TsmProspect::OK;
        case 10:
          return TsmProspect::OK;
        case 11:
          return TsmProspect::OK;
        case 12:
          return TsmProspect::OK;
        case 13:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 573:
        Tra_0534_0573( oHandler );
        break;
      case 543:
        Tra_0537_0543( oHandler );
        break;
      case 567:
        Tra_0547_0567( oHandler );
        break;
      case 576:
        Tra_0534_0576( oHandler );
        break;
      case 579:
        Tra_0534_0579( oHandler );
        break;
      case 585:
        Tra_0534_0585( oHandler );
        break;
      case 581:
        Tra_0534_0581( oHandler );
        break;
      case 583:
        Tra_0534_0583( oHandler );
        break;
      case 577:
        Tra_0534_0577( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm )
  class Fsm_0531_0533 : public TsmFsm
  {
  private:
    Reg_0533_0534* oReg_0533_0534; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >)

  public:
    Fsm_0531_0533( TsmBase* oParent )
    {
      TsmName = "ProxyReaderServerPsm";
      TsmParent = oParent;
      oReg_0533_0534 = new Reg_0533_0534( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0533_0534;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer )
  class Cla_0530_0531 : public TsmProxy
  {
  private:
    Fsm_0531_0533* oFsm_0531_0533; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm )
    TsmIPort_IProxyReaderServer* TsmPI__Port; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > Port )
    TsmIPort_IProxyReaderClient* Port; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > Port )
    TsmPSPort* mPSMessager;
    int BadSector;

  public:
    Cla_0530_0531( TsmBase* oParent, string sInstanceName ) : BadSector(0)
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0531_0533 = new Fsm_0531_0533( this );
      TsmPI__Port = new TsmIPort_IProxyReaderServer( this );
      mPSMessager = new TsmPSPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0531_0533;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "Port" )
      {
        return TsmPI__Port;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "Port" )
      {
        Port = static_cast<TsmIPort_IProxyReaderClient*>(oProvidedInterface);
        Port->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0531_0533->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    eRV Function_1051( int FileHandle );
    void Function_1052( TsmHandler& oHandler );
    eRV Function_1053( int FileHandle );
    void Function_1054( TsmHandler& oHandler );
    eRV Function_1055( tChunk* Chunk );
    void Function_1056( TsmHandler& oHandler );
    eRV Function_1057( tChunk* Chunk );
    void Function_1058( TsmHandler& oHandler );
    void Function_1104( TsmHandler& oHandler );
    void Function_1105( TsmHandler& oHandler );
    void Function_1106( TsmHandler& oHandler );
    void Function_1107( TsmHandler& oHandler );
    void Function_1108( TsmHandler& oHandler );
    void Function_1109( TsmHandler& oHandler );
    void Function_1110( TsmHandler& oHandler );
    eRV Function_1281( int FileHandle );
    void Function_1282( TsmHandler& oHandler );
    eRV Function_1283( int FileHandle );
    void Function_1284( TsmHandler& oHandler );
    void Function_1285( TsmHandler& oHandler );
    void Function_1286( TsmHandler& oHandler );
    void Function_1287( TsmHandler& oHandler );
    void Function_1288( TsmHandler& oHandler );
    void Function_1289( TsmHandler& oHandler );
    void Function_1290( TsmHandler& oHandler );
    void Function_1291( TsmHandler& oHandler );
    void Function_1292( TsmHandler& oHandler );
    void Function_1293( TsmHandler& oHandler );
    eRV Function_1294( tChunk* Chunk );
    void Function_1295( TsmHandler& oHandler );
    eRV Function_1296( tChunk* Chunk );
    void Function_1297( TsmHandler& oHandler );
    void Function_1298( TsmHandler& oHandler );
    void Function_1299( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0530_0531()
    {
      delete TsmPI__Port;
      delete mPSMessager;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> InitialState )
  class Ini_0590_0591 : public TsmPseudo
  {
  public:
    Ini_0590_0591( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 640, "( ProxyReaderClientPsm >> InitialState ) => ( ProxyReaderClientPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 640: // UP: ( ProxyReaderClientPsm >> InitialState ) => ( ProxyReaderClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
  class Cho_0590_0592 : public TsmPseudo
  {
  public:
    Cho_0590_0592( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 641, "( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Idle ) : 'IsProxyOk'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0590_0661( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 641: // UP: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Idle )
        bHigher = true;
        break;
      case 661:
        Tra_0590_0661( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
  class Cho_0590_0593 : public TsmPseudo
  {
  public:
    Cho_0590_0593( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 643, "( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Idle ) : 'IsProxyOk'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0590_0642( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 643: // UP: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Idle )
        bHigher = true;
        break;
      case 642:
        Tra_0590_0642( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
  class Cho_0590_0594 : public TsmPseudo
  {
  public:
    Cho_0590_0594( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 644, "( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Closing ) : 'IsProxyNok'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0602_0628( TsmHandler& oHandler );
    void Tra_0590_0645( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 644: // UP: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Closing )
        bHigher = true;
        break;
      case 628:
        Tra_0602_0628( oHandler );
        break;
      case 645:
        Tra_0590_0645( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
  class Cho_0590_0595 : public TsmPseudo
  {
  public:
    Cho_0590_0595( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 647, "( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Opening ) : 'IsProxyNok'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0590_0663( TsmHandler& oHandler );
    void Tra_0590_0646( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 647: // UP: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Opening )
        bHigher = true;
        break;
      case 663:
        Tra_0590_0663( oHandler );
        break;
      case 646:
        Tra_0590_0646( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
  class Cho_0590_0596 : public TsmPseudo
  {
  public:
    Cho_0590_0596( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 634, "( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Open ) : 'IsProxyOk'" );
      mTransitions[ 1 ] = new TsmTransition( 649, "( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Stopping ) : 'IsProxyNok'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0590_0648( TsmHandler& oHandler );
    void Tra_0590_0650( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 634: // UP: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
        bHigher = true;
        break;
      case 649: // UP: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Stopping )
        bHigher = true;
        break;
      case 648:
        Tra_0590_0648( oHandler );
        break;
      case 650:
        Tra_0590_0650( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
  class Cho_0590_0597 : public TsmPseudo
  {
  public:
    Cho_0590_0597( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 652, "( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Opening ) : 'IsProxyNok'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0590_0651( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 652: // UP: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Opening )
        bHigher = true;
        break;
      case 651:
        Tra_0590_0651( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
  class Cho_0590_0598 : public TsmPseudo
  {
  public:
    Cho_0590_0598( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 654, "( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Seeking ) : 'IsProxyNok'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0602_0632( TsmHandler& oHandler );
    void Tra_0590_0660( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 654: // UP: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Seeking )
        bHigher = true;
        break;
      case 632:
        Tra_0602_0632( oHandler );
        break;
      case 660:
        Tra_0590_0660( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
  class Cho_0590_0599 : public TsmPseudo
  {
  public:
    Cho_0590_0599( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 656, "( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Seeking ) : 'IsProxyNok'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0590_0655( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 656: // UP: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Seeking )
        bHigher = true;
        break;
      case 655:
        Tra_0590_0655( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
  class Cho_0590_0600 : public TsmPseudo
  {
  public:
    Cho_0590_0600( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 663, "( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> ChoiceState )" );
      mTransitions[ 1 ] = new TsmTransition( 661, "( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> ChoiceState )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0590_0662( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 663: // UP: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> ChoiceState )
        bHigher = true;
        break;
      case 661: // UP: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> ChoiceState )
        bHigher = true;
        break;
      case 662:
        Tra_0590_0662( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> ChoiceState )
  class Cho_0602_0603 : public TsmPseudo
  {
  public:
    Cho_0602_0603( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 626, "( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Open ) : 'IsProxyOk'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0602_0627( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 626: // UP: ( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
        bHigher = true;
        break;
      case 627:
        Tra_0602_0627( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> ChoiceState )
  class Cho_0602_0604 : public TsmPseudo
  {
  public:
    Cho_0602_0604( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 632, "( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> ChoiceState )" );
      mTransitions[ 1 ] = new TsmTransition( 631, "( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0602_0630( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 632: // UP: ( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> ChoiceState )
        bHigher = true;
        break;
      case 631: // UP: ( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )
        bHigher = true;
        break;
      case 630:
        Tra_0602_0630( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> ChoiceState )
  class Cho_0602_0605 : public TsmPseudo
  {
  public:
    Cho_0602_0605( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 633, "( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Error ) : 'IsProxyOk'" );
    }

    void Tra_0602_0631( TsmHandler& oHandler );
    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 631:
        Tra_0602_0631( oHandler );
        break;
      case 633: // UP: ( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Error )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >> InitialState )
  class Ini_0607_0608 : public TsmPseudo
  {
  public:
    Ini_0607_0608( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 614, "( ProxyReaderClientPsm >> CompoundState >> Reading >> InitialState ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 614: // UP: ( ProxyReaderClientPsm >> CompoundState >> Reading >> InitialState ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
  class Cho_0607_0609 : public TsmPseudo
  {
  public:
    Cho_0607_0609( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 619, "( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) : 'IsProxyOk'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0607_0618( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 619: // UP: ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough )
        bHigher = true;
        break;
      case 618:
        Tra_0607_0618( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
  class Cho_0607_0610 : public TsmPseudo
  {
  public:
    Cho_0607_0610( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 621, "( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough ) : 'IsProxyOk'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0607_0620( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 621: // UP: ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough )
        bHigher = true;
        break;
      case 620:
        Tra_0607_0620( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
  class Cho_0607_0611 : public TsmPseudo
  {
  public:
    Cho_0607_0611( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 623, "( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) : 'IsProxyNok'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0607_0622( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 623: // UP: ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough )
        bHigher = true;
        break;
      case 622:
        Tra_0607_0622( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough )
  class Lea_0607_0612 : public TsmLeaf
  {
  private:
    static const int aNatives[2];

  public:
    Lea_0607_0612( TsmBase* oParent )
    {
      TsmName = "NotEnough";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 618, "( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )" );
      mTransitions[ 1 ] = new TsmTransition( 622, "( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )" );
      mTransitions[ 2 ] = new TsmTransition( 615, "( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough ) : Px_CbFilled" );
    }

    void Tra_0607_0614( TsmHandler& oHandler );
    void Tra_0607_0619( TsmHandler& oHandler );
    void Tra_0607_0623( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___Px_CbFilled( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 618:
          return TsmProspect::OK;
        case 622:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 588:
        switch ( Command )
        {
        case 36:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 614:
        Tra_0607_0614( oHandler );
        break;
      case 619:
        Tra_0607_0619( oHandler );
        break;
      case 623:
        Tra_0607_0623( oHandler );
        break;
      case 618: // UP: ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 622: // UP: ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 615: // UP: ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >> Enough )
  class Lea_0607_0613 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0607_0613( TsmBase* oParent )
    {
      TsmName = "Enough";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 620, "( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )" );
      mTransitions[ 1 ] = new TsmTransition( 617, "( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderClientPsm >> CompoundState >> Open ) : Px_CbDone" );
    }

    void Tra_0607_0621( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___Px_CbDone( TsmHandler& oHandler );
    void Tra_0607_0615( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 620:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 588:
        switch ( Command )
        {
        case 32:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 621:
        Tra_0607_0621( oHandler );
        break;
      case 620: // UP: ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 617: // UP: ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 615:
        Tra_0607_0615( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >)
  class Reg_0606_0607 : public TsmRegion
  {
  private:
    Ini_0607_0608* oIni_0607_0608; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >> InitialState )
    Cho_0607_0609* oCho_0607_0609; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
    Cho_0607_0610* oCho_0607_0610; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
    Cho_0607_0611* oCho_0607_0611; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
    Lea_0607_0612* oLea_0607_0612; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough )
    Lea_0607_0613* oLea_0607_0613; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >> Enough )

  public:
    Reg_0606_0607( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0607_0608 = new Ini_0607_0608( this );
      oCho_0607_0609 = new Cho_0607_0609( this );
      oCho_0607_0610 = new Cho_0607_0610( this );
      oCho_0607_0611 = new Cho_0607_0611( this );
      oLea_0607_0612 = new Lea_0607_0612( this );
      oLea_0607_0613 = new Lea_0607_0613( this );
      mNrStates = 6;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0607_0608;
      mStates[ 1 ] = oCho_0607_0609;
      mStates[ 2 ] = oCho_0607_0610;
      mStates[ 3 ] = oCho_0607_0611;
      mStates[ 4 ] = oLea_0607_0612;
      mStates[ 5 ] = oLea_0607_0613;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0607_0614( TsmHandler& oHandler );
    void Tra_0607_0619( TsmHandler& oHandler );
    void Tra_0607_0621( TsmHandler& oHandler );
    void Tra_0607_0623( TsmHandler& oHandler );
    void Tra_0607_0618( TsmHandler& oHandler );
    void Tra_0607_0622( TsmHandler& oHandler );
    void Tra_0607_0620( TsmHandler& oHandler );
    void Tra_0607_0615( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 618:
          return TsmProspect::OK;
        case 622:
          return TsmProspect::OK;
        case 620:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 588:
        switch ( Command )
        {
        case 32:
          return TsmProspect::OK;
        case 36:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 614:
        Tra_0607_0614( oHandler );
        break;
      case 619:
        Tra_0607_0619( oHandler );
        break;
      case 621:
        Tra_0607_0621( oHandler );
        break;
      case 623:
        Tra_0607_0623( oHandler );
        break;
      case 618:
        Tra_0607_0618( oHandler );
        break;
      case 622:
        Tra_0607_0622( oHandler );
        break;
      case 620:
        Tra_0607_0620( oHandler );
        break;
      case 617: // Up: ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 615:
        Tra_0607_0615( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading )
  class Com_0602_0606 : public TsmCompound
  {
  private:
    Reg_0606_0607* oReg_0606_0607; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >)

  public:
    Com_0602_0606( TsmBase* oParent )
    {
      TsmName = "Reading";
      TsmParent = oParent;
      oReg_0606_0607 = new Reg_0606_0607( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0606_0607;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 616, "( ProxyReaderClientPsm >> CompoundState >> Reading ) => ( ProxyReaderClientPsm >> CompoundState >> Error ) : Px_CbError" );
    }

    void Port___Px_CbError( int BadSector, TsmHandler& oHandler );
    void Tra_0590_0653( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 588:
        switch ( Command )
        {
        case 33:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 617: // UP: ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 616: // UP: ( ProxyReaderClientPsm >> CompoundState >> Reading ) => ( ProxyReaderClientPsm >> CompoundState >> Error )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 653:
        Tra_0590_0653( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Open )
  class Lea_0602_0624 : public TsmLeaf
  {
  private:
    static const int aNatives[4];

  public:
    Lea_0602_0624( TsmBase* oParent )
    {
      TsmName = "Open";
      TsmParent = oParent;
      mNrTransitions = 4;
      mTransitions = new TsmTransition*[ 4 ];
      mTransitions[ 0 ] = new TsmTransition( 627, "( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )" );
      mTransitions[ 1 ] = new TsmTransition( 628, "( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> ChoiceState )" );
      mTransitions[ 2 ] = new TsmTransition( 629, "( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> CompoundState >> Open )" );
      mTransitions[ 3 ] = new TsmTransition( 630, "( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )" );
    }

    void Tra_0602_0634( TsmHandler& oHandler );
    void Tra_0602_0626( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0602_0629( TsmHandler& oHandler );
    void Tra_0590_0658( TsmHandler& oHandler );
    void Tra_0590_0657( TsmHandler& oHandler );
    void Tra_0607_0617( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 627:
          return TsmProspect::OK;
        case 628:
          return TsmProspect::OK;
        case 629:
          return TsmProspect::OK;
        case 630:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 634:
        Tra_0602_0634( oHandler );
        break;
      case 626:
        Tra_0602_0626( oHandler );
        break;
      case 627: // UP: ( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 628: // UP: ( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 629:
        Tra_0602_0629( oHandler );
        break;
      case 630: // UP: ( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 658:
        Tra_0590_0658( oHandler );
        break;
      case 657:
        Tra_0590_0657( oHandler );
        break;
      case 617:
        Tra_0607_0617( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Error )
  class Lea_0602_0625 : public TsmLeaf
  {
  public:
    Lea_0602_0625( TsmBase* oParent )
    {
      TsmName = "Error";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Tra_0602_0633( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0607_0616( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 633:
        Tra_0602_0633( oHandler );
        break;
      case 616:
        Tra_0607_0616( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >)
  class Reg_0601_0602 : public TsmRegion
  {
  private:
    Cho_0602_0603* oCho_0602_0603; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> ChoiceState )
    Cho_0602_0604* oCho_0602_0604; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> ChoiceState )
    Cho_0602_0605* oCho_0602_0605; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> ChoiceState )
    Com_0602_0606* oCom_0602_0606; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading )
    Lea_0602_0624* oLea_0602_0624; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Open )
    Lea_0602_0625* oLea_0602_0625; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Error )

  public:
    Reg_0601_0602( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oCho_0602_0603 = new Cho_0602_0603( this );
      oCho_0602_0604 = new Cho_0602_0604( this );
      oCho_0602_0605 = new Cho_0602_0605( this );
      oCom_0602_0606 = new Com_0602_0606( this );
      oLea_0602_0624 = new Lea_0602_0624( this );
      oLea_0602_0625 = new Lea_0602_0625( this );
      mNrStates = 6;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oCho_0602_0603;
      mStates[ 1 ] = oCho_0602_0604;
      mStates[ 2 ] = oCho_0602_0605;
      mStates[ 3 ] = oCom_0602_0606;
      mStates[ 4 ] = oLea_0602_0624;
      mStates[ 5 ] = oLea_0602_0625;
    }

    void Tra_0602_0634( TsmHandler& oHandler );
    void Tra_0602_0626( TsmHandler& oHandler );
    void Tra_0602_0631( TsmHandler& oHandler );
    void Tra_0602_0633( TsmHandler& oHandler );
    void Tra_0602_0627( TsmHandler& oHandler );
    void Tra_0602_0630( TsmHandler& oHandler );
    void Tra_0590_0658( TsmHandler& oHandler );
    void Tra_0590_0657( TsmHandler& oHandler );
    void Tra_0607_0617( TsmHandler& oHandler );
    void Tra_0607_0616( TsmHandler& oHandler );
    void Tra_0590_0653( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 618:
          return TsmProspect::OK;
        case 622:
          return TsmProspect::OK;
        case 620:
          return TsmProspect::OK;
        case 627:
          return TsmProspect::OK;
        case 628:
          return TsmProspect::OK;
        case 629:
          return TsmProspect::OK;
        case 630:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 588:
        switch ( Command )
        {
        case 32:
          return TsmProspect::OK;
        case 33:
          return TsmProspect::OK;
        case 36:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 634:
        Tra_0602_0634( oHandler );
        break;
      case 626:
        Tra_0602_0626( oHandler );
        break;
      case 632: // Up: ( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> ChoiceState )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 631:
        Tra_0602_0631( oHandler );
        break;
      case 633:
        Tra_0602_0633( oHandler );
        break;
      case 627:
        Tra_0602_0627( oHandler );
        break;
      case 628: // Up: ( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> ChoiceState )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 630:
        Tra_0602_0630( oHandler );
        break;
      case 658:
        Tra_0590_0658( oHandler );
        break;
      case 657:
        Tra_0590_0657( oHandler );
        break;
      case 617:
        Tra_0607_0617( oHandler );
        break;
      case 616:
        Tra_0607_0616( oHandler );
        break;
      case 653:
        Tra_0590_0653( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState )
  class Com_0590_0601 : public TsmCompound
  {
  private:
    static const int aNatives[1];
    Reg_0601_0602* oReg_0601_0602; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >)

  public:
    Com_0590_0601( TsmBase* oParent )
    {
      TsmName = "CS_601";
      TsmParent = oParent;
      oReg_0601_0602 = new Reg_0601_0602( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0601_0602;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 648, "( ProxyReaderClientPsm >> CompoundState ) => ( ProxyReaderClientPsm >> ChoiceState )" );
    }

    void Tra_0602_0634( TsmHandler& oHandler );
    void Tra_0590_0658( TsmHandler& oHandler );
    void Tra_0590_0657( TsmHandler& oHandler );
    void Tra_0590_0653( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtMyExit( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 648:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 634:
        Tra_0602_0634( oHandler );
        break;
      case 632: // UP: ( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 648: // UP: ( ProxyReaderClientPsm >> CompoundState ) => ( ProxyReaderClientPsm >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 628: // UP: ( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 658:
        Tra_0590_0658( oHandler );
        break;
      case 657:
        Tra_0590_0657( oHandler );
        break;
      case 653:
        Tra_0590_0653( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> Idle )
  class Lea_0590_0635 : public TsmLeaf
  {
  private:
    static const int aNatives[2];

  public:
    Lea_0590_0635( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 642, "( ProxyReaderClientPsm >> Idle ) => ( ProxyReaderClientPsm >> ChoiceState )" );
      mTransitions[ 1 ] = new TsmTransition( 662, "( ProxyReaderClientPsm >> Idle ) => ( ProxyReaderClientPsm >> ChoiceState )" );
    }

    void Tra_0590_0640( TsmHandler& oHandler );
    void Tra_0590_0641( TsmHandler& oHandler );
    void Tra_0590_0643( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0590_0659( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 642:
          return TsmProspect::OK;
        case 662:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 640:
        Tra_0590_0640( oHandler );
        break;
      case 641:
        Tra_0590_0641( oHandler );
        break;
      case 643:
        Tra_0590_0643( oHandler );
        break;
      case 642: // UP: ( ProxyReaderClientPsm >> Idle ) => ( ProxyReaderClientPsm >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 662: // UP: ( ProxyReaderClientPsm >> Idle ) => ( ProxyReaderClientPsm >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 659:
        Tra_0590_0659( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> Opening )
  class Lea_0590_0636 : public TsmLeaf
  {
  private:
    static const int aNatives[2];

  public:
    Lea_0590_0636( TsmBase* oParent )
    {
      TsmName = "Opening";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 646, "( ProxyReaderClientPsm >> Opening ) => ( ProxyReaderClientPsm >> ChoiceState )" );
      mTransitions[ 1 ] = new TsmTransition( 651, "( ProxyReaderClientPsm >> Opening ) => ( ProxyReaderClientPsm >> ChoiceState )" );
      mTransitions[ 2 ] = new TsmTransition( 658, "( ProxyReaderClientPsm >> Opening ) => ( ProxyReaderClientPsm >> CompoundState >> Open ) : Px_CbOpened" );
    }

    void Tra_0590_0647( TsmHandler& oHandler );
    void Tra_0590_0652( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___Px_CbOpened( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 646:
          return TsmProspect::OK;
        case 651:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 588:
        switch ( Command )
        {
        case 30:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 647:
        Tra_0590_0647( oHandler );
        break;
      case 652:
        Tra_0590_0652( oHandler );
        break;
      case 646: // UP: ( ProxyReaderClientPsm >> Opening ) => ( ProxyReaderClientPsm >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 651: // UP: ( ProxyReaderClientPsm >> Opening ) => ( ProxyReaderClientPsm >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 658: // UP: ( ProxyReaderClientPsm >> Opening ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> Stopping )
  class Lea_0590_0637 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0590_0637( TsmBase* oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 650, "( ProxyReaderClientPsm >> Stopping ) => ( ProxyReaderClientPsm >> ChoiceState )" );
      mTransitions[ 1 ] = new TsmTransition( 657, "( ProxyReaderClientPsm >> Stopping ) => ( ProxyReaderClientPsm >> CompoundState >> Open ) : Px_CbStopped" );
    }

    void Tra_0590_0649( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___Px_CbStopped( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 650:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 588:
        switch ( Command )
        {
        case 31:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 649:
        Tra_0590_0649( oHandler );
        break;
      case 650: // UP: ( ProxyReaderClientPsm >> Stopping ) => ( ProxyReaderClientPsm >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 657: // UP: ( ProxyReaderClientPsm >> Stopping ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> Closing )
  class Lea_0590_0638 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0590_0638( TsmBase* oParent )
    {
      TsmName = "Closing";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 645, "( ProxyReaderClientPsm >> Closing ) => ( ProxyReaderClientPsm >> ChoiceState )" );
      mTransitions[ 1 ] = new TsmTransition( 659, "( ProxyReaderClientPsm >> Closing ) => ( ProxyReaderClientPsm >> Idle ) : Px_CbClosed" );
    }

    void Tra_0590_0644( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___Px_CbClosed( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 645:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 588:
        switch ( Command )
        {
        case 34:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 644:
        Tra_0590_0644( oHandler );
        break;
      case 645: // UP: ( ProxyReaderClientPsm >> Closing ) => ( ProxyReaderClientPsm >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 659: // UP: ( ProxyReaderClientPsm >> Closing ) => ( ProxyReaderClientPsm >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> Seeking )
  class Lea_0590_0639 : public TsmLeaf
  {
  private:
    static const int aNatives[2];

  public:
    Lea_0590_0639( TsmBase* oParent )
    {
      TsmName = "Seeking";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 655, "( ProxyReaderClientPsm >> Seeking ) => ( ProxyReaderClientPsm >> ChoiceState )" );
      mTransitions[ 1 ] = new TsmTransition( 660, "( ProxyReaderClientPsm >> Seeking ) => ( ProxyReaderClientPsm >> ChoiceState )" );
      mTransitions[ 2 ] = new TsmTransition( 653, "( ProxyReaderClientPsm >> Seeking ) => ( ProxyReaderClientPsm >> CompoundState >> Reading ) : Px_CbReading" );
    }

    void Tra_0590_0654( TsmHandler& oHandler );
    void Tra_0590_0656( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___Px_CbReading( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 655:
          return TsmProspect::OK;
        case 660:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 588:
        switch ( Command )
        {
        case 35:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 654:
        Tra_0590_0654( oHandler );
        break;
      case 656:
        Tra_0590_0656( oHandler );
        break;
      case 655: // UP: ( ProxyReaderClientPsm >> Seeking ) => ( ProxyReaderClientPsm >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 660: // UP: ( ProxyReaderClientPsm >> Seeking ) => ( ProxyReaderClientPsm >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 653: // UP: ( ProxyReaderClientPsm >> Seeking ) => ( ProxyReaderClientPsm >> CompoundState >> Reading )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >)
  class Reg_0589_0590 : public TsmRegion
  {
  private:
    Ini_0590_0591* oIni_0590_0591; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> InitialState )
    Cho_0590_0592* oCho_0590_0592; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
    Cho_0590_0593* oCho_0590_0593; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
    Cho_0590_0594* oCho_0590_0594; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
    Cho_0590_0595* oCho_0590_0595; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
    Cho_0590_0596* oCho_0590_0596; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
    Cho_0590_0597* oCho_0590_0597; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
    Cho_0590_0598* oCho_0590_0598; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
    Cho_0590_0599* oCho_0590_0599; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
    Cho_0590_0600* oCho_0590_0600; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
    Com_0590_0601* oCom_0590_0601; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState )
    Lea_0590_0635* oLea_0590_0635; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> Idle )
    Lea_0590_0636* oLea_0590_0636; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> Opening )
    Lea_0590_0637* oLea_0590_0637; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> Stopping )
    Lea_0590_0638* oLea_0590_0638; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> Closing )
    Lea_0590_0639* oLea_0590_0639; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> Seeking )

  public:
    Reg_0589_0590( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0590_0591 = new Ini_0590_0591( this );
      oCho_0590_0592 = new Cho_0590_0592( this );
      oCho_0590_0593 = new Cho_0590_0593( this );
      oCho_0590_0594 = new Cho_0590_0594( this );
      oCho_0590_0595 = new Cho_0590_0595( this );
      oCho_0590_0596 = new Cho_0590_0596( this );
      oCho_0590_0597 = new Cho_0590_0597( this );
      oCho_0590_0598 = new Cho_0590_0598( this );
      oCho_0590_0599 = new Cho_0590_0599( this );
      oCho_0590_0600 = new Cho_0590_0600( this );
      oCom_0590_0601 = new Com_0590_0601( this );
      oLea_0590_0635 = new Lea_0590_0635( this );
      oLea_0590_0636 = new Lea_0590_0636( this );
      oLea_0590_0637 = new Lea_0590_0637( this );
      oLea_0590_0638 = new Lea_0590_0638( this );
      oLea_0590_0639 = new Lea_0590_0639( this );
      mNrStates = 16;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0590_0591;
      mStates[ 1 ] = oCho_0590_0592;
      mStates[ 2 ] = oCho_0590_0593;
      mStates[ 3 ] = oCho_0590_0594;
      mStates[ 4 ] = oCho_0590_0595;
      mStates[ 5 ] = oCho_0590_0596;
      mStates[ 6 ] = oCho_0590_0597;
      mStates[ 7 ] = oCho_0590_0598;
      mStates[ 8 ] = oCho_0590_0599;
      mStates[ 9 ] = oCho_0590_0600;
      mStates[ 10 ] = oCom_0590_0601;
      mStates[ 11 ] = oLea_0590_0635;
      mStates[ 12 ] = oLea_0590_0636;
      mStates[ 13 ] = oLea_0590_0637;
      mStates[ 14 ] = oLea_0590_0638;
      mStates[ 15 ] = oLea_0590_0639;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0590_0640( TsmHandler& oHandler );
    void Tra_0590_0641( TsmHandler& oHandler );
    void Tra_0590_0643( TsmHandler& oHandler );
    void Tra_0590_0644( TsmHandler& oHandler );
    void Tra_0590_0647( TsmHandler& oHandler );
    void Tra_0602_0634( TsmHandler& oHandler );
    void Tra_0590_0649( TsmHandler& oHandler );
    void Tra_0590_0652( TsmHandler& oHandler );
    void Tra_0590_0654( TsmHandler& oHandler );
    void Tra_0590_0656( TsmHandler& oHandler );
    void Tra_0590_0663( TsmHandler& oHandler );
    void Tra_0590_0661( TsmHandler& oHandler );
    void Tra_0602_0632( TsmHandler& oHandler );
    void Tra_0590_0648( TsmHandler& oHandler );
    void Tra_0602_0628( TsmHandler& oHandler );
    void Tra_0590_0642( TsmHandler& oHandler );
    void Tra_0590_0662( TsmHandler& oHandler );
    void Tra_0590_0646( TsmHandler& oHandler );
    void Tra_0590_0651( TsmHandler& oHandler );
    void Tra_0590_0650( TsmHandler& oHandler );
    void Tra_0590_0645( TsmHandler& oHandler );
    void Tra_0590_0655( TsmHandler& oHandler );
    void Tra_0590_0660( TsmHandler& oHandler );
    void Tra_0590_0658( TsmHandler& oHandler );
    void Tra_0590_0657( TsmHandler& oHandler );
    void Tra_0590_0659( TsmHandler& oHandler );
    void Tra_0590_0653( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 648:
          return TsmProspect::OK;
        case 618:
          return TsmProspect::OK;
        case 622:
          return TsmProspect::OK;
        case 620:
          return TsmProspect::OK;
        case 627:
          return TsmProspect::OK;
        case 628:
          return TsmProspect::OK;
        case 629:
          return TsmProspect::OK;
        case 630:
          return TsmProspect::OK;
        case 642:
          return TsmProspect::OK;
        case 662:
          return TsmProspect::OK;
        case 646:
          return TsmProspect::OK;
        case 651:
          return TsmProspect::OK;
        case 650:
          return TsmProspect::OK;
        case 645:
          return TsmProspect::OK;
        case 655:
          return TsmProspect::OK;
        case 660:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 588:
        switch ( Command )
        {
        case 30:
          return TsmProspect::OK;
        case 31:
          return TsmProspect::OK;
        case 32:
          return TsmProspect::OK;
        case 33:
          return TsmProspect::OK;
        case 34:
          return TsmProspect::OK;
        case 35:
          return TsmProspect::OK;
        case 36:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 640:
        Tra_0590_0640( oHandler );
        break;
      case 641:
        Tra_0590_0641( oHandler );
        break;
      case 643:
        Tra_0590_0643( oHandler );
        break;
      case 644:
        Tra_0590_0644( oHandler );
        break;
      case 647:
        Tra_0590_0647( oHandler );
        break;
      case 634:
        Tra_0602_0634( oHandler );
        break;
      case 649:
        Tra_0590_0649( oHandler );
        break;
      case 652:
        Tra_0590_0652( oHandler );
        break;
      case 654:
        Tra_0590_0654( oHandler );
        break;
      case 656:
        Tra_0590_0656( oHandler );
        break;
      case 663:
        Tra_0590_0663( oHandler );
        break;
      case 661:
        Tra_0590_0661( oHandler );
        break;
      case 632:
        Tra_0602_0632( oHandler );
        break;
      case 648:
        Tra_0590_0648( oHandler );
        break;
      case 628:
        Tra_0602_0628( oHandler );
        break;
      case 642:
        Tra_0590_0642( oHandler );
        break;
      case 662:
        Tra_0590_0662( oHandler );
        break;
      case 646:
        Tra_0590_0646( oHandler );
        break;
      case 651:
        Tra_0590_0651( oHandler );
        break;
      case 650:
        Tra_0590_0650( oHandler );
        break;
      case 645:
        Tra_0590_0645( oHandler );
        break;
      case 655:
        Tra_0590_0655( oHandler );
        break;
      case 660:
        Tra_0590_0660( oHandler );
        break;
      case 658:
        Tra_0590_0658( oHandler );
        break;
      case 657:
        Tra_0590_0657( oHandler );
        break;
      case 659:
        Tra_0590_0659( oHandler );
        break;
      case 653:
        Tra_0590_0653( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm )
  class Fsm_0587_0589 : public TsmFsm
  {
  private:
    Reg_0589_0590* oReg_0589_0590; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >)

  public:
    Fsm_0587_0589( TsmBase* oParent )
    {
      TsmName = "ProxyReaderClientPsm";
      TsmParent = oParent;
      oReg_0589_0590 = new Reg_0589_0590( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0589_0590;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient )
  class Cla_0530_0587 : public TsmProxyUser
  {
  private:
    Fsm_0587_0589* oFsm_0587_0589; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm )
    TsmIPort_IProxyReaderServer* Port; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > Port )
    TsmIPort_IProxyReaderClient* TsmPI__Port; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > Port )
    TsmPCPort* mPCMessager;
    eRV RV;
    int FileHandle;
    tChunk Chunk;

  public:
    Cla_0530_0587( TsmBase* oParent, string sInstanceName ) : RV(OK), FileHandle(0)
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0587_0589 = new Fsm_0587_0589( this );
      TsmPI__Port = new TsmIPort_IProxyReaderClient( this );
      mPCMessager = new TsmPCPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0587_0589;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "Port" )
      {
        return TsmPI__Port;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "Port" )
      {
        Port = static_cast<TsmIPort_IProxyReaderServer*>(oProvidedInterface);
        Port->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0587_0589->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    bool Guard_1059();
    bool Guard_1060();
    void Function_1111( TsmHandler& oHandler );
    void Function_1112( TsmHandler& oHandler );
    void Function_1113( TsmHandler& oHandler );
    void Function_1114( TsmHandler& oHandler );
    void Function_1115( TsmHandler& oHandler );
    void Function_1116( TsmHandler& oHandler );
    void Function_1117( TsmHandler& oHandler );
    void Function_1118( TsmHandler& oHandler );
    void Function_1119( TsmHandler& oHandler );
    void Function_1120( TsmHandler& oHandler );
    void Function_1121( TsmHandler& oHandler );
    void Function_1122( TsmHandler& oHandler );
    void Function_1123( TsmHandler& oHandler );
    void Function_1124( TsmHandler& oHandler );
    void Function_1125( TsmHandler& oHandler );
    void Function_1126( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0530_0587()
    {
      delete TsmPI__Port;
      delete mPCMessager;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol )
   ********************************************************************/

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol )
  class Pac_0529_0530 : public TsmPackage
  {
  public:
    Pac_0529_0530( TsmBase* oParent )
    {
      TsmName = "ProxyReaderProtocol";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> InitialState )
  class Ini_0668_0669 : public TsmPseudo
  {
  public:
    Ini_0668_0669( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 717, "( ProxyDisplayServerPsm >> InitialState ) => ( ProxyDisplayServerPsm >> CompoundState )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 717: // UP: ( ProxyDisplayServerPsm >> InitialState ) => ( ProxyDisplayServerPsm >> CompoundState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> InitialState )
  class Ini_0671_0672 : public TsmPseudo
  {
  public:
    Ini_0671_0672( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 697, "( ProxyDisplayServerPsm >> CompoundState >> InitialState ) => ( ProxyDisplayServerPsm >> CompoundState >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 697: // UP: ( ProxyDisplayServerPsm >> CompoundState >> InitialState ) => ( ProxyDisplayServerPsm >> CompoundState >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> JuncState )
  class Jun_0671_0673 : public TsmPseudo
  {
  public:
    Jun_0671_0673( TsmBase* oParent )
    {
      TsmName = "JuncState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 715, "( ProxyDisplayServerPsm >> CompoundState >> JuncState ) => ( ProxyDisplayServerPsm >> CompoundState >> Synclost )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0671_0713( TsmHandler& oHandler );
    void Tra_0671_0712( TsmHandler& oHandler );
    void Tra_0671_0714( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 715: // UP: ( ProxyDisplayServerPsm >> CompoundState >> JuncState ) => ( ProxyDisplayServerPsm >> CompoundState >> Synclost )
        bHigher = true;
        break;
      case 713:
        Tra_0671_0713( oHandler );
        break;
      case 712:
        Tra_0671_0712( oHandler );
        break;
      case 714:
        Tra_0671_0714( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState )
  class Cho_0675_0676 : public TsmPseudo
  {
  private:
    int MaxNrChoices;

  public:
    Cho_0675_0676( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      MaxNrChoices = 2;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 688, "( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing ) : 'ProxyNok'" );
      mTransitions[ 1 ] = new TsmTransition( 687, "( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play ) : 'ProxyOk'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0675_0686( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 688: // UP: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing )
        bHigher = true;
        break;
      case 687: // UP: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
        bHigher = true;
        break;
      case 686:
        Tra_0675_0686( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
  class Lea_0675_0677 : public TsmLeaf
  {
  public:
    Lea_0675_0677( TsmBase* oParent )
    {
      TsmName = "Play";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 684, "( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play ) : 'ProxyOk' Px_Continue" );
      mTransitions[ 1 ] = new TsmTransition( 686, "( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState ) : Px_Pause" );
      mTransitions[ 2 ] = new TsmTransition( 680, "( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play ) : 'ProxyOk' Px_Start" );
    }

    void Tra_0675_0687( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0675_0683( TsmHandler& oHandler );
    void Tra_0671_0709( TsmHandler& oHandler );
    void Tra_0675_0684( TsmHandler& oHandler );
    void Port___Px_Continue( TsmHandler& oHandler );
    void Port___Px_Pause( TsmHandler& oHandler );
    void Tra_0675_0680( TsmHandler& oHandler );
    void Port___Px_Start( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 666:
        switch ( Command )
        {
        case 14:
          return TsmProspect::OK;
        case 15:
          return TsmProspect::OK;
        case 17:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 687:
        Tra_0675_0687( oHandler );
        break;
      case 683:
        Tra_0675_0683( oHandler );
        break;
      case 709:
        Tra_0671_0709( oHandler );
        break;
      case 684:
        Tra_0675_0684( oHandler );
        break;
      case 686: // UP: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState )
        bHigher = true;
        break;
      case 680:
        Tra_0675_0680( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing )
  class Lea_0675_0678 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0675_0678( TsmBase* oParent )
    {
      TsmName = "Pausing";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 681, "( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayServerPsm >> CompoundState >> Paused )" );
      mTransitions[ 1 ] = new TsmTransition( 682, "( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing ) : 'ProxyNok' Px_Pause" );
    }

    void Tra_0675_0688( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0675_0682( TsmHandler& oHandler );
    void Port___Px_Pause( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 681:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 666:
        switch ( Command )
        {
        case 15:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 688:
        Tra_0675_0688( oHandler );
        break;
      case 681: // UP: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayServerPsm >> CompoundState >> Paused )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 682:
        Tra_0675_0682( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing )
  class Lea_0675_0679 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0675_0679( TsmBase* oParent )
    {
      TsmName = "Continuing";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 683, "( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )" );
      mTransitions[ 1 ] = new TsmTransition( 685, "( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing ) : 'ProxyNok' Px_Continue" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0675_0685( TsmHandler& oHandler );
    void Port___Px_Continue( TsmHandler& oHandler );
    void Tra_0671_0710( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 683:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 666:
        switch ( Command )
        {
        case 14:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 683: // UP: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 685:
        Tra_0675_0685( oHandler );
        break;
      case 710:
        Tra_0671_0710( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> CompoundState >)
  class Reg_0674_0675 : public TsmRegion
  {
  private:
    Cho_0675_0676* oCho_0675_0676; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState )
    Lea_0675_0677* oLea_0675_0677; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
    Lea_0675_0678* oLea_0675_0678; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing )
    Lea_0675_0679* oLea_0675_0679; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing )

  public:
    Reg_0674_0675( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oCho_0675_0676 = new Cho_0675_0676( this );
      oLea_0675_0677 = new Lea_0675_0677( this );
      oLea_0675_0678 = new Lea_0675_0678( this );
      oLea_0675_0679 = new Lea_0675_0679( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oCho_0675_0676;
      mStates[ 1 ] = oLea_0675_0677;
      mStates[ 2 ] = oLea_0675_0678;
      mStates[ 3 ] = oLea_0675_0679;
    }

    void Tra_0675_0688( TsmHandler& oHandler );
    void Tra_0675_0687( TsmHandler& oHandler );
    void Tra_0675_0683( TsmHandler& oHandler );
    void Tra_0671_0709( TsmHandler& oHandler );
    void Tra_0671_0710( TsmHandler& oHandler );
    void Tra_0675_0686( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 681:
          return TsmProspect::OK;
        case 683:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 666:
        switch ( Command )
        {
        case 14:
          return TsmProspect::OK;
        case 15:
          return TsmProspect::OK;
        case 17:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 688:
        Tra_0675_0688( oHandler );
        break;
      case 687:
        Tra_0675_0687( oHandler );
        break;
      case 681: // Up: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayServerPsm >> CompoundState >> Paused )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 683:
        Tra_0675_0683( oHandler );
        break;
      case 709:
        Tra_0671_0709( oHandler );
        break;
      case 710:
        Tra_0671_0710( oHandler );
        break;
      case 686:
        Tra_0675_0686( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> CompoundState )
  class Com_0671_0674 : public TsmCompound
  {
  private:
    static const int aNatives[2];
    Reg_0674_0675* oReg_0674_0675; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> CompoundState >)

  public:
    Com_0671_0674( TsmBase* oParent )
    {
      TsmName = "CS_674";
      TsmParent = oParent;
      oReg_0674_0675 = new Reg_0674_0675( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0674_0675;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 711, "( ProxyDisplayServerPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayServerPsm >> CompoundState >> Finishing )" );
      mTransitions[ 1 ] = new TsmTransition( 713, "( ProxyDisplayServerPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayServerPsm >> CompoundState >> JuncState )" );
    }

    void Tra_0671_0709( TsmHandler& oHandler );
    void Tra_0671_0710( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtMyExit( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 711:
          return TsmProspect::OK;
        case 713:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 711: // UP: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayServerPsm >> CompoundState >> Finishing )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 713: // UP: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayServerPsm >> CompoundState >> JuncState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 681: // UP: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayServerPsm >> CompoundState >> Paused )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 709:
        Tra_0671_0709( oHandler );
        break;
      case 710:
        Tra_0671_0710( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Ready )
  class Lea_0671_0689 : public TsmLeaf
  {
  public:
    Lea_0671_0689( TsmBase* oParent )
    {
      TsmName = "Ready";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 703, "( ProxyDisplayServerPsm >> CompoundState >> Ready ) => ( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) : 'ProxyNok' Px_Pause" );
      mTransitions[ 1 ] = new TsmTransition( 704, "( ProxyDisplayServerPsm >> CompoundState >> Ready ) => ( ProxyDisplayServerPsm >> CompoundState >> Ready ) : 'ProxyOk' Px_Prepare" );
      mTransitions[ 2 ] = new TsmTransition( 702, "( ProxyDisplayServerPsm >> CompoundState >> Ready ) => ( ProxyDisplayServerPsm >> CompoundState >> Starting ) : 'ProxyNok' Px_Start" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0671_0700( TsmHandler& oHandler );
    void Port___Px_Pause( TsmHandler& oHandler );
    void Tra_0671_0704( TsmHandler& oHandler );
    void Port___Px_Prepare( TsmHandler& oHandler );
    void Port___Px_Start( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 666:
        switch ( Command )
        {
        case 15:
          return TsmProspect::OK;
        case 16:
          return TsmProspect::OK;
        case 17:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 700:
        Tra_0671_0700( oHandler );
        break;
      case 703: // UP: ( ProxyDisplayServerPsm >> CompoundState >> Ready ) => ( ProxyDisplayServerPsm >> CompoundState >> StartPausing )
        bHigher = true;
        break;
      case 704:
        Tra_0671_0704( oHandler );
        break;
      case 702: // UP: ( ProxyDisplayServerPsm >> CompoundState >> Ready ) => ( ProxyDisplayServerPsm >> CompoundState >> Starting )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Preparing )
  class Lea_0671_0690 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0671_0690( TsmBase* oParent )
    {
      TsmName = "Preparing";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 700, "( ProxyDisplayServerPsm >> CompoundState >> Preparing ) => ( ProxyDisplayServerPsm >> CompoundState >> Ready )" );
      mTransitions[ 1 ] = new TsmTransition( 701, "( ProxyDisplayServerPsm >> CompoundState >> Preparing ) => ( ProxyDisplayServerPsm >> CompoundState >> Preparing ) : 'ProxyNok' Px_Prepare" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0671_0701( TsmHandler& oHandler );
    void Port___Px_Prepare( TsmHandler& oHandler );
    void Tra_0671_0699( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 700:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 666:
        switch ( Command )
        {
        case 16:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 700: // UP: ( ProxyDisplayServerPsm >> CompoundState >> Preparing ) => ( ProxyDisplayServerPsm >> CompoundState >> Ready )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 701:
        Tra_0671_0701( oHandler );
        break;
      case 699:
        Tra_0671_0699( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Idle )
  class Lea_0671_0691 : public TsmLeaf
  {
  public:
    Lea_0671_0691( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 699, "( ProxyDisplayServerPsm >> CompoundState >> Idle ) => ( ProxyDisplayServerPsm >> CompoundState >> Preparing ) : 'ProxyNok' Px_Prepare" );
      mTransitions[ 1 ] = new TsmTransition( 698, "( ProxyDisplayServerPsm >> CompoundState >> Idle ) => ( ProxyDisplayServerPsm >> CompoundState >> Idle ) : 'ProxyOk' Px_Stop" );
    }

    void Tra_0671_0697( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___Px_Prepare( TsmHandler& oHandler );
    void Tra_0671_0698( TsmHandler& oHandler );
    void Port___Px_Stop( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 666:
        switch ( Command )
        {
        case 16:
          return TsmProspect::OK;
        case 18:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 697:
        Tra_0671_0697( oHandler );
        break;
      case 699: // UP: ( ProxyDisplayServerPsm >> CompoundState >> Idle ) => ( ProxyDisplayServerPsm >> CompoundState >> Preparing )
        bHigher = true;
        break;
      case 698:
        Tra_0671_0698( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Starting )
  class Lea_0671_0692 : public TsmLeaf
  {
  private:
    static const int aNatives[2];

  public:
    Lea_0671_0692( TsmBase* oParent )
    {
      TsmName = "Starting";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 709, "( ProxyDisplayServerPsm >> CompoundState >> Starting ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )" );
      mTransitions[ 1 ] = new TsmTransition( 712, "( ProxyDisplayServerPsm >> CompoundState >> Starting ) => ( ProxyDisplayServerPsm >> CompoundState >> JuncState )" );
      mTransitions[ 2 ] = new TsmTransition( 705, "( ProxyDisplayServerPsm >> CompoundState >> Starting ) => ( ProxyDisplayServerPsm >> CompoundState >> Starting ) : 'ProxyNok' Px_Start" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0671_0702( TsmHandler& oHandler );
    void Tra_0671_0705( TsmHandler& oHandler );
    void Port___Px_Start( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 709:
          return TsmProspect::OK;
        case 712:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 666:
        switch ( Command )
        {
        case 17:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 709: // UP: ( ProxyDisplayServerPsm >> CompoundState >> Starting ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 712: // UP: ( ProxyDisplayServerPsm >> CompoundState >> Starting ) => ( ProxyDisplayServerPsm >> CompoundState >> JuncState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 702:
        Tra_0671_0702( oHandler );
        break;
      case 705:
        Tra_0671_0705( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Synclost )
  class Lea_0671_0693 : public TsmLeaf
  {
  public:
    Lea_0671_0693( TsmBase* oParent )
    {
      TsmName = "Synclost";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Tra_0671_0715( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 715:
        Tra_0671_0715( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> StartPausing )
  class Lea_0671_0694 : public TsmLeaf
  {
  private:
    static const int aNatives[2];

  public:
    Lea_0671_0694( TsmBase* oParent )
    {
      TsmName = "StartPausing";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 707, "( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayServerPsm >> CompoundState >> Paused )" );
      mTransitions[ 1 ] = new TsmTransition( 714, "( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayServerPsm >> CompoundState >> JuncState )" );
      mTransitions[ 2 ] = new TsmTransition( 706, "( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) : 'ProxyNok' Px_Pause" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0671_0703( TsmHandler& oHandler );
    void Tra_0671_0706( TsmHandler& oHandler );
    void Port___Px_Pause( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 707:
          return TsmProspect::OK;
        case 714:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 666:
        switch ( Command )
        {
        case 15:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 707: // UP: ( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayServerPsm >> CompoundState >> Paused )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 714: // UP: ( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayServerPsm >> CompoundState >> JuncState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 703:
        Tra_0671_0703( oHandler );
        break;
      case 706:
        Tra_0671_0706( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Paused )
  class Lea_0671_0695 : public TsmLeaf
  {
  public:
    Lea_0671_0695( TsmBase* oParent )
    {
      TsmName = "Paused";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 710, "( ProxyDisplayServerPsm >> CompoundState >> Paused ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing ) : 'ProxyNok' Px_Continue" );
      mTransitions[ 1 ] = new TsmTransition( 708, "( ProxyDisplayServerPsm >> CompoundState >> Paused ) => ( ProxyDisplayServerPsm >> CompoundState >> Paused ) : 'ProxyOk' Px_Pause" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0675_0681( TsmHandler& oHandler );
    void Tra_0671_0707( TsmHandler& oHandler );
    void Port___Px_Continue( TsmHandler& oHandler );
    void Tra_0671_0708( TsmHandler& oHandler );
    void Port___Px_Pause( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 666:
        switch ( Command )
        {
        case 14:
          return TsmProspect::OK;
        case 15:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 681:
        Tra_0675_0681( oHandler );
        break;
      case 707:
        Tra_0671_0707( oHandler );
        break;
      case 710: // UP: ( ProxyDisplayServerPsm >> CompoundState >> Paused ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing )
        bHigher = true;
        break;
      case 708:
        Tra_0671_0708( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Finishing )
  class Lea_0671_0696 : public TsmLeaf
  {
  public:
    Lea_0671_0696( TsmBase* oParent )
    {
      TsmName = "Finishing";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0671_0711( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 711:
        Tra_0671_0711( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >)
  class Reg_0670_0671 : public TsmRegion
  {
  private:
    Ini_0671_0672* oIni_0671_0672; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> InitialState )
    Jun_0671_0673* oJun_0671_0673; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> JuncState )
    Com_0671_0674* oCom_0671_0674; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> CompoundState )
    Lea_0671_0689* oLea_0671_0689; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Ready )
    Lea_0671_0690* oLea_0671_0690; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Preparing )
    Lea_0671_0691* oLea_0671_0691; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Idle )
    Lea_0671_0692* oLea_0671_0692; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Starting )
    Lea_0671_0693* oLea_0671_0693; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Synclost )
    Lea_0671_0694* oLea_0671_0694; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> StartPausing )
    Lea_0671_0695* oLea_0671_0695; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Paused )
    Lea_0671_0696* oLea_0671_0696; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Finishing )

  public:
    Reg_0670_0671( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0671_0672 = new Ini_0671_0672( this );
      oJun_0671_0673 = new Jun_0671_0673( this );
      oCom_0671_0674 = new Com_0671_0674( this );
      oLea_0671_0689 = new Lea_0671_0689( this );
      oLea_0671_0690 = new Lea_0671_0690( this );
      oLea_0671_0691 = new Lea_0671_0691( this );
      oLea_0671_0692 = new Lea_0671_0692( this );
      oLea_0671_0693 = new Lea_0671_0693( this );
      oLea_0671_0694 = new Lea_0671_0694( this );
      oLea_0671_0695 = new Lea_0671_0695( this );
      oLea_0671_0696 = new Lea_0671_0696( this );
      mNrStates = 11;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0671_0672;
      mStates[ 1 ] = oJun_0671_0673;
      mStates[ 2 ] = oCom_0671_0674;
      mStates[ 3 ] = oLea_0671_0689;
      mStates[ 4 ] = oLea_0671_0690;
      mStates[ 5 ] = oLea_0671_0691;
      mStates[ 6 ] = oLea_0671_0692;
      mStates[ 7 ] = oLea_0671_0693;
      mStates[ 8 ] = oLea_0671_0694;
      mStates[ 9 ] = oLea_0671_0695;
      mStates[ 10 ] = oLea_0671_0696;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0671_0697( TsmHandler& oHandler );
    void Tra_0671_0715( TsmHandler& oHandler );
    void Tra_0671_0711( TsmHandler& oHandler );
    void Tra_0671_0713( TsmHandler& oHandler );
    void Tra_0675_0681( TsmHandler& oHandler );
    void Tra_0671_0700( TsmHandler& oHandler );
    void Tra_0671_0709( TsmHandler& oHandler );
    void Tra_0671_0712( TsmHandler& oHandler );
    void Tra_0671_0707( TsmHandler& oHandler );
    void Tra_0671_0714( TsmHandler& oHandler );
    void Tra_0671_0710( TsmHandler& oHandler );
    void Tra_0671_0703( TsmHandler& oHandler );
    void Tra_0671_0699( TsmHandler& oHandler );
    void Tra_0671_0702( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 711:
          return TsmProspect::OK;
        case 713:
          return TsmProspect::OK;
        case 681:
          return TsmProspect::OK;
        case 683:
          return TsmProspect::OK;
        case 700:
          return TsmProspect::OK;
        case 709:
          return TsmProspect::OK;
        case 712:
          return TsmProspect::OK;
        case 707:
          return TsmProspect::OK;
        case 714:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 666:
        switch ( Command )
        {
        case 14:
          return TsmProspect::OK;
        case 15:
          return TsmProspect::OK;
        case 16:
          return TsmProspect::OK;
        case 17:
          return TsmProspect::OK;
        case 18:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 697:
        Tra_0671_0697( oHandler );
        break;
      case 715:
        Tra_0671_0715( oHandler );
        break;
      case 711:
        Tra_0671_0711( oHandler );
        break;
      case 713:
        Tra_0671_0713( oHandler );
        break;
      case 681:
        Tra_0675_0681( oHandler );
        break;
      case 700:
        Tra_0671_0700( oHandler );
        break;
      case 709:
        Tra_0671_0709( oHandler );
        break;
      case 712:
        Tra_0671_0712( oHandler );
        break;
      case 707:
        Tra_0671_0707( oHandler );
        break;
      case 714:
        Tra_0671_0714( oHandler );
        break;
      case 710:
        Tra_0671_0710( oHandler );
        break;
      case 703:
        Tra_0671_0703( oHandler );
        break;
      case 699:
        Tra_0671_0699( oHandler );
        break;
      case 702:
        Tra_0671_0702( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState )
  class Com_0668_0670 : public TsmCompound
  {
  private:
    Reg_0670_0671* oReg_0670_0671; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >)

  public:
    Com_0668_0670( TsmBase* oParent )
    {
      TsmName = "CS_670";
      TsmParent = oParent;
      oReg_0670_0671 = new Reg_0670_0671( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0670_0671;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 718, "( ProxyDisplayServerPsm >> CompoundState ) => ( ProxyDisplayServerPsm >> Stopping ) : 'ProxyNok' Px_Stop" );
    }

    void Tra_0668_0717( TsmHandler& oHandler );
    void Tra_0668_0720( TsmHandler& oHandler );
    void Port___Px_Stop( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 666:
        switch ( Command )
        {
        case 18:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 717:
        Tra_0668_0717( oHandler );
        break;
      case 720:
        Tra_0668_0720( oHandler );
        break;
      case 718: // UP: ( ProxyDisplayServerPsm >> CompoundState ) => ( ProxyDisplayServerPsm >> Stopping )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> Stopping )
  class Lea_0668_0716 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0668_0716( TsmBase* oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 720, "( ProxyDisplayServerPsm >> Stopping ) => ( ProxyDisplayServerPsm >> CompoundState )" );
      mTransitions[ 1 ] = new TsmTransition( 719, "( ProxyDisplayServerPsm >> Stopping ) => ( ProxyDisplayServerPsm >> Stopping ) : 'ProxyNok' Px_Stop" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0668_0718( TsmHandler& oHandler );
    void Tra_0668_0719( TsmHandler& oHandler );
    void Port___Px_Stop( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 720:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 666:
        switch ( Command )
        {
        case 18:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 720: // UP: ( ProxyDisplayServerPsm >> Stopping ) => ( ProxyDisplayServerPsm >> CompoundState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 718:
        Tra_0668_0718( oHandler );
        break;
      case 719:
        Tra_0668_0719( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >)
  class Reg_0667_0668 : public TsmRegion
  {
  private:
    Ini_0668_0669* oIni_0668_0669; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> InitialState )
    Com_0668_0670* oCom_0668_0670; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState )
    Lea_0668_0716* oLea_0668_0716; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> Stopping )

  public:
    Reg_0667_0668( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0668_0669 = new Ini_0668_0669( this );
      oCom_0668_0670 = new Com_0668_0670( this );
      oLea_0668_0716 = new Lea_0668_0716( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0668_0669;
      mStates[ 1 ] = oCom_0668_0670;
      mStates[ 2 ] = oLea_0668_0716;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0668_0717( TsmHandler& oHandler );
    void Tra_0668_0720( TsmHandler& oHandler );
    void Tra_0668_0718( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 711:
          return TsmProspect::OK;
        case 713:
          return TsmProspect::OK;
        case 681:
          return TsmProspect::OK;
        case 683:
          return TsmProspect::OK;
        case 700:
          return TsmProspect::OK;
        case 709:
          return TsmProspect::OK;
        case 712:
          return TsmProspect::OK;
        case 707:
          return TsmProspect::OK;
        case 714:
          return TsmProspect::OK;
        case 720:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 666:
        switch ( Command )
        {
        case 14:
          return TsmProspect::OK;
        case 15:
          return TsmProspect::OK;
        case 16:
          return TsmProspect::OK;
        case 17:
          return TsmProspect::OK;
        case 18:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 717:
        Tra_0668_0717( oHandler );
        break;
      case 720:
        Tra_0668_0720( oHandler );
        break;
      case 718:
        Tra_0668_0718( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm )
  class Fsm_0665_0667 : public TsmFsm
  {
  private:
    Reg_0667_0668* oReg_0667_0668; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >)

  public:
    Fsm_0665_0667( TsmBase* oParent )
    {
      TsmName = "ProxyDisplayServerPsm";
      TsmParent = oParent;
      oReg_0667_0668 = new Reg_0667_0668( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0667_0668;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer )
  class Cla_0664_0665 : public TsmProxy
  {
  private:
    Fsm_0665_0667* oFsm_0665_0667; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm )
    TsmIPort_IProxyDisplayServer* TsmPI__Port; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > Port )
    TsmIPort_IProxyDisplayClient* Port; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > Port )
    TsmPSPort* mPSMessager;
    tTime BadTime;

  public:
    Cla_0664_0665( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0665_0667 = new Fsm_0665_0667( this );
      TsmPI__Port = new TsmIPort_IProxyDisplayServer( this );
      mPSMessager = new TsmPSPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0665_0667;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "Port" )
      {
        return TsmPI__Port;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "Port" )
      {
        Port = static_cast<TsmIPort_IProxyDisplayClient*>(oProvidedInterface);
        Port->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0665_0667->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    eRV Function_1061();
    void Function_1062( TsmHandler& oHandler );
    eRV Function_1063();
    void Function_1064( TsmHandler& oHandler );
    void Function_1127( TsmHandler& oHandler );
    void Function_1128( TsmHandler& oHandler );
    void Function_1129( TsmHandler& oHandler );
    void Function_1130( TsmHandler& oHandler );
    void Function_1131( TsmHandler& oHandler );
    void Function_1132( TsmHandler& oHandler );
    void Function_1133( TsmHandler& oHandler );
    void Function_1134( TsmHandler& oHandler );
    void Function_1135( TsmHandler& oHandler );
    void Function_1136( TsmHandler& oHandler );
    void Function_1300( TsmHandler& oHandler );
    void Function_1301( TsmHandler& oHandler );
    void Function_1302( TsmHandler& oHandler );
    void Function_1303( TsmHandler& oHandler );
    eRV Function_1304();
    void Function_1305( TsmHandler& oHandler );
    eRV Function_1306();
    void Function_1307( TsmHandler& oHandler );
    eRV Function_1308();
    void Function_1309( TsmHandler& oHandler );
    void Function_1310( TsmHandler& oHandler );
    void Function_1311( TsmHandler& oHandler );
    void Function_1312( TsmHandler& oHandler );
    void Function_1313( TsmHandler& oHandler );
    void Function_1314( TsmHandler& oHandler );
    void Function_1315( TsmHandler& oHandler );
    void Function_1316( TsmHandler& oHandler );
    void Function_1317( TsmHandler& oHandler );
    void Function_1318( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0664_0665()
    {
      delete TsmPI__Port;
      delete mPSMessager;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> InitialState )
  class Ini_0724_0725 : public TsmPseudo
  {
  public:
    Ini_0724_0725( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 792, "( ProxyDisplayClientPsm >> InitialState ) => ( ProxyDisplayClientPsm >> CompoundState )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 792: // UP: ( ProxyDisplayClientPsm >> InitialState ) => ( ProxyDisplayClientPsm >> CompoundState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> ChoiceState )
  class Cho_0724_0726 : public TsmPseudo
  {
  public:
    Cho_0724_0726( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 790, "( ProxyDisplayClientPsm >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState ) : 'IsProxyOk'" );
      mTransitions[ 1 ] = new TsmTransition( 794, "( ProxyDisplayClientPsm >> ChoiceState ) => ( ProxyDisplayClientPsm >> Stopping ) : 'IsProxyNok'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0724_0793( TsmHandler& oHandler );
    void Tra_0724_0795( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 790: // UP: ( ProxyDisplayClientPsm >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState )
        bHigher = true;
        break;
      case 794: // UP: ( ProxyDisplayClientPsm >> ChoiceState ) => ( ProxyDisplayClientPsm >> Stopping )
        bHigher = true;
        break;
      case 793:
        Tra_0724_0793( oHandler );
        break;
      case 795:
        Tra_0724_0795( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> InitialState )
  class Ini_0728_0729 : public TsmPseudo
  {
  public:
    Ini_0728_0729( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 768, "( ProxyDisplayClientPsm >> CompoundState >> InitialState ) => ( ProxyDisplayClientPsm >> CompoundState >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 768: // UP: ( ProxyDisplayClientPsm >> CompoundState >> InitialState ) => ( ProxyDisplayClientPsm >> CompoundState >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  class Cho_0728_0730 : public TsmPseudo
  {
  public:
    Cho_0728_0730( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 775, "( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> Preparing ) : 'IsProxyNok'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0728_0789( TsmHandler& oHandler );
    void Tra_0728_0774( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 775: // UP: ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> Preparing )
        bHigher = true;
        break;
      case 789:
        Tra_0728_0789( oHandler );
        break;
      case 774:
        Tra_0728_0774( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  class Cho_0728_0731 : public TsmPseudo
  {
  public:
    Cho_0728_0731( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 777, "( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> Ready ) : 'IsProxyOk'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0728_0776( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 777: // UP: ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> Ready )
        bHigher = true;
        break;
      case 776:
        Tra_0728_0776( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  class Cho_0728_0732 : public TsmPseudo
  {
  public:
    Cho_0728_0732( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 779, "( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> Starting ) : 'IsProxyNok'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0728_0778( TsmHandler& oHandler );
    void Tra_0728_0780( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 779: // UP: ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> Starting )
        bHigher = true;
        break;
      case 778:
        Tra_0728_0778( oHandler );
        break;
      case 780:
        Tra_0728_0780( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  class Cho_0728_0733 : public TsmPseudo
  {
  public:
    Cho_0728_0733( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 782, "( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> StartPausing ) : 'IsProxyNok'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0728_0781( TsmHandler& oHandler );
    void Tra_0728_0783( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 782: // UP: ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> StartPausing )
        bHigher = true;
        break;
      case 781:
        Tra_0728_0781( oHandler );
        break;
      case 783:
        Tra_0728_0783( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  class Cho_0728_0734 : public TsmPseudo
  {
  public:
    Cho_0728_0734( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 786, "( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> Paused ) : 'IsProxyOk'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0728_0787( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 786: // UP: ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> Paused )
        bHigher = true;
        break;
      case 787:
        Tra_0728_0787( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  class Cho_0736_0737 : public TsmPseudo
  {
  public:
    Cho_0736_0737( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 747, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) : 'IsProxyOk'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0736_0746( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 747: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
        bHigher = true;
        break;
      case 746:
        Tra_0736_0746( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  class Cho_0736_0738 : public TsmPseudo
  {
  public:
    Cho_0736_0738( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 757, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) : 'IsProxyNok'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0736_0756( TsmHandler& oHandler );
    void Tra_0736_0748( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 757: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing )
        bHigher = true;
        break;
      case 756:
        Tra_0736_0756( oHandler );
        break;
      case 748:
        Tra_0736_0748( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  class Cho_0736_0739 : public TsmPseudo
  {
  public:
    Cho_0736_0739( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 750, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing ) : 'IsProxyNok'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0736_0751( TsmHandler& oHandler );
    void Tra_0728_0788( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 750: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing )
        bHigher = true;
        break;
      case 751:
        Tra_0736_0751( oHandler );
        break;
      case 788:
        Tra_0728_0788( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  class Cho_0736_0740 : public TsmPseudo
  {
  public:
    Cho_0736_0740( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 754, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) : 'IsProxyOk'" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0736_0753( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 754: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
        bHigher = true;
        break;
      case 753:
        Tra_0736_0753( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  class Cho_0736_0741 : public TsmPseudo
  {
  public:
    Cho_0736_0741( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 756, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )" );
      mTransitions[ 1 ] = new TsmTransition( 758, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0736_0755( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 756: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
        bHigher = true;
        break;
      case 758: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
        bHigher = true;
        break;
      case 755:
        Tra_0736_0755( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  class Cho_0736_0742 : public TsmPseudo
  {
  public:
    Cho_0736_0742( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 759, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) : 'IsProxyOk'" );
    }

    void Tra_0736_0758( TsmHandler& oHandler );
    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 758:
        Tra_0736_0758( oHandler );
        break;
      case 759: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
  class Lea_0736_0743 : public TsmLeaf
  {
  private:
    static const int aNatives[3];

  public:
    Lea_0736_0743( TsmBase* oParent )
    {
      TsmName = "Play";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 746, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )" );
      mTransitions[ 1 ] = new TsmTransition( 753, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )" );
      mTransitions[ 2 ] = new TsmTransition( 755, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )" );
    }

    void Tra_0736_0747( TsmHandler& oHandler );
    void Tra_0736_0754( TsmHandler& oHandler );
    void Tra_0736_0759( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0736_0752( TsmHandler& oHandler );
    void Tra_0728_0773( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 746:
          return TsmProspect::OK;
        case 753:
          return TsmProspect::OK;
        case 755:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 747:
        Tra_0736_0747( oHandler );
        break;
      case 754:
        Tra_0736_0754( oHandler );
        break;
      case 759:
        Tra_0736_0759( oHandler );
        break;
      case 746: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 753: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 755: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 752:
        Tra_0736_0752( oHandler );
        break;
      case 773:
        Tra_0728_0773( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing )
  class Lea_0736_0744 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0736_0744( TsmBase* oParent )
    {
      TsmName = "Pausing";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 748, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )" );
      mTransitions[ 1 ] = new TsmTransition( 749, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayClientPsm >> CompoundState >> Paused ) : Px_CbPaused" );
    }

    void Tra_0736_0757( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___Px_CbPaused( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 748:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 722:
        switch ( Command )
        {
        case 39:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 757:
        Tra_0736_0757( oHandler );
        break;
      case 748: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 749: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayClientPsm >> CompoundState >> Paused )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing )
  class Lea_0736_0745 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0736_0745( TsmBase* oParent )
    {
      TsmName = "Continuing";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 751, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )" );
      mTransitions[ 1 ] = new TsmTransition( 752, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) : Px_CbContinued" );
    }

    void Tra_0736_0750( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___Px_CbContinued( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 751:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 722:
        switch ( Command )
        {
        case 37:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 750:
        Tra_0736_0750( oHandler );
        break;
      case 751: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 752: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >)
  class Reg_0735_0736 : public TsmRegion
  {
  private:
    Cho_0736_0737* oCho_0736_0737; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
    Cho_0736_0738* oCho_0736_0738; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
    Cho_0736_0739* oCho_0736_0739; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
    Cho_0736_0740* oCho_0736_0740; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
    Cho_0736_0741* oCho_0736_0741; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
    Cho_0736_0742* oCho_0736_0742; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
    Lea_0736_0743* oLea_0736_0743; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
    Lea_0736_0744* oLea_0736_0744; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing )
    Lea_0736_0745* oLea_0736_0745; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing )

  public:
    Reg_0735_0736( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oCho_0736_0737 = new Cho_0736_0737( this );
      oCho_0736_0738 = new Cho_0736_0738( this );
      oCho_0736_0739 = new Cho_0736_0739( this );
      oCho_0736_0740 = new Cho_0736_0740( this );
      oCho_0736_0741 = new Cho_0736_0741( this );
      oCho_0736_0742 = new Cho_0736_0742( this );
      oLea_0736_0743 = new Lea_0736_0743( this );
      oLea_0736_0744 = new Lea_0736_0744( this );
      oLea_0736_0745 = new Lea_0736_0745( this );
      mNrStates = 9;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oCho_0736_0737;
      mStates[ 1 ] = oCho_0736_0738;
      mStates[ 2 ] = oCho_0736_0739;
      mStates[ 3 ] = oCho_0736_0740;
      mStates[ 4 ] = oCho_0736_0741;
      mStates[ 5 ] = oCho_0736_0742;
      mStates[ 6 ] = oLea_0736_0743;
      mStates[ 7 ] = oLea_0736_0744;
      mStates[ 8 ] = oLea_0736_0745;
    }

    void Tra_0736_0747( TsmHandler& oHandler );
    void Tra_0736_0757( TsmHandler& oHandler );
    void Tra_0736_0750( TsmHandler& oHandler );
    void Tra_0736_0754( TsmHandler& oHandler );
    void Tra_0736_0756( TsmHandler& oHandler );
    void Tra_0736_0758( TsmHandler& oHandler );
    void Tra_0736_0759( TsmHandler& oHandler );
    void Tra_0736_0746( TsmHandler& oHandler );
    void Tra_0736_0753( TsmHandler& oHandler );
    void Tra_0736_0755( TsmHandler& oHandler );
    void Tra_0736_0748( TsmHandler& oHandler );
    void Tra_0736_0751( TsmHandler& oHandler );
    void Tra_0728_0788( TsmHandler& oHandler );
    void Tra_0736_0752( TsmHandler& oHandler );
    void Tra_0728_0773( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 746:
          return TsmProspect::OK;
        case 753:
          return TsmProspect::OK;
        case 755:
          return TsmProspect::OK;
        case 748:
          return TsmProspect::OK;
        case 751:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 722:
        switch ( Command )
        {
        case 37:
          return TsmProspect::OK;
        case 39:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 747:
        Tra_0736_0747( oHandler );
        break;
      case 757:
        Tra_0736_0757( oHandler );
        break;
      case 750:
        Tra_0736_0750( oHandler );
        break;
      case 754:
        Tra_0736_0754( oHandler );
        break;
      case 756:
        Tra_0736_0756( oHandler );
        break;
      case 758:
        Tra_0736_0758( oHandler );
        break;
      case 759:
        Tra_0736_0759( oHandler );
        break;
      case 746:
        Tra_0736_0746( oHandler );
        break;
      case 753:
        Tra_0736_0753( oHandler );
        break;
      case 755:
        Tra_0736_0755( oHandler );
        break;
      case 748:
        Tra_0736_0748( oHandler );
        break;
      case 751:
        Tra_0736_0751( oHandler );
        break;
      case 788:
        Tra_0728_0788( oHandler );
        break;
      case 752:
        Tra_0736_0752( oHandler );
        break;
      case 749: // Up: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayClientPsm >> CompoundState >> Paused )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 773:
        Tra_0728_0773( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState )
  class Com_0728_0735 : public TsmCompound
  {
  private:
    Reg_0735_0736* oReg_0735_0736; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >)

  public:
    Com_0728_0735( TsmBase* oParent )
    {
      TsmName = "CS_735";
      TsmParent = oParent;
      oReg_0735_0736 = new Reg_0735_0736( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0735_0736;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 784, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayClientPsm >> CompoundState >> Finishing ) : Px_CbFinished" );
      mTransitions[ 1 ] = new TsmTransition( 772, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayClientPsm >> CompoundState >> Synclost ) : Px_CbSynclost" );
    }

    void Tra_0728_0788( TsmHandler& oHandler );
    void Port___Px_CbFinished( TsmHandler& oHandler );
    void Tra_0728_0773( TsmHandler& oHandler );
    void Port___Px_CbSynclost( tTime BadTime, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 722:
        switch ( Command )
        {
        case 38:
          return TsmProspect::OK;
        case 43:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 788:
        Tra_0728_0788( oHandler );
        break;
      case 784: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayClientPsm >> CompoundState >> Finishing )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 749: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayClientPsm >> CompoundState >> Paused )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 773:
        Tra_0728_0773( oHandler );
        break;
      case 772: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayClientPsm >> CompoundState >> Synclost )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Ready )
  class Lea_0728_0760 : public TsmLeaf
  {
  private:
    static const int aNatives[3];

  public:
    Lea_0728_0760( TsmBase* oParent )
    {
      TsmName = "Ready";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 776, "( ProxyDisplayClientPsm >> CompoundState >> Ready ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )" );
      mTransitions[ 1 ] = new TsmTransition( 778, "( ProxyDisplayClientPsm >> CompoundState >> Ready ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )" );
      mTransitions[ 2 ] = new TsmTransition( 781, "( ProxyDisplayClientPsm >> CompoundState >> Ready ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )" );
    }

    void Tra_0728_0777( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0728_0769( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 776:
          return TsmProspect::OK;
        case 778:
          return TsmProspect::OK;
        case 781:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 777:
        Tra_0728_0777( oHandler );
        break;
      case 776: // UP: ( ProxyDisplayClientPsm >> CompoundState >> Ready ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 778: // UP: ( ProxyDisplayClientPsm >> CompoundState >> Ready ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 781: // UP: ( ProxyDisplayClientPsm >> CompoundState >> Ready ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 769:
        Tra_0728_0769( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Preparing )
  class Lea_0728_0761 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0728_0761( TsmBase* oParent )
    {
      TsmName = "Preparing";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 789, "( ProxyDisplayClientPsm >> CompoundState >> Preparing ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )" );
      mTransitions[ 1 ] = new TsmTransition( 769, "( ProxyDisplayClientPsm >> CompoundState >> Preparing ) => ( ProxyDisplayClientPsm >> CompoundState >> Ready ) : Px_CbPrepared" );
    }

    void Tra_0728_0775( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___Px_CbPrepared( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 789:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 722:
        switch ( Command )
        {
        case 40:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 775:
        Tra_0728_0775( oHandler );
        break;
      case 789: // UP: ( ProxyDisplayClientPsm >> CompoundState >> Preparing ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 769: // UP: ( ProxyDisplayClientPsm >> CompoundState >> Preparing ) => ( ProxyDisplayClientPsm >> CompoundState >> Ready )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Idle )
  class Lea_0728_0762 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0728_0762( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 774, "( ProxyDisplayClientPsm >> CompoundState >> Idle ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )" );
    }

    void Tra_0728_0768( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 774:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 768:
        Tra_0728_0768( oHandler );
        break;
      case 774: // UP: ( ProxyDisplayClientPsm >> CompoundState >> Idle ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Starting )
  class Lea_0728_0763 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0728_0763( TsmBase* oParent )
    {
      TsmName = "Starting";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 780, "( ProxyDisplayClientPsm >> CompoundState >> Starting ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )" );
      mTransitions[ 1 ] = new TsmTransition( 773, "( ProxyDisplayClientPsm >> CompoundState >> Starting ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) : Px_CbStarted" );
      mTransitions[ 2 ] = new TsmTransition( 770, "( ProxyDisplayClientPsm >> CompoundState >> Starting ) => ( ProxyDisplayClientPsm >> CompoundState >> Synclost ) : Px_CbSynclost" );
    }

    void Tra_0728_0779( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___Px_CbStarted( TsmHandler& oHandler );
    void Port___Px_CbSynclost( tTime BadTime, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 780:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 722:
        switch ( Command )
        {
        case 41:
          return TsmProspect::OK;
        case 43:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 779:
        Tra_0728_0779( oHandler );
        break;
      case 780: // UP: ( ProxyDisplayClientPsm >> CompoundState >> Starting ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 773: // UP: ( ProxyDisplayClientPsm >> CompoundState >> Starting ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 770: // UP: ( ProxyDisplayClientPsm >> CompoundState >> Starting ) => ( ProxyDisplayClientPsm >> CompoundState >> Synclost )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Synclost )
  class Lea_0728_0764 : public TsmLeaf
  {
  public:
    Lea_0728_0764( TsmBase* oParent )
    {
      TsmName = "Synclost";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0728_0772( TsmHandler& oHandler );
    void Tra_0728_0770( TsmHandler& oHandler );
    void Tra_0728_0771( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 772:
        Tra_0728_0772( oHandler );
        break;
      case 770:
        Tra_0728_0770( oHandler );
        break;
      case 771:
        Tra_0728_0771( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> StartPausing )
  class Lea_0728_0765 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0728_0765( TsmBase* oParent )
    {
      TsmName = "StartPausing";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 783, "( ProxyDisplayClientPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )" );
      mTransitions[ 1 ] = new TsmTransition( 785, "( ProxyDisplayClientPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayClientPsm >> CompoundState >> Paused ) : Px_CbPaused" );
      mTransitions[ 2 ] = new TsmTransition( 771, "( ProxyDisplayClientPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayClientPsm >> CompoundState >> Synclost ) : Px_CbSynclost" );
    }

    void Tra_0728_0782( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___Px_CbPaused( TsmHandler& oHandler );
    void Port___Px_CbSynclost( tTime BadTime, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 783:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 722:
        switch ( Command )
        {
        case 39:
          return TsmProspect::OK;
        case 43:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 782:
        Tra_0728_0782( oHandler );
        break;
      case 783: // UP: ( ProxyDisplayClientPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 785: // UP: ( ProxyDisplayClientPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayClientPsm >> CompoundState >> Paused )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 771: // UP: ( ProxyDisplayClientPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayClientPsm >> CompoundState >> Synclost )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Paused )
  class Lea_0728_0766 : public TsmLeaf
  {
  private:
    static const int aNatives[2];

  public:
    Lea_0728_0766( TsmBase* oParent )
    {
      TsmName = "Paused";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 787, "( ProxyDisplayClientPsm >> CompoundState >> Paused ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )" );
      mTransitions[ 1 ] = new TsmTransition( 788, "( ProxyDisplayClientPsm >> CompoundState >> Paused ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )" );
    }

    void Tra_0728_0786( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0736_0749( TsmHandler& oHandler );
    void Tra_0728_0785( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 787:
          return TsmProspect::OK;
        case 788:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 786:
        Tra_0728_0786( oHandler );
        break;
      case 787: // UP: ( ProxyDisplayClientPsm >> CompoundState >> Paused ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 788: // UP: ( ProxyDisplayClientPsm >> CompoundState >> Paused ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 749:
        Tra_0736_0749( oHandler );
        break;
      case 785:
        Tra_0728_0785( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Finishing )
  class Lea_0728_0767 : public TsmLeaf
  {
  public:
    Lea_0728_0767( TsmBase* oParent )
    {
      TsmName = "Finishing";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0728_0784( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 784:
        Tra_0728_0784( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >)
  class Reg_0727_0728 : public TsmRegion
  {
  private:
    Ini_0728_0729* oIni_0728_0729; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> InitialState )
    Cho_0728_0730* oCho_0728_0730; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
    Cho_0728_0731* oCho_0728_0731; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
    Cho_0728_0732* oCho_0728_0732; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
    Cho_0728_0733* oCho_0728_0733; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
    Cho_0728_0734* oCho_0728_0734; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
    Com_0728_0735* oCom_0728_0735; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState )
    Lea_0728_0760* oLea_0728_0760; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Ready )
    Lea_0728_0761* oLea_0728_0761; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Preparing )
    Lea_0728_0762* oLea_0728_0762; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Idle )
    Lea_0728_0763* oLea_0728_0763; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Starting )
    Lea_0728_0764* oLea_0728_0764; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Synclost )
    Lea_0728_0765* oLea_0728_0765; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> StartPausing )
    Lea_0728_0766* oLea_0728_0766; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Paused )
    Lea_0728_0767* oLea_0728_0767; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Finishing )

  public:
    Reg_0727_0728( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0728_0729 = new Ini_0728_0729( this );
      oCho_0728_0730 = new Cho_0728_0730( this );
      oCho_0728_0731 = new Cho_0728_0731( this );
      oCho_0728_0732 = new Cho_0728_0732( this );
      oCho_0728_0733 = new Cho_0728_0733( this );
      oCho_0728_0734 = new Cho_0728_0734( this );
      oCom_0728_0735 = new Com_0728_0735( this );
      oLea_0728_0760 = new Lea_0728_0760( this );
      oLea_0728_0761 = new Lea_0728_0761( this );
      oLea_0728_0762 = new Lea_0728_0762( this );
      oLea_0728_0763 = new Lea_0728_0763( this );
      oLea_0728_0764 = new Lea_0728_0764( this );
      oLea_0728_0765 = new Lea_0728_0765( this );
      oLea_0728_0766 = new Lea_0728_0766( this );
      oLea_0728_0767 = new Lea_0728_0767( this );
      mNrStates = 15;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0728_0729;
      mStates[ 1 ] = oCho_0728_0730;
      mStates[ 2 ] = oCho_0728_0731;
      mStates[ 3 ] = oCho_0728_0732;
      mStates[ 4 ] = oCho_0728_0733;
      mStates[ 5 ] = oCho_0728_0734;
      mStates[ 6 ] = oCom_0728_0735;
      mStates[ 7 ] = oLea_0728_0760;
      mStates[ 8 ] = oLea_0728_0761;
      mStates[ 9 ] = oLea_0728_0762;
      mStates[ 10 ] = oLea_0728_0763;
      mStates[ 11 ] = oLea_0728_0764;
      mStates[ 12 ] = oLea_0728_0765;
      mStates[ 13 ] = oLea_0728_0766;
      mStates[ 14 ] = oLea_0728_0767;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0728_0768( TsmHandler& oHandler );
    void Tra_0728_0775( TsmHandler& oHandler );
    void Tra_0728_0777( TsmHandler& oHandler );
    void Tra_0728_0779( TsmHandler& oHandler );
    void Tra_0728_0782( TsmHandler& oHandler );
    void Tra_0728_0786( TsmHandler& oHandler );
    void Tra_0728_0776( TsmHandler& oHandler );
    void Tra_0728_0778( TsmHandler& oHandler );
    void Tra_0728_0781( TsmHandler& oHandler );
    void Tra_0728_0789( TsmHandler& oHandler );
    void Tra_0728_0774( TsmHandler& oHandler );
    void Tra_0728_0780( TsmHandler& oHandler );
    void Tra_0728_0783( TsmHandler& oHandler );
    void Tra_0728_0787( TsmHandler& oHandler );
    void Tra_0728_0788( TsmHandler& oHandler );
    void Tra_0728_0784( TsmHandler& oHandler );
    void Tra_0736_0749( TsmHandler& oHandler );
    void Tra_0728_0785( TsmHandler& oHandler );
    void Tra_0728_0769( TsmHandler& oHandler );
    void Tra_0728_0773( TsmHandler& oHandler );
    void Tra_0728_0772( TsmHandler& oHandler );
    void Tra_0728_0770( TsmHandler& oHandler );
    void Tra_0728_0771( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 746:
          return TsmProspect::OK;
        case 753:
          return TsmProspect::OK;
        case 755:
          return TsmProspect::OK;
        case 748:
          return TsmProspect::OK;
        case 751:
          return TsmProspect::OK;
        case 776:
          return TsmProspect::OK;
        case 778:
          return TsmProspect::OK;
        case 781:
          return TsmProspect::OK;
        case 789:
          return TsmProspect::OK;
        case 774:
          return TsmProspect::OK;
        case 780:
          return TsmProspect::OK;
        case 783:
          return TsmProspect::OK;
        case 787:
          return TsmProspect::OK;
        case 788:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 722:
        switch ( Command )
        {
        case 37:
          return TsmProspect::OK;
        case 38:
          return TsmProspect::OK;
        case 39:
          return TsmProspect::OK;
        case 40:
          return TsmProspect::OK;
        case 41:
          return TsmProspect::OK;
        case 43:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 768:
        Tra_0728_0768( oHandler );
        break;
      case 775:
        Tra_0728_0775( oHandler );
        break;
      case 777:
        Tra_0728_0777( oHandler );
        break;
      case 779:
        Tra_0728_0779( oHandler );
        break;
      case 782:
        Tra_0728_0782( oHandler );
        break;
      case 786:
        Tra_0728_0786( oHandler );
        break;
      case 776:
        Tra_0728_0776( oHandler );
        break;
      case 778:
        Tra_0728_0778( oHandler );
        break;
      case 781:
        Tra_0728_0781( oHandler );
        break;
      case 789:
        Tra_0728_0789( oHandler );
        break;
      case 774:
        Tra_0728_0774( oHandler );
        break;
      case 780:
        Tra_0728_0780( oHandler );
        break;
      case 783:
        Tra_0728_0783( oHandler );
        break;
      case 787:
        Tra_0728_0787( oHandler );
        break;
      case 788:
        Tra_0728_0788( oHandler );
        break;
      case 784:
        Tra_0728_0784( oHandler );
        break;
      case 749:
        Tra_0736_0749( oHandler );
        break;
      case 785:
        Tra_0728_0785( oHandler );
        break;
      case 769:
        Tra_0728_0769( oHandler );
        break;
      case 773:
        Tra_0728_0773( oHandler );
        break;
      case 772:
        Tra_0728_0772( oHandler );
        break;
      case 770:
        Tra_0728_0770( oHandler );
        break;
      case 771:
        Tra_0728_0771( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState )
  class Com_0724_0727 : public TsmCompound
  {
  private:
    static const int aNatives[1];
    Reg_0727_0728* oReg_0727_0728; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >)

  public:
    Com_0724_0727( TsmBase* oParent )
    {
      TsmName = "CS_727";
      TsmParent = oParent;
      oReg_0727_0728 = new Reg_0727_0728( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0727_0728;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 793, "( ProxyDisplayClientPsm >> CompoundState ) => ( ProxyDisplayClientPsm >> ChoiceState )" );
    }

    void Tra_0724_0792( TsmHandler& oHandler );
    void Tra_0728_0790( TsmHandler& oHandler );
    void Tra_0724_0796( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtMyExit( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 793:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 792:
        Tra_0724_0792( oHandler );
        break;
      case 790:
        Tra_0728_0790( oHandler );
        break;
      case 793: // UP: ( ProxyDisplayClientPsm >> CompoundState ) => ( ProxyDisplayClientPsm >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 796:
        Tra_0724_0796( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> Stopping )
  class Lea_0724_0791 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0724_0791( TsmBase* oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 795, "( ProxyDisplayClientPsm >> Stopping ) => ( ProxyDisplayClientPsm >> ChoiceState )" );
      mTransitions[ 1 ] = new TsmTransition( 796, "( ProxyDisplayClientPsm >> Stopping ) => ( ProxyDisplayClientPsm >> CompoundState ) : Px_CbStopped" );
    }

    void Tra_0724_0794( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___Px_CbStopped( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 795:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 722:
        switch ( Command )
        {
        case 42:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 794:
        Tra_0724_0794( oHandler );
        break;
      case 795: // UP: ( ProxyDisplayClientPsm >> Stopping ) => ( ProxyDisplayClientPsm >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 796: // UP: ( ProxyDisplayClientPsm >> Stopping ) => ( ProxyDisplayClientPsm >> CompoundState )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >)
  class Reg_0723_0724 : public TsmRegion
  {
  private:
    Ini_0724_0725* oIni_0724_0725; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> InitialState )
    Cho_0724_0726* oCho_0724_0726; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> ChoiceState )
    Com_0724_0727* oCom_0724_0727; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState )
    Lea_0724_0791* oLea_0724_0791; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> Stopping )

  public:
    Reg_0723_0724( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0724_0725 = new Ini_0724_0725( this );
      oCho_0724_0726 = new Cho_0724_0726( this );
      oCom_0724_0727 = new Com_0724_0727( this );
      oLea_0724_0791 = new Lea_0724_0791( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0724_0725;
      mStates[ 1 ] = oCho_0724_0726;
      mStates[ 2 ] = oCom_0724_0727;
      mStates[ 3 ] = oLea_0724_0791;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0724_0792( TsmHandler& oHandler );
    void Tra_0728_0790( TsmHandler& oHandler );
    void Tra_0724_0794( TsmHandler& oHandler );
    void Tra_0724_0793( TsmHandler& oHandler );
    void Tra_0724_0795( TsmHandler& oHandler );
    void Tra_0724_0796( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 793:
          return TsmProspect::OK;
        case 746:
          return TsmProspect::OK;
        case 753:
          return TsmProspect::OK;
        case 755:
          return TsmProspect::OK;
        case 748:
          return TsmProspect::OK;
        case 751:
          return TsmProspect::OK;
        case 776:
          return TsmProspect::OK;
        case 778:
          return TsmProspect::OK;
        case 781:
          return TsmProspect::OK;
        case 789:
          return TsmProspect::OK;
        case 774:
          return TsmProspect::OK;
        case 780:
          return TsmProspect::OK;
        case 783:
          return TsmProspect::OK;
        case 787:
          return TsmProspect::OK;
        case 788:
          return TsmProspect::OK;
        case 795:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 722:
        switch ( Command )
        {
        case 37:
          return TsmProspect::OK;
        case 38:
          return TsmProspect::OK;
        case 39:
          return TsmProspect::OK;
        case 40:
          return TsmProspect::OK;
        case 41:
          return TsmProspect::OK;
        case 42:
          return TsmProspect::OK;
        case 43:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 792:
        Tra_0724_0792( oHandler );
        break;
      case 790:
        Tra_0728_0790( oHandler );
        break;
      case 794:
        Tra_0724_0794( oHandler );
        break;
      case 793:
        Tra_0724_0793( oHandler );
        break;
      case 795:
        Tra_0724_0795( oHandler );
        break;
      case 796:
        Tra_0724_0796( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm )
  class Fsm_0721_0723 : public TsmFsm
  {
  private:
    Reg_0723_0724* oReg_0723_0724; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >)

  public:
    Fsm_0721_0723( TsmBase* oParent )
    {
      TsmName = "ProxyDisplayClientPsm";
      TsmParent = oParent;
      oReg_0723_0724 = new Reg_0723_0724( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0723_0724;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient )
  class Cla_0664_0721 : public TsmProxyUser
  {
  private:
    Fsm_0721_0723* oFsm_0721_0723; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm )
    TsmIPort_IProxyDisplayServer* Port; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > Port )
    TsmIPort_IProxyDisplayClient* TsmPI__Port; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > Port )
    TsmPCPort* mPCMessager;
    eRV RV;

  public:
    Cla_0664_0721( TsmBase* oParent, string sInstanceName ) : RV(OK)
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0721_0723 = new Fsm_0721_0723( this );
      TsmPI__Port = new TsmIPort_IProxyDisplayClient( this );
      mPCMessager = new TsmPCPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0721_0723;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "Port" )
      {
        return TsmPI__Port;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "Port" )
      {
        Port = static_cast<TsmIPort_IProxyDisplayServer*>(oProvidedInterface);
        Port->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0721_0723->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    bool Guard_1065();
    void Function_1137( TsmHandler& oHandler );
    void Function_1138( TsmHandler& oHandler );
    void Function_1139( TsmHandler& oHandler );
    void Function_1140( TsmHandler& oHandler );
    void Function_1141( TsmHandler& oHandler );
    void Function_1142( TsmHandler& oHandler );
    void Function_1143( TsmHandler& oHandler );
    void Function_1144( TsmHandler& oHandler );
    void Function_1145( TsmHandler& oHandler );
    void Function_1146( TsmHandler& oHandler );
    void Function_1147( TsmHandler& oHandler );
    void Function_1148( TsmHandler& oHandler );
    void Function_1149( TsmHandler& oHandler );
    void Function_1150( TsmHandler& oHandler );
    void Function_1151( TsmHandler& oHandler );
    void Function_1152( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0664_0721()
    {
      delete TsmPI__Port;
      delete mPCMessager;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol )
   ********************************************************************/

   // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol )
  class Pac_0529_0664 : public TsmPackage
  {
  public:
    Pac_0529_0664( TsmBase* oParent )
    {
      TsmName = "ProxyDisplayProtocol";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository > Player > ProxyProtocols )
   ********************************************************************/

   // ( Xmi > Data > Repository > Player > ProxyProtocols )
  class Pac_0016_0529 : public TsmPackage
  {
  public:
    Pac_0016_0529( TsmBase* oParent )
    {
      TsmName = "ProxyProtocols";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository > Player )
   ********************************************************************/

   // ( Xmi > Data > Repository > Player )
  class Pac_0007_0016 : public TsmPackage
  {
  public:
    Pac_0007_0016( TsmBase* oParent )
    {
      TsmName = "Player";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository )
   ********************************************************************/

   // ( Xmi > Data > Repository )
  class Pac_0006_0007 : public TsmPackage
  {
  public:
    Pac_0006_0007( TsmBase* oParent )
    {
      TsmName = "Repository";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> InitialState )
  class Ini_0852_0853 : public TsmPseudo
  {
  public:
    Ini_0852_0853( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 887, "( ReaderServerPsm >> InitialState ) => ( ReaderServerPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 887: // UP: ( ReaderServerPsm >> InitialState ) => ( ReaderServerPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> ChoiceState )
  class Cho_0852_0854 : public TsmPseudo
  {
  private:
    int MaxNrChoices;

  public:
    Cho_0852_0854( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      MaxNrChoices = 2;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 885, "( ReaderServerPsm >> ChoiceState ) => ( ReaderServerPsm >> Opening )" );
      mTransitions[ 1 ] = new TsmTransition( 883, "( ReaderServerPsm >> ChoiceState ) => ( ReaderServerPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0852_0884( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 885: // UP: ( ReaderServerPsm >> ChoiceState ) => ( ReaderServerPsm >> Opening )
        bHigher = true;
        break;
      case 883: // UP: ( ReaderServerPsm >> ChoiceState ) => ( ReaderServerPsm >> Idle )
        bHigher = true;
        break;
      case 884:
        Tra_0852_0884( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> ChoiceState )
  class Cho_0856_0857 : public TsmPseudo
  {
  private:
    int MaxNrChoices;

  public:
    Cho_0856_0857( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      MaxNrChoices = 2;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 871, "( ReaderServerPsm >> CompoundState >> ChoiceState ) => ( ReaderServerPsm >> Seeking )" );
      mTransitions[ 1 ] = new TsmTransition( 873, "( ReaderServerPsm >> CompoundState >> ChoiceState ) => ( ReaderServerPsm >> CompoundState >> Error )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0856_0870( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 871: // UP: ( ReaderServerPsm >> CompoundState >> ChoiceState ) => ( ReaderServerPsm >> Seeking )
        bHigher = true;
        break;
      case 873: // UP: ( ReaderServerPsm >> CompoundState >> ChoiceState ) => ( ReaderServerPsm >> CompoundState >> Error )
        bHigher = true;
        break;
      case 870:
        Tra_0856_0870( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Reading >> InitialState )
  class Ini_0859_0860 : public TsmPseudo
  {
  public:
    Ini_0859_0860( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 864, "( ReaderServerPsm >> CompoundState >> Reading >> InitialState ) => ( ReaderServerPsm >> CompoundState >> Reading >> NotEnough )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 864: // UP: ( ReaderServerPsm >> CompoundState >> Reading >> InitialState ) => ( ReaderServerPsm >> CompoundState >> Reading >> NotEnough )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Reading >> NotEnough )
  class Lea_0859_0861 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0859_0861( TsmBase* oParent )
    {
      TsmName = "NotEnough";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 863, "( ReaderServerPsm >> CompoundState >> Reading >> NotEnough ) => ( ReaderServerPsm >> CompoundState >> Reading >> Enough )" );
    }

    void Tra_0859_0864( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 863:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 864:
        Tra_0859_0864( oHandler );
        break;
      case 863: // UP: ( ReaderServerPsm >> CompoundState >> Reading >> NotEnough ) => ( ReaderServerPsm >> CompoundState >> Reading >> Enough )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Reading >> Enough )
  class Lea_0859_0862 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0859_0862( TsmBase* oParent )
    {
      TsmName = "Enough";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 868, "( ReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ReaderServerPsm >> CompoundState >> Open )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0859_0863( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 868:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 863:
        Tra_0859_0863( oHandler );
        break;
      case 868: // UP: ( ReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ReaderServerPsm >> CompoundState >> Open )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Reading >)
  class Reg_0858_0859 : public TsmRegion
  {
  private:
    Ini_0859_0860* oIni_0859_0860; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Reading >> InitialState )
    Lea_0859_0861* oLea_0859_0861; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Reading >> NotEnough )
    Lea_0859_0862* oLea_0859_0862; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Reading >> Enough )

  public:
    Reg_0858_0859( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0859_0860 = new Ini_0859_0860( this );
      oLea_0859_0861 = new Lea_0859_0861( this );
      oLea_0859_0862 = new Lea_0859_0862( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0859_0860;
      mStates[ 1 ] = oLea_0859_0861;
      mStates[ 2 ] = oLea_0859_0862;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0859_0864( TsmHandler& oHandler );
    void Tra_0859_0863( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 863:
          return TsmProspect::OK;
        case 868:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 864:
        Tra_0859_0864( oHandler );
        break;
      case 863:
        Tra_0859_0863( oHandler );
        break;
      case 868: // Up: ( ReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ReaderServerPsm >> CompoundState >> Open )
        mCurrentState = NULL;
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Reading )
  class Com_0856_0858 : public TsmCompound
  {
  private:
    static const int aNatives[1];
    Reg_0858_0859* oReg_0858_0859; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Reading >)

  public:
    Com_0856_0858( TsmBase* oParent )
    {
      TsmName = "Reading";
      TsmParent = oParent;
      oReg_0858_0859 = new Reg_0858_0859( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0858_0859;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 869, "( ReaderServerPsm >> CompoundState >> Reading ) => ( ReaderServerPsm >> CompoundState >> Error )" );
    }

    void Tra_0852_0880( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtMyExit( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 869:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 869: // UP: ( ReaderServerPsm >> CompoundState >> Reading ) => ( ReaderServerPsm >> CompoundState >> Error )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 868: // UP: ( ReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ReaderServerPsm >> CompoundState >> Open )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 880:
        Tra_0852_0880( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Open )
  class Lea_0856_0865 : public TsmLeaf
  {
  public:
    Lea_0856_0865( TsmBase* oParent )
    {
      TsmName = "Open";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 872, "( ReaderServerPsm >> CompoundState >> Open ) => ( ReaderServerPsm >> Closing ) : Close" );
      mTransitions[ 1 ] = new TsmTransition( 870, "( ReaderServerPsm >> CompoundState >> Open ) => ( ReaderServerPsm >> CompoundState >> ChoiceState ) : Read" );
      mTransitions[ 2 ] = new TsmTransition( 867, "( ReaderServerPsm >> CompoundState >> Open ) => ( ReaderServerPsm >> CompoundState >> Open ) : Clear" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0856_0868( TsmHandler& oHandler );
    void Tra_0852_0879( TsmHandler& oHandler );
    void Tra_0852_0881( TsmHandler& oHandler );
    void Port___Close( TsmHandler& oHandler );
    void Port___Read( tChunk* Chunk, TsmHandler& oHandler );
    void Tra_0856_0867( TsmHandler& oHandler );
    void Port___Clear( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 850:
        switch ( Command )
        {
        case 44:
          return TsmProspect::OK;
        case 47:
          return TsmProspect::OK;
        case 48:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 868:
        Tra_0856_0868( oHandler );
        break;
      case 879:
        Tra_0852_0879( oHandler );
        break;
      case 881:
        Tra_0852_0881( oHandler );
        break;
      case 872: // UP: ( ReaderServerPsm >> CompoundState >> Open ) => ( ReaderServerPsm >> Closing )
        bHigher = true;
        break;
      case 870: // UP: ( ReaderServerPsm >> CompoundState >> Open ) => ( ReaderServerPsm >> CompoundState >> ChoiceState )
        bHigher = true;
        break;
      case 867:
        Tra_0856_0867( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Error )
  class Lea_0856_0866 : public TsmLeaf
  {
  public:
    Lea_0856_0866( TsmBase* oParent )
    {
      TsmName = "Error";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Tra_0856_0873( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0856_0869( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 873:
        Tra_0856_0873( oHandler );
        break;
      case 869:
        Tra_0856_0869( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >)
  class Reg_0855_0856 : public TsmRegion
  {
  private:
    Cho_0856_0857* oCho_0856_0857; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> ChoiceState )
    Com_0856_0858* oCom_0856_0858; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Reading )
    Lea_0856_0865* oLea_0856_0865; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Open )
    Lea_0856_0866* oLea_0856_0866; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Error )

  public:
    Reg_0855_0856( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oCho_0856_0857 = new Cho_0856_0857( this );
      oCom_0856_0858 = new Com_0856_0858( this );
      oLea_0856_0865 = new Lea_0856_0865( this );
      oLea_0856_0866 = new Lea_0856_0866( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oCho_0856_0857;
      mStates[ 1 ] = oCom_0856_0858;
      mStates[ 2 ] = oLea_0856_0865;
      mStates[ 3 ] = oLea_0856_0866;
    }

    void Tra_0856_0873( TsmHandler& oHandler );
    void Tra_0856_0869( TsmHandler& oHandler );
    void Tra_0856_0868( TsmHandler& oHandler );
    void Tra_0852_0879( TsmHandler& oHandler );
    void Tra_0852_0880( TsmHandler& oHandler );
    void Tra_0852_0881( TsmHandler& oHandler );
    void Tra_0856_0870( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 869:
          return TsmProspect::OK;
        case 863:
          return TsmProspect::OK;
        case 868:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 850:
        switch ( Command )
        {
        case 44:
          return TsmProspect::OK;
        case 47:
          return TsmProspect::OK;
        case 48:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 871: // Up: ( ReaderServerPsm >> CompoundState >> ChoiceState ) => ( ReaderServerPsm >> Seeking )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 873:
        Tra_0856_0873( oHandler );
        break;
      case 869:
        Tra_0856_0869( oHandler );
        break;
      case 868:
        Tra_0856_0868( oHandler );
        break;
      case 879:
        Tra_0852_0879( oHandler );
        break;
      case 880:
        Tra_0852_0880( oHandler );
        break;
      case 881:
        Tra_0852_0881( oHandler );
        break;
      case 872: // Up: ( ReaderServerPsm >> CompoundState >> Open ) => ( ReaderServerPsm >> Closing )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 870:
        Tra_0856_0870( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState )
  class Com_0852_0855 : public TsmCompound
  {
  private:
    Reg_0855_0856* oReg_0855_0856; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >)

  public:
    Com_0852_0855( TsmBase* oParent )
    {
      TsmName = "CS_855";
      TsmParent = oParent;
      oReg_0855_0856 = new Reg_0855_0856( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0855_0856;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 886, "( ReaderServerPsm >> CompoundState ) => ( ReaderServerPsm >> Stopping ) : Stop" );
    }

    void Tra_0852_0879( TsmHandler& oHandler );
    void Tra_0852_0880( TsmHandler& oHandler );
    void Tra_0852_0881( TsmHandler& oHandler );
    void Port___Stop( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 850:
        switch ( Command )
        {
        case 45:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 871: // UP: ( ReaderServerPsm >> CompoundState >> ChoiceState ) => ( ReaderServerPsm >> Seeking )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 879:
        Tra_0852_0879( oHandler );
        break;
      case 880:
        Tra_0852_0880( oHandler );
        break;
      case 881:
        Tra_0852_0881( oHandler );
        break;
      case 872: // UP: ( ReaderServerPsm >> CompoundState >> Open ) => ( ReaderServerPsm >> Closing )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 886: // UP: ( ReaderServerPsm >> CompoundState ) => ( ReaderServerPsm >> Stopping )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> Idle )
  class Lea_0852_0874 : public TsmLeaf
  {
  public:
    Lea_0852_0874( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 884, "( ReaderServerPsm >> Idle ) => ( ReaderServerPsm >> ChoiceState ) : Open" );
    }

    void Tra_0852_0887( TsmHandler& oHandler );
    void Tra_0852_0883( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0852_0882( TsmHandler& oHandler );
    void Port___Open( int FileHandle, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 850:
        switch ( Command )
        {
        case 46:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 887:
        Tra_0852_0887( oHandler );
        break;
      case 883:
        Tra_0852_0883( oHandler );
        break;
      case 882:
        Tra_0852_0882( oHandler );
        break;
      case 884: // UP: ( ReaderServerPsm >> Idle ) => ( ReaderServerPsm >> ChoiceState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> Opening )
  class Lea_0852_0875 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0852_0875( TsmBase* oParent )
    {
      TsmName = "Opening";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 879, "( ReaderServerPsm >> Opening ) => ( ReaderServerPsm >> CompoundState >> Open )" );
    }

    void Tra_0852_0885( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 879:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 885:
        Tra_0852_0885( oHandler );
        break;
      case 879: // UP: ( ReaderServerPsm >> Opening ) => ( ReaderServerPsm >> CompoundState >> Open )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> Seeking )
  class Lea_0852_0876 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0852_0876( TsmBase* oParent )
    {
      TsmName = "Seeking";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 880, "( ReaderServerPsm >> Seeking ) => ( ReaderServerPsm >> CompoundState >> Reading )" );
    }

    void Tra_0856_0871( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 880:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 871:
        Tra_0856_0871( oHandler );
        break;
      case 880: // UP: ( ReaderServerPsm >> Seeking ) => ( ReaderServerPsm >> CompoundState >> Reading )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> Stopping )
  class Lea_0852_0877 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0852_0877( TsmBase* oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 881, "( ReaderServerPsm >> Stopping ) => ( ReaderServerPsm >> CompoundState >> Open )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0852_0886( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 881:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 881: // UP: ( ReaderServerPsm >> Stopping ) => ( ReaderServerPsm >> CompoundState >> Open )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 886:
        Tra_0852_0886( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> Closing )
  class Lea_0852_0878 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0852_0878( TsmBase* oParent )
    {
      TsmName = "Closing";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 882, "( ReaderServerPsm >> Closing ) => ( ReaderServerPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0856_0872( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 882:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 882: // UP: ( ReaderServerPsm >> Closing ) => ( ReaderServerPsm >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 872:
        Tra_0856_0872( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >)
  class Reg_0851_0852 : public TsmRegion
  {
  private:
    Ini_0852_0853* oIni_0852_0853; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> InitialState )
    Cho_0852_0854* oCho_0852_0854; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> ChoiceState )
    Com_0852_0855* oCom_0852_0855; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState )
    Lea_0852_0874* oLea_0852_0874; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> Idle )
    Lea_0852_0875* oLea_0852_0875; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> Opening )
    Lea_0852_0876* oLea_0852_0876; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> Seeking )
    Lea_0852_0877* oLea_0852_0877; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> Stopping )
    Lea_0852_0878* oLea_0852_0878; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> Closing )

  public:
    Reg_0851_0852( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0852_0853 = new Ini_0852_0853( this );
      oCho_0852_0854 = new Cho_0852_0854( this );
      oCom_0852_0855 = new Com_0852_0855( this );
      oLea_0852_0874 = new Lea_0852_0874( this );
      oLea_0852_0875 = new Lea_0852_0875( this );
      oLea_0852_0876 = new Lea_0852_0876( this );
      oLea_0852_0877 = new Lea_0852_0877( this );
      oLea_0852_0878 = new Lea_0852_0878( this );
      mNrStates = 8;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0852_0853;
      mStates[ 1 ] = oCho_0852_0854;
      mStates[ 2 ] = oCom_0852_0855;
      mStates[ 3 ] = oLea_0852_0874;
      mStates[ 4 ] = oLea_0852_0875;
      mStates[ 5 ] = oLea_0852_0876;
      mStates[ 6 ] = oLea_0852_0877;
      mStates[ 7 ] = oLea_0852_0878;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0852_0887( TsmHandler& oHandler );
    void Tra_0852_0885( TsmHandler& oHandler );
    void Tra_0852_0883( TsmHandler& oHandler );
    void Tra_0856_0871( TsmHandler& oHandler );
    void Tra_0852_0879( TsmHandler& oHandler );
    void Tra_0852_0880( TsmHandler& oHandler );
    void Tra_0852_0881( TsmHandler& oHandler );
    void Tra_0852_0882( TsmHandler& oHandler );
    void Tra_0856_0872( TsmHandler& oHandler );
    void Tra_0852_0886( TsmHandler& oHandler );
    void Tra_0852_0884( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 869:
          return TsmProspect::OK;
        case 863:
          return TsmProspect::OK;
        case 868:
          return TsmProspect::OK;
        case 879:
          return TsmProspect::OK;
        case 880:
          return TsmProspect::OK;
        case 881:
          return TsmProspect::OK;
        case 882:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 850:
        switch ( Command )
        {
        case 44:
          return TsmProspect::OK;
        case 45:
          return TsmProspect::OK;
        case 46:
          return TsmProspect::OK;
        case 47:
          return TsmProspect::OK;
        case 48:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 887:
        Tra_0852_0887( oHandler );
        break;
      case 885:
        Tra_0852_0885( oHandler );
        break;
      case 883:
        Tra_0852_0883( oHandler );
        break;
      case 871:
        Tra_0856_0871( oHandler );
        break;
      case 879:
        Tra_0852_0879( oHandler );
        break;
      case 880:
        Tra_0852_0880( oHandler );
        break;
      case 881:
        Tra_0852_0881( oHandler );
        break;
      case 882:
        Tra_0852_0882( oHandler );
        break;
      case 872:
        Tra_0856_0872( oHandler );
        break;
      case 886:
        Tra_0852_0886( oHandler );
        break;
      case 884:
        Tra_0852_0884( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm )
  class Fsm_0849_0851 : public TsmFsm
  {
  private:
    Reg_0851_0852* oReg_0851_0852; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >)

  public:
    Fsm_0849_0851( TsmBase* oParent )
    {
      TsmName = "ReaderServerPsm";
      TsmParent = oParent;
      oReg_0851_0852 = new Reg_0851_0852( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0851_0852;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer )
  class Cla_0806_0849 : public TsmProtocolClass
  {
  private:
    Fsm_0849_0851* oFsm_0849_0851; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm )
    TsmIPort_IReaderServer* TsmPI__Port; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > Port )
    TsmIPort_IReaderClient* Port; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > Port )
    TsmPSPort* mPSMessager;
    int Sector;

  public:
    Cla_0806_0849( TsmBase* oParent, string sInstanceName ) : Sector(0)
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0849_0851 = new Fsm_0849_0851( this );
      TsmPI__Port = new TsmIPort_IReaderServer( this );
      mPSMessager = new TsmPSPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0849_0851;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "Port" )
      {
        return TsmPI__Port;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "Port" )
      {
        Port = static_cast<TsmIPort_IReaderClient*>(oProvidedInterface);
        Port->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0849_0851->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    eRV Function_1068( int FileHandle );
    void Function_1069( TsmHandler& oHandler );
    eRV Function_1070( int FileHandle );
    void Function_1071( TsmHandler& oHandler );
    eRV Function_1072( tChunk* Chunk );
    void Function_1073( TsmHandler& oHandler );
    eRV Function_1074( tChunk* Chunk );
    void Function_1075( TsmHandler& oHandler );
    void Function_1158( TsmHandler& oHandler );
    void Function_1159( TsmHandler& oHandler );
    void Function_1160( TsmHandler& oHandler );
    void Function_1161( TsmHandler& oHandler );
    void Function_1162( TsmHandler& oHandler );
    void Function_1163( TsmHandler& oHandler );
    void Function_1164( TsmHandler& oHandler );
    eRV Function_1319( tChunk* Chunk );
    void Function_1320( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0806_0849()
    {
      delete TsmPI__Port;
      delete mPSMessager;
    }
  };

   // ( Xmi > Data > Architecture > ExEnv > ReaderMock )
  class Com_0798_0001 : public TsmPComponent
  {
  private:
    Cla_0806_0849* InsReaderServer; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > InsReaderServer )

  public:
    Com_0798_0001( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsReaderServer = new Cla_0806_0849( this, "InsReaderServer" );
      InsReaderServer->IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = InsReaderServer;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "pp_reader" )
      {
        return InsReaderServer->GetProvidedInterface( "Port" );
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExEnv > ReaderMock )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "pp_reader" )
      {
        InsReaderServer->SetRequiredInterface( "Port", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExEnv > ReaderMock )";
      throw TsmException( s );
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> InitialState )
  class Ini_1015_1016 : public TsmPseudo
  {
  public:
    Ini_1015_1016( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1039, "( TbServerPsm >> InitialState ) => ( TbServerPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1039: // UP: ( TbServerPsm >> InitialState ) => ( TbServerPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> ChoiceState )
  class Cho_1015_1017 : public TsmPseudo
  {
  private:
    int MaxNrChoices;

  public:
    Cho_1015_1017( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      MaxNrChoices = 2;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 1042, "( TbServerPsm >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Ready )" );
      mTransitions[ 1 ] = new TsmTransition( 1041, "( TbServerPsm >> ChoiceState ) => ( TbServerPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_1015_1040( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1042: // UP: ( TbServerPsm >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Ready )
        bHigher = true;
        break;
      case 1041: // UP: ( TbServerPsm >> ChoiceState ) => ( TbServerPsm >> Idle )
        bHigher = true;
        break;
      case 1040:
        Tra_1015_1040( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >> ChoiceState )
  class Cho_1019_1020 : public TsmPseudo
  {
  private:
    int MaxNrChoices;

  public:
    Cho_1019_1020( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      MaxNrChoices = 2;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 1028, "( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Play )" );
      mTransitions[ 1 ] = new TsmTransition( 1027, "( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Ready )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_1019_1026( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1028: // UP: ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Play )
        bHigher = true;
        break;
      case 1027: // UP: ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Ready )
        bHigher = true;
        break;
      case 1026:
        Tra_1019_1026( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >> ChoiceState )
  class Cho_1019_1021 : public TsmPseudo
  {
  private:
    int MaxNrChoices;

  public:
    Cho_1019_1021( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      MaxNrChoices = 2;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 1037, "( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Play )" );
      mTransitions[ 1 ] = new TsmTransition( 1036, "( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> End )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_1019_1029( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1037: // UP: ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Play )
        bHigher = true;
        break;
      case 1036: // UP: ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> End )
        bHigher = true;
        break;
      case 1029:
        Tra_1019_1029( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >> ChoiceState )
  class Cho_1019_1022 : public TsmPseudo
  {
  private:
    int MaxNrChoices;

  public:
    Cho_1019_1022( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      MaxNrChoices = 2;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 1035, "( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> End )" );
      mTransitions[ 1 ] = new TsmTransition( 1034, "( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> End )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_1019_1033( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1035: // UP: ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> End )
        bHigher = true;
        break;
      case 1034: // UP: ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> End )
        bHigher = true;
        break;
      case 1033:
        Tra_1019_1033( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >> Ready )
  class Lea_1019_1023 : public TsmLeaf
  {
  public:
    Lea_1019_1023( TsmBase* oParent )
    {
      TsmName = "Ready";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1026, "( TbServerPsm >> CompoundState >> Ready ) => ( TbServerPsm >> CompoundState >> ChoiceState ) : SetTime" );
    }

    void Tra_1015_1042( TsmHandler& oHandler );
    void Tra_1019_1027( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___SetTime( tTime& AtTime, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 1013:
        switch ( Command )
        {
        case 56:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1042:
        Tra_1015_1042( oHandler );
        break;
      case 1027:
        Tra_1019_1027( oHandler );
        break;
      case 1026: // UP: ( TbServerPsm >> CompoundState >> Ready ) => ( TbServerPsm >> CompoundState >> ChoiceState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >> Play )
  class Lea_1019_1024 : public TsmLeaf
  {
  public:
    Lea_1019_1024( TsmBase* oParent )
    {
      TsmName = "Play";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 1029, "( TbServerPsm >> CompoundState >> Play ) => ( TbServerPsm >> CompoundState >> ChoiceState ) : GetChunk" );
      mTransitions[ 1 ] = new TsmTransition( 1030, "( TbServerPsm >> CompoundState >> Play ) => ( TbServerPsm >> CompoundState >> Play ) : ReportReadError" );
      mTransitions[ 2 ] = new TsmTransition( 1032, "( TbServerPsm >> CompoundState >> Play ) => ( TbServerPsm >> CompoundState >> Play ) : ReportSynclost" );
    }

    void Tra_1019_1028( TsmHandler& oHandler );
    void Tra_1019_1037( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___GetChunk( tChunk& NewChunk, TsmHandler& oHandler );
    void Tra_1019_1030( TsmHandler& oHandler );
    void Port___ReportReadError( int BadSector, TsmHandler& oHandler );
    void Tra_1019_1032( TsmHandler& oHandler );
    void Port___ReportSynclost( tTime& BadTime, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 1013:
        switch ( Command )
        {
        case 57:
          return TsmProspect::OK;
        case 58:
          return TsmProspect::OK;
        case 59:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1028:
        Tra_1019_1028( oHandler );
        break;
      case 1037:
        Tra_1019_1037( oHandler );
        break;
      case 1029: // UP: ( TbServerPsm >> CompoundState >> Play ) => ( TbServerPsm >> CompoundState >> ChoiceState )
        bHigher = true;
        break;
      case 1030:
        Tra_1019_1030( oHandler );
        break;
      case 1032:
        Tra_1019_1032( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >> End )
  class Lea_1019_1025 : public TsmLeaf
  {
  public:
    Lea_1019_1025( TsmBase* oParent )
    {
      TsmName = "End";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1033, "( TbServerPsm >> CompoundState >> End ) => ( TbServerPsm >> CompoundState >> ChoiceState ) : GetResult" );
    }

    void Tra_1019_1036( TsmHandler& oHandler );
    void Tra_1019_1035( TsmHandler& oHandler );
    void Tra_1019_1034( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___GetResult( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 1013:
        switch ( Command )
        {
        case 60:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1036:
        Tra_1019_1036( oHandler );
        break;
      case 1035:
        Tra_1019_1035( oHandler );
        break;
      case 1034:
        Tra_1019_1034( oHandler );
        break;
      case 1033: // UP: ( TbServerPsm >> CompoundState >> End ) => ( TbServerPsm >> CompoundState >> ChoiceState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >)
  class Reg_1018_1019 : public TsmRegion
  {
  private:
    Cho_1019_1020* oCho_1019_1020; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >> ChoiceState )
    Cho_1019_1021* oCho_1019_1021; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >> ChoiceState )
    Cho_1019_1022* oCho_1019_1022; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >> ChoiceState )
    Lea_1019_1023* oLea_1019_1023; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >> Ready )
    Lea_1019_1024* oLea_1019_1024; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >> Play )
    Lea_1019_1025* oLea_1019_1025; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >> End )

  public:
    Reg_1018_1019( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oCho_1019_1020 = new Cho_1019_1020( this );
      oCho_1019_1021 = new Cho_1019_1021( this );
      oCho_1019_1022 = new Cho_1019_1022( this );
      oLea_1019_1023 = new Lea_1019_1023( this );
      oLea_1019_1024 = new Lea_1019_1024( this );
      oLea_1019_1025 = new Lea_1019_1025( this );
      mNrStates = 6;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oCho_1019_1020;
      mStates[ 1 ] = oCho_1019_1021;
      mStates[ 2 ] = oCho_1019_1022;
      mStates[ 3 ] = oLea_1019_1023;
      mStates[ 4 ] = oLea_1019_1024;
      mStates[ 5 ] = oLea_1019_1025;
    }

    void Tra_1015_1042( TsmHandler& oHandler );
    void Tra_1019_1028( TsmHandler& oHandler );
    void Tra_1019_1027( TsmHandler& oHandler );
    void Tra_1019_1037( TsmHandler& oHandler );
    void Tra_1019_1036( TsmHandler& oHandler );
    void Tra_1019_1035( TsmHandler& oHandler );
    void Tra_1019_1034( TsmHandler& oHandler );
    void Tra_1019_1026( TsmHandler& oHandler );
    void Tra_1019_1029( TsmHandler& oHandler );
    void Tra_1019_1033( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 1013:
        switch ( Command )
        {
        case 56:
          return TsmProspect::OK;
        case 57:
          return TsmProspect::OK;
        case 58:
          return TsmProspect::OK;
        case 59:
          return TsmProspect::OK;
        case 60:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1042:
        Tra_1015_1042( oHandler );
        break;
      case 1028:
        Tra_1019_1028( oHandler );
        break;
      case 1027:
        Tra_1019_1027( oHandler );
        break;
      case 1037:
        Tra_1019_1037( oHandler );
        break;
      case 1036:
        Tra_1019_1036( oHandler );
        break;
      case 1035:
        Tra_1019_1035( oHandler );
        break;
      case 1034:
        Tra_1019_1034( oHandler );
        break;
      case 1026:
        Tra_1019_1026( oHandler );
        break;
      case 1029:
        Tra_1019_1029( oHandler );
        break;
      case 1033:
        Tra_1019_1033( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState )
  class Com_1015_1018 : public TsmCompound
  {
  private:
    Reg_1018_1019* oReg_1018_1019; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >)

  public:
    Com_1015_1018( TsmBase* oParent )
    {
      TsmName = "CS_1018";
      TsmParent = oParent;
      oReg_1018_1019 = new Reg_1018_1019( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_1018_1019;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1031, "( TbServerPsm >> CompoundState ) => ( TbServerPsm >> Idle ) : CloseTitle" );
    }

    void Tra_1015_1042( TsmHandler& oHandler );
    void Port___CloseTitle( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 1013:
        switch ( Command )
        {
        case 55:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1042:
        Tra_1015_1042( oHandler );
        break;
      case 1031: // UP: ( TbServerPsm >> CompoundState ) => ( TbServerPsm >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> Idle )
  class Lea_1015_1038 : public TsmLeaf
  {
  public:
    Lea_1015_1038( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1040, "( TbServerPsm >> Idle ) => ( TbServerPsm >> ChoiceState ) : OpenTitle" );
    }

    void Tra_1015_1039( TsmHandler& oHandler );
    void Tra_1015_1041( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___OpenTitle( string TitleId, TsmHandler& oHandler );
    void Tra_1019_1031( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 1013:
        switch ( Command )
        {
        case 54:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1039:
        Tra_1015_1039( oHandler );
        break;
      case 1041:
        Tra_1015_1041( oHandler );
        break;
      case 1040: // UP: ( TbServerPsm >> Idle ) => ( TbServerPsm >> ChoiceState )
        bHigher = true;
        break;
      case 1031:
        Tra_1019_1031( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >)
  class Reg_1014_1015 : public TsmRegion
  {
  private:
    Ini_1015_1016* oIni_1015_1016; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> InitialState )
    Cho_1015_1017* oCho_1015_1017; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> ChoiceState )
    Com_1015_1018* oCom_1015_1018; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState )
    Lea_1015_1038* oLea_1015_1038; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> Idle )

  public:
    Reg_1014_1015( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_1015_1016 = new Ini_1015_1016( this );
      oCho_1015_1017 = new Cho_1015_1017( this );
      oCom_1015_1018 = new Com_1015_1018( this );
      oLea_1015_1038 = new Lea_1015_1038( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_1015_1016;
      mStates[ 1 ] = oCho_1015_1017;
      mStates[ 2 ] = oCom_1015_1018;
      mStates[ 3 ] = oLea_1015_1038;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_1015_1039( TsmHandler& oHandler );
    void Tra_1015_1042( TsmHandler& oHandler );
    void Tra_1015_1041( TsmHandler& oHandler );
    void Tra_1015_1040( TsmHandler& oHandler );
    void Tra_1019_1031( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 1013:
        switch ( Command )
        {
        case 54:
          return TsmProspect::OK;
        case 55:
          return TsmProspect::OK;
        case 56:
          return TsmProspect::OK;
        case 57:
          return TsmProspect::OK;
        case 58:
          return TsmProspect::OK;
        case 59:
          return TsmProspect::OK;
        case 60:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1039:
        Tra_1015_1039( oHandler );
        break;
      case 1042:
        Tra_1015_1042( oHandler );
        break;
      case 1041:
        Tra_1015_1041( oHandler );
        break;
      case 1040:
        Tra_1015_1040( oHandler );
        break;
      case 1031:
        Tra_1019_1031( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm )
  class Fsm_1012_1014 : public TsmFsm
  {
  private:
    Reg_1014_1015* oReg_1014_1015; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >)

  public:
    Fsm_1012_1014( TsmBase* oParent )
    {
      TsmName = "TbServerPsm";
      TsmParent = oParent;
      oReg_1014_1015 = new Reg_1014_1015( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_1014_1015;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer )
  class Cla_0980_1012 : public TsmProtocolClass
  {
  private:
    Fsm_1012_1014* oFsm_1012_1014; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm )
    TsmIPort_ITitlebaseServer* TsmPI__Port; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > Port )
    TsmPSPort* mPSMessager;
    int FileHandle;
    tChunk Chunk;

  public:
    Cla_0980_1012( TsmBase* oParent, string sInstanceName ) : FileHandle(12345)
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_1012_1014 = new Fsm_1012_1014( this );
      TsmPI__Port = new TsmIPort_ITitlebaseServer( this );
      mPSMessager = new TsmPSPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_1012_1014;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "Port" )
      {
        return TsmPI__Port;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_1012_1014->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    int Function_1081( string TitleId );
    void Function_1082( TsmHandler& oHandler );
    int Function_1083( string TitleId );
    void Function_1084( TsmHandler& oHandler );
    eRV Function_1085( tTime& AtTime );
    void Function_1086( TsmHandler& oHandler );
    eRV Function_1087( tTime& AtTime );
    void Function_1088( TsmHandler& oHandler );
    eRV Function_1089( tChunk& NewChunk );
    void Function_1090( TsmHandler& oHandler );
    eRV Function_1091( tChunk& NewChunk );
    void Function_1092( TsmHandler& oHandler );
    eRV Function_1093();
    void Function_1094( TsmHandler& oHandler );
    eRV Function_1095();
    void Function_1096( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0980_1012()
    {
      delete TsmPI__Port;
      delete mPSMessager;
    }
  };

   // ( Xmi > Data > Architecture > ExEnv > TitlebaseMock )
  class Com_0798_0003 : public TsmPComponent
  {
  private:
    Cla_0980_1012* InsTitlebaseServer; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > InsTitlebaseServer )

  public:
    Com_0798_0003( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsTitlebaseServer = new Cla_0980_1012( this, "InsTitlebaseServer" );
      InsTitlebaseServer->IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = InsTitlebaseServer;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "pp_titlebase" )
      {
        return InsTitlebaseServer->GetProvidedInterface( "Port" );
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExEnv > TitlebaseMock )";
      throw TsmException( s );
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> InitialState )
  class Ini_0941_0942 : public TsmPseudo
  {
  public:
    Ini_0941_0942( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 979, "( DisplayServerPsm >> InitialState ) => ( DisplayServerPsm >> Active )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 979: // UP: ( DisplayServerPsm >> InitialState ) => ( DisplayServerPsm >> Active )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> InitialState )
  class Ini_0944_0945 : public TsmPseudo
  {
  public:
    Ini_0944_0945( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 962, "( DisplayServerPsm >> Active >> InitialState ) => ( DisplayServerPsm >> Active >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 962: // UP: ( DisplayServerPsm >> Active >> InitialState ) => ( DisplayServerPsm >> Active >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Busy >> Play )
  class Lea_0947_0948 : public TsmLeaf
  {
  public:
    Lea_0947_0948( TsmBase* oParent )
    {
      TsmName = "Play";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 951, "( DisplayServerPsm >> Active >> Busy >> Play ) => ( DisplayServerPsm >> Active >> Busy >> Pausing ) : Pause" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0947_0953( TsmHandler& oHandler );
    void Tra_0944_0967( TsmHandler& oHandler );
    void Port___Pause( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 939:
        switch ( Command )
        {
        case 51:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 953:
        Tra_0947_0953( oHandler );
        break;
      case 967:
        Tra_0944_0967( oHandler );
        break;
      case 951: // UP: ( DisplayServerPsm >> Active >> Busy >> Play ) => ( DisplayServerPsm >> Active >> Busy >> Pausing )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Busy >> Pausing )
  class Lea_0947_0949 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0947_0949( TsmBase* oParent )
    {
      TsmName = "Pausing";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 952, "( DisplayServerPsm >> Active >> Busy >> Pausing ) => ( DisplayServerPsm >> Active >> Paused )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0947_0951( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 952:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 952: // UP: ( DisplayServerPsm >> Active >> Busy >> Pausing ) => ( DisplayServerPsm >> Active >> Paused )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 951:
        Tra_0947_0951( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Busy >> Continuing )
  class Lea_0947_0950 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0947_0950( TsmBase* oParent )
    {
      TsmName = "Continuing";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 953, "( DisplayServerPsm >> Active >> Busy >> Continuing ) => ( DisplayServerPsm >> Active >> Busy >> Play )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0944_0972( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 953:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 953: // UP: ( DisplayServerPsm >> Active >> Busy >> Continuing ) => ( DisplayServerPsm >> Active >> Busy >> Play )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 972:
        Tra_0944_0972( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Busy >)
  class Reg_0946_0947 : public TsmRegion
  {
  private:
    Lea_0947_0948* oLea_0947_0948; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Busy >> Play )
    Lea_0947_0949* oLea_0947_0949; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Busy >> Pausing )
    Lea_0947_0950* oLea_0947_0950; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Busy >> Continuing )

  public:
    Reg_0946_0947( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oLea_0947_0948 = new Lea_0947_0948( this );
      oLea_0947_0949 = new Lea_0947_0949( this );
      oLea_0947_0950 = new Lea_0947_0950( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oLea_0947_0948;
      mStates[ 1 ] = oLea_0947_0949;
      mStates[ 2 ] = oLea_0947_0950;
    }

    void Tra_0947_0953( TsmHandler& oHandler );
    void Tra_0944_0967( TsmHandler& oHandler );
    void Tra_0947_0951( TsmHandler& oHandler );
    void Tra_0944_0972( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 952:
          return TsmProspect::OK;
        case 953:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 939:
        switch ( Command )
        {
        case 51:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 952: // Up: ( DisplayServerPsm >> Active >> Busy >> Pausing ) => ( DisplayServerPsm >> Active >> Paused )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 953:
        Tra_0947_0953( oHandler );
        break;
      case 967:
        Tra_0944_0967( oHandler );
        break;
      case 951:
        Tra_0947_0951( oHandler );
        break;
      case 972:
        Tra_0944_0972( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Busy )
  class Com_0944_0946 : public TsmCompound
  {
  private:
    static const int aNatives[2];
    Reg_0946_0947* oReg_0946_0947; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Busy >)

  public:
    Com_0944_0946( TsmBase* oParent )
    {
      TsmName = "Busy";
      TsmParent = oParent;
      oReg_0946_0947 = new Reg_0946_0947( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0946_0947;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 974, "( DisplayServerPsm >> Active >> Busy ) => ( DisplayServerPsm >> Active >> Synclost )" );
      mTransitions[ 1 ] = new TsmTransition( 975, "( DisplayServerPsm >> Active >> Busy ) => ( DisplayServerPsm >> Active >> Finishing )" );
    }

    void Tra_0944_0967( TsmHandler& oHandler );
    void Tra_0944_0972( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtMyExit( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 974:
          return TsmProspect::OK;
        case 975:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 974: // UP: ( DisplayServerPsm >> Active >> Busy ) => ( DisplayServerPsm >> Active >> Synclost )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 975: // UP: ( DisplayServerPsm >> Active >> Busy ) => ( DisplayServerPsm >> Active >> Finishing )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 952: // UP: ( DisplayServerPsm >> Active >> Busy >> Pausing ) => ( DisplayServerPsm >> Active >> Paused )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 967:
        Tra_0944_0967( oHandler );
        break;
      case 972:
        Tra_0944_0972( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Ready )
  class Lea_0944_0954 : public TsmLeaf
  {
  public:
    Lea_0944_0954( TsmBase* oParent )
    {
      TsmName = "Ready";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 963, "( DisplayServerPsm >> Active >> Ready ) => ( DisplayServerPsm >> Active >> Starting ) : Start" );
      mTransitions[ 1 ] = new TsmTransition( 964, "( DisplayServerPsm >> Active >> Ready ) => ( DisplayServerPsm >> Active >> StartPausing ) : Pause" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0944_0965( TsmHandler& oHandler );
    void Port___Start( TsmHandler& oHandler );
    void Port___Pause( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 939:
        switch ( Command )
        {
        case 50:
          return TsmProspect::OK;
        case 51:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 965:
        Tra_0944_0965( oHandler );
        break;
      case 963: // UP: ( DisplayServerPsm >> Active >> Ready ) => ( DisplayServerPsm >> Active >> Starting )
        bHigher = true;
        break;
      case 964: // UP: ( DisplayServerPsm >> Active >> Ready ) => ( DisplayServerPsm >> Active >> StartPausing )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Preparing )
  class Lea_0944_0955 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0944_0955( TsmBase* oParent )
    {
      TsmName = "Preparing";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 965, "( DisplayServerPsm >> Active >> Preparing ) => ( DisplayServerPsm >> Active >> Ready )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0944_0966( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 965:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 965: // UP: ( DisplayServerPsm >> Active >> Preparing ) => ( DisplayServerPsm >> Active >> Ready )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 966:
        Tra_0944_0966( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Idle )
  class Lea_0944_0956 : public TsmLeaf
  {
  public:
    Lea_0944_0956( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 966, "( DisplayServerPsm >> Active >> Idle ) => ( DisplayServerPsm >> Active >> Preparing ) : Prepare" );
    }

    void Tra_0944_0962( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___Prepare( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 939:
        switch ( Command )
        {
        case 49:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 962:
        Tra_0944_0962( oHandler );
        break;
      case 966: // UP: ( DisplayServerPsm >> Active >> Idle ) => ( DisplayServerPsm >> Active >> Preparing )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Starting )
  class Lea_0944_0957 : public TsmLeaf
  {
  private:
    static const int aNatives[2];

  public:
    Lea_0944_0957( TsmBase* oParent )
    {
      TsmName = "Starting";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 967, "( DisplayServerPsm >> Active >> Starting ) => ( DisplayServerPsm >> Active >> Busy >> Play )" );
      mTransitions[ 1 ] = new TsmTransition( 968, "( DisplayServerPsm >> Active >> Starting ) => ( DisplayServerPsm >> Active >> Synclost )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0944_0963( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 967:
          return TsmProspect::OK;
        case 968:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 967: // UP: ( DisplayServerPsm >> Active >> Starting ) => ( DisplayServerPsm >> Active >> Busy >> Play )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 968: // UP: ( DisplayServerPsm >> Active >> Starting ) => ( DisplayServerPsm >> Active >> Synclost )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 963:
        Tra_0944_0963( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Synclost )
  class Lea_0944_0958 : public TsmLeaf
  {
  public:
    Lea_0944_0958( TsmBase* oParent )
    {
      TsmName = "Synclost";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 969, "( DisplayServerPsm >> Active >> Synclost ) => ( DisplayServerPsm >> Active >> Synclost ) : Pause" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0944_0974( TsmHandler& oHandler );
    void Tra_0944_0968( TsmHandler& oHandler );
    void Tra_0944_0970( TsmHandler& oHandler );
    void Tra_0944_0969( TsmHandler& oHandler );
    void Port___Pause( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 939:
        switch ( Command )
        {
        case 51:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 974:
        Tra_0944_0974( oHandler );
        break;
      case 968:
        Tra_0944_0968( oHandler );
        break;
      case 970:
        Tra_0944_0970( oHandler );
        break;
      case 969:
        Tra_0944_0969( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> StartPausing )
  class Lea_0944_0959 : public TsmLeaf
  {
  private:
    static const int aNatives[2];

  public:
    Lea_0944_0959( TsmBase* oParent )
    {
      TsmName = "StartPausing";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 970, "( DisplayServerPsm >> Active >> StartPausing ) => ( DisplayServerPsm >> Active >> Synclost )" );
      mTransitions[ 1 ] = new TsmTransition( 971, "( DisplayServerPsm >> Active >> StartPausing ) => ( DisplayServerPsm >> Active >> Paused )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0944_0964( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 970:
          return TsmProspect::OK;
        case 971:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 970: // UP: ( DisplayServerPsm >> Active >> StartPausing ) => ( DisplayServerPsm >> Active >> Synclost )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 971: // UP: ( DisplayServerPsm >> Active >> StartPausing ) => ( DisplayServerPsm >> Active >> Paused )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 964:
        Tra_0944_0964( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Paused )
  class Lea_0944_0960 : public TsmLeaf
  {
  public:
    Lea_0944_0960( TsmBase* oParent )
    {
      TsmName = "Paused";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 972, "( DisplayServerPsm >> Active >> Paused ) => ( DisplayServerPsm >> Active >> Busy >> Continuing ) : Continue" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0947_0952( TsmHandler& oHandler );
    void Tra_0944_0971( TsmHandler& oHandler );
    void Port___Continue( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 939:
        switch ( Command )
        {
        case 52:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 952:
        Tra_0947_0952( oHandler );
        break;
      case 971:
        Tra_0944_0971( oHandler );
        break;
      case 972: // UP: ( DisplayServerPsm >> Active >> Paused ) => ( DisplayServerPsm >> Active >> Busy >> Continuing )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Finishing )
  class Lea_0944_0961 : public TsmLeaf
  {
  public:
    Lea_0944_0961( TsmBase* oParent )
    {
      TsmName = "Finishing";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 973, "( DisplayServerPsm >> Active >> Finishing ) => ( DisplayServerPsm >> Active >> Finishing ) : Pause" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0944_0975( TsmHandler& oHandler );
    void Tra_0944_0973( TsmHandler& oHandler );
    void Port___Pause( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 939:
        switch ( Command )
        {
        case 51:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 975:
        Tra_0944_0975( oHandler );
        break;
      case 973:
        Tra_0944_0973( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >)
  class Reg_0943_0944 : public TsmRegion
  {
  private:
    Ini_0944_0945* oIni_0944_0945; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> InitialState )
    Com_0944_0946* oCom_0944_0946; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Busy )
    Lea_0944_0954* oLea_0944_0954; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Ready )
    Lea_0944_0955* oLea_0944_0955; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Preparing )
    Lea_0944_0956* oLea_0944_0956; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Idle )
    Lea_0944_0957* oLea_0944_0957; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Starting )
    Lea_0944_0958* oLea_0944_0958; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Synclost )
    Lea_0944_0959* oLea_0944_0959; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> StartPausing )
    Lea_0944_0960* oLea_0944_0960; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Paused )
    Lea_0944_0961* oLea_0944_0961; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Finishing )

  public:
    Reg_0943_0944( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0944_0945 = new Ini_0944_0945( this );
      oCom_0944_0946 = new Com_0944_0946( this );
      oLea_0944_0954 = new Lea_0944_0954( this );
      oLea_0944_0955 = new Lea_0944_0955( this );
      oLea_0944_0956 = new Lea_0944_0956( this );
      oLea_0944_0957 = new Lea_0944_0957( this );
      oLea_0944_0958 = new Lea_0944_0958( this );
      oLea_0944_0959 = new Lea_0944_0959( this );
      oLea_0944_0960 = new Lea_0944_0960( this );
      oLea_0944_0961 = new Lea_0944_0961( this );
      mNrStates = 10;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0944_0945;
      mStates[ 1 ] = oCom_0944_0946;
      mStates[ 2 ] = oLea_0944_0954;
      mStates[ 3 ] = oLea_0944_0955;
      mStates[ 4 ] = oLea_0944_0956;
      mStates[ 5 ] = oLea_0944_0957;
      mStates[ 6 ] = oLea_0944_0958;
      mStates[ 7 ] = oLea_0944_0959;
      mStates[ 8 ] = oLea_0944_0960;
      mStates[ 9 ] = oLea_0944_0961;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0944_0962( TsmHandler& oHandler );
    void Tra_0944_0974( TsmHandler& oHandler );
    void Tra_0944_0975( TsmHandler& oHandler );
    void Tra_0947_0952( TsmHandler& oHandler );
    void Tra_0944_0965( TsmHandler& oHandler );
    void Tra_0944_0967( TsmHandler& oHandler );
    void Tra_0944_0968( TsmHandler& oHandler );
    void Tra_0944_0970( TsmHandler& oHandler );
    void Tra_0944_0971( TsmHandler& oHandler );
    void Tra_0944_0966( TsmHandler& oHandler );
    void Tra_0944_0963( TsmHandler& oHandler );
    void Tra_0944_0964( TsmHandler& oHandler );
    void Tra_0944_0972( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 974:
          return TsmProspect::OK;
        case 975:
          return TsmProspect::OK;
        case 952:
          return TsmProspect::OK;
        case 953:
          return TsmProspect::OK;
        case 965:
          return TsmProspect::OK;
        case 967:
          return TsmProspect::OK;
        case 968:
          return TsmProspect::OK;
        case 970:
          return TsmProspect::OK;
        case 971:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 939:
        switch ( Command )
        {
        case 49:
          return TsmProspect::OK;
        case 50:
          return TsmProspect::OK;
        case 51:
          return TsmProspect::OK;
        case 52:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 962:
        Tra_0944_0962( oHandler );
        break;
      case 974:
        Tra_0944_0974( oHandler );
        break;
      case 975:
        Tra_0944_0975( oHandler );
        break;
      case 952:
        Tra_0947_0952( oHandler );
        break;
      case 965:
        Tra_0944_0965( oHandler );
        break;
      case 967:
        Tra_0944_0967( oHandler );
        break;
      case 968:
        Tra_0944_0968( oHandler );
        break;
      case 970:
        Tra_0944_0970( oHandler );
        break;
      case 971:
        Tra_0944_0971( oHandler );
        break;
      case 966:
        Tra_0944_0966( oHandler );
        break;
      case 963:
        Tra_0944_0963( oHandler );
        break;
      case 964:
        Tra_0944_0964( oHandler );
        break;
      case 972:
        Tra_0944_0972( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active )
  class Com_0941_0943 : public TsmCompound
  {
  private:
    Reg_0943_0944* oReg_0943_0944; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >)

  public:
    Com_0941_0943( TsmBase* oParent )
    {
      TsmName = "Active";
      TsmParent = oParent;
      oReg_0943_0944 = new Reg_0943_0944( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0943_0944;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 977, "( DisplayServerPsm >> Active ) => ( DisplayServerPsm >> Stopping ) : Stop" );
    }

    void Tra_0941_0979( TsmHandler& oHandler );
    void Tra_0941_0978( TsmHandler& oHandler );
    void Port___Stop( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 939:
        switch ( Command )
        {
        case 53:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 979:
        Tra_0941_0979( oHandler );
        break;
      case 978:
        Tra_0941_0978( oHandler );
        break;
      case 977: // UP: ( DisplayServerPsm >> Active ) => ( DisplayServerPsm >> Stopping )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Stopping )
  class Lea_0941_0976 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0941_0976( TsmBase* oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 978, "( DisplayServerPsm >> Stopping ) => ( DisplayServerPsm >> Active )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0941_0977( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 978:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 978: // UP: ( DisplayServerPsm >> Stopping ) => ( DisplayServerPsm >> Active )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 977:
        Tra_0941_0977( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >)
  class Reg_0940_0941 : public TsmRegion
  {
  private:
    Ini_0941_0942* oIni_0941_0942; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> InitialState )
    Com_0941_0943* oCom_0941_0943; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active )
    Lea_0941_0976* oLea_0941_0976; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Stopping )

  public:
    Reg_0940_0941( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0941_0942 = new Ini_0941_0942( this );
      oCom_0941_0943 = new Com_0941_0943( this );
      oLea_0941_0976 = new Lea_0941_0976( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0941_0942;
      mStates[ 1 ] = oCom_0941_0943;
      mStates[ 2 ] = oLea_0941_0976;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0941_0979( TsmHandler& oHandler );
    void Tra_0941_0978( TsmHandler& oHandler );
    void Tra_0941_0977( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 974:
          return TsmProspect::OK;
        case 975:
          return TsmProspect::OK;
        case 952:
          return TsmProspect::OK;
        case 953:
          return TsmProspect::OK;
        case 965:
          return TsmProspect::OK;
        case 967:
          return TsmProspect::OK;
        case 968:
          return TsmProspect::OK;
        case 970:
          return TsmProspect::OK;
        case 971:
          return TsmProspect::OK;
        case 978:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 939:
        switch ( Command )
        {
        case 49:
          return TsmProspect::OK;
        case 50:
          return TsmProspect::OK;
        case 51:
          return TsmProspect::OK;
        case 52:
          return TsmProspect::OK;
        case 53:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 979:
        Tra_0941_0979( oHandler );
        break;
      case 978:
        Tra_0941_0978( oHandler );
        break;
      case 977:
        Tra_0941_0977( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm )
  class Fsm_0938_0940 : public TsmFsm
  {
  private:
    Reg_0940_0941* oReg_0940_0941; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >)

  public:
    Fsm_0938_0940( TsmBase* oParent )
    {
      TsmName = "DisplayServerPsm";
      TsmParent = oParent;
      oReg_0940_0941 = new Reg_0940_0941( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0940_0941;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer )
  class Cla_0888_0938 : public TsmProtocolClass
  {
  private:
    Fsm_0938_0940* oFsm_0938_0940; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm )
    TsmIPort_IDisplayServer* TsmPI__Port; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > Port )
    TsmIPort_IDisplayClient* Port; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > Port )
    TsmPSPort* mPSMessager;
    tTime BadTime;

  public:
    Cla_0888_0938( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0938_0940 = new Fsm_0938_0940( this );
      TsmPI__Port = new TsmIPort_IDisplayServer( this );
      mPSMessager = new TsmPSPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0938_0940;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "Port" )
      {
        return TsmPI__Port;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "Port" )
      {
        Port = static_cast<TsmIPort_IDisplayClient*>(oProvidedInterface);
        Port->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0938_0940->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    void Function_1171( TsmHandler& oHandler );
    void Function_1172( TsmHandler& oHandler );
    void Function_1173( TsmHandler& oHandler );
    void Function_1174( TsmHandler& oHandler );
    void Function_1175( TsmHandler& oHandler );
    void Function_1176( TsmHandler& oHandler );
    void Function_1177( TsmHandler& oHandler );
    void Function_1178( TsmHandler& oHandler );
    void Function_1179( TsmHandler& oHandler );
    void Function_1180( TsmHandler& oHandler );
    eRV Function_1321();
    void Function_1322( TsmHandler& oHandler );
    eRV Function_1323();
    void Function_1324( TsmHandler& oHandler );
    eRV Function_1325();
    void Function_1326( TsmHandler& oHandler );
    eRV Function_1327();
    void Function_1328( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0888_0938()
    {
      delete TsmPI__Port;
      delete mPSMessager;
    }
  };

   // ( Xmi > Data > Architecture > ExEnv > DisplayMock )
  class Com_0798_0005 : public TsmPComponent
  {
  private:
    Cla_0888_0938* InsDisplayServer; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > InsDisplayServer )

  public:
    Com_0798_0005( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsDisplayServer = new Cla_0888_0938( this, "InsDisplayServer" );
      InsDisplayServer->IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = InsDisplayServer;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "pp_display" )
      {
        return InsDisplayServer->GetProvidedInterface( "Port" );
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExEnv > DisplayMock )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "pp_display" )
      {
        InsDisplayServer->SetRequiredInterface( "Port", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExEnv > DisplayMock )";
      throw TsmException( s );
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> InitialState )
  class Ini_1085_1086 : public TsmPseudo
  {
  public:
    Ini_1085_1086( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1122, "( PlayerClientPsm >> InitialState ) => ( PlayerClientPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1122: // UP: ( PlayerClientPsm >> InitialState ) => ( PlayerClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> ChoiceState )
  class Cho_1085_1087 : public TsmPseudo
  {
  public:
    Cho_1085_1087( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 1126, "( PlayerClientPsm >> ChoiceState ) => ( PlayerClientPsm >> Active >> Starting )" );
      mTransitions[ 1 ] = new TsmTransition( 1127, "( PlayerClientPsm >> ChoiceState ) => ( PlayerClientPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_1085_1123( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1126: // UP: ( PlayerClientPsm >> ChoiceState ) => ( PlayerClientPsm >> Active >> Starting )
        bHigher = true;
        break;
      case 1127: // UP: ( PlayerClientPsm >> ChoiceState ) => ( PlayerClientPsm >> Idle )
        bHigher = true;
        break;
      case 1123:
        Tra_1085_1123( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )
  class Cho_1093_1094 : public TsmPseudo
  {
  public:
    Cho_1093_1094( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 1102, "( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Pausing )" );
      mTransitions[ 1 ] = new TsmTransition( 1103, "( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Play )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_1093_1100( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1102: // UP: ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Pausing )
        bHigher = true;
        break;
      case 1103: // UP: ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Play )
        bHigher = true;
        break;
      case 1100:
        Tra_1093_1100( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )
  class Cho_1093_1095 : public TsmPseudo
  {
  public:
    Cho_1093_1095( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 1104, "( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Continuing )" );
      mTransitions[ 1 ] = new TsmTransition( 1105, "( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Paused )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_1091_1108( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1104: // UP: ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Continuing )
        bHigher = true;
        break;
      case 1105: // UP: ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Paused )
        bHigher = true;
        break;
      case 1108:
        Tra_1091_1108( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy >> Pausing )
  class Lea_1093_1096 : public TsmLeaf
  {
  public:
    Lea_1093_1096( TsmBase* oParent )
    {
      TsmName = "Pausing";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1099, "( PlayerClientPsm >> Active >> Running >> Busy >> Pausing ) => ( PlayerClientPsm >> Active >> Running >> Paused ) : CbPaused" );
    }

    void Tra_1093_1102( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___CbPaused( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 1083:
        switch ( Command )
        {
        case 62:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1102:
        Tra_1093_1102( oHandler );
        break;
      case 1099: // UP: ( PlayerClientPsm >> Active >> Running >> Busy >> Pausing ) => ( PlayerClientPsm >> Active >> Running >> Paused )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy >> Play )
  class Lea_1093_1097 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_1093_1097( TsmBase* oParent )
    {
      TsmName = "Play";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1100, "( PlayerClientPsm >> Active >> Running >> Busy >> Play ) => ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )" );
    }

    void Tra_1093_1103( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_1089_1112( TsmHandler& oHandler );
    void Tra_1093_1101( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 1100:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1103:
        Tra_1093_1103( oHandler );
        break;
      case 1100: // UP: ( PlayerClientPsm >> Active >> Running >> Busy >> Play ) => ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 1112:
        Tra_1089_1112( oHandler );
        break;
      case 1101:
        Tra_1093_1101( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy >> Continuing )
  class Lea_1093_1098 : public TsmLeaf
  {
  public:
    Lea_1093_1098( TsmBase* oParent )
    {
      TsmName = "Continuing";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1101, "( PlayerClientPsm >> Active >> Running >> Busy >> Continuing ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Play ) : CbContinued" );
    }

    void Tra_1093_1104( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___CbContinued( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 1083:
        switch ( Command )
        {
        case 63:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1104:
        Tra_1093_1104( oHandler );
        break;
      case 1101: // UP: ( PlayerClientPsm >> Active >> Running >> Busy >> Continuing ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Play )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy >)
  class Reg_1092_1093 : public TsmRegion
  {
  private:
    Cho_1093_1094* oCho_1093_1094; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )
    Cho_1093_1095* oCho_1093_1095; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )
    Lea_1093_1096* oLea_1093_1096; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy >> Pausing )
    Lea_1093_1097* oLea_1093_1097; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy >> Play )
    Lea_1093_1098* oLea_1093_1098; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy >> Continuing )

  public:
    Reg_1092_1093( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oCho_1093_1094 = new Cho_1093_1094( this );
      oCho_1093_1095 = new Cho_1093_1095( this );
      oLea_1093_1096 = new Lea_1093_1096( this );
      oLea_1093_1097 = new Lea_1093_1097( this );
      oLea_1093_1098 = new Lea_1093_1098( this );
      mNrStates = 5;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oCho_1093_1094;
      mStates[ 1 ] = oCho_1093_1095;
      mStates[ 2 ] = oLea_1093_1096;
      mStates[ 3 ] = oLea_1093_1097;
      mStates[ 4 ] = oLea_1093_1098;
    }

    void Tra_1093_1102( TsmHandler& oHandler );
    void Tra_1093_1103( TsmHandler& oHandler );
    void Tra_1093_1104( TsmHandler& oHandler );
    void Tra_1093_1100( TsmHandler& oHandler );
    void Tra_1091_1108( TsmHandler& oHandler );
    void Tra_1089_1112( TsmHandler& oHandler );
    void Tra_1093_1101( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 1100:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 1083:
        switch ( Command )
        {
        case 62:
          return TsmProspect::OK;
        case 63:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1102:
        Tra_1093_1102( oHandler );
        break;
      case 1103:
        Tra_1093_1103( oHandler );
        break;
      case 1104:
        Tra_1093_1104( oHandler );
        break;
      case 1105: // Up: ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Paused )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 1100:
        Tra_1093_1100( oHandler );
        break;
      case 1108:
        Tra_1091_1108( oHandler );
        break;
      case 1112:
        Tra_1089_1112( oHandler );
        break;
      case 1099: // Up: ( PlayerClientPsm >> Active >> Running >> Busy >> Pausing ) => ( PlayerClientPsm >> Active >> Running >> Paused )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 1101:
        Tra_1093_1101( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy )
  class Com_1091_1092 : public TsmCompound
  {
  private:
    Reg_1092_1093* oReg_1092_1093; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy >)

  public:
    Com_1091_1092( TsmBase* oParent )
    {
      TsmName = "Busy";
      TsmParent = oParent;
      oReg_1092_1093 = new Reg_1092_1093( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_1092_1093;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1107, "( PlayerClientPsm >> Active >> Running >> Busy ) => ( PlayerClientPsm >> Active >> Finishing ) : CbFinish" );
    }

    void Tra_1091_1108( TsmHandler& oHandler );
    void Tra_1089_1112( TsmHandler& oHandler );
    void Port___CbFinish( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 1083:
        switch ( Command )
        {
        case 65:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1105: // UP: ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Paused )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 1108:
        Tra_1091_1108( oHandler );
        break;
      case 1112:
        Tra_1089_1112( oHandler );
        break;
      case 1099: // UP: ( PlayerClientPsm >> Active >> Running >> Busy >> Pausing ) => ( PlayerClientPsm >> Active >> Running >> Paused )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 1107: // UP: ( PlayerClientPsm >> Active >> Running >> Busy ) => ( PlayerClientPsm >> Active >> Finishing )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Paused )
  class Lea_1091_1106 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_1091_1106( TsmBase* oParent )
    {
      TsmName = "Paused";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1108, "( PlayerClientPsm >> Active >> Running >> Paused ) => ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )" );
    }

    void Tra_1093_1105( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_1093_1099( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 1108:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1105:
        Tra_1093_1105( oHandler );
        break;
      case 1108: // UP: ( PlayerClientPsm >> Active >> Running >> Paused ) => ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 1099:
        Tra_1093_1099( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >)
  class Reg_1090_1091 : public TsmRegion
  {
  private:
    Com_1091_1092* oCom_1091_1092; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy )
    Lea_1091_1106* oLea_1091_1106; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Paused )

  public:
    Reg_1090_1091( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oCom_1091_1092 = new Com_1091_1092( this );
      oLea_1091_1106 = new Lea_1091_1106( this );
      mNrStates = 2;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oCom_1091_1092;
      mStates[ 1 ] = oLea_1091_1106;
    }

    void Tra_1093_1105( TsmHandler& oHandler );
    void Tra_1091_1108( TsmHandler& oHandler );
    void Tra_1089_1112( TsmHandler& oHandler );
    void Tra_1093_1099( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 1100:
          return TsmProspect::OK;
        case 1108:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 1083:
        switch ( Command )
        {
        case 62:
          return TsmProspect::OK;
        case 63:
          return TsmProspect::OK;
        case 65:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1105:
        Tra_1093_1105( oHandler );
        break;
      case 1108:
        Tra_1091_1108( oHandler );
        break;
      case 1112:
        Tra_1089_1112( oHandler );
        break;
      case 1099:
        Tra_1093_1099( oHandler );
        break;
      case 1107: // Up: ( PlayerClientPsm >> Active >> Running >> Busy ) => ( PlayerClientPsm >> Active >> Finishing )
        mCurrentState = NULL;
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running )
  class Com_1089_1090 : public TsmCompound
  {
  private:
    Reg_1090_1091* oReg_1090_1091; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >)

  public:
    Com_1089_1090( TsmBase* oParent )
    {
      TsmName = "Running";
      TsmParent = oParent;
      oReg_1090_1091 = new Reg_1090_1091( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_1090_1091;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1113, "( PlayerClientPsm >> Active >> Running ) => ( PlayerClientPsm >> Active >> Error ) : CbError" );
    }

    void Tra_1089_1112( TsmHandler& oHandler );
    void Port___CbError( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 1083:
        switch ( Command )
        {
        case 66:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1112:
        Tra_1089_1112( oHandler );
        break;
      case 1107: // UP: ( PlayerClientPsm >> Active >> Running >> Busy ) => ( PlayerClientPsm >> Active >> Finishing )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 1113: // UP: ( PlayerClientPsm >> Active >> Running ) => ( PlayerClientPsm >> Active >> Error )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Finishing )
  class Lea_1089_1109 : public TsmLeaf
  {
  public:
    Lea_1089_1109( TsmBase* oParent )
    {
      TsmName = "Finishing";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_1091_1107( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1107:
        Tra_1091_1107( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Starting )
  class Lea_1089_1110 : public TsmLeaf
  {
  public:
    Lea_1089_1110( TsmBase* oParent )
    {
      TsmName = "Starting";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 1112, "( PlayerClientPsm >> Active >> Starting ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Play ) : CbStarted" );
      mTransitions[ 1 ] = new TsmTransition( 1114, "( PlayerClientPsm >> Active >> Starting ) => ( PlayerClientPsm >> Active >> Error ) : CbError" );
    }

    void Tra_1085_1126( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___CbStarted( TsmHandler& oHandler );
    void Port___CbError( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 1083:
        switch ( Command )
        {
        case 61:
          return TsmProspect::OK;
        case 66:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1126:
        Tra_1085_1126( oHandler );
        break;
      case 1112: // UP: ( PlayerClientPsm >> Active >> Starting ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Play )
        bHigher = true;
        break;
      case 1114: // UP: ( PlayerClientPsm >> Active >> Starting ) => ( PlayerClientPsm >> Active >> Error )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Error )
  class Lea_1089_1111 : public TsmLeaf
  {
  public:
    Lea_1089_1111( TsmBase* oParent )
    {
      TsmName = "Error";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_1089_1113( TsmHandler& oHandler );
    void Tra_1089_1114( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1113:
        Tra_1089_1113( oHandler );
        break;
      case 1114:
        Tra_1089_1114( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >)
  class Reg_1088_1089 : public TsmRegion
  {
  private:
    Com_1089_1090* oCom_1089_1090; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running )
    Lea_1089_1109* oLea_1089_1109; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Finishing )
    Lea_1089_1110* oLea_1089_1110; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Starting )
    Lea_1089_1111* oLea_1089_1111; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Error )

  public:
    Reg_1088_1089( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oCom_1089_1090 = new Com_1089_1090( this );
      oLea_1089_1109 = new Lea_1089_1109( this );
      oLea_1089_1110 = new Lea_1089_1110( this );
      oLea_1089_1111 = new Lea_1089_1111( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oCom_1089_1090;
      mStates[ 1 ] = oLea_1089_1109;
      mStates[ 2 ] = oLea_1089_1110;
      mStates[ 3 ] = oLea_1089_1111;
    }

    void Tra_1085_1126( TsmHandler& oHandler );
    void Tra_1089_1112( TsmHandler& oHandler );
    void Tra_1091_1107( TsmHandler& oHandler );
    void Tra_1089_1113( TsmHandler& oHandler );
    void Tra_1089_1114( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 1100:
          return TsmProspect::OK;
        case 1108:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 1083:
        switch ( Command )
        {
        case 61:
          return TsmProspect::OK;
        case 62:
          return TsmProspect::OK;
        case 63:
          return TsmProspect::OK;
        case 65:
          return TsmProspect::OK;
        case 66:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1126:
        Tra_1085_1126( oHandler );
        break;
      case 1112:
        Tra_1089_1112( oHandler );
        break;
      case 1107:
        Tra_1091_1107( oHandler );
        break;
      case 1113:
        Tra_1089_1113( oHandler );
        break;
      case 1114:
        Tra_1089_1114( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active )
  class Com_1085_1088 : public TsmCompound
  {
  private:
    static const int aNatives[1];
    Reg_1088_1089* oReg_1088_1089; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >)

  public:
    Com_1085_1088( TsmBase* oParent )
    {
      TsmName = "Active";
      TsmParent = oParent;
      oReg_1088_1089 = new Reg_1088_1089( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_1088_1089;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1124, "( PlayerClientPsm >> Active ) => ( PlayerClientPsm >> Stopping )" );
    }

    void Tra_1085_1126( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtMyExit( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 1124:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1126:
        Tra_1085_1126( oHandler );
        break;
      case 1124: // UP: ( PlayerClientPsm >> Active ) => ( PlayerClientPsm >> Stopping )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Idle )
  class Lea_1085_1115 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_1085_1115( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1123, "( PlayerClientPsm >> Idle ) => ( PlayerClientPsm >> ChoiceState )" );
    }

    void Tra_1085_1122( TsmHandler& oHandler );
    void Tra_1085_1127( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_1085_1125( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 1123:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1122:
        Tra_1085_1122( oHandler );
        break;
      case 1127:
        Tra_1085_1127( oHandler );
        break;
      case 1123: // UP: ( PlayerClientPsm >> Idle ) => ( PlayerClientPsm >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 1125:
        Tra_1085_1125( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Stopping )
  class Lea_1085_1116 : public TsmLeaf
  {
  public:
    Lea_1085_1116( TsmBase* oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      mNrTransitions = 6;
      mTransitions = new TsmTransition*[ 6 ];
      mTransitions[ 0 ] = new TsmTransition( 1117, "( PlayerClientPsm >> Stopping ) => ( PlayerClientPsm >> Stopping ) : CbStarted" );
      mTransitions[ 1 ] = new TsmTransition( 1119, "( PlayerClientPsm >> Stopping ) => ( PlayerClientPsm >> Stopping ) : CbPaused" );
      mTransitions[ 2 ] = new TsmTransition( 1120, "( PlayerClientPsm >> Stopping ) => ( PlayerClientPsm >> Stopping ) : CbContinued" );
      mTransitions[ 3 ] = new TsmTransition( 1125, "( PlayerClientPsm >> Stopping ) => ( PlayerClientPsm >> Idle ) : CbStopped" );
      mTransitions[ 4 ] = new TsmTransition( 1121, "( PlayerClientPsm >> Stopping ) => ( PlayerClientPsm >> Stopping ) : CbFinish" );
      mTransitions[ 5 ] = new TsmTransition( 1118, "( PlayerClientPsm >> Stopping ) => ( PlayerClientPsm >> Stopping ) : CbError" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_1085_1124( TsmHandler& oHandler );
    void Tra_1085_1117( TsmHandler& oHandler );
    void Port___CbStarted( TsmHandler& oHandler );
    void Tra_1085_1119( TsmHandler& oHandler );
    void Port___CbPaused( TsmHandler& oHandler );
    void Tra_1085_1120( TsmHandler& oHandler );
    void Port___CbContinued( TsmHandler& oHandler );
    void Port___CbStopped( TsmHandler& oHandler );
    void Tra_1085_1121( TsmHandler& oHandler );
    void Port___CbFinish( TsmHandler& oHandler );
    void Tra_1085_1118( TsmHandler& oHandler );
    void Port___CbError( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 1083:
        switch ( Command )
        {
        case 61:
          return TsmProspect::OK;
        case 62:
          return TsmProspect::OK;
        case 63:
          return TsmProspect::OK;
        case 64:
          return TsmProspect::OK;
        case 65:
          return TsmProspect::OK;
        case 66:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1124:
        Tra_1085_1124( oHandler );
        break;
      case 1117:
        Tra_1085_1117( oHandler );
        break;
      case 1119:
        Tra_1085_1119( oHandler );
        break;
      case 1120:
        Tra_1085_1120( oHandler );
        break;
      case 1125: // UP: ( PlayerClientPsm >> Stopping ) => ( PlayerClientPsm >> Idle )
        bHigher = true;
        break;
      case 1121:
        Tra_1085_1121( oHandler );
        break;
      case 1118:
        Tra_1085_1118( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >)
  class Reg_1084_1085 : public TsmRegion
  {
  private:
    Ini_1085_1086* oIni_1085_1086; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> InitialState )
    Cho_1085_1087* oCho_1085_1087; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> ChoiceState )
    Com_1085_1088* oCom_1085_1088; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active )
    Lea_1085_1115* oLea_1085_1115; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Idle )
    Lea_1085_1116* oLea_1085_1116; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Stopping )

  public:
    Reg_1084_1085( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_1085_1086 = new Ini_1085_1086( this );
      oCho_1085_1087 = new Cho_1085_1087( this );
      oCom_1085_1088 = new Com_1085_1088( this );
      oLea_1085_1115 = new Lea_1085_1115( this );
      oLea_1085_1116 = new Lea_1085_1116( this );
      mNrStates = 5;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_1085_1086;
      mStates[ 1 ] = oCho_1085_1087;
      mStates[ 2 ] = oCom_1085_1088;
      mStates[ 3 ] = oLea_1085_1115;
      mStates[ 4 ] = oLea_1085_1116;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_1085_1122( TsmHandler& oHandler );
    void Tra_1085_1126( TsmHandler& oHandler );
    void Tra_1085_1127( TsmHandler& oHandler );
    void Tra_1085_1124( TsmHandler& oHandler );
    void Tra_1085_1123( TsmHandler& oHandler );
    void Tra_1085_1125( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 1124:
          return TsmProspect::OK;
        case 1100:
          return TsmProspect::OK;
        case 1108:
          return TsmProspect::OK;
        case 1123:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 1083:
        switch ( Command )
        {
        case 61:
          return TsmProspect::OK;
        case 62:
          return TsmProspect::OK;
        case 63:
          return TsmProspect::OK;
        case 64:
          return TsmProspect::OK;
        case 65:
          return TsmProspect::OK;
        case 66:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1122:
        Tra_1085_1122( oHandler );
        break;
      case 1126:
        Tra_1085_1126( oHandler );
        break;
      case 1127:
        Tra_1085_1127( oHandler );
        break;
      case 1124:
        Tra_1085_1124( oHandler );
        break;
      case 1123:
        Tra_1085_1123( oHandler );
        break;
      case 1125:
        Tra_1085_1125( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm )
  class Fsm_1082_1084 : public TsmFsm
  {
  private:
    Reg_1084_1085* oReg_1084_1085; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >)

  public:
    Fsm_1082_1084( TsmBase* oParent )
    {
      TsmName = "PlayerClientPsm";
      TsmParent = oParent;
      oReg_1084_1085 = new Reg_1084_1085( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_1084_1085;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient )
  class Cla_1043_1082 : public TsmProtocolClass
  {
  private:
    Fsm_1082_1084* oFsm_1082_1084; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm )
    TsmIPort_IPlayerServer* Port; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > Port )
    TsmIPort_IPlayerClient* TsmPI__Port; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > Port )
    TsmPCPort* mPCMessager;
    eRV RV;
    string TitleId;
    tTime AtTime;

  public:
    Cla_1043_1082( TsmBase* oParent, string sInstanceName ) : RV(OK)
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_1082_1084 = new Fsm_1082_1084( this );
      TsmPI__Port = new TsmIPort_IPlayerClient( this );
      mPCMessager = new TsmPCPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_1082_1084;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "Port" )
      {
        return TsmPI__Port;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "Port" )
      {
        Port = static_cast<TsmIPort_IPlayerServer*>(oProvidedInterface);
        Port->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_1082_1084->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    bool Guard_1101();
    bool Guard_1102();
    bool Guard_1103();
    void Function_1195( TsmHandler& oHandler );
    void Function_1196( TsmHandler& oHandler );
    void Function_1197( TsmHandler& oHandler );
    void Function_1198( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_1043_1082()
    {
      delete TsmPI__Port;
      delete mPCMessager;
    }
  };

   // ( Xmi > Data > Architecture > ExEnv > UserMock )
  class Com_0798_0007 : public TsmPComponent
  {
  private:
    Cla_1043_1082* InsPlayerClient; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > InsPlayerClient )

  public:
    Com_0798_0007( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsPlayerClient = new Cla_1043_1082( this, "InsPlayerClient" );
      InsPlayerClient->IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = InsPlayerClient;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "rp_player" )
      {
        return InsPlayerClient->GetProvidedInterface( "Port" );
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExEnv > UserMock )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "rp_player" )
      {
        InsPlayerClient->SetRequiredInterface( "Port", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExEnv > UserMock )";
      throw TsmException( s );
    }
  };

   // ( Xmi > Data > Architecture > ExEnv )
  class Com_0797_0798 : public TsmPComponent
  {
  private:
    Com_0016_0017* Player; // ( Xmi > Data > Architecture > ExEnv > Player )
    Com_0798_0001* ReaderMock; // ( Xmi > Data > Architecture > ExEnv > ReaderMock )
    Com_0798_0003* TitlebaseMock; // ( Xmi > Data > Architecture > ExEnv > TitlebaseMock )
    Com_0798_0005* DisplayMock; // ( Xmi > Data > Architecture > ExEnv > DisplayMock )
    Com_0798_0007* UserMock; // ( Xmi > Data > Architecture > ExEnv > UserMock )

  public:
    Com_0797_0798( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      Player = new Com_0016_0017( this, "Player" );
      ReaderMock = new Com_0798_0001( this, "ReaderMock" );
      TitlebaseMock = new Com_0798_0003( this, "TitlebaseMock" );
      DisplayMock = new Com_0798_0005( this, "DisplayMock" );
      UserMock = new Com_0798_0007( this, "UserMock" );
      mNrComponents = 5;
      mComponents = new TsmComponent*[ 5 ];
      mComponents[ 0 ] = Player;
      mComponents[ 1 ] = ReaderMock;
      mComponents[ 2 ] = TitlebaseMock;
      mComponents[ 3 ] = DisplayMock;
      mComponents[ 4 ] = UserMock;
    }

    void TsmConnect( void* oObject );
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Architecture > Sequence Diagrams )
   ********************************************************************/

   // ( Xmi > Data > Architecture > Sequence Diagrams )
  class Pac_0797_0804 : public TsmPackage
  {
  public:
    Pac_0797_0804( TsmBase* oParent )
    {
      TsmName = "Sequence Diagrams";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Architecture )
   ********************************************************************/

   // ( Xmi > Data > Architecture )
  class Pac_0006_0797 : public TsmPackage
  {
  public:
    Pac_0006_0797( TsmBase* oParent )
    {
      TsmName = "Architecture";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> InitialState )
  class Ini_0810_0811 : public TsmPseudo
  {
  public:
    Ini_0810_0811( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 837, "( ReaderClientPsm >> InitialState ) => ( ReaderClientPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 837: // UP: ( ReaderClientPsm >> InitialState ) => ( ReaderClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> ChoiceState )
  class Cho_0810_0812 : public TsmPseudo
  {
  public:
    Cho_0810_0812( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 843, "( ReaderClientPsm >> ChoiceState ) => ( ReaderClientPsm >> Opening )" );
      mTransitions[ 1 ] = new TsmTransition( 844, "( ReaderClientPsm >> ChoiceState ) => ( ReaderClientPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0810_0842( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 843: // UP: ( ReaderClientPsm >> ChoiceState ) => ( ReaderClientPsm >> Opening )
        bHigher = true;
        break;
      case 844: // UP: ( ReaderClientPsm >> ChoiceState ) => ( ReaderClientPsm >> Idle )
        bHigher = true;
        break;
      case 842:
        Tra_0810_0842( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> ChoiceState )
  class Cho_0814_0815 : public TsmPseudo
  {
  public:
    Cho_0814_0815( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 830, "( ReaderClientPsm >> CompoundState >> ChoiceState ) => ( ReaderClientPsm >> Seeking )" );
      mTransitions[ 1 ] = new TsmTransition( 831, "( ReaderClientPsm >> CompoundState >> ChoiceState ) => ( ReaderClientPsm >> CompoundState >> Error )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0814_0829( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 830: // UP: ( ReaderClientPsm >> CompoundState >> ChoiceState ) => ( ReaderClientPsm >> Seeking )
        bHigher = true;
        break;
      case 831: // UP: ( ReaderClientPsm >> CompoundState >> ChoiceState ) => ( ReaderClientPsm >> CompoundState >> Error )
        bHigher = true;
        break;
      case 829:
        Tra_0814_0829( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Reading >> InitialState )
  class Ini_0817_0818 : public TsmPseudo
  {
  public:
    Ini_0817_0818( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 821, "( ReaderClientPsm >> CompoundState >> Reading >> InitialState ) => ( ReaderClientPsm >> CompoundState >> Reading >> NotEnough )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 821: // UP: ( ReaderClientPsm >> CompoundState >> Reading >> InitialState ) => ( ReaderClientPsm >> CompoundState >> Reading >> NotEnough )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Reading >> Enough )
  class Lea_0817_0819 : public TsmLeaf
  {
  public:
    Lea_0817_0819( TsmBase* oParent )
    {
      TsmName = "Enough";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 827, "( ReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ReaderClientPsm >> CompoundState >> Open ) : CbDone" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___CbDone( TsmHandler& oHandler );
    void Tra_0817_0822( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 808:
        switch ( Command )
        {
        case 3:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 827: // UP: ( ReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ReaderClientPsm >> CompoundState >> Open )
        bHigher = true;
        break;
      case 822:
        Tra_0817_0822( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Reading >> NotEnough )
  class Lea_0817_0820 : public TsmLeaf
  {
  public:
    Lea_0817_0820( TsmBase* oParent )
    {
      TsmName = "NotEnough";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 822, "( ReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ReaderClientPsm >> CompoundState >> Reading >> Enough ) : CbFilled" );
    }

    void Tra_0817_0821( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___CbFilled( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 808:
        switch ( Command )
        {
        case 7:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 821:
        Tra_0817_0821( oHandler );
        break;
      case 822: // UP: ( ReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ReaderClientPsm >> CompoundState >> Reading >> Enough )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Reading >)
  class Reg_0816_0817 : public TsmRegion
  {
  private:
    Ini_0817_0818* oIni_0817_0818; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Reading >> InitialState )
    Lea_0817_0819* oLea_0817_0819; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Reading >> Enough )
    Lea_0817_0820* oLea_0817_0820; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Reading >> NotEnough )

  public:
    Reg_0816_0817( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0817_0818 = new Ini_0817_0818( this );
      oLea_0817_0819 = new Lea_0817_0819( this );
      oLea_0817_0820 = new Lea_0817_0820( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0817_0818;
      mStates[ 1 ] = oLea_0817_0819;
      mStates[ 2 ] = oLea_0817_0820;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0817_0821( TsmHandler& oHandler );
    void Tra_0817_0822( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 808:
        switch ( Command )
        {
        case 3:
          return TsmProspect::OK;
        case 7:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 821:
        Tra_0817_0821( oHandler );
        break;
      case 827: // Up: ( ReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ReaderClientPsm >> CompoundState >> Open )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 822:
        Tra_0817_0822( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Reading )
  class Com_0814_0816 : public TsmCompound
  {
  private:
    Reg_0816_0817* oReg_0816_0817; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Reading >)

  public:
    Com_0814_0816( TsmBase* oParent )
    {
      TsmName = "Reading";
      TsmParent = oParent;
      oReg_0816_0817 = new Reg_0816_0817( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0816_0817;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 828, "( ReaderClientPsm >> CompoundState >> Reading ) => ( ReaderClientPsm >> CompoundState >> Error ) : CbError" );
    }

    void Port___CbError( int Sector, TsmHandler& oHandler );
    void Tra_0810_0848( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 808:
        switch ( Command )
        {
        case 4:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 827: // UP: ( ReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ReaderClientPsm >> CompoundState >> Open )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 828: // UP: ( ReaderClientPsm >> CompoundState >> Reading ) => ( ReaderClientPsm >> CompoundState >> Error )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 848:
        Tra_0810_0848( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Open )
  class Lea_0814_0823 : public TsmLeaf
  {
  private:
    static const int aNatives[3];

  public:
    Lea_0814_0823( TsmBase* oParent )
    {
      TsmName = "Open";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 825, "( ReaderClientPsm >> CompoundState >> Open ) => ( ReaderClientPsm >> CompoundState >> Open )" );
      mTransitions[ 1 ] = new TsmTransition( 826, "( ReaderClientPsm >> CompoundState >> Open ) => ( ReaderClientPsm >> Closing )" );
      mTransitions[ 2 ] = new TsmTransition( 829, "( ReaderClientPsm >> CompoundState >> Open ) => ( ReaderClientPsm >> CompoundState >> ChoiceState )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0814_0825( TsmHandler& oHandler );
    void Tra_0810_0838( TsmHandler& oHandler );
    void Tra_0810_0840( TsmHandler& oHandler );
    void Tra_0814_0827( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 825:
          return TsmProspect::OK;
        case 826:
          return TsmProspect::OK;
        case 829:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 825:
        Tra_0814_0825( oHandler );
        break;
      case 826: // UP: ( ReaderClientPsm >> CompoundState >> Open ) => ( ReaderClientPsm >> Closing )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 829: // UP: ( ReaderClientPsm >> CompoundState >> Open ) => ( ReaderClientPsm >> CompoundState >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 838:
        Tra_0810_0838( oHandler );
        break;
      case 840:
        Tra_0810_0840( oHandler );
        break;
      case 827:
        Tra_0814_0827( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Error )
  class Lea_0814_0824 : public TsmLeaf
  {
  public:
    Lea_0814_0824( TsmBase* oParent )
    {
      TsmName = "Error";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Tra_0814_0831( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0814_0828( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 831:
        Tra_0814_0831( oHandler );
        break;
      case 828:
        Tra_0814_0828( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >)
  class Reg_0813_0814 : public TsmRegion
  {
  private:
    Cho_0814_0815* oCho_0814_0815; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> ChoiceState )
    Com_0814_0816* oCom_0814_0816; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Reading )
    Lea_0814_0823* oLea_0814_0823; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Open )
    Lea_0814_0824* oLea_0814_0824; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Error )

  public:
    Reg_0813_0814( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oCho_0814_0815 = new Cho_0814_0815( this );
      oCom_0814_0816 = new Com_0814_0816( this );
      oLea_0814_0823 = new Lea_0814_0823( this );
      oLea_0814_0824 = new Lea_0814_0824( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oCho_0814_0815;
      mStates[ 1 ] = oCom_0814_0816;
      mStates[ 2 ] = oLea_0814_0823;
      mStates[ 3 ] = oLea_0814_0824;
    }

    void Tra_0814_0831( TsmHandler& oHandler );
    void Tra_0814_0829( TsmHandler& oHandler );
    void Tra_0810_0838( TsmHandler& oHandler );
    void Tra_0810_0840( TsmHandler& oHandler );
    void Tra_0814_0827( TsmHandler& oHandler );
    void Tra_0814_0828( TsmHandler& oHandler );
    void Tra_0810_0848( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 825:
          return TsmProspect::OK;
        case 826:
          return TsmProspect::OK;
        case 829:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 808:
        switch ( Command )
        {
        case 3:
          return TsmProspect::OK;
        case 4:
          return TsmProspect::OK;
        case 7:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 830: // Up: ( ReaderClientPsm >> CompoundState >> ChoiceState ) => ( ReaderClientPsm >> Seeking )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 831:
        Tra_0814_0831( oHandler );
        break;
      case 826: // Up: ( ReaderClientPsm >> CompoundState >> Open ) => ( ReaderClientPsm >> Closing )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 829:
        Tra_0814_0829( oHandler );
        break;
      case 838:
        Tra_0810_0838( oHandler );
        break;
      case 840:
        Tra_0810_0840( oHandler );
        break;
      case 827:
        Tra_0814_0827( oHandler );
        break;
      case 828:
        Tra_0814_0828( oHandler );
        break;
      case 848:
        Tra_0810_0848( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState )
  class Com_0810_0813 : public TsmCompound
  {
  private:
    static const int aNatives[1];
    Reg_0813_0814* oReg_0813_0814; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >)

  public:
    Com_0810_0813( TsmBase* oParent )
    {
      TsmName = "CS_813";
      TsmParent = oParent;
      oReg_0813_0814 = new Reg_0813_0814( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0813_0814;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 839, "( ReaderClientPsm >> CompoundState ) => ( ReaderClientPsm >> Stopping )" );
    }

    void Tra_0810_0838( TsmHandler& oHandler );
    void Tra_0810_0840( TsmHandler& oHandler );
    void Tra_0810_0848( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtMyExit( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 839:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 830: // UP: ( ReaderClientPsm >> CompoundState >> ChoiceState ) => ( ReaderClientPsm >> Seeking )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 839: // UP: ( ReaderClientPsm >> CompoundState ) => ( ReaderClientPsm >> Stopping )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 826: // UP: ( ReaderClientPsm >> CompoundState >> Open ) => ( ReaderClientPsm >> Closing )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 838:
        Tra_0810_0838( oHandler );
        break;
      case 840:
        Tra_0810_0840( oHandler );
        break;
      case 848:
        Tra_0810_0848( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> Idle )
  class Lea_0810_0832 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0810_0832( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 842, "( ReaderClientPsm >> Idle ) => ( ReaderClientPsm >> ChoiceState )" );
    }

    void Tra_0810_0837( TsmHandler& oHandler );
    void Tra_0810_0844( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0810_0841( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 842:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 837:
        Tra_0810_0837( oHandler );
        break;
      case 844:
        Tra_0810_0844( oHandler );
        break;
      case 842: // UP: ( ReaderClientPsm >> Idle ) => ( ReaderClientPsm >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 841:
        Tra_0810_0841( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> Opening )
  class Lea_0810_0833 : public TsmLeaf
  {
  public:
    Lea_0810_0833( TsmBase* oParent )
    {
      TsmName = "Opening";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 838, "( ReaderClientPsm >> Opening ) => ( ReaderClientPsm >> CompoundState >> Open ) : CbOpened" );
    }

    void Tra_0810_0843( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___CbOpened( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 808:
        switch ( Command )
        {
        case 1:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 843:
        Tra_0810_0843( oHandler );
        break;
      case 838: // UP: ( ReaderClientPsm >> Opening ) => ( ReaderClientPsm >> CompoundState >> Open )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> Seeking )
  class Lea_0810_0834 : public TsmLeaf
  {
  public:
    Lea_0810_0834( TsmBase* oParent )
    {
      TsmName = "Seeking";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 848, "( ReaderClientPsm >> Seeking ) => ( ReaderClientPsm >> CompoundState >> Reading ) : CbReading" );
    }

    void Tra_0814_0830( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___CbReading( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 808:
        switch ( Command )
        {
        case 6:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 830:
        Tra_0814_0830( oHandler );
        break;
      case 848: // UP: ( ReaderClientPsm >> Seeking ) => ( ReaderClientPsm >> CompoundState >> Reading )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> Stopping )
  class Lea_0810_0835 : public TsmLeaf
  {
  public:
    Lea_0810_0835( TsmBase* oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      mNrTransitions = 4;
      mTransitions = new TsmTransition*[ 4 ];
      mTransitions[ 0 ] = new TsmTransition( 840, "( ReaderClientPsm >> Stopping ) => ( ReaderClientPsm >> CompoundState >> Open ) : CbStopped" );
      mTransitions[ 1 ] = new TsmTransition( 847, "( ReaderClientPsm >> Stopping ) => ( ReaderClientPsm >> Stopping ) : CbDone" );
      mTransitions[ 2 ] = new TsmTransition( 845, "( ReaderClientPsm >> Stopping ) => ( ReaderClientPsm >> Stopping ) : CbError" );
      mTransitions[ 3 ] = new TsmTransition( 846, "( ReaderClientPsm >> Stopping ) => ( ReaderClientPsm >> Stopping ) : CbFilled" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0810_0839( TsmHandler& oHandler );
    void Port___CbStopped( TsmHandler& oHandler );
    void Tra_0810_0847( TsmHandler& oHandler );
    void Port___CbDone( TsmHandler& oHandler );
    void Tra_0810_0845( TsmHandler& oHandler );
    void Port___CbError( int Sector, TsmHandler& oHandler );
    void Tra_0810_0846( TsmHandler& oHandler );
    void Port___CbFilled( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 808:
        switch ( Command )
        {
        case 2:
          return TsmProspect::OK;
        case 3:
          return TsmProspect::OK;
        case 4:
          return TsmProspect::OK;
        case 7:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 839:
        Tra_0810_0839( oHandler );
        break;
      case 840: // UP: ( ReaderClientPsm >> Stopping ) => ( ReaderClientPsm >> CompoundState >> Open )
        bHigher = true;
        break;
      case 847:
        Tra_0810_0847( oHandler );
        break;
      case 845:
        Tra_0810_0845( oHandler );
        break;
      case 846:
        Tra_0810_0846( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> Closing )
  class Lea_0810_0836 : public TsmLeaf
  {
  public:
    Lea_0810_0836( TsmBase* oParent )
    {
      TsmName = "Closing";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 841, "( ReaderClientPsm >> Closing ) => ( ReaderClientPsm >> Idle ) : CbClosed" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0814_0826( TsmHandler& oHandler );
    void Port___CbClosed( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 808:
        switch ( Command )
        {
        case 5:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 826:
        Tra_0814_0826( oHandler );
        break;
      case 841: // UP: ( ReaderClientPsm >> Closing ) => ( ReaderClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >)
  class Reg_0809_0810 : public TsmRegion
  {
  private:
    Ini_0810_0811* oIni_0810_0811; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> InitialState )
    Cho_0810_0812* oCho_0810_0812; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> ChoiceState )
    Com_0810_0813* oCom_0810_0813; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState )
    Lea_0810_0832* oLea_0810_0832; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> Idle )
    Lea_0810_0833* oLea_0810_0833; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> Opening )
    Lea_0810_0834* oLea_0810_0834; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> Seeking )
    Lea_0810_0835* oLea_0810_0835; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> Stopping )
    Lea_0810_0836* oLea_0810_0836; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> Closing )

  public:
    Reg_0809_0810( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0810_0811 = new Ini_0810_0811( this );
      oCho_0810_0812 = new Cho_0810_0812( this );
      oCom_0810_0813 = new Com_0810_0813( this );
      oLea_0810_0832 = new Lea_0810_0832( this );
      oLea_0810_0833 = new Lea_0810_0833( this );
      oLea_0810_0834 = new Lea_0810_0834( this );
      oLea_0810_0835 = new Lea_0810_0835( this );
      oLea_0810_0836 = new Lea_0810_0836( this );
      mNrStates = 8;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0810_0811;
      mStates[ 1 ] = oCho_0810_0812;
      mStates[ 2 ] = oCom_0810_0813;
      mStates[ 3 ] = oLea_0810_0832;
      mStates[ 4 ] = oLea_0810_0833;
      mStates[ 5 ] = oLea_0810_0834;
      mStates[ 6 ] = oLea_0810_0835;
      mStates[ 7 ] = oLea_0810_0836;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0810_0837( TsmHandler& oHandler );
    void Tra_0810_0843( TsmHandler& oHandler );
    void Tra_0810_0844( TsmHandler& oHandler );
    void Tra_0814_0830( TsmHandler& oHandler );
    void Tra_0810_0839( TsmHandler& oHandler );
    void Tra_0814_0826( TsmHandler& oHandler );
    void Tra_0810_0842( TsmHandler& oHandler );
    void Tra_0810_0838( TsmHandler& oHandler );
    void Tra_0810_0840( TsmHandler& oHandler );
    void Tra_0810_0841( TsmHandler& oHandler );
    void Tra_0810_0848( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 839:
          return TsmProspect::OK;
        case 825:
          return TsmProspect::OK;
        case 826:
          return TsmProspect::OK;
        case 829:
          return TsmProspect::OK;
        case 842:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 808:
        switch ( Command )
        {
        case 1:
          return TsmProspect::OK;
        case 2:
          return TsmProspect::OK;
        case 3:
          return TsmProspect::OK;
        case 4:
          return TsmProspect::OK;
        case 5:
          return TsmProspect::OK;
        case 6:
          return TsmProspect::OK;
        case 7:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 837:
        Tra_0810_0837( oHandler );
        break;
      case 843:
        Tra_0810_0843( oHandler );
        break;
      case 844:
        Tra_0810_0844( oHandler );
        break;
      case 830:
        Tra_0814_0830( oHandler );
        break;
      case 839:
        Tra_0810_0839( oHandler );
        break;
      case 826:
        Tra_0814_0826( oHandler );
        break;
      case 842:
        Tra_0810_0842( oHandler );
        break;
      case 838:
        Tra_0810_0838( oHandler );
        break;
      case 840:
        Tra_0810_0840( oHandler );
        break;
      case 841:
        Tra_0810_0841( oHandler );
        break;
      case 848:
        Tra_0810_0848( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm )
  class Fsm_0807_0809 : public TsmFsm
  {
  private:
    Reg_0809_0810* oReg_0809_0810; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >)

  public:
    Fsm_0807_0809( TsmBase* oParent )
    {
      TsmName = "ReaderClientPsm";
      TsmParent = oParent;
      oReg_0809_0810 = new Reg_0809_0810( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0809_0810;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient )
  class Cla_0806_0807 : public TsmProtocolClass
  {
  private:
    Fsm_0807_0809* oFsm_0807_0809; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm )
    TsmIPort_IReaderServer* Port; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > Port )
    TsmIPort_IReaderClient* TsmPI__Port; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > Port )
    TsmPCPort* mPCMessager;
    eRV RV;
    int FileHandle;
    tChunk Chunk;

  public:
    Cla_0806_0807( TsmBase* oParent, string sInstanceName ) : RV(OK), FileHandle(0)
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0807_0809 = new Fsm_0807_0809( this );
      TsmPI__Port = new TsmIPort_IReaderClient( this );
      mPCMessager = new TsmPCPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0807_0809;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "Port" )
      {
        return TsmPI__Port;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "Port" )
      {
        Port = static_cast<TsmIPort_IReaderServer*>(oProvidedInterface);
        Port->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0807_0809->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    bool Guard_1066();
    bool Guard_1067();
    void Function_1153( TsmHandler& oHandler );
    void Function_1154( TsmHandler& oHandler );
    void Function_1155( TsmHandler& oHandler );
    void Function_1156( TsmHandler& oHandler );
    void Function_1157( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0806_0807()
    {
      delete TsmPI__Port;
      delete mPCMessager;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols > ReaderProtocol )
   ********************************************************************/

   // ( Xmi > Data > Protocols > ReaderProtocol )
  class Pac_0805_0806 : public TsmPackage
  {
  public:
    Pac_0805_0806( TsmBase* oParent )
    {
      TsmName = "ReaderProtocol";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> InitialState )
  class Ini_0892_0893 : public TsmPseudo
  {
  public:
    Ini_0892_0893( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 929, "( DisplayClientPsm >> InitialState ) => ( DisplayClientPsm >> CompoundState )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 929: // UP: ( DisplayClientPsm >> InitialState ) => ( DisplayClientPsm >> CompoundState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> InitialState )
  class Ini_0895_0896 : public TsmPseudo
  {
  public:
    Ini_0895_0896( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 916, "( DisplayClientPsm >> CompoundState >> InitialState ) => ( DisplayClientPsm >> CompoundState >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 916: // UP: ( DisplayClientPsm >> CompoundState >> InitialState ) => ( DisplayClientPsm >> CompoundState >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  class Cho_0898_0899 : public TsmPseudo
  {
  public:
    Cho_0898_0899( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 906, "( DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Pausing )" );
      mTransitions[ 1 ] = new TsmTransition( 907, "( DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Play )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0898_0903( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 906: // UP: ( DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Pausing )
        bHigher = true;
        break;
      case 907: // UP: ( DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Play )
        bHigher = true;
        break;
      case 903:
        Tra_0898_0903( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> CompoundState >> Play )
  class Lea_0898_0900 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0898_0900( TsmBase* oParent )
    {
      TsmName = "Play";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 903, "( DisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )" );
    }

    void Tra_0898_0907( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0895_0924( TsmHandler& oHandler );
    void Tra_0898_0905( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 903:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 907:
        Tra_0898_0907( oHandler );
        break;
      case 903: // UP: ( DisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 924:
        Tra_0895_0924( oHandler );
        break;
      case 905:
        Tra_0898_0905( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> CompoundState >> Pausing )
  class Lea_0898_0901 : public TsmLeaf
  {
  public:
    Lea_0898_0901( TsmBase* oParent )
    {
      TsmName = "Pausing";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 904, "( DisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( DisplayClientPsm >> CompoundState >> Paused ) : CbPaused" );
    }

    void Tra_0898_0906( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___CbPaused( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 890:
        switch ( Command )
        {
        case 21:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 906:
        Tra_0898_0906( oHandler );
        break;
      case 904: // UP: ( DisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( DisplayClientPsm >> CompoundState >> Paused )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> CompoundState >> Continuing )
  class Lea_0898_0902 : public TsmLeaf
  {
  public:
    Lea_0898_0902( TsmBase* oParent )
    {
      TsmName = "Continuing";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 905, "( DisplayClientPsm >> CompoundState >> CompoundState >> Continuing ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Play ) : CbContinued" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0895_0921( TsmHandler& oHandler );
    void Port___CbContinued( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 890:
        switch ( Command )
        {
        case 22:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 921:
        Tra_0895_0921( oHandler );
        break;
      case 905: // UP: ( DisplayClientPsm >> CompoundState >> CompoundState >> Continuing ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Play )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> CompoundState >)
  class Reg_0897_0898 : public TsmRegion
  {
  private:
    Cho_0898_0899* oCho_0898_0899; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
    Lea_0898_0900* oLea_0898_0900; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> CompoundState >> Play )
    Lea_0898_0901* oLea_0898_0901; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> CompoundState >> Pausing )
    Lea_0898_0902* oLea_0898_0902; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> CompoundState >> Continuing )

  public:
    Reg_0897_0898( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oCho_0898_0899 = new Cho_0898_0899( this );
      oLea_0898_0900 = new Lea_0898_0900( this );
      oLea_0898_0901 = new Lea_0898_0901( this );
      oLea_0898_0902 = new Lea_0898_0902( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oCho_0898_0899;
      mStates[ 1 ] = oLea_0898_0900;
      mStates[ 2 ] = oLea_0898_0901;
      mStates[ 3 ] = oLea_0898_0902;
    }

    void Tra_0898_0906( TsmHandler& oHandler );
    void Tra_0898_0907( TsmHandler& oHandler );
    void Tra_0898_0903( TsmHandler& oHandler );
    void Tra_0895_0921( TsmHandler& oHandler );
    void Tra_0895_0924( TsmHandler& oHandler );
    void Tra_0898_0905( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 903:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 890:
        switch ( Command )
        {
        case 21:
          return TsmProspect::OK;
        case 22:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 906:
        Tra_0898_0906( oHandler );
        break;
      case 907:
        Tra_0898_0907( oHandler );
        break;
      case 903:
        Tra_0898_0903( oHandler );
        break;
      case 921:
        Tra_0895_0921( oHandler );
        break;
      case 924:
        Tra_0895_0924( oHandler );
        break;
      case 904: // Up: ( DisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( DisplayClientPsm >> CompoundState >> Paused )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 905:
        Tra_0898_0905( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> CompoundState )
  class Com_0895_0897 : public TsmCompound
  {
  private:
    Reg_0897_0898* oReg_0897_0898; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> CompoundState >)

  public:
    Com_0895_0897( TsmBase* oParent )
    {
      TsmName = "CS_897";
      TsmParent = oParent;
      oReg_0897_0898 = new Reg_0897_0898( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0897_0898;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 927, "( DisplayClientPsm >> CompoundState >> CompoundState ) => ( DisplayClientPsm >> CompoundState >> Finishing ) : CbFinished" );
      mTransitions[ 1 ] = new TsmTransition( 926, "( DisplayClientPsm >> CompoundState >> CompoundState ) => ( DisplayClientPsm >> CompoundState >> Synclost ) : CbSynclost" );
    }

    void Tra_0895_0921( TsmHandler& oHandler );
    void Tra_0895_0924( TsmHandler& oHandler );
    void Port___CbFinished( TsmHandler& oHandler );
    void Port___CbSynclost( tTime BadTime, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 890:
        switch ( Command )
        {
        case 23:
          return TsmProspect::OK;
        case 24:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 921:
        Tra_0895_0921( oHandler );
        break;
      case 924:
        Tra_0895_0924( oHandler );
        break;
      case 904: // UP: ( DisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( DisplayClientPsm >> CompoundState >> Paused )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 927: // UP: ( DisplayClientPsm >> CompoundState >> CompoundState ) => ( DisplayClientPsm >> CompoundState >> Finishing )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 926: // UP: ( DisplayClientPsm >> CompoundState >> CompoundState ) => ( DisplayClientPsm >> CompoundState >> Synclost )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Ready )
  class Lea_0895_0908 : public TsmLeaf
  {
  private:
    static const int aNatives[2];

  public:
    Lea_0895_0908( TsmBase* oParent )
    {
      TsmName = "Ready";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 917, "( DisplayClientPsm >> CompoundState >> Ready ) => ( DisplayClientPsm >> CompoundState >> Starting )" );
      mTransitions[ 1 ] = new TsmTransition( 918, "( DisplayClientPsm >> CompoundState >> Ready ) => ( DisplayClientPsm >> CompoundState >> StartPausing )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0895_0919( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 917:
          return TsmProspect::OK;
        case 918:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 917: // UP: ( DisplayClientPsm >> CompoundState >> Ready ) => ( DisplayClientPsm >> CompoundState >> Starting )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 918: // UP: ( DisplayClientPsm >> CompoundState >> Ready ) => ( DisplayClientPsm >> CompoundState >> StartPausing )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 919:
        Tra_0895_0919( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Preparing )
  class Lea_0895_0909 : public TsmLeaf
  {
  public:
    Lea_0895_0909( TsmBase* oParent )
    {
      TsmName = "Preparing";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 919, "( DisplayClientPsm >> CompoundState >> Preparing ) => ( DisplayClientPsm >> CompoundState >> Ready ) : CbPrepared" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0895_0920( TsmHandler& oHandler );
    void Port___CbPrepared( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 890:
        switch ( Command )
        {
        case 19:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 920:
        Tra_0895_0920( oHandler );
        break;
      case 919: // UP: ( DisplayClientPsm >> CompoundState >> Preparing ) => ( DisplayClientPsm >> CompoundState >> Ready )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Idle )
  class Lea_0895_0910 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0895_0910( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 920, "( DisplayClientPsm >> CompoundState >> Idle ) => ( DisplayClientPsm >> CompoundState >> Preparing )" );
    }

    void Tra_0895_0916( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 920:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 916:
        Tra_0895_0916( oHandler );
        break;
      case 920: // UP: ( DisplayClientPsm >> CompoundState >> Idle ) => ( DisplayClientPsm >> CompoundState >> Preparing )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Finishing )
  class Lea_0895_0911 : public TsmLeaf
  {
  public:
    Lea_0895_0911( TsmBase* oParent )
    {
      TsmName = "Finishing";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0895_0927( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 927:
        Tra_0895_0927( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Paused )
  class Lea_0895_0912 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0895_0912( TsmBase* oParent )
    {
      TsmName = "Paused";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 921, "( DisplayClientPsm >> CompoundState >> Paused ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Continuing )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0898_0904( TsmHandler& oHandler );
    void Tra_0895_0922( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 921:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 921: // UP: ( DisplayClientPsm >> CompoundState >> Paused ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Continuing )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 904:
        Tra_0898_0904( oHandler );
        break;
      case 922:
        Tra_0895_0922( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> StartPausing )
  class Lea_0895_0913 : public TsmLeaf
  {
  public:
    Lea_0895_0913( TsmBase* oParent )
    {
      TsmName = "StartPausing";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 922, "( DisplayClientPsm >> CompoundState >> StartPausing ) => ( DisplayClientPsm >> CompoundState >> Paused ) : CbPaused" );
      mTransitions[ 1 ] = new TsmTransition( 923, "( DisplayClientPsm >> CompoundState >> StartPausing ) => ( DisplayClientPsm >> CompoundState >> Synclost ) : CbSynclost" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0895_0918( TsmHandler& oHandler );
    void Port___CbPaused( TsmHandler& oHandler );
    void Port___CbSynclost( tTime BadTime, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 890:
        switch ( Command )
        {
        case 21:
          return TsmProspect::OK;
        case 24:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 918:
        Tra_0895_0918( oHandler );
        break;
      case 922: // UP: ( DisplayClientPsm >> CompoundState >> StartPausing ) => ( DisplayClientPsm >> CompoundState >> Paused )
        bHigher = true;
        break;
      case 923: // UP: ( DisplayClientPsm >> CompoundState >> StartPausing ) => ( DisplayClientPsm >> CompoundState >> Synclost )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Starting )
  class Lea_0895_0914 : public TsmLeaf
  {
  public:
    Lea_0895_0914( TsmBase* oParent )
    {
      TsmName = "Starting";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 924, "( DisplayClientPsm >> CompoundState >> Starting ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Play ) : CbStarted" );
      mTransitions[ 1 ] = new TsmTransition( 925, "( DisplayClientPsm >> CompoundState >> Starting ) => ( DisplayClientPsm >> CompoundState >> Synclost ) : CbSynclost" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0895_0917( TsmHandler& oHandler );
    void Port___CbStarted( TsmHandler& oHandler );
    void Port___CbSynclost( tTime BadTime, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 890:
        switch ( Command )
        {
        case 20:
          return TsmProspect::OK;
        case 24:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 917:
        Tra_0895_0917( oHandler );
        break;
      case 924: // UP: ( DisplayClientPsm >> CompoundState >> Starting ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Play )
        bHigher = true;
        break;
      case 925: // UP: ( DisplayClientPsm >> CompoundState >> Starting ) => ( DisplayClientPsm >> CompoundState >> Synclost )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Synclost )
  class Lea_0895_0915 : public TsmLeaf
  {
  public:
    Lea_0895_0915( TsmBase* oParent )
    {
      TsmName = "Synclost";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0895_0926( TsmHandler& oHandler );
    void Tra_0895_0923( TsmHandler& oHandler );
    void Tra_0895_0925( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 926:
        Tra_0895_0926( oHandler );
        break;
      case 923:
        Tra_0895_0923( oHandler );
        break;
      case 925:
        Tra_0895_0925( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >)
  class Reg_0894_0895 : public TsmRegion
  {
  private:
    Ini_0895_0896* oIni_0895_0896; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> InitialState )
    Com_0895_0897* oCom_0895_0897; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> CompoundState )
    Lea_0895_0908* oLea_0895_0908; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Ready )
    Lea_0895_0909* oLea_0895_0909; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Preparing )
    Lea_0895_0910* oLea_0895_0910; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Idle )
    Lea_0895_0911* oLea_0895_0911; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Finishing )
    Lea_0895_0912* oLea_0895_0912; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Paused )
    Lea_0895_0913* oLea_0895_0913; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> StartPausing )
    Lea_0895_0914* oLea_0895_0914; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Starting )
    Lea_0895_0915* oLea_0895_0915; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Synclost )

  public:
    Reg_0894_0895( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0895_0896 = new Ini_0895_0896( this );
      oCom_0895_0897 = new Com_0895_0897( this );
      oLea_0895_0908 = new Lea_0895_0908( this );
      oLea_0895_0909 = new Lea_0895_0909( this );
      oLea_0895_0910 = new Lea_0895_0910( this );
      oLea_0895_0911 = new Lea_0895_0911( this );
      oLea_0895_0912 = new Lea_0895_0912( this );
      oLea_0895_0913 = new Lea_0895_0913( this );
      oLea_0895_0914 = new Lea_0895_0914( this );
      oLea_0895_0915 = new Lea_0895_0915( this );
      mNrStates = 10;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0895_0896;
      mStates[ 1 ] = oCom_0895_0897;
      mStates[ 2 ] = oLea_0895_0908;
      mStates[ 3 ] = oLea_0895_0909;
      mStates[ 4 ] = oLea_0895_0910;
      mStates[ 5 ] = oLea_0895_0911;
      mStates[ 6 ] = oLea_0895_0912;
      mStates[ 7 ] = oLea_0895_0913;
      mStates[ 8 ] = oLea_0895_0914;
      mStates[ 9 ] = oLea_0895_0915;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0895_0916( TsmHandler& oHandler );
    void Tra_0895_0917( TsmHandler& oHandler );
    void Tra_0895_0918( TsmHandler& oHandler );
    void Tra_0895_0920( TsmHandler& oHandler );
    void Tra_0895_0921( TsmHandler& oHandler );
    void Tra_0895_0919( TsmHandler& oHandler );
    void Tra_0895_0924( TsmHandler& oHandler );
    void Tra_0898_0904( TsmHandler& oHandler );
    void Tra_0895_0922( TsmHandler& oHandler );
    void Tra_0895_0927( TsmHandler& oHandler );
    void Tra_0895_0926( TsmHandler& oHandler );
    void Tra_0895_0923( TsmHandler& oHandler );
    void Tra_0895_0925( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 903:
          return TsmProspect::OK;
        case 917:
          return TsmProspect::OK;
        case 918:
          return TsmProspect::OK;
        case 920:
          return TsmProspect::OK;
        case 921:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 890:
        switch ( Command )
        {
        case 19:
          return TsmProspect::OK;
        case 20:
          return TsmProspect::OK;
        case 21:
          return TsmProspect::OK;
        case 22:
          return TsmProspect::OK;
        case 23:
          return TsmProspect::OK;
        case 24:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 916:
        Tra_0895_0916( oHandler );
        break;
      case 917:
        Tra_0895_0917( oHandler );
        break;
      case 918:
        Tra_0895_0918( oHandler );
        break;
      case 920:
        Tra_0895_0920( oHandler );
        break;
      case 921:
        Tra_0895_0921( oHandler );
        break;
      case 919:
        Tra_0895_0919( oHandler );
        break;
      case 924:
        Tra_0895_0924( oHandler );
        break;
      case 904:
        Tra_0898_0904( oHandler );
        break;
      case 922:
        Tra_0895_0922( oHandler );
        break;
      case 927:
        Tra_0895_0927( oHandler );
        break;
      case 926:
        Tra_0895_0926( oHandler );
        break;
      case 923:
        Tra_0895_0923( oHandler );
        break;
      case 925:
        Tra_0895_0925( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState )
  class Com_0892_0894 : public TsmCompound
  {
  private:
    static const int aNatives[1];
    Reg_0894_0895* oReg_0894_0895; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >)

  public:
    Com_0892_0894( TsmBase* oParent )
    {
      TsmName = "CS_894";
      TsmParent = oParent;
      oReg_0894_0895 = new Reg_0894_0895( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0894_0895;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 930, "( DisplayClientPsm >> CompoundState ) => ( DisplayClientPsm >> Stopping )" );
    }

    void Tra_0892_0929( TsmHandler& oHandler );
    void Tra_0892_0931( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtMyExit( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 930:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 929:
        Tra_0892_0929( oHandler );
        break;
      case 930: // UP: ( DisplayClientPsm >> CompoundState ) => ( DisplayClientPsm >> Stopping )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 931:
        Tra_0892_0931( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> Stopping )
  class Lea_0892_0928 : public TsmLeaf
  {
  public:
    Lea_0892_0928( TsmBase* oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      mNrTransitions = 7;
      mTransitions = new TsmTransition*[ 7 ];
      mTransitions[ 0 ] = new TsmTransition( 932, "( DisplayClientPsm >> Stopping ) => ( DisplayClientPsm >> Stopping ) : CbPrepared" );
      mTransitions[ 1 ] = new TsmTransition( 933, "( DisplayClientPsm >> Stopping ) => ( DisplayClientPsm >> Stopping ) : CbStarted" );
      mTransitions[ 2 ] = new TsmTransition( 934, "( DisplayClientPsm >> Stopping ) => ( DisplayClientPsm >> Stopping ) : CbPaused" );
      mTransitions[ 3 ] = new TsmTransition( 935, "( DisplayClientPsm >> Stopping ) => ( DisplayClientPsm >> Stopping ) : CbContinued" );
      mTransitions[ 4 ] = new TsmTransition( 936, "( DisplayClientPsm >> Stopping ) => ( DisplayClientPsm >> Stopping ) : CbFinished" );
      mTransitions[ 5 ] = new TsmTransition( 937, "( DisplayClientPsm >> Stopping ) => ( DisplayClientPsm >> Stopping ) : CbSynclost" );
      mTransitions[ 6 ] = new TsmTransition( 931, "( DisplayClientPsm >> Stopping ) => ( DisplayClientPsm >> CompoundState ) : CbStopped" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0892_0930( TsmHandler& oHandler );
    void Tra_0892_0932( TsmHandler& oHandler );
    void Port___CbPrepared( TsmHandler& oHandler );
    void Tra_0892_0933( TsmHandler& oHandler );
    void Port___CbStarted( TsmHandler& oHandler );
    void Tra_0892_0934( TsmHandler& oHandler );
    void Port___CbPaused( TsmHandler& oHandler );
    void Tra_0892_0935( TsmHandler& oHandler );
    void Port___CbContinued( TsmHandler& oHandler );
    void Tra_0892_0936( TsmHandler& oHandler );
    void Port___CbFinished( TsmHandler& oHandler );
    void Tra_0892_0937( TsmHandler& oHandler );
    void Port___CbSynclost( tTime BadTime, TsmHandler& oHandler );
    void Port___CbStopped( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 890:
        switch ( Command )
        {
        case 19:
          return TsmProspect::OK;
        case 20:
          return TsmProspect::OK;
        case 21:
          return TsmProspect::OK;
        case 22:
          return TsmProspect::OK;
        case 23:
          return TsmProspect::OK;
        case 24:
          return TsmProspect::OK;
        case 25:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 930:
        Tra_0892_0930( oHandler );
        break;
      case 932:
        Tra_0892_0932( oHandler );
        break;
      case 933:
        Tra_0892_0933( oHandler );
        break;
      case 934:
        Tra_0892_0934( oHandler );
        break;
      case 935:
        Tra_0892_0935( oHandler );
        break;
      case 936:
        Tra_0892_0936( oHandler );
        break;
      case 937:
        Tra_0892_0937( oHandler );
        break;
      case 931: // UP: ( DisplayClientPsm >> Stopping ) => ( DisplayClientPsm >> CompoundState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >)
  class Reg_0891_0892 : public TsmRegion
  {
  private:
    Ini_0892_0893* oIni_0892_0893; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> InitialState )
    Com_0892_0894* oCom_0892_0894; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState )
    Lea_0892_0928* oLea_0892_0928; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> Stopping )

  public:
    Reg_0891_0892( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0892_0893 = new Ini_0892_0893( this );
      oCom_0892_0894 = new Com_0892_0894( this );
      oLea_0892_0928 = new Lea_0892_0928( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0892_0893;
      mStates[ 1 ] = oCom_0892_0894;
      mStates[ 2 ] = oLea_0892_0928;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0892_0929( TsmHandler& oHandler );
    void Tra_0892_0930( TsmHandler& oHandler );
    void Tra_0892_0931( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 930:
          return TsmProspect::OK;
        case 903:
          return TsmProspect::OK;
        case 917:
          return TsmProspect::OK;
        case 918:
          return TsmProspect::OK;
        case 920:
          return TsmProspect::OK;
        case 921:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 890:
        switch ( Command )
        {
        case 19:
          return TsmProspect::OK;
        case 20:
          return TsmProspect::OK;
        case 21:
          return TsmProspect::OK;
        case 22:
          return TsmProspect::OK;
        case 23:
          return TsmProspect::OK;
        case 24:
          return TsmProspect::OK;
        case 25:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 929:
        Tra_0892_0929( oHandler );
        break;
      case 930:
        Tra_0892_0930( oHandler );
        break;
      case 931:
        Tra_0892_0931( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm )
  class Fsm_0889_0891 : public TsmFsm
  {
  private:
    Reg_0891_0892* oReg_0891_0892; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >)

  public:
    Fsm_0889_0891( TsmBase* oParent )
    {
      TsmName = "DisplayClientPsm";
      TsmParent = oParent;
      oReg_0891_0892 = new Reg_0891_0892( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0891_0892;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient )
  class Cla_0888_0889 : public TsmProtocolClass
  {
  private:
    Fsm_0889_0891* oFsm_0889_0891; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm )
    TsmIPort_IDisplayServer* Port; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > Port )
    TsmIPort_IDisplayClient* TsmPI__Port; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > Port )
    TsmPCPort* mPCMessager;
    eRV RV;

  public:
    Cla_0888_0889( TsmBase* oParent, string sInstanceName ) : RV(OK)
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0889_0891 = new Fsm_0889_0891( this );
      TsmPI__Port = new TsmIPort_IDisplayClient( this );
      mPCMessager = new TsmPCPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0889_0891;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "Port" )
      {
        return TsmPI__Port;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "Port" )
      {
        Port = static_cast<TsmIPort_IDisplayServer*>(oProvidedInterface);
        Port->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0889_0891->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    bool Guard_1076();
    void Function_1165( TsmHandler& oHandler );
    void Function_1166( TsmHandler& oHandler );
    void Function_1167( TsmHandler& oHandler );
    void Function_1168( TsmHandler& oHandler );
    void Function_1169( TsmHandler& oHandler );
    void Function_1170( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0888_0889()
    {
      delete TsmPI__Port;
      delete mPCMessager;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols > DisplayProtocol )
   ********************************************************************/

   // ( Xmi > Data > Protocols > DisplayProtocol )
  class Pac_0805_0888 : public TsmPackage
  {
  public:
    Pac_0805_0888( TsmBase* oParent )
    {
      TsmName = "DisplayProtocol";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> InitialState )
  class Ini_0984_0985 : public TsmPseudo
  {
  public:
    Ini_0984_0985( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1008, "( TbClientPsm >> InitialState ) => ( TbClientPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1008: // UP: ( TbClientPsm >> InitialState ) => ( TbClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> ChoiceState )
  class Cho_0984_0986 : public TsmPseudo
  {
  public:
    Cho_0984_0986( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 1010, "( TbClientPsm >> ChoiceState ) => ( TbClientPsm >> Idle )" );
      mTransitions[ 1 ] = new TsmTransition( 1011, "( TbClientPsm >> ChoiceState ) => ( TbClientPsm >> CompoundState >> Ready )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0984_1009( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1010: // UP: ( TbClientPsm >> ChoiceState ) => ( TbClientPsm >> Idle )
        bHigher = true;
        break;
      case 1011: // UP: ( TbClientPsm >> ChoiceState ) => ( TbClientPsm >> CompoundState >> Ready )
        bHigher = true;
        break;
      case 1009:
        Tra_0984_1009( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >> ChoiceState )
  class Cho_0988_0989 : public TsmPseudo
  {
  public:
    Cho_0988_0989( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 1006, "( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> End )" );
      mTransitions[ 1 ] = new TsmTransition( 995, "( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> Play )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0988_0997( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1006: // UP: ( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> End )
        bHigher = true;
        break;
      case 995: // UP: ( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> Play )
        bHigher = true;
        break;
      case 997:
        Tra_0988_0997( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >> ChoiceState )
  class Cho_0988_0990 : public TsmPseudo
  {
  public:
    Cho_0988_0990( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 1001, "( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> Play )" );
      mTransitions[ 1 ] = new TsmTransition( 1002, "( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> Ready )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0988_1000( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1001: // UP: ( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> Play )
        bHigher = true;
        break;
      case 1002: // UP: ( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> Ready )
        bHigher = true;
        break;
      case 1000:
        Tra_0988_1000( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >> ChoiceState )
  class Cho_0988_0991 : public TsmPseudo
  {
  public:
    Cho_0988_0991( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 1005, "( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> End )" );
      mTransitions[ 1 ] = new TsmTransition( 1004, "( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> End )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0988_1003( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1005: // UP: ( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> End )
        bHigher = true;
        break;
      case 1004: // UP: ( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> End )
        bHigher = true;
        break;
      case 1003:
        Tra_0988_1003( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >> Play )
  class Lea_0988_0992 : public TsmLeaf
  {
  private:
    static const int aNatives[3];

  public:
    Lea_0988_0992( TsmBase* oParent )
    {
      TsmName = "Play";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 996, "( TbClientPsm >> CompoundState >> Play ) => ( TbClientPsm >> CompoundState >> Play )" );
      mTransitions[ 1 ] = new TsmTransition( 997, "( TbClientPsm >> CompoundState >> Play ) => ( TbClientPsm >> CompoundState >> ChoiceState )" );
      mTransitions[ 2 ] = new TsmTransition( 999, "( TbClientPsm >> CompoundState >> Play ) => ( TbClientPsm >> CompoundState >> Play )" );
    }

    void Tra_0988_0995( TsmHandler& oHandler );
    void Tra_0988_1001( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0988_0996( TsmHandler& oHandler );
    void Tra_0988_0999( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 996:
          return TsmProspect::OK;
        case 997:
          return TsmProspect::OK;
        case 999:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 995:
        Tra_0988_0995( oHandler );
        break;
      case 1001:
        Tra_0988_1001( oHandler );
        break;
      case 996:
        Tra_0988_0996( oHandler );
        break;
      case 997: // UP: ( TbClientPsm >> CompoundState >> Play ) => ( TbClientPsm >> CompoundState >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 999:
        Tra_0988_0999( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >> Ready )
  class Lea_0988_0993 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0988_0993( TsmBase* oParent )
    {
      TsmName = "Ready";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1000, "( TbClientPsm >> CompoundState >> Ready ) => ( TbClientPsm >> CompoundState >> ChoiceState )" );
    }

    void Tra_0984_1011( TsmHandler& oHandler );
    void Tra_0988_1002( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 1000:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1011:
        Tra_0984_1011( oHandler );
        break;
      case 1002:
        Tra_0988_1002( oHandler );
        break;
      case 1000: // UP: ( TbClientPsm >> CompoundState >> Ready ) => ( TbClientPsm >> CompoundState >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >> End )
  class Lea_0988_0994 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0988_0994( TsmBase* oParent )
    {
      TsmName = "End";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1003, "( TbClientPsm >> CompoundState >> End ) => ( TbClientPsm >> CompoundState >> ChoiceState )" );
    }

    void Tra_0988_1006( TsmHandler& oHandler );
    void Tra_0988_1005( TsmHandler& oHandler );
    void Tra_0988_1004( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 1003:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1006:
        Tra_0988_1006( oHandler );
        break;
      case 1005:
        Tra_0988_1005( oHandler );
        break;
      case 1004:
        Tra_0988_1004( oHandler );
        break;
      case 1003: // UP: ( TbClientPsm >> CompoundState >> End ) => ( TbClientPsm >> CompoundState >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >)
  class Reg_0987_0988 : public TsmRegion
  {
  private:
    Cho_0988_0989* oCho_0988_0989; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >> ChoiceState )
    Cho_0988_0990* oCho_0988_0990; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >> ChoiceState )
    Cho_0988_0991* oCho_0988_0991; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >> ChoiceState )
    Lea_0988_0992* oLea_0988_0992; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >> Play )
    Lea_0988_0993* oLea_0988_0993; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >> Ready )
    Lea_0988_0994* oLea_0988_0994; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >> End )

  public:
    Reg_0987_0988( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oCho_0988_0989 = new Cho_0988_0989( this );
      oCho_0988_0990 = new Cho_0988_0990( this );
      oCho_0988_0991 = new Cho_0988_0991( this );
      oLea_0988_0992 = new Lea_0988_0992( this );
      oLea_0988_0993 = new Lea_0988_0993( this );
      oLea_0988_0994 = new Lea_0988_0994( this );
      mNrStates = 6;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oCho_0988_0989;
      mStates[ 1 ] = oCho_0988_0990;
      mStates[ 2 ] = oCho_0988_0991;
      mStates[ 3 ] = oLea_0988_0992;
      mStates[ 4 ] = oLea_0988_0993;
      mStates[ 5 ] = oLea_0988_0994;
    }

    void Tra_0984_1011( TsmHandler& oHandler );
    void Tra_0988_1006( TsmHandler& oHandler );
    void Tra_0988_0995( TsmHandler& oHandler );
    void Tra_0988_1001( TsmHandler& oHandler );
    void Tra_0988_1002( TsmHandler& oHandler );
    void Tra_0988_1005( TsmHandler& oHandler );
    void Tra_0988_1004( TsmHandler& oHandler );
    void Tra_0988_0997( TsmHandler& oHandler );
    void Tra_0988_1000( TsmHandler& oHandler );
    void Tra_0988_1003( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 996:
          return TsmProspect::OK;
        case 997:
          return TsmProspect::OK;
        case 999:
          return TsmProspect::OK;
        case 1000:
          return TsmProspect::OK;
        case 1003:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1011:
        Tra_0984_1011( oHandler );
        break;
      case 1006:
        Tra_0988_1006( oHandler );
        break;
      case 995:
        Tra_0988_0995( oHandler );
        break;
      case 1001:
        Tra_0988_1001( oHandler );
        break;
      case 1002:
        Tra_0988_1002( oHandler );
        break;
      case 1005:
        Tra_0988_1005( oHandler );
        break;
      case 1004:
        Tra_0988_1004( oHandler );
        break;
      case 997:
        Tra_0988_0997( oHandler );
        break;
      case 1000:
        Tra_0988_1000( oHandler );
        break;
      case 1003:
        Tra_0988_1003( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState )
  class Com_0984_0987 : public TsmCompound
  {
  private:
    static const int aNatives[1];
    Reg_0987_0988* oReg_0987_0988; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >)

  public:
    Com_0984_0987( TsmBase* oParent )
    {
      TsmName = "CS_987";
      TsmParent = oParent;
      oReg_0987_0988 = new Reg_0987_0988( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0987_0988;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 998, "( TbClientPsm >> CompoundState ) => ( TbClientPsm >> Idle )" );
    }

    void Tra_0984_1011( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtMyExit( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 998:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1011:
        Tra_0984_1011( oHandler );
        break;
      case 998: // UP: ( TbClientPsm >> CompoundState ) => ( TbClientPsm >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> Idle )
  class Lea_0984_1007 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0984_1007( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1009, "( TbClientPsm >> Idle ) => ( TbClientPsm >> ChoiceState )" );
    }

    void Tra_0984_1008( TsmHandler& oHandler );
    void Tra_0984_1010( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0988_0998( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 1009:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1008:
        Tra_0984_1008( oHandler );
        break;
      case 1010:
        Tra_0984_1010( oHandler );
        break;
      case 998:
        Tra_0988_0998( oHandler );
        break;
      case 1009: // UP: ( TbClientPsm >> Idle ) => ( TbClientPsm >> ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >)
  class Reg_0983_0984 : public TsmRegion
  {
  private:
    Ini_0984_0985* oIni_0984_0985; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> InitialState )
    Cho_0984_0986* oCho_0984_0986; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> ChoiceState )
    Com_0984_0987* oCom_0984_0987; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState )
    Lea_0984_1007* oLea_0984_1007; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> Idle )

  public:
    Reg_0983_0984( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0984_0985 = new Ini_0984_0985( this );
      oCho_0984_0986 = new Cho_0984_0986( this );
      oCom_0984_0987 = new Com_0984_0987( this );
      oLea_0984_1007 = new Lea_0984_1007( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0984_0985;
      mStates[ 1 ] = oCho_0984_0986;
      mStates[ 2 ] = oCom_0984_0987;
      mStates[ 3 ] = oLea_0984_1007;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0984_1008( TsmHandler& oHandler );
    void Tra_0984_1010( TsmHandler& oHandler );
    void Tra_0984_1011( TsmHandler& oHandler );
    void Tra_0988_0998( TsmHandler& oHandler );
    void Tra_0984_1009( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 998:
          return TsmProspect::OK;
        case 996:
          return TsmProspect::OK;
        case 997:
          return TsmProspect::OK;
        case 999:
          return TsmProspect::OK;
        case 1000:
          return TsmProspect::OK;
        case 1003:
          return TsmProspect::OK;
        case 1009:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1008:
        Tra_0984_1008( oHandler );
        break;
      case 1010:
        Tra_0984_1010( oHandler );
        break;
      case 1011:
        Tra_0984_1011( oHandler );
        break;
      case 998:
        Tra_0988_0998( oHandler );
        break;
      case 1009:
        Tra_0984_1009( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm )
  class Fsm_0981_0983 : public TsmFsm
  {
  private:
    Reg_0983_0984* oReg_0983_0984; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >)

  public:
    Fsm_0981_0983( TsmBase* oParent )
    {
      TsmName = "TbClientPsm";
      TsmParent = oParent;
      oReg_0983_0984 = new Reg_0983_0984( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0983_0984;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient )
  class Cla_0980_0981 : public TsmProtocolClass
  {
  private:
    Fsm_0981_0983* oFsm_0981_0983; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm )
    TsmIPort_ITitlebaseServer* Port; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > Port )
    eRV RV;
    int FileHandle;
    tChunk Chunk;
    string TitleId;
    tTime AtTime;
    int BadSector;
    tTime BadTime;

  public:
    Cla_0980_0981( TsmBase* oParent, string sInstanceName ) : RV(OK), FileHandle(0), BadSector(0)
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0981_0983 = new Fsm_0981_0983( this );
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0981_0983;
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "Port" )
      {
        Port = static_cast<TsmIPort_ITitlebaseServer*>(oProvidedInterface);
        Port->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0981_0983->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    bool Guard_1077();
    bool Guard_1078();
    bool Guard_1079();
    bool Guard_1080();
    void Function_1181( TsmHandler& oHandler );
    void Function_1182( TsmHandler& oHandler );
    void Function_1183( TsmHandler& oHandler );
    void Function_1184( TsmHandler& oHandler );
    void Function_1185( TsmHandler& oHandler );
    void Function_1186( TsmHandler& oHandler );
    void Function_1187( TsmHandler& oHandler );
    void TsmPrepare( void* oObject );
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols > TitlebaseProtocol )
   ********************************************************************/

   // ( Xmi > Data > Protocols > TitlebaseProtocol )
  class Pac_0805_0980 : public TsmPackage
  {
  public:
    Pac_0805_0980( TsmBase* oParent )
    {
      TsmName = "TitlebaseProtocol";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> InitialState )
  class Ini_1047_1048 : public TsmPseudo
  {
  public:
    Ini_1047_1048( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1076, "( PlayerServerPsm >> InitialState ) => ( PlayerServerPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1076: // UP: ( PlayerServerPsm >> InitialState ) => ( PlayerServerPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> ChoiceState )
  class Cho_1047_1049 : public TsmPseudo
  {
  private:
    int MaxNrChoices;

  public:
    Cho_1047_1049( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      MaxNrChoices = 2;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 1080, "( PlayerServerPsm >> ChoiceState ) => ( PlayerServerPsm >> Active >> Starting )" );
      mTransitions[ 1 ] = new TsmTransition( 1081, "( PlayerServerPsm >> ChoiceState ) => ( PlayerServerPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_1047_1077( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1080: // UP: ( PlayerServerPsm >> ChoiceState ) => ( PlayerServerPsm >> Active >> Starting )
        bHigher = true;
        break;
      case 1081: // UP: ( PlayerServerPsm >> ChoiceState ) => ( PlayerServerPsm >> Idle )
        bHigher = true;
        break;
      case 1077:
        Tra_1047_1077( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >> Busy >> Pausing )
  class Lea_1055_1056 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_1055_1056( TsmBase* oParent )
    {
      TsmName = "Pausing";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1059, "( PlayerServerPsm >> Active >> Running >> Busy >> Pausing ) => ( PlayerServerPsm >> Active >> Running >> Paused )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_1055_1060( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 1059:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1059: // UP: ( PlayerServerPsm >> Active >> Running >> Busy >> Pausing ) => ( PlayerServerPsm >> Active >> Running >> Paused )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 1060:
        Tra_1055_1060( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >> Busy >> Play )
  class Lea_1055_1057 : public TsmLeaf
  {
  public:
    Lea_1055_1057( TsmBase* oParent )
    {
      TsmName = "Play";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1060, "( PlayerServerPsm >> Active >> Running >> Busy >> Play ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Pausing ) : Pause" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_1055_1061( TsmHandler& oHandler );
    void Tra_1051_1070( TsmHandler& oHandler );
    void Port___Pause( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 1045:
        switch ( Command )
        {
        case 27:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1061:
        Tra_1055_1061( oHandler );
        break;
      case 1070:
        Tra_1051_1070( oHandler );
        break;
      case 1060: // UP: ( PlayerServerPsm >> Active >> Running >> Busy >> Play ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Pausing )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >> Busy >> Continuing )
  class Lea_1055_1058 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_1055_1058( TsmBase* oParent )
    {
      TsmName = "Continuing";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1061, "( PlayerServerPsm >> Active >> Running >> Busy >> Continuing ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Play )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_1053_1064( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 1061:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1061: // UP: ( PlayerServerPsm >> Active >> Running >> Busy >> Continuing ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Play )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 1064:
        Tra_1053_1064( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >> Busy >)
  class Reg_1054_1055 : public TsmRegion
  {
  private:
    Lea_1055_1056* oLea_1055_1056; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >> Busy >> Pausing )
    Lea_1055_1057* oLea_1055_1057; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >> Busy >> Play )
    Lea_1055_1058* oLea_1055_1058; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >> Busy >> Continuing )

  public:
    Reg_1054_1055( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oLea_1055_1056 = new Lea_1055_1056( this );
      oLea_1055_1057 = new Lea_1055_1057( this );
      oLea_1055_1058 = new Lea_1055_1058( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oLea_1055_1056;
      mStates[ 1 ] = oLea_1055_1057;
      mStates[ 2 ] = oLea_1055_1058;
    }

    void Tra_1055_1061( TsmHandler& oHandler );
    void Tra_1051_1070( TsmHandler& oHandler );
    void Tra_1055_1060( TsmHandler& oHandler );
    void Tra_1053_1064( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 1059:
          return TsmProspect::OK;
        case 1061:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 1045:
        switch ( Command )
        {
        case 27:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1059: // Up: ( PlayerServerPsm >> Active >> Running >> Busy >> Pausing ) => ( PlayerServerPsm >> Active >> Running >> Paused )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 1061:
        Tra_1055_1061( oHandler );
        break;
      case 1070:
        Tra_1051_1070( oHandler );
        break;
      case 1060:
        Tra_1055_1060( oHandler );
        break;
      case 1064:
        Tra_1053_1064( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >> Busy )
  class Com_1053_1054 : public TsmCompound
  {
  private:
    static const int aNatives[1];
    Reg_1054_1055* oReg_1054_1055; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >> Busy >)

  public:
    Com_1053_1054( TsmBase* oParent )
    {
      TsmName = "Busy";
      TsmParent = oParent;
      oReg_1054_1055 = new Reg_1054_1055( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_1054_1055;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1063, "( PlayerServerPsm >> Active >> Running >> Busy ) => ( PlayerServerPsm >> Active >> Finishing )" );
    }

    void Tra_1051_1070( TsmHandler& oHandler );
    void Tra_1053_1064( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtMyExit( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 1063:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1063: // UP: ( PlayerServerPsm >> Active >> Running >> Busy ) => ( PlayerServerPsm >> Active >> Finishing )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 1059: // UP: ( PlayerServerPsm >> Active >> Running >> Busy >> Pausing ) => ( PlayerServerPsm >> Active >> Running >> Paused )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 1070:
        Tra_1051_1070( oHandler );
        break;
      case 1064:
        Tra_1053_1064( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >> Paused )
  class Lea_1053_1062 : public TsmLeaf
  {
  public:
    Lea_1053_1062( TsmBase* oParent )
    {
      TsmName = "Paused";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1064, "( PlayerServerPsm >> Active >> Running >> Paused ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Continuing ) : Continue" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_1055_1059( TsmHandler& oHandler );
    void Port___Continue( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 1045:
        switch ( Command )
        {
        case 28:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1059:
        Tra_1055_1059( oHandler );
        break;
      case 1064: // UP: ( PlayerServerPsm >> Active >> Running >> Paused ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Continuing )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >)
  class Reg_1052_1053 : public TsmRegion
  {
  private:
    Com_1053_1054* oCom_1053_1054; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >> Busy )
    Lea_1053_1062* oLea_1053_1062; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >> Paused )

  public:
    Reg_1052_1053( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oCom_1053_1054 = new Com_1053_1054( this );
      oLea_1053_1062 = new Lea_1053_1062( this );
      mNrStates = 2;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oCom_1053_1054;
      mStates[ 1 ] = oLea_1053_1062;
    }

    void Tra_1055_1059( TsmHandler& oHandler );
    void Tra_1051_1070( TsmHandler& oHandler );
    void Tra_1053_1064( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 1063:
          return TsmProspect::OK;
        case 1059:
          return TsmProspect::OK;
        case 1061:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 1045:
        switch ( Command )
        {
        case 27:
          return TsmProspect::OK;
        case 28:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1063: // Up: ( PlayerServerPsm >> Active >> Running >> Busy ) => ( PlayerServerPsm >> Active >> Finishing )
        mCurrentState = NULL;
        bHigher = true;
        break;
      case 1059:
        Tra_1055_1059( oHandler );
        break;
      case 1070:
        Tra_1051_1070( oHandler );
        break;
      case 1064:
        Tra_1053_1064( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running )
  class Com_1051_1052 : public TsmCompound
  {
  private:
    static const int aNatives[1];
    Reg_1052_1053* oReg_1052_1053; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >)

  public:
    Com_1051_1052( TsmBase* oParent )
    {
      TsmName = "Running";
      TsmParent = oParent;
      oReg_1052_1053 = new Reg_1052_1053( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_1052_1053;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1071, "( PlayerServerPsm >> Active >> Running ) => ( PlayerServerPsm >> Active >> Error )" );
    }

    void Tra_1051_1070( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtMyExit( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 1071:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1071: // UP: ( PlayerServerPsm >> Active >> Running ) => ( PlayerServerPsm >> Active >> Error )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 1063: // UP: ( PlayerServerPsm >> Active >> Running >> Busy ) => ( PlayerServerPsm >> Active >> Finishing )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 1070:
        Tra_1051_1070( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Finishing )
  class Lea_1051_1065 : public TsmLeaf
  {
  public:
    Lea_1051_1065( TsmBase* oParent )
    {
      TsmName = "Finishing";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1073, "( PlayerServerPsm >> Active >> Finishing ) => ( PlayerServerPsm >> Active >> Finishing ) : Pause" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_1053_1063( TsmHandler& oHandler );
    void Tra_1051_1073( TsmHandler& oHandler );
    void Port___Pause( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 1045:
        switch ( Command )
        {
        case 27:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1063:
        Tra_1053_1063( oHandler );
        break;
      case 1073:
        Tra_1051_1073( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Starting )
  class Lea_1051_1066 : public TsmLeaf
  {
  private:
    static const int aNatives[2];

  public:
    Lea_1051_1066( TsmBase* oParent )
    {
      TsmName = "Starting";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 1070, "( PlayerServerPsm >> Active >> Starting ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Play )" );
      mTransitions[ 1 ] = new TsmTransition( 1072, "( PlayerServerPsm >> Active >> Starting ) => ( PlayerServerPsm >> Active >> Error )" );
    }

    void Tra_1047_1080( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 1070:
          return TsmProspect::OK;
        case 1072:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1080:
        Tra_1047_1080( oHandler );
        break;
      case 1070: // UP: ( PlayerServerPsm >> Active >> Starting ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Play )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 1072: // UP: ( PlayerServerPsm >> Active >> Starting ) => ( PlayerServerPsm >> Active >> Error )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Error )
  class Lea_1051_1067 : public TsmLeaf
  {
  public:
    Lea_1051_1067( TsmBase* oParent )
    {
      TsmName = "Error";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 1069, "( PlayerServerPsm >> Active >> Error ) => ( PlayerServerPsm >> Active >> Error ) : Pause" );
      mTransitions[ 1 ] = new TsmTransition( 1068, "( PlayerServerPsm >> Active >> Error ) => ( PlayerServerPsm >> Active >> Error ) : Continue" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_1051_1071( TsmHandler& oHandler );
    void Tra_1051_1072( TsmHandler& oHandler );
    void Tra_1051_1069( TsmHandler& oHandler );
    void Port___Pause( TsmHandler& oHandler );
    void Tra_1051_1068( TsmHandler& oHandler );
    void Port___Continue( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 1045:
        switch ( Command )
        {
        case 27:
          return TsmProspect::OK;
        case 28:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1071:
        Tra_1051_1071( oHandler );
        break;
      case 1072:
        Tra_1051_1072( oHandler );
        break;
      case 1069:
        Tra_1051_1069( oHandler );
        break;
      case 1068:
        Tra_1051_1068( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >)
  class Reg_1050_1051 : public TsmRegion
  {
  private:
    Com_1051_1052* oCom_1051_1052; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running )
    Lea_1051_1065* oLea_1051_1065; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Finishing )
    Lea_1051_1066* oLea_1051_1066; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Starting )
    Lea_1051_1067* oLea_1051_1067; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Error )

  public:
    Reg_1050_1051( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oCom_1051_1052 = new Com_1051_1052( this );
      oLea_1051_1065 = new Lea_1051_1065( this );
      oLea_1051_1066 = new Lea_1051_1066( this );
      oLea_1051_1067 = new Lea_1051_1067( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oCom_1051_1052;
      mStates[ 1 ] = oLea_1051_1065;
      mStates[ 2 ] = oLea_1051_1066;
      mStates[ 3 ] = oLea_1051_1067;
    }

    void Tra_1047_1080( TsmHandler& oHandler );
    void Tra_1051_1071( TsmHandler& oHandler );
    void Tra_1053_1063( TsmHandler& oHandler );
    void Tra_1051_1070( TsmHandler& oHandler );
    void Tra_1051_1072( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 1071:
          return TsmProspect::OK;
        case 1063:
          return TsmProspect::OK;
        case 1059:
          return TsmProspect::OK;
        case 1061:
          return TsmProspect::OK;
        case 1070:
          return TsmProspect::OK;
        case 1072:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 1045:
        switch ( Command )
        {
        case 27:
          return TsmProspect::OK;
        case 28:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1080:
        Tra_1047_1080( oHandler );
        break;
      case 1071:
        Tra_1051_1071( oHandler );
        break;
      case 1063:
        Tra_1053_1063( oHandler );
        break;
      case 1070:
        Tra_1051_1070( oHandler );
        break;
      case 1072:
        Tra_1051_1072( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active )
  class Com_1047_1050 : public TsmCompound
  {
  private:
    Reg_1050_1051* oReg_1050_1051; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >)

  public:
    Com_1047_1050( TsmBase* oParent )
    {
      TsmName = "Active";
      TsmParent = oParent;
      oReg_1050_1051 = new Reg_1050_1051( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_1050_1051;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1078, "( PlayerServerPsm >> Active ) => ( PlayerServerPsm >> Stopping ) : Stop" );
    }

    void Tra_1047_1080( TsmHandler& oHandler );
    void Port___Stop( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 1045:
        switch ( Command )
        {
        case 29:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1080:
        Tra_1047_1080( oHandler );
        break;
      case 1078: // UP: ( PlayerServerPsm >> Active ) => ( PlayerServerPsm >> Stopping )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Idle )
  class Lea_1047_1074 : public TsmLeaf
  {
  public:
    Lea_1047_1074( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1077, "( PlayerServerPsm >> Idle ) => ( PlayerServerPsm >> ChoiceState ) : Start" );
    }

    void Tra_1047_1076( TsmHandler& oHandler );
    void Tra_1047_1081( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_1047_1079( TsmHandler& oHandler );
    void Port___Start( string TitleId, tTime* AtTime, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 1045:
        switch ( Command )
        {
        case 26:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1076:
        Tra_1047_1076( oHandler );
        break;
      case 1081:
        Tra_1047_1081( oHandler );
        break;
      case 1079:
        Tra_1047_1079( oHandler );
        break;
      case 1077: // UP: ( PlayerServerPsm >> Idle ) => ( PlayerServerPsm >> ChoiceState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Stopping )
  class Lea_1047_1075 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_1047_1075( TsmBase* oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 1079, "( PlayerServerPsm >> Stopping ) => ( PlayerServerPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_1047_1078( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 1079:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1079: // UP: ( PlayerServerPsm >> Stopping ) => ( PlayerServerPsm >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 1078:
        Tra_1047_1078( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >)
  class Reg_1046_1047 : public TsmRegion
  {
  private:
    Ini_1047_1048* oIni_1047_1048; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> InitialState )
    Cho_1047_1049* oCho_1047_1049; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> ChoiceState )
    Com_1047_1050* oCom_1047_1050; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active )
    Lea_1047_1074* oLea_1047_1074; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Idle )
    Lea_1047_1075* oLea_1047_1075; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Stopping )

  public:
    Reg_1046_1047( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_1047_1048 = new Ini_1047_1048( this );
      oCho_1047_1049 = new Cho_1047_1049( this );
      oCom_1047_1050 = new Com_1047_1050( this );
      oLea_1047_1074 = new Lea_1047_1074( this );
      oLea_1047_1075 = new Lea_1047_1075( this );
      mNrStates = 5;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_1047_1048;
      mStates[ 1 ] = oCho_1047_1049;
      mStates[ 2 ] = oCom_1047_1050;
      mStates[ 3 ] = oLea_1047_1074;
      mStates[ 4 ] = oLea_1047_1075;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_1047_1076( TsmHandler& oHandler );
    void Tra_1047_1080( TsmHandler& oHandler );
    void Tra_1047_1081( TsmHandler& oHandler );
    void Tra_1047_1079( TsmHandler& oHandler );
    void Tra_1047_1077( TsmHandler& oHandler );
    void Tra_1047_1078( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 1071:
          return TsmProspect::OK;
        case 1063:
          return TsmProspect::OK;
        case 1059:
          return TsmProspect::OK;
        case 1061:
          return TsmProspect::OK;
        case 1070:
          return TsmProspect::OK;
        case 1072:
          return TsmProspect::OK;
        case 1079:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 1045:
        switch ( Command )
        {
        case 26:
          return TsmProspect::OK;
        case 27:
          return TsmProspect::OK;
        case 28:
          return TsmProspect::OK;
        case 29:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 1076:
        Tra_1047_1076( oHandler );
        break;
      case 1080:
        Tra_1047_1080( oHandler );
        break;
      case 1081:
        Tra_1047_1081( oHandler );
        break;
      case 1079:
        Tra_1047_1079( oHandler );
        break;
      case 1077:
        Tra_1047_1077( oHandler );
        break;
      case 1078:
        Tra_1047_1078( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm )
  class Fsm_1044_1046 : public TsmFsm
  {
  private:
    Reg_1046_1047* oReg_1046_1047; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >)

  public:
    Fsm_1044_1046( TsmBase* oParent )
    {
      TsmName = "PlayerServerPsm";
      TsmParent = oParent;
      oReg_1046_1047 = new Reg_1046_1047( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_1046_1047;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer )
  class Cla_1043_1044 : public TsmProtocolClass
  {
  private:
    Fsm_1044_1046* oFsm_1044_1046; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm )
    TsmIPort_IPlayerServer* TsmPI__Port; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > Port )
    TsmIPort_IPlayerClient* Port; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > Port )
    TsmPSPort* mPSMessager;

  public:
    Cla_1043_1044( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_1044_1046 = new Fsm_1044_1046( this );
      TsmPI__Port = new TsmIPort_IPlayerServer( this );
      mPSMessager = new TsmPSPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_1044_1046;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "Port" )
      {
        return TsmPI__Port;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "Port" )
      {
        Port = static_cast<TsmIPort_IPlayerClient*>(oProvidedInterface);
        Port->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_1044_1046->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    eRV Function_1097( string TitleId, tTime* AtTime );
    void Function_1098( TsmHandler& oHandler );
    eRV Function_1099( string TitleId, tTime* AtTime );
    void Function_1100( TsmHandler& oHandler );
    void Function_1188( TsmHandler& oHandler );
    void Function_1189( TsmHandler& oHandler );
    void Function_1190( TsmHandler& oHandler );
    void Function_1191( TsmHandler& oHandler );
    void Function_1192( TsmHandler& oHandler );
    void Function_1193( TsmHandler& oHandler );
    void Function_1194( TsmHandler& oHandler );
    eRV Function_1329();
    void Function_1330( TsmHandler& oHandler );
    eRV Function_1331();
    void Function_1332( TsmHandler& oHandler );
    eRV Function_1333();
    void Function_1334( TsmHandler& oHandler );
    eRV Function_1335();
    void Function_1336( TsmHandler& oHandler );
    eRV Function_1337();
    void Function_1338( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_1043_1044()
    {
      delete TsmPI__Port;
      delete mPSMessager;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols > PlayerProtocol )
   ********************************************************************/

   // ( Xmi > Data > Protocols > PlayerProtocol )
  class Pac_0805_1043 : public TsmPackage
  {
  public:
    Pac_0805_1043( TsmBase* oParent )
    {
      TsmName = "PlayerProtocol";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols )
   ********************************************************************/

   // ( Xmi > Data > Protocols )
  class Pac_0006_0805 : public TsmPackage
  {
  public:
    Pac_0006_0805( TsmBase* oParent )
    {
      TsmName = "Protocols";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > TypeDefinitions )
   ********************************************************************/

   // ( Xmi > Data > TypeDefinitions )
  class Pac_0006_1128 : public TsmPackage
  {
  public:
    Pac_0006_1128( TsmBase* oParent )
    {
      TsmName = "TypeDefinitions";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > TismStereotypes )
   ********************************************************************/

   // ( Xmi > Data > TismStereotypes )
  class Pac_0006_1129 : public TsmPackage
  {
  public:
    Pac_0006_1129( TsmBase* oParent )
    {
      TsmName = "TismStereotypes";
      TsmParent = oParent;
    }
  };

   // ( Xmi )
  class TsmSystem : public TsmExecComponent
  {
  private:
    Com_0797_0798* ExEnv; // ( Xmi > Data > Architecture > ExEnv )

  public:
    TsmSystem( TsmBase* oParent )
    {
      TsmName = "Xmi";
      TsmParent = oParent;
      mNrComponents = 1;
      mComponents = new TsmComponent*[ 1 ];
      ExEnv = new Com_0797_0798( NULL, "ExEnv" );
      mComponents[ 0 ] = ExEnv;
    }
  };
}
#endif
